# **Introduction**

This Python package serves as the frontend for calculating and building a Green's function library for synthetic seismograms. The backend consists of Wang Rongjiang's program for calculating synthetic seismograms, including EDGRN/EDCMP, [QSEIS_STRESS](https://github.com/Zhou-Jiangcheng/QSEIS_2006_STRESS), SPGRN, and QSSP (Wang, 1999; Wang 2003; Wang and Wang 2007; Wang et al., 2017). The code includes two parallel modes: one using the multiprocessing library (single-node multi-process) and the other using MPI (multi-node).

# Installation

1. For user mode

```
pip install pygrnwang
```

2. For developer mode

```
conda create -n pygrnwang python=3.14
conda install obspy tqdm mpi4py gfortran -c conda-forge
git clone https://github.com/Zhou-Jiangcheng/pygrnwang.git
cd pygrnwang
pip install -e .
```

# Usage
1. An example for creating a Green's function library with qssp2020

```
from pygrnwang.create_qssp2020_bulk import *

if __name__ == '__main__':
    wavelet_duration = 0
    sampling_interval = 1
    time_window = 4096 - sampling_interval
    path_green = r'path\grns_qssp2020\ak135fc'
    os.makedirs(path_green, exist_ok=True)
    output_observables = [0 for _ in range(11)]
    output_observables[0] = 1
    output_observables[1] = 1
    output_observables[2] = 1
    pre_process_qssp2020(
        processes_num=24,
        path_green=path_green,
        event_depth_list=[h for h in range(1, 41, 2)],
        receiver_depth_list=[0],
        dist_range=[3000, 12000],
        delta_dist=10,
        spec_time_window=time_window,
        sampling_interval=sampling_interval,
        max_frequency=0.2,
        max_slowness=0.4,
        anti_alias=0.01,
        turning_point_filter=0,
        turning_point_d1=0,
        turning_point_d2=0,
        free_surface_filter=1,
        gravity_fc=0,
        gravity_harmonic=0,
        cal_sph=1,
        cal_tor=1,
        min_harmonic=4000,
        max_harmonic=10000,
        source_radius=0,
        source_duration=wavelet_duration * sampling_interval,
        output_observables=output_observables,
        time_window=time_window,
        time_reduction=-20,
        path_nd=r'path\ak135fc.nd',
        earth_model_layer_num=None,
        physical_dispersion=0,
        check_finished_tpts_table=False
    )
    create_grnlib_qssp2020_parallel(
        path_green=path_green, check_finished=False, cal_spec=False
    )

```

2. An example for reading from a Green's function library created by qssp2020
```
from pygrnwang.read_qssp2020 import seek_qssp2020


if __name__ == "__main__":
    seismograms, tpts_table, first_p, first_s, grn_dep, grn_receiver, green_dist = (
        seek_qssp2020(
            path_green="/e/grns_test/test_qssp",
            event_depth_km=10,
            receiver_depth_km=0,
            az_deg=60,
            dist_km=5000,
            focal_mechanism=[30, 40, 50],
            srate=1,
            before_p=20,
            pad_zeros=False,
            shift=False,
            rotate=True,
            only_seismograms=False,
            output_type='disp',
            model_name=r"path\ak135fc.nd",
        )
    )

    import matplotlib.pyplot as plt
    fig, axs = plt.subplots(nrows=3, ncols=1)
    axs[0].plot(seismograms[0])
    axs[1].plot(seismograms[1])
    axs[2].plot(seismograms[2])
    plt.show()

```

# Reference

Wang, R. (1999). A simple orthonormalization method for stable and efficient computation of Green’s functions.  *Bulletin of the Seismological Society of America* ,  *89* (3), 733–741. https://doi.org/10.1785/BSSA0890030733

Wang, R. (2003). Computation of deformation induced by earthquakes in a multi-layered elastic crust—FORTRAN programs EDGRN/EDCMP. Computers & Geosciences, 29(2), 195–207. https://doi.org/10.1016/S0098-3004(02)00111-5

Wang, R., & Wang, H. (2007). A fast converging and anti-aliasing algorithm for green’s functions in terms of spherical or cylindrical harmonics. Geophysical Journal International, 170(1), 239–248. https://doi.org/10.1111/j.1365-246X.2007.03385.x

Wang, R., Heimann, S., Zhang, Y., Wang, H., & Dahm, T. (2017). Complete synthetic seismograms based on a spherical self-gravitating earth model with an atmosphere–ocean–mantle–core structure. Geophysical Journal International, 210(3), 1739–1764. https://doi.org/10.1093/gji/ggx259

Zhou, J., Wang, R., & Zhang, Y. (2026). DynCFS: a program for modeling dynamic coulomb failure stress changes in layered elastic media. Geophysical Journal International, ggaf534. https://doi.org/10.1093/gji/ggaf534

      program qpmain
      use qpalloc
      implicit none
c
c     work space
c
      integer*4 i,j,ig,ierr,runtime
      integer*4 time
      character*80 inputfile
c
c     read input file file
c
      print *,'######################################################'
      print *,'#                                                    #'
      print *,'#               Welcome to the program               #'
      print *,'#                                                    #'
      print *,'#                                                    #'
      print *,'#      SSSS    PPPP      GGG     RRRR     N   N      #'
      print *,'#     S        P   P    G        R   R    NN  N      #'
      print *,'#      SSS     PPPP     G  GG    RRRR     N N N      #'
      print *,'#         S    P        G   G    R R      N   N      #'
      print *,'#     SSSS     P         GGG     R  R     N   N      #'
      print *,'#                                                    #'
      print *,'#                                                    #'
      print *,'#                        for                         #'
      print *,'#              synthetic Green functions             #'
      print *,'#                      based on                      #'
      print *,'#      a spherical self-gravitating earth model      #'
      print *,'#                                                    #'
      print *,'#                  (Version 2020)                    #'
      print *,'#                                                    #'
      print *,'#                                                    #'
      print *,'#                      by                            #'
      print *,'#                 Rongjiang Wang                     #'
      print *,'#              (wang@gfz-potsdam.de)                 #'
      print *,'#                                                    #'
      print *,'#     GFZ German Research Centre for Geosciences     #'
      print *,'#            last modified: Jan 2020                 #'
      print *,'######################################################'
      print *,'                          '
      write(*,'(a,$)')' the input data file is '
      read(*,'(a)')inputfile
      runtime=time()
c
      open(10,file=inputfile,status='old')
      call qpgetinp(10)
      close(10)
c
      call qpsublayer(ierr)
c
      call qpdocu(ierr)
c
      call qpmaxdeg(ierr)
c
      igfirst=0
      do ig=ngrn,1,-1
        if(grnsel(ig).eq.1)igfirst=ig
      enddo
      iglast=ngrn+1
      do ig=1,ngrn
        if(grnsel(ig).eq.1)iglast=ig
      enddo
c
      do ig=1,ngrn
        if(grnsel(ig).eq.1)then
          lys=lygrn(ig)
          call qpgrnspec(ig)
        endif
      enddo
c
      call qpwvint(ierr)
c
      runtime=time()-runtime
      write(*,'(a)')' #############################################'
      write(*,'(a)')' #                                           #'
      write(*,'(a)')' #      End of computations with spgrn       #'
      write(*,'(a)')' #                                           #'
      write(*,'(a,i10,a)')' #       Run time: ',runtime,
     +                                           ' sec            #'
      write(*,'(a)')' #############################################'
      stop
      end

	subroutine edcoutput(nrec,infile,outdir,iouts,outputs)
	implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	include 'edcglobal.h'
c
	integer nrec,iouts(NFIELDS)
	character*80 outdir,infile,outputs(NFIELDS)
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	ELASTIC PARAMETERS AT OBSERVATION DEPTH
c	=======================================
c
c	lambda,mu = the two Lame constants in pascal
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision lambda,mu
c
	common/elasticity/lambda,mu
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	OBSERVATION POSITIONS AND OBSERVABLES
c	=====================================
c
c	(xrec(i),yrec(i),zrec0)=coordinates of the observation positions
c	(Note that zrec0 is fixed)
c	disp = the 3 displcement vector components: ux,uy,uz
c	strain = the 6 strain tensor components: exx,eyy,ezz,exy,eyz,ezx
c	tilt = the two vertical tilt components: dux/dz, duy/dz
c	NRECMAX = the max. number of observation positions
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision xrec(NRECMAX),yrec(NRECMAX)
	double precision zrec0
	double precision disp(NRECMAX,3),strain(NRECMAX,6)
	double precision tilt(NRECMAX,2)
c
	common/obsarray/xrec,yrec,zrec0,disp,strain,tilt
c
	integer i,leninf,lendir,irec
	double precision dilatation
	double precision stress(6)
	character*100 title
	character*160 outfile
c
	lendir=index(outdir,' ')-1
c
	if(lendir.lt.1)then
	  stop ' Error in edcmain: wrong for output directory!'
	endif
c
	leninf=index(infile,' ')-1
c
c	DATA OUTPUT
c	===========
c
	if(iouts(1).eq.1)then
	  print *,'... output 3 displacement components ...'
c
	  outfile=outdir(1:lendir)//outputs(1)
	  open(31,file=outfile,status='unknown')
	  write(31,'(a)')'# Displacements calculated with edcmp'
	  write(31,'(a)')'# The input data file is '//infile(1:leninf)
	  title='#   X_m         Y_m         '
     &        //'Ux_m        Uy_m        Uz_m'
	  write(31,'(a57)')title
	  do irec=1,nrec
	    write(31,1001)xrec(irec),yrec(irec),(disp(irec,i),i=1,3)
	  enddo
	  close(31)
	endif
c
	if(iouts(2).eq.1)then
	  print *,'... output 6 strain components ...'
c
	  outfile=outdir(1:lendir)//outputs(2)
	  open(32,file=outfile,status='unknown')
	  write(32,'(a)')'# Strains calculated with edcmp'
	  write(32,'(a)')'# The input data file is '
     &                 //infile(1:leninf)
	  title='#   X_m         Y_m         Exx         Eyy'
     &         //'         Ezz         Exy         Eyz         Ezx'
	  write(32,'(a91)')title
	  do irec=1,nrec
	    write(32,1001)xrec(irec),yrec(irec),(strain(irec,i),i=1,6)
	  enddo
	  close(32)
	endif
c
	if(iouts(3).eq.1)then
	  print *,'... output 6 stress components ...'
c
	  outfile=outdir(1:lendir)//outputs(3)
	  open(33,file=outfile,status='unknown')
	  write(33,'(a)')'# Stresses calculated with edcmp'
	  write(33,'(a)')'# The input data file is '//infile(1:leninf)
	  title='#   X_m         Y_m         Sxx_Pa      Syy_Pa'
     &	      //'      Szz_Pa      Sxy_Pa      Syz_Pa      Szx_Pa'
	  write(33,'(a94)')title
	  do irec=1,nrec
	    dilatation=strain(irec,1)+strain(irec,2)+strain(irec,3)
	    stress(1)=lambda*dilatation+2.d0*mu*strain(irec,1)
	    stress(2)=lambda*dilatation+2.d0*mu*strain(irec,2)
	    stress(3)=lambda*dilatation+2.d0*mu*strain(irec,3)
	    stress(4)=2.d0*mu*strain(irec,4)
	    stress(5)=2.d0*mu*strain(irec,5)
	    stress(6)=2.d0*mu*strain(irec,6)
	    if(zrec0.eq.0.d0)then
	      stress(3)=0.d0
	      stress(5)=0.d0
	      stress(6)=0.d0
	    endif
	    write(33,1001)xrec(irec),yrec(irec),(stress(i),i=1,6)
	  enddo
	  close(33)
	endif
c
	if(iouts(4).eq.1)then
	  print *,'... output 2 tilt components ...'
c
	  outfile=outdir(1:lendir)//outputs(4)
	  open(34,file=outfile,status='unknown')
	  write(34,'(a)')'# Vertical tilts calculated with edcmp'
	  write(34,'(a)')'# The input data file is '//infile(1:leninf)
	  title='#   X_m         Y_m         dUx/dz      dUy/dz'
	  write(34,'(a46)')title
	  do irec=1,nrec
	    write(34,1001)xrec(irec),yrec(irec),(tilt(irec,i),i=1,2)
	  enddo
	  close(34)
	endif
1001	format(8E12.4)
	return
	end

      module qpalloc
c
c     CONSTANTS
c     =========
      integer*4 ndmax
      parameter(ndmax=2)
      real*8 PI,PI2
      parameter(PI=3.14159265358979d0,PI2=6.28318530717959d0)
      real*8 DEG2RAD,KM2M
      parameter(DEG2RAD=1.745329251994328d-02,KM2M=1.0d+03)
      real*8 BIGG
      parameter(BIGG=6.6732d-11)
      real*8 RESOLUT
      parameter(RESOLUT=0.01d0)
      real*8 FLTAPER
      parameter(FLTAPER=0.2d0)
      real*8 FSBUP,FSBLW,FSBREF
      parameter(FSBUP=1.0d+02,FSBLW=2.5d-04,FSBREF=1.0d+00)
      real*8 fbvatm,fbvocean,fbvcore
      parameter(fbvatm=1.0d-06,fbvocean=0.0d+00,fbvcore=0.0d+00)
c
      logical*2 selpsv,selsh,setzh12a,setzh12t
      logical*2 nogravity,freesurf
      logical*2 dispersion
c
      integer*4 ngrn,nt,ntcut,ntcutout,nf,nfcut,nbpf
      integer*4 lyadd,ipatha,ipathb,ldeggr,ldegmin,ldegcut,ldegmax
      integer*4 nr,igfirst,iglast
      integer*4 ns,l0,lymax
      integer*4 lys,lyr,lylwa,lylwb,lyos,lyob,lycm,lycc,ly0
      integer*4 icmp(11)
c
      real*8 dt,dtout,df,fi,fcut,fgr,rratmos,depatmos
      real*8 rearth,rr0,minpath,maxpath
      real*8 slwmax,slwlwcut,slwupcut,f1corner,f2corner
      real*8 dpr,freeairgrd
      real*8 qsmin,togsmin
c
      complex*16 comi,comi2
c
      character*100 dispout(3),veloout(3),acceout(3),
     &             rotaout(3),rotarateout(3),
     &             strainout(6),strainrateout(6),
     &             stressout(6),stressrateout(6),
     &             gravout(3),grmout
c
      logical*2,allocatable:: ksmallp(:),ksmalls(:),ksmallt(:)
c
      integer*4,allocatable:: lygrn(:),grnsel(:),ldegpsv(:),ldegsh(:)
      integer*4,allocatable:: nruku(:,:)
      integer*4,allocatable:: isg1(:),isg2(:),nsg(:)
      integer*4,allocatable:: idr(:,:)
      integer*4,allocatable:: lylwp(:),lylws(:),lylwt(:),
     &                        lyupp(:),lyups(:),lyupt(:)
      integer*4,allocatable:: ldegtap(:,:,:)
c
      real*8,allocatable:: latr(:),lonr(:),tred(:),grndep(:)
      real*8,allocatable:: sfr(:),sft(:),sfp(:),
     &                     mtt(:),mpp(:),mrr(:),mtp(:),mpr(:),mrt(:),
     &                     lats(:),lons(:),deps(:),togs(:),trss(:)
      real*8,allocatable:: dis(:,:),plm(:,:)
      real*8,allocatable:: dp0(:),dp0up(:),dp0lw(:),
     &                     vp0(:),vp0up(:),vp0lw(:),
     &                     vs0(:),vs0up(:),vs0lw(:),
     &                     ro0(:),ro0up(:),ro0lw(:),
     &                     qp0(:),qp0up(:),qp0lw(:),
     &                     qs0(:),qs0up(:),qs0lw(:)
      real*8,allocatable:: rrup(:),rrlw(:),vpup(:),vplw(:),
     &                     vsup(:),vslw(:),roup(:),rolw(:),
     &                     qpup(:),qplw(:),qsup(:),qslw(:)
      real*8,allocatable:: xp(:),xs(:),xt(:)
      real*8,allocatable:: tap(:),disk(:)
c
      complex*16,allocatable:: ul0(:,:),vl0(:,:),wl0(:,:),
     &                         el0(:,:),fl0(:,:),gl0(:,:),
     &                         pl0(:,:),ql0(:,:)
      complex*16,allocatable:: urlm(:,:,:),utlm(:,:,:),uplm(:,:,:),
     &       errlm(:,:,:),ertlm(:,:,:),erplm(:,:,:),etrlm(:,:,:),
     &       ett0lm(:,:,:),ettalm(:,:,:),ettblm(:,:,:),etp0lm(:,:,:),
     &       etpalm(:,:,:),etpblm(:,:,:),eprlm(:,:,:),ept0lm(:,:,:),
     &       eptalm(:,:,:),eptblm(:,:,:),epp0lm(:,:,:),eppalm(:,:,:),
     &       eppblm(:,:,:),grlm(:,:,:),gtlm(:,:,:),gplm(:,:,:)
      complex*16,allocatable:: ue(:,:),un(:,:),uz(:,:),
     &                      roe(:,:),ron(:,:),roz(:,:),
     &                      uee(:,:),uen(:,:),uez(:,:),
     &                      unn(:,:),unz(:,:),uzz(:,:),
     &                      see(:,:),sen(:,:),sez(:,:),
     &                      snn(:,:),snz(:,:),szz(:,:),
     &                      ge(:,:),gn(:,:),gz(:,:),gm(:,:)
      complex*16,allocatable:: ssa(:,:),ss2a(:,:),csa(:,:),cs2a(:,:),
     &                  ssb(:,:),csb(:,:),ssd(:,:),csd(:,:),ssf(:,:)
      complex*16,allocatable:: crrup(:),crrlw(:),
     &           cro(:),croup(:),crolw(:),cla(:),claup(:),clalw(:),
     &           cmu(:),cmuup(:),cmulw(:),cvp(:),cvpup(:),cvplw(:),
     &           cvs(:),cvsup(:),cvslw(:),cgr(:),cgrup(:),cgrlw(:),
     &           cga(:),cgaup(:),cgalw(:)
      complex*16,allocatable:: cps(:,:),cpt(:,:),kp(:),ks(:),kt(:)
      complex*16,allocatable:: mat2x2up(:,:,:),mat2x2lw(:,:,:),
     &        mat2x2inv(:,:,:),mas3x3up(:,:,:),mas3x3lw(:,:,:),
     &        mas3x3inv(:,:,:),mas4x4up(:,:,:),mas4x4lw(:,:,:),
     &        mas4x4inv(:,:,:),mas6x6up(:,:,:),mas6x6lw(:,:,:),
     &        mas6x6inv(:,:,:)
      complex*16,allocatable:: zjup(:,:,:),zjlw(:,:,:),
     &       zhup(:,:,:),zhlw(:,:,:),wj(:,:,:),wh(:,:,:),
     &       zh12p(:,:,:),zh12sv(:,:,:),zh12sh(:,:,:)
      complex*16,allocatable:: zjupg(:),zjlwg(:),
     &           zhupg(:),zhlwg(:),wjg(:),whg(:)
      complex*16,allocatable:: cua(:,:),cypnorm(:,:)
      complex*16,allocatable:: wvf(:,:)
      complex*16,allocatable:: sf1(:),sf2(:),sf3(:),
     &                         expl(:),clvd(:),ss12(:),
     &                         ss11(:),ds31(:),ds23(:)
c
      character*100,allocatable:: specfile(:),uspecfile(:),vspecfile(:),
     &  wspecfile(:),especfile(:),fspecfile(:),gspecfile(:),
     &  pspecfile(:),qspecfile(:)
      character*10,allocatable:: rname(:)
c
      end module

      subroutine qssublay(resolut,fcut)
      implicit none
c
      real*8 resolut(3),fcut
c
      include 'qsglobal.h'
c
c     work space
c
      integer*4 i,i0,l,ivp,ivs,iro
      real*8 dh,dro,dvp,dvs,dqp,dqs,z,dz,halfwvlen
c
      n0=0
      do l=1,l0-1
        dz=z2(l)-z1(l)
        dvp=2.d0*dabs(vp2(l)-vp1(l))/(vp2(l)+vp1(l))
        if(vs1(l).gt.vspmin*vp1(l))then
          dvs=2.d0*dabs(vs2(l)-vs1(l))/(vs2(l)+vs1(l))
        else
          dvs=0.d0
        endif
        dro=2.d0*dabs(ro2(l)-ro1(l))/(ro2(l)+ro1(l))
c
        if(dvp.le.0.d0)then
          ivp=1
        else
          halfwvlen=0.25d0*(vp2(l)+vp1(l))/fcut
          ivp=1+idint(dz/halfwvlen)
          if(resolut(1).gt.0.d0)ivp=min0(ivp,1+idint(dvp/resolut(1)))
        endif
        if(dvs.le.0.d0)then
          ivs=1
        else
          halfwvlen=0.25d0*(vs2(l)+vs1(l))/fcut
          ivs=1+idint(dz/halfwvlen)
          if(resolut(2).gt.0.d0)ivs=min0(ivs,1+idint(dvs/resolut(2)))
        endif
        iro=1
        if(dro.gt.0.d0.and.resolut(3).gt.0.d0)then
          iro=1+idint(dro/resolut(3))
        endif
c
        i0=max0(ivp,ivs,iro)
        dro=(ro2(l)-ro1(l))/dz
        dvp=(vp2(l)-vp1(l))/dz
        dvs=(vs2(l)-vs1(l))/dz
        dqp=(qp2(l)-qp1(l))/dz
        dqs=(qs2(l)-qs1(l))/dz
        dh=dz/dble(i0)
        do i=1,i0
          n0=n0+1
          if(n0.ge.lmax)then
            stop ' Max. number of layers (lmax) too small defined!'
          endif
          h(n0)=dh
          z=(dble(i)-0.5d0)*dh
          ro(n0)=ro1(l)+dro*z
          vp(n0)=vp1(l)+dvp*z
          vs(n0)=vs1(l)+dvs*z
          qp(n0)=qp1(l)+dqp*z
          qs(n0)=qs1(l)+dqs*z
        enddo
      enddo
c
c     last layer is halfspace
c
      n0=n0+1
      h(n0)=0.d0
      ro(n0)=ro1(l0)
      vp(n0)=vp1(l0)
      vs(n0)=vs1(l0)
      qp(n0)=qp1(l0)
      qs(n0)=qs1(l0)
c
c     for receiver site
c
      n0rs=0
      if(l0rs.gt.0)then
        do l=1,l0rs-1
          dz=z2rs(l)-z1rs(l)
          dvp=2.d0*dabs(vp2rs(l)-vp1rs(l))/(vp2rs(l)+vp1rs(l))
          if(vs1rs(l).gt.vspmin*vp1rs(l))then
            dvs=2.d0*dabs(vs2rs(l)-vs1rs(l))/(vs2rs(l)+vs1rs(l))
          else
            dvs=0.d0
          endif
          dro=2.d0*dabs(ro2rs(l)-ro1rs(l))/(ro2rs(l)+ro1rs(l))
c
          if(dvp.le.0.d0)then
            ivp=1
          else
            halfwvlen=0.25d0*(vp2rs(l)+vp1rs(l))/fcut
            ivp=1+idint(dz/halfwvlen)
            if(resolut(1).gt.0.d0)ivp=min0(ivp,1+idint(dvp/resolut(1)))
          endif
          if(dvs.le.0.d0)then
            ivs=1
          else
            halfwvlen=0.25d0*(vs2rs(l)+vs1rs(l))/fcut
            ivs=1+idint(dz/halfwvlen)
            if(resolut(2).gt.0.d0)ivs=min0(ivs,1+idint(dvs/resolut(2)))
          endif
          iro=1
          if(dro.gt.0.d0.and.resolut(3).gt.0.d0)then
            iro=1+idint(dro/resolut(3))
          endif
c
          i0=max0(ivp,ivs,iro)
          dro=(ro2rs(l)-ro1rs(l))/dz
          dvp=(vp2rs(l)-vp1rs(l))/dz
          dvs=(vs2rs(l)-vs1rs(l))/dz
          dqp=(qp2rs(l)-qp1rs(l))/dz
          dqs=(qs2rs(l)-qs1rs(l))/dz
          dh=dz/dble(i0)
          do i=1,i0
            n0rs=n0rs+1
            if(n0rs.ge.lmax)then
              stop ' Max. number of layers (lmax) too small defined!'
            endif
            hrs(n0rs)=dh
            z=(dble(i)-0.5d0)*dh
            rors(n0rs)=ro1rs(l)+dro*z
            vprs(n0rs)=vp1rs(l)+dvp*z
            vsrs(n0rs)=vs1rs(l)+dvs*z
            qprs(n0rs)=qp1rs(l)+dqp*z
            qsrs(n0rs)=qs1rs(l)+dqs*z
          enddo
        enddo
c
c       last layer is halfspace
c
        n0rs=n0rs+1
        hrs(n0rs)=0.d0
        rors(n0rs)=ro1rs(l0rs)
        vprs(n0rs)=vp1rs(l0rs)
        vsrs(n0rs)=vs1rs(l0rs)
        qprs(n0rs)=qp1rs(l0rs)
        qsrs(n0rs)=qs1rs(l0rs)
      endif
c
      return
      end

      subroutine qsgetinp(unit,srate,nssel)
      implicit none
      integer*4 unit,nssel
      real*8 srate
c
      include 'qsglobal.h'
c
c     work space
c
      integer*4 i,ir,istp,j,l,l1,lrs,lcut,n,ierr,iazi
      integer*4 irlast,irnow,is,ns
      integer*4 ieqdis,kmordeg,iv0,flen0,nup,nlw
      real*8 rr,z,pi,taunorm,rnow,rlast,tnow,tlast
      real*8 v00,depth,hpmin,vsliquid
      real*8 s1,s2,s,ds,smin,shead,twinmin
      real*8 r1,r2,dr,dm,t1,rdis
      real*8 mis,mcl,mdc,st,di,ra,deg2rad
      real*8 suppress,ros,vps,vss,fcut
      real*8 rot(3,3),sm(3,3),swap(3,3)
      real*8 resolut(3),t0(nrmax)
      character*80 outfile0(7),comments*180
c
c     source parameters
c     =================
c
      pi=4.d0*datan(1.d0)
      deg2rad=pi/180.d0
      call getdata(unit,comments)
      read(comments,*)zs
      zs=dmax1(0.d0,km2m*zs)
c
c     receiver parameters
c     ===================
c
      call getdata(unit,comments)
      read(comments,*)zr
      zr=km2m*zr
      call getdata(unit,comments)
      read(comments,*)ieqdis,kmordeg
      call getdata(unit,comments)
      read(comments,*)nr
      if(nr.gt.nrmax)then
        stop 'Error in input: nr > nrmax!'  
      endif
      if(kmordeg.eq.1)then
        dm=km2m
      else
        dm=(rr0-zr)*pi/180.d0
      endif
      if(ieqdis.eq.1.and.nr.gt.1)then
        read(unit,*)r1,r2
        if(nr.eq.1)then
          dr=0.d0
        else
          dr=(r2-r1)/dble(nr-1)
        endif
        do i=1,nr
          r(i)=dm*(r1+dr*dble(i-1))
        enddo
      else
        read(unit,*)(r(i),i=1,nr)
        do i=1,nr
          r(i)=dm*r(i)
        enddo
      endif
c
      call getdata(unit,comments)
      read(comments,*)tstart,twindow,nt
      if(twindow.le.0.d0.or.nt.le.0)then
        stop 'Error in input: time window or sampling no <= 0!'  
      endif
c
      call getdata(unit,comments)
      read(comments,*)iv0,v0
      if(iv0.eq.1)then
        v0=km2m*v0
      else if(v0.gt.0.d0)then
        v0=rr0*pi/180.d0/v0
        write(*,'(a,f10.4,a)')' Velocity for time reduction: ',
     &                        v0/km2m,' km/s'
      else
        v0=0.d0
      endif
c
c     wavenumber integration parameters
c     =================================
c
      call getdata(unit,comments)
      read(comments,*)ndtrans
      if(ndtrans.lt.0.or.ndtrans.gt.ndtransmax)then
        stop 'Error in input: wrong select of integration algorithm!'
      endif
      call getdata(unit,comments)
      read(comments,*)(slw(j),j=1,4)
      do j=1,4
        slw(j)=slw(j)/km2m
      enddo
      if(slw(1).lt.0.d0.or.slw(2).lt.0.d0.or.
     +   slw(3).le.0.d0.or.slw(4).le.0.d0.or.
     +   slw(2).lt.slw(1).or.slw(3).lt.slw(2).or.
     +   slw(4).lt.slw(3))then
        fullwave=.true.
      else
        fullwave=.false.
      endif
      call getdata(unit,comments)
      read(comments,*)srate
      if(srate.lt.1.d0)srate=1.d0
c
      call getdata(unit,comments)
      read(comments,*)suppress
      if(suppress.le.0.d0.or.suppress.ge.1.d0)then
        suppress=dexp(-1.d0)
        print *,'warning in qsmain: aliasing suppression'
        print *,'factor is replaced by the default value of 1/e.'
      endif
      fi=dlog(suppress)/(2.d0*pi*twindow)
c
c     partial solution parameters
c     ===========================
c
      call getdata(unit,comments)
      read(comments,*)isurf
      if(isurf.lt.0.or.isurf.gt.2)then
        stop 'Error: wrong switch for filtering surface reflection!'
      else if(isurf.eq.2.and.zr.gt.0.d0)then
        stop 'Error: filtering surface multiples for zr > 0!'
      endif
      call getdata(unit,comments)
      read(comments,*)ipath,pathdepth
      pathdepth=pathdepth*km2m
      if(ipath.eq.1.and.(pathdepth.lt.zs.or.pathdepth.lt.zr))then
        print *,'warning: condition for path filter is not satisfied,'
        print *,'==> path filter will not be selected!'
        ipath=0
      endif
      call getdata(unit,comments)
      read(comments,*)npar
      if(npar.ge.1)then
        ipartial=1
        do i=1,npar
          call getdata(unit,comments)
          read(comments,*)zup(i),zlow(i),ipsv(i)
          if(ipsv(i).le.0.or.ipsv(i).ge.5)then
            stop ' Error in qsmain: wrong partial solution selection!'
          endif
          zup(i)=zup(i)*km2m
          zlow(i)=zlow(i)*km2m
        enddo
      endif
c
c     wavelet parameters
c     ==================
c
      call getdata(unit,comments)
      read(comments,*)taunorm,wdeg
      if(wdeg.lt.0.or.wdeg.gt.2)then
        stop ' Error in qsmain: wrong wavelet selection!'
      else if(wdeg.eq.0)then
        call getdata(unit,comments)
        read(comments,*)nn0
        read(unit,*)(wv0(i),i=1,nn0)
      endif
c
c     seimometer parameters
c     =====================
c
      call getdata(unit,comments)
      read(comments,*)asm
      call getdata(unit,comments)
      read(comments,*)nroot
      read(unit,*)(root(i),i=1,nroot)
      call getdata(unit,comments)
      read(comments,*)npole
      read(unit,*)(pole(i),i=1,npole)
c
c     output files
c     ============
c
      varbtxt='U'
      call getdata(unit,comments)
      read(comments,*)(ssel(istp),istp=1,6)
      call getdata(unit,comments)
      read(comments,*)(outfile0(istp),istp=1,6)
      do istp=1,6
        if(ssel(istp).ne.1)ssel(istp)=0
        do flen0=80,1,-1
          if(outfile0(istp)(flen0:flen0).ne.' ')goto 100
        enddo
100     continue
        outfile(1,istp)=outfile0(istp)(1:flen0)//'.tz'
        outfile(2,istp)=outfile0(istp)(1:flen0)//'.tr'
        outfile(3,istp)=outfile0(istp)(1:flen0)//'.tt'
        outfile(4,istp)=outfile0(istp)(1:flen0)//'.tv'
        do i=1,4
          flen(i,istp)=flen0+3
        enddo
      enddo
      call getdata(unit,comments)
      read(comments,*)ssel(7)
      if(ssel(7).eq.1)then
        read(comments,*)ssel(7),(mtensor(i),i=1,6),outfile0(7)
      else if(ssel(7).eq.2)then
        read(comments,*)ssel(7),mis,mcl,mdc,st,di,ra,outfile0(7)
        st=st*deg2rad
        di=di*deg2rad
        ra=ra*deg2rad
c
c       use principal stress coordinates:
c       x: along T-axis
c       y: along N-axis
c       z: along P-axis (symmetry axis of CLVD)
c
        do i=1,3
          do j=1,3
            sm(i,j)=0.d0
          enddo
        enddo
        sm(1,1)=mis-0.5d0*mcl+mdc
        sm(2,2)=mis-0.5d0*mcl
        sm(3,3)=mis+mcl-mdc
c
c       construct the rotation matrix:
c       1. around x by -45 deg;
c       2. around z by rake angle
c       3. around x -dip angle;
c       4. around z by -strike angle.
c
        rot(1,1)=(dcos(st)*dcos(ra)
     &           +dsin(st)*(dcos(di)*dsin(ra)-dsin(di)))/dsqrt(2.d0)
        rot(1,2)=dcos(st)*dsin(ra)-dsin(st)*dcos(di)*dcos(ra)
        rot(1,3)=(dcos(st)*dcos(ra)
     &           +dsin(st)*(dcos(di)*dsin(ra)+dsin(di)))/dsqrt(2.d0)
        rot(2,1)=(dsin(st)*dcos(ra)
     &           -dcos(st)*(dcos(di)*dsin(ra)-dsin(di)))/dsqrt(2.d0)
        rot(2,2)=dsin(st)*dsin(ra)+dcos(st)*dcos(di)*dcos(ra)
        rot(2,3)=(dsin(st)*dcos(ra)
     &           -dcos(st)*(dcos(di)*dsin(ra)+dsin(di)))/dsqrt(2.d0)
        rot(3,1)=(-dsin(di)*dsin(ra)-dcos(di))/dsqrt(2.d0)
        rot(3,2)=dsin(di)*dcos(ra)
        rot(3,3)=(-dsin(di)*dsin(ra)+dcos(di))/dsqrt(2.d0)
c
        do i=1,3
          do j=1,3
            swap(i,j)=0.d0
            do l=1,3
              swap(i,j)=swap(i,j)+rot(i,l)*sm(l,j)
            enddo
          enddo
        enddo
        do i=1,3
          do j=1,3
            sm(i,j)=0.d0
            do l=1,3
              sm(i,j)=sm(i,j)+swap(i,l)*rot(j,l)
            enddo
          enddo
        enddo
        mtensor(1)=sm(1,1)
        mtensor(2)=sm(2,2)
        mtensor(3)=sm(3,3)
        mtensor(4)=sm(1,2)
        mtensor(5)=sm(2,3)
        mtensor(6)=sm(3,1)
      else
        do i=1,6
          mtensor(i)=0.d0
        enddo
        ssel(7)=0
      endif
      call getdata(unit,comments)
      read(comments,*)iazi
      if(iazi.eq.0)then
        read(unit,*)azimuth(1)
        do i=2,nr
          azimuth(i)=azimuth(1)
        enddo
      else
        read(unit,*)(azimuth(i),i=1,nr)
      endif
      do flen0=80,1,-1
        if(outfile0(7)(flen0:flen0).ne.' ')goto 200
      enddo
200   continue
      outfile(1,7)=outfile0(7)(1:flen0)//'.tz'
      outfile(2,7)=outfile0(7)(1:flen0)//'.tr'
      outfile(3,7)=outfile0(7)(1:flen0)//'.tt'
      outfile(4,7)=outfile0(7)(1:flen0)//'.tv'
      do i=1,4
        flen(i,7)=flen0+3
      enddo
c
      nssel=0
      do istp=1,7
        nssel=nssel+ssel(istp)
      enddo
      if(nssel.le.0)then
        stop ' Error in input file: no outputs selected!'
      endif
c
c     global model parameters
c     =======================
c
      call getdata(unit,comments)
      read(comments,*)iflat
      call getdata(unit,comments)
      read(comments,*)(resolut(i),i=1,3)
      do i=1,3
        if(resolut(i).le.0.d0)resolut(i)=0.1d0
        resolut(i)=1.d-02*resolut(i)
      enddo
      call getdata(unit,comments)
      read(comments,*)l
      if(l.gt.lmax)then
        stop ' Error in input: to large number of layers!'
      endif
c
c     multilayered model parameters
c     =============================
c
      do i=1,l
        call getdata(unit,comments)
        read(comments,*)j,h(i),vp(i),vs(i),ro(i),qp(i),qs(i)
c
c       input units:    -,km,  km/s, km/s, g/cm^3,-,-
c
        h(i)=km2m*h(i)
        vp(i)=km2m*vp(i)
        vs(i)=km2m*vs(i)
        ro(i)=km2m*ro(i)
        if(vs(i).le.vspmin*vp(i))vs(i)=0.9d0*vspmin*vp(i)
      enddo
c
      call getdata(unit,comments)
      read(comments,*)lrs
      if(lrs.gt.lmax)then
        stop ' Error in input: to large number of layers!'
      endif
c
c     multilayered model parameters
c     =============================
c
      do i=1,lrs
        call getdata(unit,comments)
        read(comments,*)j,hrs(i),vprs(i),vsrs(i),rors(i),qprs(i),qsrs(i)
c
c       input units:    -,km,  km/s, km/s, g/cm^3,-,-
c
        hrs(i)=km2m*hrs(i)
        vprs(i)=km2m*vprs(i)
        vsrs(i)=km2m*vsrs(i)
        rors(i)=km2m*rors(i)
        if(vsrs(i).le.vspmin*vprs(i))vsrs(i)=0.9d0*vspmin*vprs(i)
      enddo
      zrrs=zr
      if(lrs.gt.0)zr=hrs(lrs)
c
c     end of inputs
c     =============
c
      if(iflat.eq.1)then
c
c       flat earth transformation (Mueller, 1985)
c
        zs=rr0*dlog(rr0/(rr0-zs))
        zr=rr0*dlog(rr0/(rr0-zr))
        zrrs=rr0*dlog(rr0/(rr0-zrrs))
        if(ipartial.eq.1)then
          do i=1,npar
            zup(i)=rr0*dlog(rr0/(rr0-zup(i)))
            zlow(i)=rr0*dlog(rr0/(rr0-zlow(i)))
          enddo
        endif
        if(ipath.eq.1)then
          pathdepth=rr0*dlog(rr0/(rr0-pathdepth))
        endif
c
        do i=1,l
          rr=rr0-h(i)
          h(i)=rr0*dlog(rr0/rr)
          vp(i)=vp(i)*rr0/rr
          vs(i)=vs(i)*rr0/rr
          ro(i)=ro(i)*(rr/rr0)**ndens
        enddo
c
        do i=1,lrs
          rr=rr0-hrs(i)
          hrs(i)=rr0*dlog(rr0/rr)
          vprs(i)=vprs(i)*rr0/rr
          vsrs(i)=vsrs(i)*rr0/rr
          rors(i)=rors(i)*(rr/rr0)**ndens
        enddo
      endif
c
c     end of the flat earth transformation
c
      dt=twindow/dble(nt-1)
      nf=1
300   nf=2*nf
      if(nf.lt.nt)goto 300
      nf=nf/2
      if(nf.gt.nfmax)then
        print *,'Error in input: time sampling no > ',2*nfmax,'!'
        stop
      endif
      df=1.d0/(dble(2*nf)*dt)
      fcut=0.5d0/dt
      tau=taunorm*dt
      if(taunorm.le.0.d0)tau=2.d0*dt
c
      comptxt(1)='z'
      comptxt(2)='r'
      comptxt(3)='t'
      comptxt(4)='v'
      do j=1,nr
        i=j/1000
        rcvtxt(j)(1:1)=char(ichar('0')+i)
        i=mod(j,1000)/100
        rcvtxt(j)(2:2)=char(ichar('0')+i)
        i=mod(j,100)/10
        rcvtxt(j)(3:3)=char(ichar('0')+i)
        i=mod(j,10)
        rcvtxt(j)(4:4)=char(ichar('0')+i)
      enddo
c
c     determine upper und lower parameter values of each layer
c
      l0=1
      z1(l0)=0.d0
      do i=2,l
        if(h(i).gt.h(i-1))then
          z1(l0)=h(i-1)
          vp1(l0)=vp(i-1)
          vs1(l0)=vs(i-1)
          ro1(l0)=ro(i-1)
          qp1(l0)=qp(i-1)
          qs1(l0)=qs(i-1)
c
          z2(l0)=h(i)
          vp2(l0)=vp(i)
          vs2(l0)=vs(i)
          ro2(l0)=ro(i)
          qp2(l0)=qp(i)
          qs2(l0)=qs(i)
          l0=l0+1
        else
          z1(l0)=h(i)
          vp1(l0)=vp(i)
          vs1(l0)=vs(i)
          ro1(l0)=ro(i)
          qp1(l0)=qp(i)
          qs1(l0)=qs(i)
        endif
      enddo
      z1(l0)=h(l)
      vp1(l0)=vp(l)
      vs1(l0)=vs(l)
      ro1(l0)=ro(l)
      qp1(l0)=qp(l)
      qs1(l0)=qs(l)
c
c     determine upper und lower parameter values of each layer (receiver site)
c
      if(lrs.le.0)then
        l0rs=0
      else
        l0rs=1
        z1rs(l0rs)=0.d0
        do i=2,lrs
          if(hrs(i).gt.hrs(i-1))then
            z1rs(l0rs)=hrs(i-1)
            vp1rs(l0rs)=vprs(i-1)
            vs1rs(l0rs)=vsrs(i-1)
            ro1rs(l0rs)=rors(i-1)
            qp1rs(l0rs)=qprs(i-1)
            qs1rs(l0rs)=qsrs(i-1)
c
            z2rs(l0rs)=hrs(i)
            vp2rs(l0rs)=vprs(i)
            vs2rs(l0rs)=vsrs(i)
            ro2rs(l0rs)=rors(i)
            qp2rs(l0rs)=qprs(i)
            qs2rs(l0rs)=qsrs(i)
            l0rs=l0rs+1
          else
            z1rs(l0rs)=hrs(i)
            vp1rs(l0rs)=vprs(i)
            vs1rs(l0rs)=vsrs(i)
            ro1rs(l0rs)=rors(i)
            qp1rs(l0rs)=qprs(i)
            qs1rs(l0rs)=qsrs(i)
          endif
        enddo
        z1rs(l0rs)=hrs(lrs)
        vp1rs(l0rs)=vprs(lrs)
        vs1rs(l0rs)=vsrs(lrs)
        ro1rs(l0rs)=rors(lrs)
        qp1rs(l0rs)=qprs(lrs)
        qs1rs(l0rs)=qsrs(lrs)
c
        ipath=1
        pathdepth=dmax1(pathdepth,zr)
      endif
c
c     construction of sublayers at the cutoff frequency
c
      call qssublay(resolut,fcut)
      write(*,*)' The layered model of source site:'
      write(*,'(7a)')'    no ','  z(km)  ',
     &               '  vp(km/s) ','  vs(km/s) ',' ro(g/cm^3)',
     &               '    qp   ','    qs'
      depth=0.d0
      do i=1,n0
        if(vs(i).le.vspmin*vp(i))then
          vsliquid=0.d0
        else
          vsliquid=vs(i)
        endif
        write(*,1000)i,depth/km2m,vp(i)/km2m,
     &               vsliquid/km2m,ro(i)/km2m,qp(i),qs(i)
        depth=depth+h(i)
        if(i.lt.n0)then
          write(*,1000)i,depth/km2m,vp(i)/km2m,
     &               vsliquid/km2m,ro(i)/km2m,qp(i),qs(i)
        endif
      enddo
      if(n0rs.gt.0)then
        write(*,*)' The layered model of receiver site:'
        write(*,'(7a)')'    no ','  z(km)  ',
     &               '  vp(km/s) ','  vs(km/s) ',' ro(g/cm^3)',
     &               '    qp   ','    qs'
        depth=0.d0
        do i=1,n0rs
          if(vsrs(i).le.vspmin*vprs(i))then
            vsliquid=0.d0
          else
            vsliquid=vsrs(i)
          endif
          write(*,1000)i,depth/km2m,vprs(i)/km2m,
     &               vsliquid/km2m,rors(i)/km2m,qprs(i),qsrs(i)
          depth=depth+hrs(i)
          if(i.lt.n0rs)then
            write(*,1000)i,depth/km2m,vprs(i)/km2m,
     &               vsliquid/km2m,rors(i)/km2m,qprs(i),qsrs(i)
          endif
        enddo
      endif
c
      call qslayer(ierr)
      n=nno(ls)
      ros=ro(n)
      vps=vp(n)
      vss=vs(n)
      if(iflat.eq.1)then
        rr=rr0*dexp(-zs/rr0)
        ros=ros*(rr0/rr)**ndens
        vps=vps*rr/rr0
        vss=vss*rr/rr0
      endif
      call qssource(ros,vps,vss)
c
      if(v0.gt.0.d0)then
        v00=1.d0/v0
      else
        v00=0.d0
      endif
      do ir=1,nr
        t0(ir)=tstart+r(ir)*v00
      enddo
c
      hpmin=hp(min0(ls,lzr))
      smin=1.d0/vp(nno(min0(ls,lzr)))
      do l=min0(ls,lzr),max0(ls,lzr)-1
        if(smin.gt.1.d0/vp(nno(l)))then
          smin=1.d0/vp(nno(l))
          hpmin=hp(l)
        endif
      enddo
c
c     compare direct p, reflected p and head wave phase
c
      lcut=0
      do l=max0(ls,lzr),lp
c
        twinmin=twindow
c
c       1. direct or reflected p wave
c
        irlast=0
        rlast=0.d0
        tlast=0.d0
        do l1=min0(ls,lzr),max0(ls,lzr)-1
          tlast=tlast+hp(l1)/vp(nno(l1))
        enddo
        do l1=max0(ls,lzr),l-1
          tlast=tlast+2.d0*hp(l1)/vp(nno(l1))
        enddo
        s1=0.d0
        s2=smin/dsqrt(1.d0+0.5d0*(hpmin/r(nr))**2)
        ns=2*nr+10
        ds=s2/dble(ns)
        do is=1,ns
          s=s1+dble(is)*ds
          rnow=0.d0
          tnow=0.d0
          do l1=min0(ls,lzr),max0(ls,lzr)-1
            rdis=hp(l1)*s/dsqrt(1.d0/vp(nno(l1))**2-s**2)
            rnow=rnow+rdis
            tnow=tnow+dsqrt(rdis**2+hp(l1)**2)/vp(nno(l1))
          enddo
          do l1=max0(ls,lzr),l-1
            rdis=hp(l1)*s/dsqrt(1.d0/vp(nno(l1))**2-s**2)
            rnow=rnow+2.d0*rdis
            tnow=tnow+2.d0*dsqrt(rdis**2+hp(l1)**2)/vp(nno(l1))
          enddo
          irnow=irlast
          do ir=irlast+1,nr
            if(r(ir).gt.rnow)then
              goto 400
            else if(r(ir).ge.rlast)then
              t1=(tlast*(rnow-r(ir))+tnow*(r(ir)-rlast))
     &          /(rnow-rlast)
              irnow=ir
              twinmin=dmin1(twinmin,t1-t0(ir))
            endif
          enddo
400       rlast=rnow
          tlast=tnow
          irlast=irnow
        enddo
c
c       2. head wave
c
        shead=1.d0/vp(nno(l))
        if(smin.gt.shead)then
          rlast=0.d0
          tlast=0.d0
          do l1=min0(ls,lzr),max0(ls,lzr)-1
            rdis=hp(l1)*shead/dsqrt(1.d0/vp(nno(l1))**2-shead**2)
            rlast=rlast+rdis
            tlast=tlast+dsqrt(rdis**2+hp(l1)**2)/vp(nno(l1))
          enddo
          do l1=max0(ls,lzr),l-1
            rdis=hp(l1)*shead/dsqrt(1.d0/vp(nno(l1))**2-shead**2)
            rlast=rlast+2.d0*rdis
            tlast=tlast+2.d0*dsqrt(rdis**2+hp(l1)**2)/vp(nno(l1))
          enddo
          irlast=1
          do ir=1,nr
            if(r(ir).lt.rlast)irlast=ir+1
          enddo
          do ir=irlast,nr
            t1=tlast+shead*(r(ir)-rlast)
            twinmin=dmin1(twinmin,t1-t0(ir))
          enddo
          smin=shead
          hpmin=hp(l)
        endif
c
        if(twinmin.lt.twindow)lcut=l
      enddo
      if(lcut.lt.1)then
        stop ' time window too small!'
      else if(lcut.lt.lp)then
        lp=lcut
        hp(lp)=0.d0
        n0=nno(lp)
        write(*,'(a,i3)')' actually used number of layers: ',n0
      endif
c
c     for partial solution only
c
      do i=1,lp
        n=nno(i)
        pup(i)=.true.
        pdw(i)=.true.
        if(vs(n).gt.vspmin*vp(n))then
          svup(i)=.true.
          svdw(i)=.true.
          sh(i)=.true.
        else
          svup(i)=.false.
          svdw(i)=.false.
          sh(i)=.false.
        endif
      enddo
      if(ipartial.eq.1)then
        z=zr
        do i=1,lp-1
          z=z+0.5d0*hp(i)
          do j=1,npar
            if(z.ge.zup(j).and.z.le.zlow(j))then
              if(ipsv(j).eq.1)pup(i)=.false.
              if(ipsv(j).eq.2)pdw(i)=.false.
              if(ipsv(j).eq.3)svup(i)=.false.
              if(ipsv(j).eq.4)svdw(i)=.false.
            endif
          enddo
          z=z+0.5d0*hp(i)
        enddo
      endif
      if(ipath.eq.1)then
        z=dmax1(zs,zr)
        lpath=max0(ls,lzr)
        do i=max0(ls,lzr)+1,lp
          z=z+hp(i-1)
          if(pathdepth.ge.z)lpath=i
        enddo
        if(lpath.eq.lp)then
          print *,'the depth limit for path filter is too large!'
          print *,'=> no signals in the given time window!'
          stop
        endif
      else
        lpath=0
      endif
c
      write(*,'(a)')' The receiver distance profile:'
      do j=1,nr
        if(mod(j,8).eq.0)then
          write(*,'(f10.3)')r(j)/km2m
        else
          write(*,'(f10.3,$)')r(j)/km2m
        endif
      enddo
      write(*,'(a)')' km'
c
      do istp=1,7
        do i=1,4
          if(ssel(istp).ge.1)then
            fsel(i,istp)=1
          else
            fsel(i,istp)=0
          endif
        enddo
      enddo
c
c     no toroidal component if ms = 0
c
      do istp=1,6
        if(ms(istp).eq.0)fsel(3,istp)=0
      enddo
c
      calsh=ssel(2).eq.1.or.ssel(3).eq.1.or.ssel(6).eq.1
c
c     for marine seismic
c
      if(lzr.lt.lp)then
        nup=nno(lzr)
        nlw=nno(lzr+1)
        if(vs(nup).lt.vspmin*vp(nup).and.
     +     vs(nlw).lt.vspmin*vp(nlw))then
          do istp=1,7
            do i=1,3
              fsel(i,istp)=0
            enddo
          enddo
        endif
      endif
1000  format(i5,f12.2,3f11.4,2f8.1)
c
      return
      end

      module qpalloc
c===================================================================
c     allocatable variables
c===================================================================
c
c     LEGENDRE POLYNOMIALS TABLES
c     ===========================
c
c     plm = associated Legendre polynomials divided by sin(x)**m
c
      double precision, allocatable:: plm(:,:,:)
c
c     SPHERICAL BESSEL FUNCTIONS
c     ==========================
c
c     lylwpsv = starting layer number for psv solution
c     lylwsh = starting layer number for sh solution
c
c     integer lylwsh(0:ldegmax),lylwpsv(0:ldegmax)
c     integer lyupatm(0:ldegmax)
c     zj(x)=x*j_(n+1)(x)/[j_n(x)+ix*j_(n+1)(x)]
c     wj(xa,xb)=ln{[j_n(xa)+i*xa*j_(n+1)(xa)]/[j_n(xb)+i*xb*j_(n+1)(xb)]}
c     zh(x)=x*h_(n+1)(x)/h_n(x), where h_n(x) = j_n(x) + sign[im(x)]iy_n(x)
c     wh(xa,xb)=ln[h_n(xa)/h_n(xb)]
c
c      double complex zjup(0:ldegmax,lymax,3),zjlw(0:ldegmax,lymax,3)
c      double complex zhup(0:ldegmax,lymax,3),zhlw(0:ldegmax,lymax,3)
c      double complex wj(0:ldegmax,lymax,3),wh(0:ldegmax,lymax,3)
      integer, allocatable:: lylwsh(:)
      integer, allocatable:: lylwpsv(:)
      integer, allocatable:: lyupatm(:)
      double complex, allocatable:: zjup(:,:,:)
      double complex, allocatable:: zjlw(:,:,:)
      double complex, allocatable:: zhup(:,:,:)
      double complex, allocatable:: zhlw(:,:,:)
      double complex, allocatable:: wj(:,:,:)
      double complex, allocatable:: wh(:,:,:)
c
c     same as above but with gravity effect
c
c      double complex zjupg(0:ldegmax),zjlwg(0:ldegmax)
c      double complex zhupg(0:ldegmax),zhlwg(0:ldegmax)
c      double complex wjg(0:ldegmax),whg(0:ldegmax)
      double complex, allocatable:: zjupg(:)
      double complex, allocatable:: zjlwg(:)
      double complex, allocatable:: zhupg(:)
      double complex, allocatable:: zhlwg(:)
      double complex, allocatable:: wjg(:)
      double complex, allocatable:: whg(:)
c
c     GREEN FUNCTION PARAMETERS
c     =========================
c
c     yr,yt,yp = velocity Green's function spectra
c     (r,t,p = spherical coordinate system: radius, theta, phi)
c
c      complex*8 yr(0:ldegmax,4,0:ndmax),yt(0:ldegmax,4,0:ndmax)
c      complex*8 yp(0:ldegmax,4,0:ndmax)
c      double complex vgrnr(nfmax,nrmax,4),vgrnt(nfmax,nrmax,4)
c      double complex vgrnp(nfmax,nrmax,4)
      complex*8, allocatable:: yr(:,:,:)
      complex*8, allocatable:: yt(:,:,:)
      complex*8, allocatable:: yp(:,:,:)
      double complex, allocatable:: vgrnr(:,:,:)
      double complex, allocatable:: vgrnt(:,:,:)
      double complex, allocatable:: vgrnp(:,:,:)
c
      end module

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Function: spbpsy                                                          c
c     calculates eq.(103) of Takeuchi & Saito related to spherical Bessel       c
c     functions for complex argument                                            c
c                                                                               c
c     Input:                                                                    c
c     n = order                                                                 c
c     x = complex argument                                                      c
c                                                                               c
c     Return:                                                                   c
c     psy(n,x)=-[1+y_(n)(x)*x^(n+1)/(2*n-1)!!]*2*(2*n-1)/x^2                    c
c     for |x/2|^2 << n                                                          c
c                                                                               c
c     First implemention: 17 June 2007                                          c
c     Rongjiang Wang                                                            c
c     GeoForschungsZentrum Potsdam, Germany                                     c
c     Email: wang@gfz-potsdam.de                                                c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      complex*16 function spbpsy(n,x)
      implicit none
	integer*4 n
	complex*16 x
c
c     local memory
c
      integer*4 i
      complex*16 cx2,fn,cy
c
      real*8 eps
      data eps/1.0d-08/
c
      cx2=(0.5d0,0.d0)*x*x
      i=0
      fn=(1.d0,0.d0)
      cy=(1.d0,0.d0)
100   i=i+1
      fn=-fn*cx2/dcmplx(dble((2*(i-n)+1)*(i+1)),0.d0)
      cy=cy+fn
      if(cdabs(fn).gt.eps*cdabs(cy))goto 100
c
      spbpsy=cy
c
      return
      end

c*******************************************************************************
c*******************************************************************************
        subroutine gemp(a,b,n,n1,eps,key)
        implicit none
c-------------------------------------------------------------------------------
c       subroutine gemp to solve linear equation system                        i
c       a: coefficient matrix(n,n);                                            i
c       b: right-hand matrix(n,n1) by input,                                   i
c          solution matrix(n,n1) by return;                                    i
c       eps: control constant;                                                 i
c       key: the main term of a column                                         i
c            smaller than eps, key=0: anormal return,                          i
c            else key=1: normal return.                                        i
c-------------------------------------------------------------------------------
        integer n,n1,key
        double precision eps
        double precision a(n,n),b(n,n1)
c
        integer i,j,k,l,m
        double precision p
        double precision q
c
        do m=1,n
          p=0.d0
          do i=m,n
            do j=1,n
              if(dabs(a(i,j)).le.p)goto 10
              p=dabs(a(i,j))
              k=i
              l=j
10          continue
            enddo
          enddo
          key=0
          if(p.le.eps)return
          do j=1,n
            q=a(k,j)
            a(k,j)=a(m,j)
            a(m,j)=q
          enddo
          do j=1,n1
            q=b(k,j)
            b(k,j)=b(m,j)
            b(m,j)=q
          enddo
          do i=1,n
            q=-a(i,l)/a(m,l)
            if(i.eq.m)goto 20
            do j=1,n
              a(i,j)=a(i,j)+a(m,j)*q
            enddo
            do j=1,n1
              b(i,j)=b(i,j)+b(m,j)*q
            enddo
20          continue
          enddo
          q=a(m,l)
          do j=1,n
            a(m,j)=a(m,j)/q
          enddo
          do j=1,n1
            b(m,j)=b(m,j)/q
          enddo
        enddo
        do j=1,n
          do i=1,n
            if(a(i,j).lt.0.5d0)goto 30
            do k=1,n
              q=a(i,k)
              a(i,k)=a(j,k)
              a(j,k)=q
            enddo
            do k=1,n1
              q=b(i,k)
              b(i,k)=b(j,k)
              b(j,k)=q
            enddo
30          continue
          enddo
        enddo
        key=1
        return
        end

      subroutine qpstart6g(ldeg,ly,jh,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c
      integer*4 ldeg,ly,jh
      complex*16 cy(6,3)
c
      integer*4 i,j
c
      if(jh.eq.0.and.ly.ge.lys)then
        if(lylwa.gt.0.or.lylwb.le.ly0)then
          do j=1,3
            do i=1,6
              cy(i,j)=mas6x6up(i,2*j-1,ly)
            enddo
          enddo
        else
          call qpstart6(ldeg,ly,cy)
        endif
      else if(jh.eq.1.and.ly.ge.lys.or.jh.eq.2.and.ly.le.lys)then
        call qpstart6a(ldeg,ly,jh,cy)
      else
        stop ' Error in qpstart6g: bad jh value!'
      endif
c
      return
      end

	subroutine edgbstab(n)
	implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	integer n
c
	include 'edgglobal.h'
c
c 	table of J_n(x), dJ_n(x)/dx and n*J_n(x)/x
c	all multiplied by sqrt(x)
c
	double precision bsdx,bsfct(0:nnbess1,3)
	common /bessels/ bsdx,bsfct
c
	double precision pi,pi2
	data pi,pi2/3.14159265358979d0,6.28318530717959d0/
	integer i,j
	double precision x,xsqrt,a,b
	double precision bessj0,bessj1,bessj
c
	do j=1,3
	  bsfct(0,j)=0.d0
	enddo
	bsdx=pi2/dble(ndbess)
	if(n.eq.0)then
	  do i=1,nnbess1
	    x=bsdx*dble(i)
	    xsqrt=dsqrt(x)
	    bsfct(i,1)=xsqrt*bessj0(x)
	    bsfct(i,2)=-xsqrt*bessj1(x)
	    bsfct(i,3)=0.d0
	  enddo
	else if(n.eq.1)then
	  do i=1,nnbess1
	    x=bsdx*dble(i)
	    xsqrt=dsqrt(x)
	    bsfct(i,1)=xsqrt*bessj1(x)
	    a=xsqrt*bessj0(x)
	    b=xsqrt*bessj(2,x)
	    bsfct(i,2)=0.5d0*(a-b)
	    bsfct(i,3)=0.5d0*(a+b)
	  enddo
	else if(n.eq.2)then
	  do i=1,nnbess1
	    x=bsdx*dble(i)
	    xsqrt=dsqrt(x)
	    bsfct(i,1)=xsqrt*bessj(2,x)
	    a=xsqrt*bessj1(x)
	    b=xsqrt*bessj(3,x)
	    bsfct(i,2)=0.5d0*(a-b)
	    bsfct(i,3)=0.5d0*(a+b)
	  enddo
	else
	  stop ' Error in edgbstab: check 0<= n <= 2?'
	endif
c
	return
	end

	subroutine getdata(unit,line)
	implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	integer unit
	character line*180,char*1
c
	integer i
c
c	this subroutine reads over all comment lines starting with "#".
c
	char='#'
100	continue
	if(char.eq.'#')then
	  read(unit,'(a)')line
	  i=1
	  char=line(1:1)
200	  continue
	  if(char.eq.' ')then
	    i=i+1
	    char=line(i:i)
	    goto 200
	  endif
	  goto 100
	endif
c
	return
	end

        subroutine edgmatrix(a,m,k,z,n)
        implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
        integer m,n
        double precision k,z
        double precision a(m,m)
c
	include 'edgglobal.h'
c       
c       model parameter:
c       n0: number of model layers
c
        integer n0
        double precision h(lmax),ro(lmax),vp(lmax),vs(lmax)
        common /model/ h,ro,vp,vs,n0
c
        double precision x,la,mu,eta,alfa
c
        if(m.ne.4)then
          stop ' Error in edgmatrix: n != 4'
        endif
        x=k*z
	mu=ro(n)*vs(n)**2
	la=ro(n)*vp(n)**2-2.d0*mu
        eta=mu/(la+mu)
	alfa=2.d0*mu*k
        a(1,1)=1.d0
        a(1,2)=-1.d0
        a(1,3)=-x+1.d0+2.d0*eta
        a(1,4)=x+1.d0+2.d0*eta
        a(2,1)=alfa
        a(2,2)=alfa
        a(2,3)=alfa*(-x+1.d0+eta)
        a(2,4)=-alfa*(x+1.d0+eta)
        a(3,1)=1.d0
        a(3,2)=1.d0
        a(3,3)=-x
        a(3,4)=-x
        a(4,1)=alfa
        a(4,2)=-alfa
        a(4,3)=alfa*(-x+eta)
        a(4,4)=alfa*(x+eta)
c
        return
        end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Subroutine: spbh12                                                        c
c     calculates spherical Bessel functions for complex argument                c
c     zh^(1,2)(x)=x*h^(1,2)_(n+1)(x)/h^(1,2)_n(x),                              c
c     for harmonic degree nn                                                    c
c                                                                               c
c     Input:                                                                    c
c     nn = max. order                                                           c
c                                                                               c
c     Output:                                                                   c
c     complex zh^(1,2)(n,x)                                                     c
c             for n = 0, ..., nn                                                c
c                                                                               c
c     First implemention: 29 November 2016                                      c
c     Rongjiang Wang                                                            c
c     GeoForschungsZentrum Potsdam, Germany                                     c
c     Email: wang@gfz-potsdam.de                                                c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine spbh12(n,nmax,cx,zh12)
      implicit none
      integer*4 n,nmax
      complex*16 cx
      complex*16 zh12(0:nmax,2)
c
c     local memory
c
      integer*4 i
      complex*16 cx2
c
      cx2=cx*cx
c
      zh12(0,1)=(1.d0,0.d0)-(0.d0,1.d0)*cx
      zh12(0,2)=(1.d0,0.d0)+(0.d0,1.d0)*cx
c
      do i=1,n
        zh12(i,1)=dcmplx(dble(2*i+1),0.d0)-cx2/zh12(i-1,1)
        zh12(i,2)=dcmplx(dble(2*i+1),0.d0)-cx2/zh12(i-1,2)
      enddo
c
      return
      end

      subroutine qpshkern(f,ldeg,ysh)
      use qpalloc
      implicit none
c
c     calculation of response function in frequency-wavelength domain
c     ldeg: harmonic degree
c     ysh(2,2): sh solution vector (complex)
c
      integer*4 ldeg
      real*8 f
      complex*16 ysh(2,2)
c
      integer*4 i,j,ly,istp,lyup,lylw,lwup
      real*8 xmin
      complex*16 cldeg,cll1,cruplw,cxt
c
      complex*16 c1,c2
      data c1,c2/(1.d0,0.d0),(2.d0,0.d0)/
c
      do istp=1,2
        do i=1,2
          ysh(i,istp)=(0.d0,0.d0)
        enddo
      enddo
c
      lyup=lyupt(ldeg)
      lylw=min0(lylwb,lylwt(ldeg))
c
      if(ldeg.le.1.or.lyr.lt.lyup.or.lyr.gt.lylw.or.lylw.lt.lylwa)return
c
      if(.not.setzh12t)then
        if(lys.ge.lycc)then
          do ly=lycc,ly0
            cxt=kt(ly)*crrup(ly)
            call spbh12(ldegpsv(ly),ldegmax,cxt,zh12sh(0,1,ly))
          enddo
        else
          do ly=lyob,min0(lycm-1,ly0)
            cxt=kt(ly)*crrup(ly)
            call spbh12(ldegpsv(ly),ldegmax,cxt,zh12sh(0,1,ly))
          enddo
        endif
        setzh12t=.true.
      endif
c
      xmin=dsqrt(2.d0*dble(2*ldeg+1))
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      cll1=cldeg*(cldeg+c1)
c
      do ly=lyup,lylw
        if(vsup(ly).gt.0.d0)then
          if(rrlw(ly).gt.0.d0)then
            cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
          else
            cruplw=(0.d0,0.d0)
          endif
          if(xt(ly).le.xmin)then
            ksmallt(ly)=.true.
            wj(ldeg,ly,3)=cldeg*cruplw
            wh(ldeg,ly,3)=-(cldeg+c1)*cruplw
          else if(ksmallt(ly))then
            ksmallt(ly)=.false.
            call spbjh(ldegsh(ly),kt(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,3),zjlw(0,ly,3),wj(0,ly,3),
     &                 zhup(0,ly,3),zhlw(0,ly,3),wh(0,ly,3))
          endif
        endif
      enddo
c
      do ly=lyup,lylw
        if(vsup(ly).gt.0.d0)then
          if(ly.lt.lys)then
            lwup=0
            cpt(1,ly)=-wj(ldeg,ly,3)
            cpt(2,ly)=-wh(ldeg,ly,3)
          else
            lwup=1
            cpt(1,ly)=wj(ldeg,ly,3)
            cpt(2,ly)=wh(ldeg,ly,3)
          endif
          call qptmat(ldeg,ly,lylw,lwup)
        endif
      enddo
c
      call qptprop(ldeg,ysh,lyup,lylw)
c
      return
      end

      subroutine qpfftinv(ierr)
      use qpalloc
      implicit none
      integer*4 ierr
c
      integer*4 lf,mf,it
      real*8 t,a,b
c
      do lf=1,nf
        cswap(lf)=sgrn(lf)*cdexp(dcmplx(-fi,dble(lf-1)*df)
     &                         *dcmplx(PI2*tred,0.d0))
      enddo
c
      mf=1
      do lf=2*nf,nf+2,-1
        mf=mf+1
        cswap(lf)=dconjg(cswap(mf))
      enddo
      cswap(nf+1)=(0.d0,0.d0)
c
c     convention for Fourier transform:
c     f(t)=\int F(f) exp(i2\pi f t) df
c
      call four1w(cswap,dswap,2*nf,+1)
      do lf=1,2*nf
        t=dble(lf-1)*dt
        cswap(lf)=cswap(lf)*dcmplx(dexp(-PI2*fi*t)*df,0.d0)
      enddo
c
      do it=1,ntout
        t=dble(it-1)*dtout
        lf=1+int(t/dt)
        if(lf.lt.2*nf)then
          b=t/dt-dble(lf-1)
          a=1.d0-b
          tgrn(it)=sngl(a*dreal(cswap(lf))+b*dreal(cswap(lf+1)))
        else
          tgrn(it)=sngl(dreal(cswap(lf)))
        endif
      enddo
      return
      end

      subroutine qpmaxdeg(ierr)
      use qpalloc
      implicit none
      integer*4 ierr
c
c     work space
c
      integer*4 ig,ly
      real*8 ray,raymin,raymax
c
      if(fullwave)then
        ldegmin=ldeg0
        raymax=0.d0
        do ig=1,ngrn
          lys=lygrn(ig)
          raymin=0.d0
          do ly=min0(lyr,lys),max0(lyr,lys)
            if(vsup(ly).gt.0.d0)then
              ray=rrup(ly)/vsup(ly)
            else
              ray=rrup(ly)/vpup(ly)
            endif
            if(raymin.le.0.d0.or.raymin.gt.ray)raymin=ray
            if(ly.gt.1)then
              if(vslw(ly-1).gt.0.d0)then
                ray=rrup(ly)/vslw(ly-1)
              else
                ray=rrup(ly)/vplw(ly-1)
              endif
              if(raymin.le.0.d0.or.raymin.gt.ray)raymin=ray
            endif
          enddo
          slwmax=dmax1(slwmax,raymin/rrup(lys))
        enddo
        slwmax=slwfac*slwmax
      else
        ldegmin=ldeg1+ndmax
      endif
c
      ldegmax=1+ldegmin+idnint(REARTH*PI2*fcut*slwmax)
c
      allocate(yr(0:ldegmax,4,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpmaxdeg: yr not allocated!'
      allocate(yt(0:ldegmax,4,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpmaxdeg: yp not allocated!'
      allocate(yp(0:ldegmax,4,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpmaxdeg: yt not allocated!'
c
      return
      end

	subroutine disazi(rearth,lateq,loneq,latst,lonst,xnorth,yeast)
	implicit none
c
	real*8 rearth,lateq,loneq,latst,lonst,xnorth,yeast
c
	integer*4 iangle
	real*8 latb,lonb,latc,lonc,angleb,anglec
	real*8 dis,a,b,c,s,aa
c
	real*8 PI,PI2,DEGTORAD
	data PI,PI2/3.14159265358979d0,6.28318530717959d0/
	data DEGTORAD/1.745329251994328d-02/
c
c	A is north pole
c     B is station
c     C is epicentre (local cartesian coordinate origin)
c
	latb=lateq*DEGTORAD
	lonb=loneq*DEGTORAD
	latc=latst*DEGTORAD
	lonc=lonst*DEGTORAD
c
	if(lonb.lt.0.d0)lonb=lonb+PI2
	if(lonc.lt.0.d0)lonc=lonc+PI2
c
	b=0.5d0*PI-latb
	c=0.5d0*PI-latc
	if(lonc.gt.lonb)then
	  aa=lonc-lonb
	  if(aa.le.PI)then
	    iangle=1
	  else
	    aa=PI2-aa
	    iangle=-1
	  endif
	else
	  aa=lonb-lonc
	  if(aa.le.PI)then
	    iangle=-1
	  else
	    aa=PI2-aa
	    iangle=1
	  endif
	endif
	s=dcos(b)*dcos(c)+dsin(b)*dsin(c)*dcos(aa)
	a=dacos(dsign(dmin1(dabs(s),1.d0),s))
	dis=a*rearth
	if(a*b*c.eq.0.d0)then
	  angleb=0.d0
	  anglec=0.d0
	else
	  s=0.5d0*(a+b+c)
	  a=dmin1(a,s)
	  b=dmin1(b,s)
	  c=dmin1(c,s)
	  anglec=2.d0*dasin(dmin1(1.d0,
     &            dsqrt(dsin(s-a)*dsin(s-b)/(dsin(a)*dsin(b)))))
	  angleb=2.d0*dasin(dmin1(1.d0,
     &            dsqrt(dsin(s-a)*dsin(s-c)/(dsin(a)*dsin(c)))))
	  if(iangle.eq.1)then
	    angleb=PI2-angleb
	  else
	    anglec=PI2-anglec
	  endif
	endif
c
c	cartesian coordinates of the station
c
	xnorth=dis*dcos(anglec)
	yeast=dis*dsin(anglec)
c
	return
	end

      subroutine transfs2t(nf,nr,df,t0,dt,dtout,fi,shift,cy0,cy,
     &                     cswap,dswap,iof,ntcutout,rname,y0,y,outfile)
      implicit none
c
      integer*4 nf,nr,iof,ntcutout
      real*8 df,t0,dt,dtout,fi
      real*8 shift(nr),dswap(4*nf),y0(nr),y(nr)
      complex*16 cy0(nf,nr),cy(nf,nr),cswap(2*nf)
      character*10 rname(nr)
      character*100 outfile
c
      real*8 PI2
      data PI2/6.28318530717959d0/
c
      integer*4 ir,lf,mf,it,itout
      real*8 t,sr,si,a,b
      complex*16 s
c
      do ir=1,nr
        do lf=1,nf
          s=dcmplx(-fi,dble(lf-1)*df)*dcmplx(PI2*shift(ir),0.d0)
          cswap(lf)=cy0(lf,ir)*cdexp(s)
        enddo
        mf=1
        do lf=2*nf,nf+2,-1
          mf=mf+1
          cswap(lf)=dconjg(cswap(mf))
        enddo
        cswap(nf+1)=(0.d0,0.d0)
c
c       convention for Fourier transform:
c       f(t)=\int F(f) exp(i2\pi f t) df
c
        call four1w(cswap,dswap,2*nf,+1)
c
        do lf=1,2*nf
          t=dble(lf-1)*dt
          cswap(lf)=cswap(lf)*dcmplx(dexp(-PI2*fi*t)*df,0.d0)
        enddo
c
        do lf=1,(ntcutout+1)/2
          t=dble(2*lf-1)*dtout
          it=1+idint(t/dt)
          if(it.ge.2*nf)then
            sr=dreal(cswap(2*nf))
          else
            b=dmod(t,dt)/dt
            a=1.d0-b
            sr=a*dreal(cswap(it))+b*dreal(cswap(it+1))
          endif
c
          t=dble(2*lf)*dtout
          it=1+idint(t/dt)
          if(it.ge.2*nf)then
            si=dreal(cswap(2*nf))
          else
            b=dmod(t,dt)/dt
            a=1.d0-b
            si=a*dreal(cswap(it))+b*dreal(cswap(it+1))
          endif
c
          cy(lf,ir)=dcmplx(sr,si)
        enddo
      enddo
c
      open(20,file=outfile,status='unknown')
      write(20,'(a,$)')' TIME       '
      do ir=1,nr-1
        write(20,'(a16,$)')rname(ir)
      enddo
      write(20,'(a16)')rname(nr)
      if(iof.eq.0)then
        do ir=1,nr
          y(ir)=0.d0
        enddo
        do it=1,ntcutout
          t=t0+dble(it-1)*dtout
          write(20,'(f12.3,$)')t
          do ir=1,nr-1
            write(20,'(E16.8,$)')y(ir)
          enddo
          write(20,'(E16.8)')y(nr)
          lf=(it+1)/2
          if(it.gt.2*(it/2))then
            do ir=1,nr
              y(ir)=y(ir)+dreal(cy(lf,ir))*dtout
            enddo
          else
            do ir=1,nr
              y(ir)=y(ir)+dimag(cy(lf,ir))*dtout
            enddo
          endif
        enddo
      else if(iof.eq.1)then
        do it=1,ntcutout
          t=t0+dble(it-1)*dtout
          write(20,'(f12.3,$)')t
          lf=(it+1)/2
          if(it.gt.2*(it/2))then
            do ir=1,nr
              y(ir)=dreal(cy(lf,ir))
            enddo
          else
            do ir=1,nr
              y(ir)=dimag(cy(lf,ir))
            enddo
          endif
          do ir=1,nr-1
            write(20,'(E16.8,$)')y(ir)
          enddo
          write(20,'(E16.8)')y(nr)
        enddo
      else if(iof.eq.2)then
        do ir=1,nr
          y0(ir)=dreal(cy(1,ir))
        enddo
        do it=1,ntcutout
          t=t0+dble(it-1)*dtout
          lf=(it+1)/2
          if(it.gt.2*(it/2))then
            do ir=1,nr
              y(ir)=dreal(cy(lf,ir))
            enddo
          else
            do ir=1,nr
              y(ir)=dimag(cy(lf,ir))
            enddo
          endif
          write(20,'(f12.3,$)')t
          do ir=1,nr-1
            write(20,'(E16.8,$)')(y(ir)-y0(ir))/dtout
          enddo
          write(20,'(E16.8)')(y(nr)-y0(nr))/dtout
          do ir=1,nr
            y0(ir)=y(ir)
          enddo
        enddo
      else
        stop ' Error in transfs2t: bad iof value!'
      endif
      close(20)
      return
      end

      subroutine qpgetinp(unit)
      use qpalloc
      implicit none
      integer unit
c
c     work space
c
      integer*4 i,j,l,ir,ig,isg,is,is1,flen,iswap,nhypo,sdfsel,ierr
      integer*4 ipath,isurf
      real*8 twindow,twinout,suppress,munit,sfe,sfn,sfz,omi
      real*8 strike,dip,rake,depdif,dswap(14)
      character*100 grndir,outfile,fswap
c
c     uniform receiver depth
c     ======================
c
      lyadd=1
c
      call skipdoc(unit)
      read(unit,*)dpr
      dpr=KM2M*dpr
c
c     time (frequency) sampling
c     =========================
c
      call skipdoc(unit)
      read(unit,*)twindow,dtout
      ntcut=1+idnint(twindow/dtout)
      nt=2
100   nt=2*nt
      if(nt.lt.ntcut)goto 100
      dt=twindow/dble(nt-1)
      nf=nt/2
      df=1.d0/(dble(nt)*dt)
c
      call skipdoc(unit)
      read(unit,*)fcut
      nfcut=min0(nf,1+idnint(fcut/df))
      fcut=dble(nfcut-1)*df
      call skipdoc(unit)
      read(unit,*)slwmax
      if(slwmax.le.0.d0)then
        stop ' Error in qpgetinp: bad selection of max. slowness!'
      else
        slwmax=slwmax/KM2M
      endif
c
      call skipdoc(unit)
      read(unit,*)suppress
      if(suppress.le.0.d0.or.suppress.ge.1.d0)then
        suppress=dexp(-1.d0)
      endif
      fi=dlog(suppress)*df/PI2
      call skipdoc(unit)
      read(unit,*)ipath,minpath,maxpath
      minpath=minpath*KM2M
      maxpath=maxpath*KM2M
      call skipdoc(unit)
      read(unit,*)rearth,isurf
      rearth=rearth*KM2M
      freesurf=isurf.eq.1
      if(ipath.ne.1)then
        ipatha=0
        ipathb=0
        minpath=0.d0
        maxpath=rearth
      else
        if(minpath.lt.dpr.or.minpath.ge.dmax1(rearth,maxpath))then
          ipatha=0
          minpath=0.d0
        else
          ipatha=1
          lyadd=lyadd+1
        endif
        if(maxpath.ge.rearth.or.maxpath.le.minpath)then
          ipathb=0
          maxpath=rearth
        else
          ipathb=1
          lyadd=lyadd+1
        endif
      endif
c
c     cutoffs of spectra
c     ==================
c
      call skipdoc(unit)
      read(unit,*)fgr,ldeggr
      if(fgr.lt.0.d0)fgr=0.d0
      if(ldeggr.lt.0)ldeggr=0
      if(fgr.gt.0.d0.and.ldeggr.le.0.or.
     &   fgr.le.0.d0.and.ldeggr.gt.0)then
        stop ' Bad fgr and ldeggr combination!'
      endif
      nogravity=fgr*dble(ldeggr).le.0.d0
c
      call skipdoc(unit)
      read(unit,*)i,j,ldegmin,ldegcut
      selpsv=i.eq.1
      selsh=j.eq.1
      if(.not.(selpsv.or.selsh))then
        stop ' Error in qpgetinp: none of PSV and SH is selected!'
      endif
      if(ldegcut.lt.ldegmin)ldegcut=ldegmin
      ldegmin=min0(max0(1+ndmax,ldegmin),ldegcut)
      ldegmax=ldegcut+1+ndmax
c
      omi=PI*fcut
      if(idint(rearth*omi*slwmax).gt.ldegmax)then
        write(*,'(a)')' Warning from qpgrnspec:'
        write(*,'(a)')' Maximum harmonic degree not large enough!'
        write(*,'(a,i6)')' Suggestion: increase the max. degree to >= ',
     &                   1+idint(rearth*omi*slwmax)
        write(*,'(a,f10.5,a)')' ... or decrease frequency cutoff to <=',
     &                   dble(ldegcut)/(rearth*PI2*slwmax),' Hz'
        write(*,'(a,f10.5,a)')' ... or decrease slowness cutoff to <=',
     &                   dble(ldegcut)*KM2M/(rearth*omi),' s/km'
        stop
      endif
c
      allocate(plm(0:ldegmax,0:2),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: plm not allocated!'
c
      allocate(ul0(0:ldegmax,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: ul0 not allocated!'
      allocate(vl0(0:ldegmax,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: vl0 not allocated!'
      allocate(wl0(0:ldegmax,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: wl0 not allocated!'
      allocate(el0(0:ldegmax,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: el0 not allocated!'
      allocate(fl0(0:ldegmax,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: fl0 not allocated!'
      allocate(gl0(0:ldegmax,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: gl0 not allocated!'
c
      allocate(pl0(0:ldegmax,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: pl0 not allocated!'
      allocate(ql0(0:ldegmax,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: ql0 not allocated!'
c
      allocate(urlm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: urlm not allocated!'
      allocate(utlm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: utlm not allocated!'
      allocate(uplm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: uplm not allocated!'
c
      allocate(grlm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: grlm not allocated!'
      allocate(gtlm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: gtlm not allocated!'
      allocate(gplm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: gplm not allocated!'
c
      allocate(errlm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: errlm not allocated!'
      allocate(ertlm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: ertlm not allocated!'
      allocate(erplm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: erplm not allocated!'
      allocate(etrlm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: etrlm not allocated!'
      allocate(ett0lm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: ett0lm not allocated!'
      allocate(ettalm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: ettalm not allocated!'
      allocate(ettblm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: ettblm not allocated!'
      allocate(etp0lm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: etp0lm not allocated!'
      allocate(etpalm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: etpalm not allocated!'
      allocate(etpblm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: etpblm not allocated!'
      allocate(eprlm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: eprlm not allocated!'
      allocate(ept0lm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: ept0lm not allocated!'
      allocate(eptalm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: eptalm not allocated!'
      allocate(eptblm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: eptblm not allocated!'
      allocate(epp0lm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: epp0lm not allocated!'
      allocate(eppalm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: eppalm not allocated!'
      allocate(eppblm(0:ldegmax,6,0:ndmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgetinp: eppblm not allocated!'
c
      allocate(lyupp(0:ldegmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lyupp not allocated!'
      allocate(lyups(0:ldegmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lyups not allocated!'
      allocate(lyupt(0:ldegmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lyupt not allocated!'
      allocate(lylwp(0:ldegmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lylwp not allocated!'
      allocate(lylws(0:ldegmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lylws not allocated!'
      allocate(lylwt(0:ldegmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lylwt not allocated!'
c
c     Green's function files
c     ======================
c
      call skipdoc(unit)
      read(unit,*)ngrn,rr0,grndir
      if(ngrn.le.0)then
        stop ' bad number of source depths!'
      endif
      rr0=rr0*KM2M
      lyadd=lyadd+ngrn
c
      allocate(grndep(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: grndep not allocated!'
      allocate(grnsel(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: grnsel not allocated!'
      allocate(lygrn(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lygrn not allocated!'
c
      allocate(specfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: specfile not allocated!'
      allocate(uspecfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: uspecfile not allocated!'
      allocate(vspecfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: vspecfile not allocated!'
      allocate(wspecfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: wspecfile not allocated!'
      allocate(especfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: especfile not allocated!'
      allocate(fspecfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: fspecfile not allocated!'
      allocate(gspecfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: gspecfile not allocated!'
      allocate(pspecfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: pspecfile not allocated!'
      allocate(qspecfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: qspecfile not allocated!'
c
      allocate(isg1(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: isg1 not allocated!'
      allocate(isg2(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: isg2 not allocated!'
      allocate(nsg(ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: nsg not allocated!'
c
      do ig=1,ngrn
        call skipdoc(unit)
        read(unit,*)grndep(ig),specfile(ig),grnsel(ig)
        if(grnsel(ig).lt.0.or.grnsel(ig).gt.1)then
          stop ' bad Green function selection!'
        endif
        grndep(ig)=grndep(ig)*KM2M
      enddo
c
c     sort green function files by source depth
c
      do i=1,ngrn
        do j=i+1,ngrn
          if(grndep(j).lt.grndep(i))then
            dswap(1)=grndep(i)
            fswap=specfile(i)
            iswap=grnsel(i)
c
            grndep(i)=grndep(j)
            specfile(i)=specfile(j)
            grnsel(i)=grnsel(j)
c
            grndep(j)=dswap(1)
            specfile(j)=fswap
            grnsel(j)=iswap
          endif
        enddo
      enddo
c
      do flen=100,1,-1
        if(grndir(flen:flen).ne.' ')goto 200
      enddo
200   continue
      do ig=1,ngrn
        uspecfile(ig)=grndir(1:flen)//'U_'//specfile(ig)
        vspecfile(ig)=grndir(1:flen)//'V_'//specfile(ig)
        wspecfile(ig)=grndir(1:flen)//'W_'//specfile(ig)
        especfile(ig)=grndir(1:flen)//'E_'//specfile(ig)
        fspecfile(ig)=grndir(1:flen)//'F_'//specfile(ig)
        gspecfile(ig)=grndir(1:flen)//'G_'//specfile(ig)
        pspecfile(ig)=grndir(1:flen)//'P_'//specfile(ig)
        qspecfile(ig)=grndir(1:flen)//'Q_'//specfile(ig)
      enddo
c
c     multi-event source parameters
c     =============================
c
      call skipdoc(unit)
      read(unit,*)ns,sdfsel
c
      allocate(sfr(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: sfr not allocated!'
      allocate(sft(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: sft not allocated!'
      allocate(sfp(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: sfp not allocated!'
c
      allocate(mrr(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: mrr not allocated!'
      allocate(mtt(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: mtt not allocated!'
      allocate(mpp(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: mpp not allocated!'
      allocate(mrt(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: mrt not allocated!'
      allocate(mpr(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: mpr not allocated!'
      allocate(mtp(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: mtp not allocated!'
      allocate(lats(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lats not allocated!'
      allocate(lons(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lons not allocated!'
      allocate(deps(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: deps not allocated!'
      allocate(togs(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: togs not allocated!'
      allocate(trss(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: trss not allocated!'
c
      if(sdfsel.eq.1)then
        do is=1,ns
          call skipdoc(unit)
c
c         the six moment-tensor elements: Mrr, Mtt, Mpp, Mrt, Mrp, Mtp
c
          read(unit,*)munit,mrr(is),mtt(is),mpp(is),
     &                      mrt(is),mpr(is),mtp(is),
     &                      lats(is),lons(is),deps(is),togs(is),trss(is)
          mtt(is)=mtt(is)*munit
          mpp(is)=mpp(is)*munit
          mrr(is)=mrr(is)*munit
          mtp(is)=mtp(is)*munit
          mpr(is)=mpr(is)*munit
          mrt(is)=mrt(is)*munit
          deps(is)=deps(is)*KM2M
          sfp(is)=0.d0
          sft(is)=0.d0
          sfr(is)=0.d0
        enddo
      else if(sdfsel.eq.2)then
        do is=1,ns
          call skipdoc(unit)
          read(unit,*)munit,strike,dip,rake,
     &                      lats(is),lons(is),deps(is),togs(is),trss(is)
          call moments(munit,strike,dip,rake,
     &                 mtt(is),mpp(is),mrr(is),
     &                 mtp(is),mpr(is),mrt(is))
          deps(is)=deps(is)*KM2M
          sfp(is)=0.d0
          sft(is)=0.d0
          sfr(is)=0.d0
        enddo
      else if(sdfsel.eq.3)then
        do is=1,ns
          call skipdoc(unit)
          read(unit,*)munit,sfe,sfn,sfz,
     &                      lats(is),lons(is),deps(is),togs(is),trss(is)
          sfp(is)=sfe*munit
          sft(is)=-sfn*munit
          sfr(is)=sfz*munit
          deps(is)=deps(is)*KM2M
          mtt(is)=0.d0
          mpp(is)=0.d0
          mrr(is)=0.d0
          mtp(is)=0.d0
          mpr(is)=0.d0
          mrt(is)=0.d0
        enddo
      else
        stop ' bad selection for the source data format!'
      endif
c
      togsmin=togs(1)
      do is=1,ns
        togsmin=dmin1(togsmin,togs(is))
      enddo
      do is=1,ns
        togs(is)=togs(is)-togsmin
      enddo
c
c     sort sub-events by depth
c
      do i=1,ns
        do j=i+1,ns
          if(deps(j).lt.deps(i))then
            dswap(1)=lats(i)
            dswap(2)=lons(i)
            dswap(3)=deps(i)
            dswap(4)=mtt(i)
            dswap(5)=mpp(i)
            dswap(6)=mrr(i)
            dswap(7)=mtp(i)
            dswap(8)=mpr(i)
            dswap(9)=mrt(i)
            dswap(10)=sft(i)
            dswap(11)=sfp(i)
            dswap(12)=sfr(i)
            dswap(13)=togs(i)
            dswap(14)=trss(i)
c
            lats(i)=lats(j)
            lons(i)=lons(j)
            deps(i)=deps(j)
            mtt(i)=mtt(j)
            mpp(i)=mpp(j)
            mrr(i)=mrr(j)
            mtp(i)=mtp(j)
            mpr(i)=mpr(j)
            mrt(i)=mrt(j)
            sft(i)=sft(j)
            sfp(i)=sfp(j)
            sfr(i)=sfr(j)
            togs(i)=togs(j)
            trss(i)=trss(j)
c
            lats(j)=dswap(1)
            lons(j)=dswap(2)
            deps(j)=dswap(3)
            mtt(j)=dswap(4)
            mpp(j)=dswap(5)
            mrr(j)=dswap(6)
            mtp(j)=dswap(7)
            mpr(j)=dswap(8)
            mrt(j)=dswap(9)
            sft(j)=dswap(10)
            sfp(j)=dswap(11)
            sfr(j)=dswap(12)
            togs(j)=dswap(13)
            trss(j)=dswap(14)
          endif
        enddo
      enddo
c
      isg1(1)=1
      is1=1
      do ig=1,ngrn-1
        depdif=0.5d0*(grndep(ig)+grndep(ig+1))
        isg2(ig)=isg1(ig)-1
        do is=is1,ns
          if(deps(is).lt.depdif)then
            isg2(ig)=is
          endif
        enddo
        isg1(ig+1)=isg2(ig)+1
        is1=isg1(ig+1)
      enddo
      isg2(ngrn)=ns
c
      do ig=1,ngrn
        nsg(ig)=max0(0,1+isg2(ig)-isg1(ig))
      enddo
c
c     receiver parameters
c     ===================
c
      call skipdoc(unit)
      read(unit,*)(icmp(i),i=1,11)
      call skipdoc(unit)
      read(unit,*)outfile
      call skipdoc(unit)
      read(unit,*)twinout
      ntcutout=1+idnint(twinout/dtout)
      call skipdoc(unit)
      read(unit,*)nbpf,f1corner,f2corner
      call skipdoc(unit)
      read(unit,*)slwlwcut,slwupcut
      slwlwcut=slwlwcut/KM2M
      slwupcut=slwupcut/KM2M
      if(slwupcut.gt.slwmax.or.slwlwcut.ge.slwupcut)then
        slwlwcut=0.d0
        slwupcut=slwmax
      endif
      call skipdoc(unit)
      read(unit,*)nr
c
      allocate(latr(nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: latr not allocated!'
      allocate(lonr(nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: lonr not allocated!'
      allocate(tred(nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: tred not allocated!'
      allocate(rname(nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: rname not allocated!'
c
      do ir=1,nr
        call skipdoc(unit)
        read(unit,*)latr(ir),lonr(ir),rname(ir),tred(ir)
      enddo
c
      do flen=100,1,-1
        if(outfile(flen:flen).ne.' ')goto 300
      enddo
300   continue
      dispout(1)=outfile(1:flen)//'_disp_e.dat'
      dispout(2)=outfile(1:flen)//'_disp_n.dat'
      dispout(3)=outfile(1:flen)//'_disp_z.dat'
      veloout(1)=outfile(1:flen)//'_velo_e.dat'
      veloout(2)=outfile(1:flen)//'_velo_n.dat'
      veloout(3)=outfile(1:flen)//'_velo_z.dat'
      acceout(1)=outfile(1:flen)//'_acce_e.dat'
      acceout(2)=outfile(1:flen)//'_acce_n.dat'
      acceout(3)=outfile(1:flen)//'_acce_z.dat'
c
      rotaout(1)=outfile(1:flen)//'_rota_e.dat'
      rotaout(2)=outfile(1:flen)//'_rota_n.dat'
      rotaout(3)=outfile(1:flen)//'_rota_z.dat'
      rotarateout(1)=outfile(1:flen)//'_rota_rate_e.dat'
      rotarateout(2)=outfile(1:flen)//'_rota_rate_n.dat'
      rotarateout(3)=outfile(1:flen)//'_rota_rate_z.dat'
c
      strainout(1)=outfile(1:flen)//'_strain_ee.dat'
      strainout(2)=outfile(1:flen)//'_strain_en.dat'
      strainout(3)=outfile(1:flen)//'_strain_ez.dat'
      strainout(4)=outfile(1:flen)//'_strain_nn.dat'
      strainout(5)=outfile(1:flen)//'_strain_nz.dat'
      strainout(6)=outfile(1:flen)//'_strain_zz.dat'
      strainrateout(1)=outfile(1:flen)//'_strain_rate_ee.dat'
      strainrateout(2)=outfile(1:flen)//'_strain_rate_en.dat'
      strainrateout(3)=outfile(1:flen)//'_strain_rate_ez.dat'
      strainrateout(4)=outfile(1:flen)//'_strain_rate_nn.dat'
      strainrateout(5)=outfile(1:flen)//'_strain_rate_nz.dat'
      strainrateout(6)=outfile(1:flen)//'_strain_rate_zz.dat'
c
      stressout(1)=outfile(1:flen)//'_stress_ee.dat'
      stressout(2)=outfile(1:flen)//'_stress_en.dat'
      stressout(3)=outfile(1:flen)//'_stress_ez.dat'
      stressout(4)=outfile(1:flen)//'_stress_nn.dat'
      stressout(5)=outfile(1:flen)//'_stress_nz.dat'
      stressout(6)=outfile(1:flen)//'_stress_zz.dat'
      stressrateout(1)=outfile(1:flen)//'_stress_rate_ee.dat'
      stressrateout(2)=outfile(1:flen)//'_stress_rate_en.dat'
      stressrateout(3)=outfile(1:flen)//'_stress_rate_ez.dat'
      stressrateout(4)=outfile(1:flen)//'_stress_rate_nn.dat'
      stressrateout(5)=outfile(1:flen)//'_stress_rate_nz.dat'
      stressrateout(6)=outfile(1:flen)//'_stress_rate_zz.dat'
c
      gravout(1)=outfile(1:flen)//'_gravitation_e.dat'
      gravout(2)=outfile(1:flen)//'_gravitation_n.dat'
      gravout(3)=outfile(1:flen)//'_gravitation_z.dat'
c
      grmout=outfile(1:flen)//'_gravimeter.dat'
c
c     multilayered model parameters
c     =============================
c
      call skipdoc(unit)
      read(unit,*)l,i
      if(i.eq.1)then
        dispersion=.true.
      else
        dispersion=.false.
      endif
c
      l0=l+1
      allocate(dp0(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: dp0 not allocated!'
      allocate(vp0(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: vp0 not allocated!'
      allocate(vs0(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: vs0 not allocated!'
      allocate(ro0(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: ro0 not allocated!'
      allocate(qp0(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: qp0 not allocated!'
      allocate(qs0(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: qs0 not allocated!'
c
      allocate(dp0up(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: dp0up not allocated!'
      allocate(vp0up(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: vp0up not allocated!'
      allocate(vs0up(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: vs0up not allocated!'
      allocate(ro0up(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: ro0up not allocated!'
      allocate(qp0up(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: qp0up not allocated!'
      allocate(qs0up(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: qs0up not allocated!'
c
      allocate(dp0lw(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: dp0lw not allocated!'
      allocate(vp0lw(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: vp0lw not allocated!'
      allocate(vs0lw(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: vs0lw not allocated!'
      allocate(ro0lw(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: ro0lw not allocated!'
      allocate(qp0lw(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: qp0lw not allocated!'
      allocate(qs0lw(l0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpgettinp: qs0lw not allocated!'
c
      qsmin=10000.d0
      depatmos=0.d0
      rratmos=rearth
      do i=1,l
        call skipdoc(unit)
        read(unit,*)j,dp0(i),vp0(i),vs0(i),ro0(i),qp0(i),qs0(i)
c
c       input units:    -,km,  km/s, km/s, g/cm^3,-,-
c
        if(vp0(i).le.0.d0.or.vs0(i).lt.0.d0.or.ro0(i).le.0.d0.or.
     &     qp0(i).le.0.d0.or.qs0(i).lt.0.d0)then
          stop ' Error in qpgetinp: bad seismic parameter!'
        endif
c
        if(i.eq.1)then
          if(dp0(1).gt.0.d0)then
            stop ' Error in qpgetinp: bad start depth!'
          endif
          depatmos=-KM2M*dp0(1)
          rratmos=rearth+depatmos
        endif
c
        dp0(i)=KM2M*dp0(i)+depatmos
        vp0(i)=KM2M*vp0(i)
        vs0(i)=KM2M*vs0(i)
        ro0(i)=KM2M*ro0(i)
        if(vs0(i).gt.0.d0)qsmin=dmin1(qsmin,qs0(i))
        if(i.gt.1)then
          if(dp0(i).lt.dp0(i-1))then
            stop ' Error in qpgetinp: bad layering of earth model!'
          endif
        endif
      enddo
c
      if(dp0(l).gt.rratmos)then
        stop ' Error in qpgetinp: earth radius larger than pre-defined!'
      else if(dp0(l).lt.rratmos)then
        l=l+1
        dp0(l)=rratmos
        vp0(l)=vp0(l-1)
        vs0(l)=vs0(l-1)
        ro0(l)=ro0(l-1)
        qp0(l)=qp0(l-1)
        qs0(l)=qs0(l-1)
      endif
c
      dpr=dpr+depatmos
      if(dpr.lt.0.d0.or.dpr.gt.dp0(l))then
        stop ' Error in qpgetinp: receiver too shallow or too deep!'
      endif
      do i=1,ngrn
        grndep(i)=grndep(i)+depatmos
        if(grndep(i).lt.0.d0.or.grndep(i).ge.dp0(l))then
          stop ' Error in qpgetinp: source too shallow or too deep!'
        endif
      enddo
      do is=1,ns
        deps(is)=deps(is)+depatmos
      enddo
c
      l0=0
      do i=2,l
        if(dp0(i).gt.dp0(i-1))then
          l0=l0+1
          dp0up(l0)=dp0(i-1)
          vp0up(l0)=vp0(i-1)
          vs0up(l0)=vs0(i-1)
          ro0up(l0)=ro0(i-1)
          qp0up(l0)=qp0(i-1)
          qs0up(l0)=qs0(i-1)
c
          dp0lw(l0)=dp0(i)
          vp0lw(l0)=vp0(i)
          vs0lw(l0)=vs0(i)
          ro0lw(l0)=ro0(i)
          qp0lw(l0)=qp0(i)
          qs0lw(l0)=qs0(i)
        endif
      enddo
c
c     end of inputs
c     =============
c
      return
      end

      subroutine qpbounds(ldegcut)
      implicit none
      integer ldegcut
c
      include 'qpglobal.h'
c
c     work space
c
      integer ig,il,ldeg,ldeg0,ldeg1,ldegup,ly
      double precision dxs,dys2,omi,dll1,ksp2,expo,rr0min,depsmin
c
      rr0min=rr0(1)
      depsmin=grndep(1)
      lys=1
      do ig=2,ngrn
        if(rr0min.gt.rr0(ig))then
          rr0min=rr0(ig)
        endif
        if(depsmin.gt.grndep(ig))then
          lys=lygrn(ig)
          depsmin=grndep(ig)
        endif
      enddo
c
c     tappered disk source:
c     2*[cos(theta)-cos(alpha)]/[1-cos(alpha)]^2
c
      if(rr0min.le.0.d0)then
        do ldeg=0,ldegmax
          fdisk(ldeg)=1.d0
        enddo
      else
        dxs=dcos(rr0min/rrup(lys))
        dys2=(dsin(0.5d0*rr0min/rrup(lys)))**2
        call legendre(ldegmax,rr0min/rrup(lys),dplm1)
        fdisk(0)=1.d0
        fdisk(1)=(2.d0+dxs)/3.d0
        do ldeg=2,ldegmax
          fdisk(ldeg)=0.5d0/dys2**2
     &             /dble(ldeg)/dble(ldeg+1)/dble(ldeg+2)
     &             *(2.d0*dys2*(2.d0*dble(ldeg)*dys2+1.d0)
     &              +dble(ldeg)*dxs**2*dplm1(ldeg)
     &              -dble(2*ldeg+1)*dxs*dplm1(ldeg-1)
     &              +dble(ldeg+1)*dplm1(ldeg-2))
        enddo
c
        do ldeg=0,ldegmax
          fdisk(ldeg)=dabs(fdisk(ldeg))
          do il=ldeg+1,ldegmax
            fdisk(ldeg)=dmax1(fdisk(ldeg),dabs(fdisk(il)))
          enddo
        enddo
      endif
c
      ldegcut=0
      do ig=1,ngrn
        lys=lygrn(ig)
c
        omi=PI2*fcut
        ldeg0=ldegmin+ndmax
        if(slwmax.le.0.d0)then
          ldeg1=ldegmax
        else
          ldeg1=min0(ldegmax,idint(REARTH*omi*slwmax))
        endif
        ldegup=ldeg0
        do ldegup=ldeg0,ldeg1
          dll1=dble(ldegup)*dble(ldegup+1)
          expo=0.d0
          do ly=min0(lys,lyr),max0(lys,lyr)-1
            if(vsup(ly).gt.0.d0)then
              ksp2=(omi*rrup(ly)/vsup(ly))**2
            else
              ksp2=(omi*rrup(ly)/vpup(ly))**2
            endif
            if(dll1.gt.ksp2)then
              expo=expo+dsqrt(dll1-ksp2)*dlog(rrup(ly)/rrlw(ly))
            endif
          enddo
          if(expo.gt.expos+dlog(fdisk(ldegup)))goto 20
        enddo
20      continue
        ldegcut=max0(ldegcut,ldegup)
      enddo
      ldegcut=ldegcut+1+ndmax
      if(ldegcut.ge.ldegmax)then
        write(*,'(2(a,i6))')' Warning in qpbounds: '
     &     //'ldegmax reguired/defined:',ldegcut,'/',ldegmax
        ldegcut=ldegmax
      endif
      return
      end

      subroutine qpdifmats(ly,ldeg,rr,mat)
      use qpalloc
      implicit none
      integer*4 ly,ldeg
      real*8 rr
      complex*16 mat(6,6)
c
c     6x6 coefficient matrix for spheroidal mode l > 0 in solid media
c
      real*8 dro,rorr,ro1,mass
      complex*16 cldeg,clp1,cll1,cup,clw
      complex*16 crr,drr,crorr,clarr,cmurr,cxirr,cgarr,cgrrr
c
      complex*16 c1,c2,c4
      data c1,c2,c4/(1.d0,0.d0),(2.d0,0.d0),(4.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      clp1=cldeg+c1
      cll1=cldeg*clp1
      crr=dcmplx(rr,0.d0)
      cup=(crr-rrlw(ly))/(crrup(ly)-crrlw(ly))
      clw=c1-cup
      clarr=cup*claup(ly)+clw*clalw(ly)
      cmurr=cup*cmuup(ly)+clw*cmulw(ly)
      cxirr=clarr+c2*cmurr
c
      crorr=cup*croup(ly)+clw*crolw(ly)
      rorr=dreal(crorr)
      cgarr=dcmplx(2.d0*PI2*BIGG*rorr,0.d0)
c
      if(rr.le.rrlw(ly))then
        mass=0.d0
        crorr=crolw(ly)
        rorr=dreal(crorr)
        cgarr=dcmplx(2.d0*PI2*BIGG*rorr,0.d0)
      else
        crorr=cup*croup(ly)+clw*crolw(ly)
        rorr=dreal(crorr)
        cgarr=dcmplx(2.d0*PI2*BIGG*rorr,0.d0)
        dro=(rorr-rolw(ly))/(rr-rrlw(ly))
        ro1=rorr-dro*rrlw(ly) 
        mass=PI*(rr-rrlw(ly))*((4.d0/3.d0)*ro1
     &        *(rr**2+rr*rrlw(ly)+rrlw(ly)**2)
     &        +dro*(rr**3+rr**2*rrlw(ly)
     &        +rr*rrlw(ly)**2+rrlw(ly)**3))
      endif
      cgrrr=cgrlw(ly)*(crrlw(ly)/crr)**2
     &     +dcmplx(BIGG*mass/rr**2,0.d0)
c
      mat(1,1)=(c1-c2*clarr/cxirr)/crr
      mat(1,2)=c1/cxirr/crr
      mat(1,3)=cll1*clarr/cxirr/crr
      mat(1,4)=(0.d0,0.d0)
      mat(1,5)=(0.d0,0.d0)
      mat(1,6)=(0.d0,0.d0)
c
      mat(2,1)=c4*(cmurr*(c1+c2*clarr/cxirr)/crr-crorr*cgrrr)
     &        -crorr*comi2*crr
      mat(2,2)=c2*clarr/cxirr/crr
      mat(2,3)=cll1*(crorr*cgrrr
     &        -c2*cmurr*(c1+c2*clarr/cxirr)/crr)
      mat(2,4)=cll1/crr
      mat(2,5)=crorr*clp1*crr
      mat(2,6)=-crorr*crr
c
      mat(3,1)=-c1/crr
      mat(3,2)=(0.d0,0.d0)
      mat(3,3)=c2/crr
      mat(3,4)=c1/cmurr/crr
      mat(3,5)=(0.d0,0.d0)
      mat(3,6)=(0.d0,0.d0)
c
      mat(4,1)=crorr*cgrrr-c2*cmurr*(c1+c2*clarr/cxirr)/crr
      mat(4,2)=-clarr/cxirr/crr
      mat(4,3)=c2*cmurr*(c2*cll1*(c1-cmurr/cxirr)-c1)/crr
     &        -crorr*comi2*crr
      mat(4,4)=-c1/crr
      mat(4,5)=-crorr*crr
      mat(4,6)=(0.d0,0.d0)
c
      mat(5,1)=cgarr/crr
      mat(5,2)=(0.d0,0.d0)
      mat(5,3)=(0.d0,0.d0)
      mat(5,4)=(0.d0,0.d0)
      mat(5,5)=-clp1/crr
      mat(5,6)=c1/crr
c
      mat(6,1)=cgarr*clp1/crr
      mat(6,2)=(0.d0,0.d0)
      mat(6,3)=-cgarr*cll1/crr
      mat(6,4)=(0.d0,0.d0)
      mat(6,5)=(0.d0,0.d0)
      mat(6,6)=cldeg/crr
c
      return
      end

      subroutine cdsvd(ca,cb,n,m,eps,key)
      implicit none
c-------------------------------------------------------------------------------
c     Solve complex linear equation system by single-value decomposiztion      i
c     method (modified from ludcmp and lubksb in the <Numerical Recipies>      i
c     ca: coefficient matrix(n,n);                                             i
c     cb: right-hand matrix(n,m) by input,                                     i
c         solution matrix(n,m) by return;                                      i
c     cunit: unit of the culomn vectors                                        i
c     eps: control constant;                                                   i
c     key: if the main term of a column is                                     i
c          smaller than eps, key=0: anormal return,                            i
c          else key=1: normal return.                                          i
c-------------------------------------------------------------------------------
      integer*4 n,m,key
      real*8 eps
      complex*16 ca(n,n),cb(n,m)
c
      integer*4 i,ii,imax,j,k,ll,ierr
      real*8 aamax,dum
      complex*16 cdum,csum
c
      integer*4, allocatable:: indx(:)
      real*8, allocatable:: vv(:)
c
      if(n.le.0)then
        key=0
        return
      endif
c
      ierr=0
      allocate(indx(n),stat=ierr)
      if(ierr.ne.0)stop 'Error in cdsvd: indx not allocated!'
      allocate(vv(n),stat=ierr)
      if(ierr.ne.0)stop 'Error in cdsvd: vv not allocated!'
c
      do i=1,n
        aamax=0.d0
        do j=1,n
          aamax=dmax1(aamax,cdabs(ca(i,j)))
        enddo
        if(aamax.le.eps)then
          key=0
          return
        endif
        vv(i)=1.d0/aamax
      enddo
      do j=1,n
        do i=1,j-1
          csum=ca(i,j)
          do k=1,i-1
            csum=csum-ca(i,k)*ca(k,j)
          enddo
          ca(i,j)=csum
        enddo
        aamax=0.d0
        do i=j,n
          csum=ca(i,j)
          do k=1,j-1
            csum=csum-ca(i,k)*ca(k,j)
          enddo
          ca(i,j)=csum
          dum=vv(i)*cdabs(csum)
          if(dum.ge.aamax) then
            imax=i
            aamax=dum
          endif
        enddo
        if(j.ne.imax) then
          do k=1,n
            cdum=ca(imax,k)
            ca(imax,k)=ca(j,k)
            ca(j,k)=cdum
          enddo
          vv(imax)=vv(j)
        endif
        indx(j)=imax
        if(cdabs(ca(j,j)).le.eps)then
          key=0
          deallocate(indx,vv)
          return
        endif
        if(j.ne.n) then
          cdum=(1.d0,0.d0)/ca(j,j)
          do i=j+1,n
            ca(i,j)=ca(i,j)*cdum
          enddo
        endif
      enddo
c
      do k=1,m
        ii=0
        do i=1,n
          ll=indx(i)
          csum=cb(ll,k)
          cb(ll,k)=cb(i,k)
          if(ii.ne.0) then
            do j=ii,i-1
              csum=csum-ca(i,j)*cb(j,k)
            enddo
          else if(cdabs(csum).ne.0.d0)then
            ii=i
          endif
          cb(i,k)=csum
        enddo
        do i=n,1,-1
          csum=cb(i,k)
          do j=i+1,n
            csum=csum-ca(i,j)*cb(j,k)
          enddo
          cb(i,k)=csum/ca(i,i)
        enddo
      enddo
      key=1
      deallocate(indx,vv)
      return
      end

      subroutine legendre(ldegcut,raddis,dp)
      implicit none
      integer*4 ldegcut
      real*8 raddis,dp(0:ldegcut)
c
c     x = cos(raddis)
c     define: P(l,x) = Legendre polynomials
c     This subroutine calculate dp(l,x) = p(l,x) - 1
c
      integer*4 l
      real*8 x,y
c
      x=dcos(raddis)
      y=-2.d0*(dsin(0.5d0*raddis))**2
c
      dp(0)=0.d0
      dp(1)=y
      do l=2,ldegcut
        dp(l)=(dble(2*l-1)*y+dble(2*l-1)*x*dp(l-1)
     &        -dble(l-1)*dp(l-2))/dble(l)
      enddo
c
      return
      end

      subroutine qpshkern(f,ldeg,ysh)
      use qpalloc
      implicit none
c
c     calculation of response function in frequency-wavelength domain
c     ldeg: harmonic degree
c     ysh(2,2): sh solution vector (complex)
c
      integer*4 ldeg
      real*8 f
      complex*16 ysh(2,2)
c
      integer*4 i,j,ly,istp,lylw,lwup
      real*8 xmin
      complex*16 cldeg,cll1,cruplw,delta
      complex*16 spbphj,spbphy
c
      complex*16 c1,c2
      data c1,c2/(1.d0,0.d0),(2.d0,0.d0)/
c
      do istp=1,2
        do i=1,2
          ysh(i,istp)=(0.d0,0.d0)
        enddo
      enddo
      lylw=lylwsh(ldeg)
      if(lyr.lt.lyob.or.lylw.lt.max0(lys,lyr))return
c
      if(ldeg.eq.0.or.ldeg.le.1.and.f.le.0.d0)return
      comi=dcmplx(PI2*f,PI2*fi)
      comi2=comi*comi
      xmin=dsqrt(2.d0*dble(2*ldeg+1))
      cldeg=dcmplx(dble(ldeg),0.d0)
      cll1=cldeg*(cldeg+c1)
c
      do ly=lyob,min0(lylwsh(ldeg),lycm-1)
        if(ldeg.le.ldegsh(ly))then
          kt(ly)=comi/cvs(ly)
          if(cdabs(kt(ly))*rrup(ly).le.xmin)then
            ksmallsh(ly)=.true.
            if(rrlw(ly).gt.0.d0)then
              cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
            else
              cruplw=(0.d0,0.d0)
            endif
            wj(ldeg,ly,3)=cldeg*cruplw
            wh(ldeg,ly,3)=-(cldeg+c1)*cruplw
          else if(ksmallsh(ly))then
            ksmallsh(ly)=.false.
            call spbjh(ldegsh(ly),kt(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,3),zjlw(0,ly,3),wj(0,ly,3),
     &                 zhup(0,ly,3),zhlw(0,ly,3),wh(0,ly,3))
          endif
        endif
      enddo
c
      do ly=lyob,min0(lylwsh(ldeg),lycm-1)
        if(ly.lt.lys)then
          lwup=0
          cpt(1,ly)=-wj(ldeg,ly,3)
          cpt(2,ly)=-wh(ldeg,ly,3)
        else
          lwup=1
          cpt(1,ly)=wj(ldeg,ly,3)
          cpt(2,ly)=wh(ldeg,ly,3)
        endif
        call qptmat(ldeg,ly,lwup)
      enddo
      if(ldeg.eq.1)then
        call qptprop1(ysh,lylw)
      else
        call qptprop(ysh,lylw)
      endif
      return
      end

      subroutine qpsprop0(ypsv,lyup,lylw)
      use qpalloc
      implicit none
c
c     calculation of spheroidal response for degree 0
c     ypsv(6,4): solution vector (complex)
c
      integer*4 lyup,lylw
      complex*16 ypsv(6,4)
c
c     work space
c
      integer*4 i,j,istp,ly,lyswap,key
      complex*16 y0(3),c(3),yup(3),ylw(3)
      complex*16 wave(2),coef(3,3),b(3,2)
c
      if(lylwa.gt.lylw)return
c
c===============================================================================
c
c     propagation from surface to source
c
      if(freesurf.and.lyup.eq.1)then
        yup(1)=(1.d0,0.d0)
        yup(2)=(0.d0,0.d0)
        yup(3)=(0.d0,0.d0)
      else
        call qpstart0a(lyup,2,yup)
      endif
c
      if(lyr.eq.lyup)call cmemcpy(yup,y0,3)
c
      do ly=lyup,lys-1
        call caxcb(mas3x3inv(1,1,ly),yup,3,3,1,c)
        wave(1)=cdexp( cps(1,ly))
        wave(2)=cdexp(-cps(2,ly))
        if(ly.ge.lyr)then
          do i=1,3
            y0(i)=y0(i)*wave(2)
          enddo
        endif
c
	  c(1)=c(1)*wave(2)*wave(1)
c       c(2)=c(2)
        c(3)=c(3)*wave(2)
c
        call caxcb(mas3x3lw(1,1,ly),c,3,3,1,yup)
        if(ly.eq.lyr-1)call cmemcpy(yup,y0,3)
      enddo
      yup(1)=yup(1)/crrup(lys)
      yup(2)=yup(2)/crrup(lys)**2
c     yup(3)=yup(3)
c
c===============================================================================
c
c     propagation from bottom to source
c
      if(lylw.eq.lylwb)then
        lyswap=lylwb
        call qpstart0a(lyswap,1,ylw)
      else
        do i=1,3
          ylw(i)=mas3x3up(i,1,lylw)
        enddo
      endif
      if(lylw.eq.lyr.and.lylw.gt.lys)call cmemcpy(ylw,y0,3)
c
      do ly=lylw-1,lys,-1
        call caxcb(mas3x3inv(1,1,ly),ylw,3,3,1,c)
        wave(1)=cdexp(-cps(1,ly))
        wave(2)=cdexp( cps(2,ly))
        if(ly.lt.lyr)then
          do i=1,3
            y0(i)=y0(i)*wave(1)
          enddo
        endif
c
c       c(1)=c(1)
        c(2)=c(2)*wave(1)*wave(2)
        c(3)=c(3)*wave(1)
c
        call caxcb(mas3x3up(1,1,ly),c,3,3,1,ylw)
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,3)
      enddo
      ylw(1)=ylw(1)/crrup(lys)
      ylw(2)=ylw(2)/crrup(lys)**2
c     ylw(3)=ylw(3)
c
      y0(1)=y0(1)/crrup(lyr)
      y0(2)=y0(2)/crrup(lyr)**2
c     y0(3)=y0(3)
c
c===============================================================================
c     source function
c===============================================================================
c
      b(1,1)=(1.d0,0.d0)
      b(2,1)=(0.d0,0.d0)
      b(3,1)=(0.d0,0.d0)
      b(1,2)=(0.d0,0.d0)
      b(2,2)=(1.d0,0.d0)
      b(3,2)=(0.d0,0.d0)
      do j=1,3
        do i=1,3
          coef(i,j)=(0.d0,0.d0)
        enddo
      enddo
      do i=1,3
        coef(i,1)=yup(i)
        coef(i,2)=-ylw(i)
        coef(i,3)=(0.d0,0.d0)
      enddo
c
c     a constant will be added to potential for region below the source
c
      coef(3,3)=-(1.d0,0.d0)
c
      key=0
      call cdsvd500(coef,b,3,2,0.d0,key)
      if(key.eq.0)then
        print *,' Warning in qpsprop0: anormal exit from cdsvd500!'
        return
      endif
      if(lyr.le.lys)then
        do istp=1,2
          do i=1,3
            ypsv(i,istp)=b(1,istp)*y0(i)
          enddo
        enddo
      else
        do istp=1,2
          do i=1,3
            ypsv(i,istp)=b(2,istp)*y0(i)
          enddo
          ypsv(3,istp)=ypsv(3,istp)+b(3,istp)
        enddo
      endif
c
      if(lylwa.le.0)then
        do istp=1,2
          ypsv(5,istp)=ypsv(3,istp)
          ypsv(6,istp)=ypsv(3,istp)/crrup(lyr)
          ypsv(3,istp)=(0.d0,0.d0)
        enddo
        return
      endif
c
c
c===============================================================================
c
c     propagation from bottom to source
c
      lyswap=lylwa
      call qpstart0a(lyswap,1,ylw)
c
      if(lylwa.eq.lyr.and.lylwa.gt.lys)call cmemcpy(ylw,y0,3)
c
      do ly=lylwa-1,lys,-1
        call caxcb(mas3x3inv(1,1,ly),ylw,3,3,1,c)
        wave(1)=cdexp(-cps(1,ly))
        wave(2)=cdexp( cps(2,ly))
        if(ly.lt.lyr)then
          do i=1,3
            y0(i)=y0(i)*wave(1)
          enddo
        endif
c
c       c(1)=c(1)
        c(2)=c(2)*wave(1)*wave(2)
        c(3)=c(3)*wave(1)
c
        call caxcb(mas3x3up(1,1,ly),c,3,3,1,ylw)
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,3)
      enddo
      ylw(1)=ylw(1)/crrup(lys)
      ylw(2)=ylw(2)/crrup(lys)**2
c     ylw(3)=ylw(3)
c
      if(lyr.gt.lys)then
        y0(1)=y0(1)/crrup(lyr)
        y0(2)=y0(2)/crrup(lyr)**2
c       y0(3)=y0(3)
      endif
c
c===============================================================================
c     source function
c===============================================================================
c
      b(1,1)=(1.d0,0.d0)
      b(2,1)=(0.d0,0.d0)
      b(3,1)=(0.d0,0.d0)
      b(1,2)=(0.d0,0.d0)
      b(2,2)=(1.d0,0.d0)
      b(3,2)=(0.d0,0.d0)
      do i=1,3
        coef(i,1)=yup(i)
        coef(i,2)=-ylw(i)
        coef(i,3)=(0.d0,0.d0)
      enddo
      coef(3,3)=-(1.d0,0.d0)
      key=0
      call cdsvd500(coef,b,3,2,0.d0,key)
      if(key.eq.0)then
        print *,' Warning in qpsprop0: anormal exit from cdsvd500!'
        return
      endif
      if(lyr.le.lys)then
        do istp=1,2
          do i=1,3
            ypsv(i,istp)=ypsv(i,istp)-b(1,istp)*y0(i)
          enddo
        enddo
      else
        do istp=1,2
          do i=1,3
            ypsv(i,istp)=ypsv(i,istp)-b(2,istp)*y0(i)
          enddo
          ypsv(3,istp)=ypsv(3,istp)-b(3,istp)
        enddo
      endif
c
      do istp=1,2
        ypsv(5,istp)=ypsv(3,istp)
        ypsv(6,istp)=ypsv(3,istp)/crrup(lyr)
        ypsv(3,istp)=(0.d0,0.d0)
      enddo
c
      return
      end

      subroutine tpssub(nz,h,vps,zs,rearth,head,diff,
     &                  nt,distance,traveltime,takeoff,slowness)
      implicit none
c-------------------------------------------------------------------------------
c     Calculte first arrival time of seismic waves based on ray theory
c
c     Input:
c     nz = number of layers of crust-mantle structure
c     h(nz) = layer thickness in m
c     vps(nz) = p or s wave velocity in m
c     zs = source depth in m
c     rearth = earth radius in m
c     head = .true. for including head waves
c     diff = .true. for including diffracted waves
c     nt = number of travel times to be returned
c     distance(nt) = distance in m
c
c     Output:
c     traveltime(nt) = travel time in second
c     takeoff(nt) = takeoff angle in degree
c     slowness(nt) = slowness in s/m
c-------------------------------------------------------------------------------
      integer*4 nz,nt
      real*8 zs,rearth
      logical*2 head, diff
      real*8 h(nz),vps(nz)
      real*8 distance(nt),traveltime(nt),takeoff(nt),slowness(nt)
c
      integer*4 npmax,npmin
      parameter(npmax=20001,npmin=100)
      integer*4 i,k,kc,m,iz,ir,jr,irs,ip,np,nr,ierr,nokay
      real*8 pi,piplus,deg2rad
      real*8 rs,a,b,c,ray,raymax,raymin,ins0,ins1,ins2,insup,inslw,dins
      real*8 dh,swap,dswap,tswap,slw,sgrd,fgrd,tup,tlw,dup,dlw
      logical*2 ninety,test
c
      logical*2, allocatable:: okay(:)
      integer*4, allocatable:: i1(:),i2(:)
      real*8, allocatable:: r(:),vel(:),tkf(:),ddg(:),tps(:),disrad(:)
c
      if(nt.le.1)then
        print *,'error in tpssub: nt <= 1!'
        stop
      endif
c
      test=.false.
c
      pi=4.d0*datan(1.d0)
      piplus=pi*(1.d0+1.0d-12)
      deg2rad=pi/180.d0
c
      ierr=0
      allocate(okay(nt),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: okay not allocated!'
      allocate(disrad(nt),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: disrad not allocated!'
c
      nr=nz+2
      allocate(r(nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: r not allocated!'
      allocate(vel(nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: v not allocated!'
c
      allocate(i1(2*nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: i1 not allocated!'
      allocate(i2(2*nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: i2 not allocated!'
c
      np=npmax+(npmin+2)*nr
      allocate(tkf(np),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: tkf not allocated!'
      allocate(ddg(np),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: ddg not allocated!'
      allocate(tps(np),stat=ierr)
      if(ierr.ne.0)stop ' Error in tpssub: tps not allocated!'
c
      nr=nz
      r(1)=rearth
      vel(1)=vps(1)
      do iz=2,nz
        r(iz)=r(iz-1)-h(iz-1)
        vel(iz)=vps(iz)
        if(r(iz).lt.0.d0)then
          nr=iz
          r(nr)=0.d0
          goto 50
        endif
      enddo
50    continue
      if(vel(nr).gt.0.d0)then
        nr=nr+1
        r(nr)=0.d0
        vel(nr)=vel(nr-1)
      endif
c
c     delete pseudo interfaces
c
      m=nr
      do ir=2,m-1
        if(vel(ir).le.0.d0)then
          nr=ir
          goto 60
        else if(vel(ir).eq.vel(ir-1))then
          do jr=ir,nr-1
            r(jr)=r(jr+1)
            vel(jr)=vel(jr+1)
          enddo
          nr=nr-1
        endif
      enddo
60    continue
c
c     add a pseudo interface at source
c
      if(zs.le.0.d0)then
        rs=rearth
        irs=1
      else
        rs=rearth-zs
c
        if(rs.le.r(nr))then
          print *,'error in tpssub: too deep source!'
          stop
        endif
c
        do ir=2,nr
          if(rs.ge.r(ir))then
            irs=ir
            if(rs.gt.r(ir))then
              do jr=nr,ir,-1
                r(jr+1)=r(jr)
                vel(jr+1)=vel(jr)
              enddo
              r(ir)=rs
              vel(ir)=vel(ir-1)
              nr=nr+1
            endif
            goto 100
          endif
        enddo
      endif
100   continue
      swap=0.d0
      do ir=1,irs-1
        swap=swap+(r(ir)-r(ir+1))/vel(ir)
      enddo
c
      do i=1,np
        tkf(i)=0.d0
        ddg(i)=0.d0
        tps(i)=0.d0
      enddo
c
      kc=1
      i1(kc)=1
      k=0
      dh=rearth/dble(npmax-1)
c
c     wave phase with takeoff >= 90 deg
c
      if(irs.eq.1)then
        k=k+1
        tkf(k)=0.5d0*pi
        ddg(k)=0.d0
        tps(k)=0.d0
c
        k=k+1
        tkf(k)=0.5d0*pi
        ddg(k)=(r(1)-r(2))/rearth
        tps(k)=ddg(k)*rearth/vel(1)
c
        i2(kc)=k
        raymin=r(irs)/vel(irs)
      else
        k=k+1
        tkf(k)=pi
        ddg(k)=0.d0
        tps(k)=0.d0
        do ir=1,irs-1
          tps(k)=tps(k)+(r(ir)-r(ir+1))/vel(ir)
        enddo
c
        np=max0(npmin,1+idint((r(1)-r(irs))/dh))
c
        raymin=r(irs)/vel(irs-1)
        ninety=.true.
        do ir=2,irs-1
          if(raymin.gt.r(ir)/vel(ir-1))then
            raymin=r(ir)/vel(ir-1)
            ninety=.false.
          endif
        enddo
c
        dins=dasin(dmin1(1.d0,raymin*vel(irs-1)/r(irs)))/dble(np)
c
        do ip=1,np
          ins0=dble(ip)*dins
          if(ip.lt.np)then
            ray=dsin(ins0)*r(irs)/vel(irs-1)
          else
            ray=raymin
          endif
c
          dswap=0.d0
          tswap=0.d0
          do ir=irs-1,1,-1
            swap=dmin1(1.d0,ray*vel(ir)/r(ir+1))
            ins1=dasin(swap)
            ins2=dasin(swap*r(ir+1)/r(ir))
            dswap=dswap+ins1-ins2
            tswap=tswap+(r(ir)*dcos(ins2)-r(ir+1)*dcos(ins1))/vel(ir)
          enddo
          k=k+1
          tkf(k)=pi-ins0
          ddg(k)=dswap
          tps(k)=tswap
        enddo
        i2(kc)=k
        if(diff.and.ninety.and.vel(irs).lt.vel(irs-1))then
c
c         add diffracted wave
c
          slw=r(irs)/vel(irs-1)
          k=k+1
          ddg(k)=piplus
          tps(k)=tps(k-1)+(ddg(k)-ddg(k-1))*slw
          tkf(k)=tkf(k-1)
          i2(kc)=k
        else if(ninety.and.vel(irs).gt.vel(irs-1))then
c
c         add pn wave
c
          ins0=dasin(dmin1(1.d0,vel(irs-1)/vel(irs)))
          ray=dsin(ins0)*r(irs)/vel(irs-1)
c
          if(head)then
            dswap=0.d0
            tswap=0.d0
            do ir=irs-1,1,-1
              swap=dmin1(1.d0,ray*vel(ir)/r(ir+1))
              ins1=dasin(swap)
              ins2=dasin(swap*r(ir+1)/r(ir))
              dswap=dswap+ins1-ins2
              tswap=tswap+(r(ir)*dcos(ins2)-r(ir+1)*dcos(ins1))/vel(ir)
            enddo
            kc=kc+1
            slw=r(irs)/vel(irs)
            i1(kc)=i2(kc-1)+1
            k=i1(kc)
            ddg(k)=dswap
            tps(k)=tswap
            tkf(k)=0.5d0*pi
            k=k+1
            ddg(k)=piplus
            tps(k)=tps(k-1)+(ddg(k)-ddg(k-1))*slw
            tkf(k)=tkf(k-1)
            i2(kc)=k
          endif
          raymin=dmin1(raymin,r(irs)/vel(irs))
        endif
      endif
c
c     wave phase with takeoff < 90 deg
c
      raymax=raymin
c
      do jr=irs+1,nr
        swap=r(jr-1)/vel(jr-1)
        if(raymax.ge.swap)then
          insup=dasin(dmin1(1.d0,swap*vel(irs)/r(irs)))
        else
          insup=dasin(dmin1(1.d0,raymax*vel(irs)/r(irs)))
        endif
        swap=r(jr)/vel(jr-1)
        if(raymax.gt.swap)then
          inslw=dasin(dmin1(1.d0,swap*vel(irs)/r(irs)))
        else
          goto 500
        endif
        raymax=swap
c
        kc=kc+1
        i1(kc)=i2(kc-1)+1
        k=i2(kc-1)
c
        np=max0(npmin,1+idint((r(jr-1)-r(jr))/dh))
        dins=(inslw-insup)/dble(np)
c
        do ip=0,np
          ins0=insup+dble(ip)*dins
          ray=dsin(ins0)*r(irs)/vel(irs)
c
c         upgoing part of the current wave phase
c
          dup=0.d0
          tup=0.d0
          do ir=irs-1,1,-1
            swap=dmin1(1.d0,ray*vel(ir)/r(ir+1))
            ins1=dasin(swap)
            ins2=dasin(swap*r(ir+1)/r(ir))
            dup=dup+ins1-ins2
            tup=tup+(r(ir)*dcos(ins2)-r(ir+1)*dcos(ins1))/vel(ir)
          enddo
c
c         downgoing part of the current wave phase
c
          dlw=0.d0
          tlw=0.d0
          do ir=irs+1,jr
            swap=dmin1(1.d0,ray*vel(ir-1)/r(ir-1))
            ins1=dasin(swap)
            if(ir.lt.jr)then
              ins2=dasin(dmin1(1.d0,swap*r(ir-1)/r(ir)))
              dlw=dlw+ins2-ins1
              tlw=tlw+(r(ir-1)*dcos(ins1)-r(ir)*dcos(ins2))/vel(ir-1)
            else
              dlw=dlw+0.5d0*pi-ins1
              tlw=tlw+r(ir-1)*dcos(ins1)/vel(ir-1)
            endif
          enddo
c
          k=k+1
          tkf(k)=ins0
          ddg(k)=2.d0*dlw+dup
          tps(k)=2.d0*tlw+tup
        enddo
c
        i2(kc)=k
c
        if(diff.and.vel(jr).lt.vel(jr-1))then
c
c         add diffracted wave
c
          slw=r(jr)/vel(jr-1)
          k=k+1
          ddg(k)=piplus
          tps(k)=tps(k-1)+(ddg(k)-ddg(k-1))*slw
          tkf(k)=tkf(k-1)
          i2(kc)=k
        else if(jr.lt.nr.and.vel(jr).gt.vel(jr-1))then
c
c         add pn wave
c
          ray=r(jr)/vel(jr)
          ins0=dasin(dmin1(1.d0,ray*vel(irs)/r(irs)))
          if(head)then
            dup=0.d0
            tup=0.d0
            do ir=irs-1,1,-1
              swap=dmin1(1.d0,ray*vel(ir)/r(ir+1))
              ins1=dasin(swap)
              ins2=dasin(swap*r(ir+1)/r(ir))
              dup=dup+ins1-ins2
              tup=tup+(r(ir)*dcos(ins2)-r(ir+1)*dcos(ins1))/vel(ir)
            enddo
            dlw=0.d0
            tlw=0.d0
            do ir=irs+1,jr
              ins1=dasin(dmin1(1.d0,ray*vel(ir-1)/r(ir-1)))
              ins2=dasin(dmin1(1.d0,ray*vel(ir-1)/r(ir)))
              dlw=dlw+ins2-ins1
              tlw=tlw+(r(ir-1)*dcos(ins1)-r(ir)*dcos(ins2))/vel(ir-1)
            enddo
c
            dswap=2.d0*dlw+dup
            tswap=2.d0*tlw+tup
            slw=r(jr)/vel(jr)
c
            kc=kc+1
            i1(kc)=i2(kc-1)+1
            k=i1(kc)
            ddg(k)=dswap
            tps(k)=tswap
            tkf(k)=ins0
            k=k+1
            ddg(k)=piplus
            tps(k)=tps(k-1)+(ddg(k)-ddg(k-1))*slw
            tkf(k)=tkf(k-1)
            i2(kc)=k
          endif
          raymax=ray
        endif
500     continue
      enddo
c
      if(test)then
        open(31,file='testing.dat',status='unknown')
        write(31,'(a)')' distance[deg] traveltime[s]'
     &               //' takeoff[deg]'
        do m=1,kc
          do k=i1(m),i2(m)
            write(31,'(2f14.6,f13.6)')ddg(k)/deg2rad,tps(k),
     &          tkf(k)/deg2rad
          enddo
          write(31,'(a)')'            '
        enddo
      endif
c
c     interpolate and output
c
      do i=1,nt
        disrad(i)=dmod(distance(i)/rearth,2.d0*pi)
        if(disrad(i).gt.pi)disrad(i)=2.d0*pi-disrad(i)
      enddo
c
      nokay=0
c
      do i=1,nt
        traveltime(i)=0.d0
        okay(i)=.false.
        do m=1,kc
          do k=i1(m),i2(m)-1
            if(disrad(i).ge.dmin1(ddg(k),ddg(k+1)).and.
     &         disrad(i).le.dmax1(ddg(k),ddg(k+1)))then
              if(ddg(k).eq.ddg(k+1))then
                a=1.d0
                b=0.d0
              else
                a=(ddg(k+1)-disrad(i))/(ddg(k+1)-ddg(k))
                b=1.d0-a
              endif
              tswap=a*tps(k)+b*tps(k+1)
              if(.not.okay(i).or.traveltime(i).gt.tswap)then
                traveltime(i)=tswap
                takeoff(i)=a*tkf(k)+b*tkf(k+1)
                okay(i)=.true.
              endif
            endif
          enddo
        enddo
        if(okay(i))nokay=nokay+1
      enddo
c
      if(nokay.ge.nt)goto 1000
c
c     add reflected waves
c
      if(irs.eq.1)then
        m=npmin+nr
        dins=0.5d0*pi/dble(m)
        do k=1,m
          tkf(k)=dble(k-1)*dins
          ddg(k)=0.d0
          tps(k)=0.d0
        enddo
      else
        m=i2(1)
        do k=1,m
          tkf(k)=pi-tkf(k)
        enddo
      endif
c
      do ir=irs+1,nr-1
        do k=1,m
          ray=dsin(tkf(k))*r(irs)/vel(irs)
          if(ray.ge.r(ir)/vel(ir-1))goto 600
          swap=ray*vel(ir-1)/r(ir-1)
          ins1=dasin(swap)
          ins2=dasin(swap*r(ir-1)/r(ir))
          dlw=ins2-ins1
          tlw=(r(ir-1)*dcos(ins1)-r(ir)*dcos(ins2))/vel(ir-1)
          ddg(k)=ddg(k)+2.d0*dlw
          tps(k)=tps(k)+2.d0*tlw
        enddo
600     m=k-1
        if(test)then
          do k=1,m
            write(31,'(2f14.6,f13.6)')ddg(k)/deg2rad,tps(k),
     &          tkf(k)/deg2rad
          enddo
          write(31,'(a)')'            '
        endif
        nokay=0
        do i=1,nt
          do k=1,m-1
            if(disrad(i).ge.dmin1(ddg(k),ddg(k+1)).and.
     &         disrad(i).le.dmax1(ddg(k),ddg(k+1)))then
              if(ddg(k).eq.ddg(k+1))then
                a=1.d0
                b=0.d0
              else
                a=(ddg(k+1)-disrad(i))/(ddg(k+1)-ddg(k))
                b=1.d0-a
              endif
              tswap=a*tps(k)+b*tps(k+1)
              if(.not.okay(i).or.traveltime(i).gt.tswap)then
                traveltime(i)=tswap
                takeoff(i)=a*tkf(k)+b*tkf(k+1)
                okay(i)=.true.
              endif
            endif
          enddo
          if(okay(i))nokay=nokay+1
        enddo
      enddo
c
1000   continue
c
c     convert unit
c
      do i=1,nt
        if(irs.gt.1.and.takeoff(i).ge.0.5d0*pi)then
          slowness(i)=dsin(takeoff(i))/vel(irs-1)
        else
          slowness(i)=dsin(takeoff(i))/vel(irs)
        endif
        takeoff(i)=takeoff(i)/deg2rad
      enddo
c
      deallocate(okay,disrad,i1,i2,r,vel,tkf,ddg,tps)
c
      if(test)then
        close(31)
        pause
      endif
c
      if(nokay.lt.nt)then
        print *,zs,nokay,nt
        stop 'error in tpssub: a problem occurred!'
      endif
c
      return
      end

      subroutine qpsmat(ldeg,ly,lylw,lwup)
      use qpalloc
      implicit none
c
c     calculate 6x6 spheroidal layer matrix for a solid shell
c
      integer*4 ldeg,ly,lylw,lwup
c
      integer*4 i,j,key
      complex*16 cldeg,cxi,c2mu,cllm1,cllp1,c2lp1,c2lm1,c2lp3
      complex*16 cs2dp2,cxp2,cxs2
      complex*16 dphjup,dphjlw,dphyup,dphylw
      complex*16 ph0jup(2),ph1jup(2),ph0yup(2),ph1yup(2)
      complex*16 ph0jlw(2),ph1jlw(2),ph0ylw(2),ph1ylw(2)
      complex*16 ps0jup(2),ps0jlw(2),ps0yup(2),ps0ylw(2)
      complex*16 spb(2,4),mas(6,6)
      complex*16 spbphj,spbphy,spbpsj,spbpsy,spbdphj,spbdphy
c
      complex*16 ci,c1,c2,c3,c4
      data ci,c1,c2,c3,c4/(0.d0,1.d0),(1.d0,0.d0),(2.d0,0.d0),
     &                    (3.d0,0.d0),(4.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      c2mu=c2*cmu(ly)
      cxi=cla(ly)+c2mu
      cllm1=cldeg*(cldeg-c1)
      cllp1=cldeg*(cldeg+c1)
      c2lp1=c2*cldeg+c1
      c2lm1=c2*cldeg-c1
      c2lp3=c2*cldeg+c3
c
c     for upper radius
c
      cxp2=(kp(ly)*crrup(ly))**2
      cxs2=(ks(ly)*crrup(ly))**2
      if(ksmallp(ly).or.ksmalls(ly))then
        ph0jup(1)=spbphj(ldeg,kp(ly)*crrup(ly))
        ph1jup(1)=spbphj(ldeg+1,kp(ly)*crrup(ly))
        ps0jup(1)=spbpsj(ldeg,kp(ly)*crrup(ly))
c
        ph0yup(1)=spbphy(ldeg,kp(ly)*crrup(ly))
        ph1yup(1)=spbphy(ldeg-1,kp(ly)*crrup(ly))
        ps0yup(1)=spbpsy(ldeg,kp(ly)*crrup(ly))
      endif
      if(ksmallp(ly))then
        mas6x6up(1,1,ly)=cldeg*ph0jup(1)-cxp2*ph1jup(1)/c2lp3
        mas6x6up(2,1,ly)=(-cxi*cxp2+c2mu*cllm1)*ph0jup(1)
     &                   +c2*c2mu*cxp2*ph1jup(1)/c2lp3
        mas6x6up(3,1,ly)=ph0jup(1)
        mas6x6up(4,1,ly)=c2mu*((cldeg-c1)*ph0jup(1)
     &                   -cxp2*ph1jup(1)/c2lp3)
        mas6x6up(5,1,ly)=cga(ly)*ph0jup(1)
        mas6x6up(6,1,ly)=cga(ly)*(cldeg+c1)*ph0jup(1)
c
        mas6x6up(1,2,ly)=-(cldeg+c1)*ph0yup(1)
     &                   +cxp2*ph1yup(1)/c2lm1
        mas6x6up(2,2,ly)=(-cxi*cxp2+c2mu*(cldeg+c1)*(cldeg+c2))
     &                  *ph0yup(1)-c2*c2mu*cxp2*ph1yup(1)/c2lm1
        mas6x6up(3,2,ly)=ph0yup(1)
        mas6x6up(4,2,ly)=c2mu*(-(cldeg+c2)*ph0yup(1)
     &                         +cxp2*ph1yup(1)/c2lm1)
        mas6x6up(5,2,ly)=cga(ly)*ph0yup(1)
        mas6x6up(6,2,ly)=cga(ly)*(cldeg+c1)*ph0yup(1)
      else
        spb(1,1)=c1-zjup(ldeg,ly,1)
        spb(2,1)=-ci*zjup(ldeg,ly,1)
        spb(1,2)=c1
        spb(2,2)=zhup(ldeg,ly,1)
        do j=1,2
          mas6x6up(1,j,ly)=cldeg*spb(1,j)-spb(2,j)
          mas6x6up(2,j,ly)=(-cxi*cxp2+c2mu*cllm1)*spb(1,j)
     &                  +c2*c2mu*spb(2,j)
          mas6x6up(3,j,ly)=spb(1,j)
          mas6x6up(4,j,ly)=c2mu*((cldeg-c1)*spb(1,j)-spb(2,j))
          mas6x6up(5,j,ly)=cga(ly)*spb(1,j)
          mas6x6up(6,j,ly)=cga(ly)*(cldeg+c1)*spb(1,j)
        enddo
      endif
      if(ksmalls(ly))then
        ph0jup(2)=spbphj(ldeg,ks(ly)*crrup(ly))
        ph1jup(2)=spbphj(ldeg+1,ks(ly)*crrup(ly))
        ps0jup(2)=spbpsj(ldeg,ks(ly)*crrup(ly))
c
        ph0yup(2)=spbphy(ldeg,ks(ly)*crrup(ly))
        ph1yup(2)=spbphy(ldeg-1,ks(ly)*crrup(ly))
        ps0yup(2)=spbpsy(ldeg,ks(ly)*crrup(ly))
c
        cs2dp2=(cvs(ly)/cvp(ly))**2
        dphjup=spbdphj(ldeg,kp(ly)*crrup(ly),ks(ly)*crrup(ly))
     &            *(c1-(cvs(ly)/cvp(ly))**2)
        dphyup=spbdphy(ldeg,kp(ly)*crrup(ly),ks(ly)*crrup(ly))
     &        *(c1-(cvs(ly)/cvp(ly))**2)
c
        mas6x6up(1,3,ly)=cldeg*dphjup-c2*cs2dp2*ph1jup(1)
        mas6x6up(2,3,ly)=c2mu*(cllm1*dphjup-c2lp3*ph0jup(1)
     &                    +c4*cs2dp2*ph1jup(1)+c2*cldeg*ph1jup(2))
        mas6x6up(3,3,ly)=dphjup+c2*ph1jup(2)/(cldeg+c1)
        mas6x6up(4,3,ly)=c2mu*((cldeg-c1)*dphjup
     &                        +c2lp3*ph0jup(2)/(cldeg+c1)
     &                -c2*(cs2dp2*ph1jup(1)+ph1jup(2)/(cldeg+c1)))
        mas6x6up(5,3,ly)=-cga(ly)*cs2dp2*ps0jup(1)
        mas6x6up(6,3,ly)=cga(ly)*((cldeg+c1)*dphjup
     &                            -ps0jup(2)*c2lp1)
c
        mas6x6up(1,4,ly)=(cldeg+c1)*dphyup+c2*cs2dp2*ph1yup(1)
        mas6x6up(2,4,ly)=c2mu*(-(cldeg+c1)*(cldeg+c2)*dphyup
     &                 -c2lm1*ph0yup(1)-c4*cs2dp2*ph1yup(1)
     &                 +c2*(cldeg+c1)*ph1yup(2))
        mas6x6up(3,4,ly)=-dphyup+c2*ph1yup(2)/cldeg
        mas6x6up(4,4,ly)=c2mu*((cldeg+c2)*dphyup
     &                  -c2lm1*ph0yup(2)/cldeg
     &                  +c2*(cs2dp2*ph1yup(1)-ph1yup(2)/cldeg))
        mas6x6up(5,4,ly)=cga(ly)*cs2dp2*ps0yup(1)
        mas6x6up(6,4,ly)=-cga(ly)*(cldeg+c1)*dphyup
      else
        spb(1,3)=c1-zjup(ldeg,ly,2)
        spb(2,3)=-ci*zjup(ldeg,ly,2)
        spb(1,4)=c1
        spb(2,4)=zhup(ldeg,ly,2)
        do j=3,4
          mas6x6up(1,j,ly)=-cllp1*spb(1,j)
          mas6x6up(2,j,ly)=c2mu*cllp1*((c1-cldeg)*spb(1,j)+spb(2,j))
          mas6x6up(3,j,ly)=-(cldeg+c1)*spb(1,j)+spb(2,j)
          mas6x6up(4,j,ly)=cmu(ly)*((cxs2-c2*(cldeg**2-c1))*spb(1,j)
     &                    -c2*spb(2,j))
          mas6x6up(5,j,ly)=(0.d0,0.d0)
          mas6x6up(6,j,ly)=cga(ly)*cllp1*spb(1,j)
        enddo
      endif
c
      do j=5,6
        do i=1,6
          mas6x6up(i,j,ly)=(0.d0,0.d0)
        enddo
      enddo
      mas6x6up(5,5,ly)=c1
      mas6x6up(6,5,ly)=c2lp1
      mas6x6up(5,6,ly)=c1
c
      if(ly.eq.lylw.or.lwup.lt.0)return
c
c     for lower radius
c
      cxp2=(kp(ly)*crrlw(ly))**2
      cxs2=(ks(ly)*crrlw(ly))**2
c
      if(ksmallp(ly).or.ksmalls(ly))then
        ph0jlw(1)=spbphj(ldeg,kp(ly)*crrlw(ly))
        ph1jlw(1)=spbphj(ldeg+1,kp(ly)*crrlw(ly))
        ps0jlw(1)=spbpsj(ldeg,kp(ly)*crrlw(ly))
c
        ph0ylw(1)=spbphy(ldeg,kp(ly)*crrlw(ly))
        ph1ylw(1)=spbphy(ldeg-1,kp(ly)*crrlw(ly))
        ps0ylw(1)=spbpsy(ldeg,kp(ly)*crrlw(ly))
      endif
c
      if(ksmallp(ly))then
c
        mas6x6lw(1,1,ly)=cldeg*ph0jlw(1)-cxp2*ph1jlw(1)/c2lp3
        mas6x6lw(2,1,ly)=(-cxi*cxp2+c2mu*cllm1)*ph0jlw(1)
     &                   +c2*c2mu*cxp2*ph1jlw(1)/c2lp3
        mas6x6lw(3,1,ly)=ph0jlw(1)
        mas6x6lw(4,1,ly)=c2mu*((cldeg-c1)*ph0jlw(1)
     &                   -cxp2*ph1jlw(1)/c2lp3)
        mas6x6lw(5,1,ly)=cga(ly)*ph0jlw(1)
        mas6x6lw(6,1,ly)=cga(ly)*(cldeg+c1)*ph0jlw(1)
c
        mas6x6lw(1,2,ly)=-(cldeg+c1)*ph0ylw(1)
     &                   +cxp2*ph1ylw(1)/c2lm1
        mas6x6lw(2,2,ly)=(-cxi*cxp2+c2mu*(cldeg+c1)*(cldeg+c2))
     &                  *ph0ylw(1)-c2*c2mu*cxp2*ph1ylw(1)/c2lm1
        mas6x6lw(3,2,ly)=ph0ylw(1)
        mas6x6lw(4,2,ly)=c2mu*(-(cldeg+c2)*ph0ylw(1)
     &                         +cxp2*ph1ylw(1)/c2lm1)
        mas6x6lw(5,2,ly)=cga(ly)*ph0ylw(1)
        mas6x6lw(6,2,ly)=cga(ly)*(cldeg+c1)*ph0ylw(1)
      else
        spb(1,1)=c1-zjlw(ldeg,ly,1)
        spb(2,1)=-ci*zjlw(ldeg,ly,1)
        spb(1,2)=c1
        spb(2,2)=zhlw(ldeg,ly,1)
        do j=1,2
          mas6x6lw(1,j,ly)=cldeg*spb(1,j)-spb(2,j)
          mas6x6lw(2,j,ly)=(-cxi*cxp2+c2mu*cllm1)*spb(1,j)
     &                  +c2*c2mu*spb(2,j)
          mas6x6lw(3,j,ly)=spb(1,j)
          mas6x6lw(4,j,ly)=c2mu*((cldeg-c1)*spb(1,j)-spb(2,j))
          mas6x6lw(5,j,ly)=cga(ly)*spb(1,j)
          mas6x6lw(6,j,ly)=cga(ly)*(cldeg+c1)*spb(1,j)
        enddo
      endif
      if(ksmalls(ly))then
        ph0jlw(2)=spbphj(ldeg,ks(ly)*crrlw(ly))
        ph1jlw(2)=spbphj(ldeg+1,ks(ly)*crrlw(ly))
        ps0jlw(2)=spbpsj(ldeg,ks(ly)*crrlw(ly))
c
        ph0ylw(2)=spbphy(ldeg,ks(ly)*crrlw(ly))
        ph1ylw(2)=spbphy(ldeg-1,ks(ly)*crrlw(ly))
        ps0ylw(2)=spbpsy(ldeg,ks(ly)*crrlw(ly))
c
        cs2dp2=(cvs(ly)/cvp(ly))**2
        dphjlw=spbdphj(ldeg,kp(ly)*crrlw(ly),ks(ly)*crrlw(ly))
     &            *(c1-(cvs(ly)/cvp(ly))**2)
        dphylw=spbdphy(ldeg,kp(ly)*crrlw(ly),ks(ly)*crrlw(ly))
     &        *(c1-(cvs(ly)/cvp(ly))**2)
c
        mas6x6lw(1,3,ly)=cldeg*dphjlw-c2*cs2dp2*ph1jlw(1)
        mas6x6lw(2,3,ly)=c2mu*(cllm1*dphjlw-c2lp3*ph0jlw(1)
     &                    +c4*cs2dp2*ph1jlw(1)+c2*cldeg*ph1jlw(2))
        mas6x6lw(3,3,ly)=dphjlw+c2*ph1jlw(2)/(cldeg+c1)
        mas6x6lw(4,3,ly)=c2mu*((cldeg-c1)*dphjlw
     &                        +c2lp3*ph0jlw(2)/(cldeg+c1)
     &                -c2*(cs2dp2*ph1jlw(1)+ph1jlw(2)/(cldeg+c1)))
        mas6x6lw(5,3,ly)=-cga(ly)*cs2dp2*ps0jlw(1)
        mas6x6lw(6,3,ly)=cga(ly)*((cldeg+c1)*dphjlw
     &                            -ps0jlw(2)*c2lp1)
c
        mas6x6lw(1,4,ly)=(cldeg+c1)*dphylw+c2*cs2dp2*ph1ylw(1)
        mas6x6lw(2,4,ly)=c2mu*(-(cldeg+c1)*(cldeg+c2)*dphylw
     &                 -c2lm1*ph0ylw(1)-c4*cs2dp2*ph1ylw(1)
     &                 +c2*(cldeg+c1)*ph1ylw(2))
        mas6x6lw(3,4,ly)=-dphylw+c2*ph1ylw(2)/cldeg
        mas6x6lw(4,4,ly)=c2mu*((cldeg+c2)*dphylw
     &                  -c2lm1*ph0ylw(2)/cldeg
     &                  +c2*(cs2dp2*ph1ylw(1)-ph1ylw(2)/cldeg))
        mas6x6lw(5,4,ly)=cga(ly)*cs2dp2*ps0ylw(1)
        mas6x6lw(6,4,ly)=-cga(ly)*(cldeg+c1)*dphylw
      else
        spb(1,3)=c1-zjlw(ldeg,ly,2)
        spb(2,3)=-ci*zjlw(ldeg,ly,2)
        spb(1,4)=c1
        spb(2,4)=zhlw(ldeg,ly,2)
        do j=3,4
          mas6x6lw(1,j,ly)=-cllp1*spb(1,j)
          mas6x6lw(2,j,ly)=c2mu*cllp1*((c1-cldeg)*spb(1,j)+spb(2,j))
          mas6x6lw(3,j,ly)=-(cldeg+c1)*spb(1,j)+spb(2,j)
          mas6x6lw(4,j,ly)=cmu(ly)*((cxs2-c2*(cldeg**2-c1))*spb(1,j)
     &                    -c2*spb(2,j))
          mas6x6lw(5,j,ly)=(0.d0,0.d0)
          mas6x6lw(6,j,ly)=cga(ly)*cllp1*spb(1,j)
        enddo
      endif
c
      do j=5,6
        do i=1,6
          mas6x6lw(i,j,ly)=(0.d0,0.d0)
        enddo
      enddo
      mas6x6lw(5,5,ly)=c1
      mas6x6lw(6,5,ly)=c2lp1
      mas6x6lw(5,6,ly)=c1
c
      if(lwup.eq.0)then
c
c       calculate inverse matrix at upper radius
c
        do j=1,6
          do i=1,6
            mas(i,j)=mas6x6up(i,j,ly)
            mas6x6inv(i,j,ly)=(0.d0,0.d0)
          enddo
          mas6x6inv(j,j,ly)=c1
        enddo
      else
c
c       calculate inverse matrix at lower radius
c
        do j=1,6
          do i=1,6
            mas(i,j)=mas6x6lw(i,j,ly)
            mas6x6inv(i,j,ly)=(0.d0,0.d0)
          enddo
          mas6x6inv(j,j,ly)=c1
        enddo
      endif
      key=0
      call cdsvd500(mas,mas6x6inv(1,1,ly),6,6,0.d0,key)
      if(key.eq.0)then
        print *,' Warning in qpsmat: anormal exit from cdsvd500!'
        return
      endif
c
      return
      end

      subroutine qsve2am(n,ck,z,dynamic,y,c,nj,rsite)
      implicit none
c
c     converting displacement-stress vectors to wave amplitudes
c     by Langer block-diagonal decomposition technique for com-
c     putational efficiency
c
      integer*4 n,nj
      real*8 z
      complex*16 ck
      complex*16 y(4,nj),c(4,nj)
      logical*4 dynamic,rsite
c
      include 'qsglobal.h'
c
      integer*4 i,j,m,key
      complex*16 ca,cadp,cads
      complex*16 swap(4),a(4,4),b(4,4)
c
      if(rsite)then
        ca=(0.5d0,0.d0)/accrs(n)
        cadp=ca/kprs(n)
        cads=ca/ksrs(n)
        do j=1,nj
          swap(1)=(-wars(n)*y(1,j)+ck*y(4,j))*cadp
          swap(2)=(-y(2,j)+wbrs(n)*y(3,j))*ca
          swap(3)=(-ck*y(2,j)+wars(n)*y(3,j))*cads
          swap(4)=(wbrs(n)*y(1,j)-y(4,j))*ca
c
          c(1,j)= swap(1)+swap(2)
          c(2,j)=-swap(1)+swap(2)
          c(3,j)=-swap(3)+swap(4)
          c(4,j)= swap(3)+swap(4)
        enddo
      else if(dynamic)then
        ca=(0.5d0,0.d0)/acc(n)
        cadp=ca/kp(n)
        cads=ca/ks(n)
        do j=1,nj
          swap(1)=(-wa(n)*y(1,j)+ck*y(4,j))*cadp
          swap(2)=(-y(2,j)+wb(n)*y(3,j))*ca
          swap(3)=(-ck*y(2,j)+wa(n)*y(3,j))*cads
          swap(4)=(wb(n)*y(1,j)-y(4,j))*ca
c
          c(1,j)= swap(1)+swap(2)
          c(2,j)=-swap(1)+swap(2)
          c(3,j)=-swap(3)+swap(4)
          c(4,j)= swap(3)+swap(4)
        enddo
      else
        call qsmatrix0(b,ck,z,n)
        do i=1,4
          do j=1,4
            a(i,j)=(0.d0,0.d0)
          enddo
          a(i,i)=(1.d0,0.d0)
        enddo
        key=0
        call cdgemp(b,a,4,4,1.d-99,key)
        if(key.eq.0)then
          print *,'warning in qsve2am: anormal exit from cdgemp!'
          return
        endif
        do j=1,nj
          do i=1,4
            c(i,j)=(0.d0,0.d0)
            do m=1,4
              c(i,j)=c(i,j)+a(i,m)*y(m,j)
            enddo
          enddo
        enddo
      endif
c
      return
      end

        program edgmain
        implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	include 'edgglobal.h'
c
	double precision pi,pi2
	data pi,pi2/3.14159265358979d0,6.28318530717959d0/
	double precision zseps
	data zseps/1.0d-02/
c
        integer nr
        double precision r(nrmax)
        common /rprofile/ r,nr
c
        integer lp,nno(nzmax)
        double precision hp(nzmax)
        common /sublayer/ hp,lp,nno
c
c       zrec: receiver depth
c       lzrec: sublayer no of receiver
c
        integer lzrec
        double precision zrec
        common /receiver/ zrec,lzrec
c       
c       model parameter:
c       n0: number of homogeneous layers
c
        integer n0
        double precision h(lmax),ro(lmax),vp(lmax),vs(lmax)
        common /model/ h,ro,vp,vs,n0
c
c	original model parameters
c
	integer l0
        double precision z1(lmax),z2(lmax),ro1(lmax),ro2(lmax)
	double precision vp1(lmax),vp2(lmax),vs1(lmax),vs2(lmax)
	common /model0/z1,z2,ro1,ro2,vp1,vp2,vs1,vs2,l0
c
c       source parameters
c
        integer ls,ms,ics
        integer kpower(6)
        double precision zs,r0
        double precision sfct(6)
        common /source/ zs,r0,sfct,ls,ms,ics,kpower
c
c 	table of J_n(x), dJ_n(x)/dx and n*J_n(x)/x
c	all multiplied by sqrt(x)
c
	double precision bsdx,bsfct(0:nnbess1,3)
	common /bessels/ bsdx,bsfct
c
c       work space
c
        integer i,j,l,itty,ierr,izs,nzs,istype,len,unit
        double precision r1,r2,dr,zs1,zs2,dzs,lambda,mu
	double precision srate,moment
	double precision resolut(3)
        double precision u(10,nrmax)
        character*80 inputfile,outdir,grnfile0(3),reports(3)
	character*160 grnfile(3)
	character*180 dataline
c
c       read input file file
c
	print *,'######################################################'
	print *,'#                                                    #'
	print *,'#                  Welcome to                        #'
	print *,'#                                                    #'
	print *,'#                                                    #'
	print *,'#     EEEEE   DDDD     GGGG   RRRR    N   N          #'
	print *,'#     E       D   D   G       R   R   NN  N          #'
	print *,'#     EEEE    D   D   G GGG   RRRR    N N N          #'
	print *,'#     E       D   D   G   G   R R     N  NN          #'
	print *,'#     EEEEE   DDDD     GGGG   R  R    N   N          #'
	print *,'#                                                    #'
	print *,'#                                                    #'
	print *,'#                      by                            #'
	print *,'#                 Rongjiang Wang                     #'
	print *,'#              (wang@gfz-potsdam.de)                 #'
	print *,'#                                                    #'
	print *,'#           GeoForschungsZentrum Potsdam             #'
	print *,'#           first implemented: Nov. 2001             #'
	print *,'#              last update: March 2006               #'
	print *,'######################################################'
	print *,'                                                      '
	write(*,'(a,$)')' Please type the file name of input data: '
        read(*,'(a)')inputfile
        open(10,file=inputfile,status='old')
c
c	source-observation grid parameters
c	==================================
c
	call getdata(10,dataline)
        read(dataline,*)zrec
        call getdata(10,dataline)
	read(dataline,*)nr,r1,r2
	if(nr.le.1)then
	  stop ' Error in edgmain: number of distance samples < 2!'
	else if(nr.gt.nrmax)then
	  stop ' Error in edgmain: no of distance samples > nrmax!'
	else
	  dr=(r2-r1)/dble(nr-1)
	  if(dr.le.0.d0)then
	    stop ' Error in edgmain: wrong distance stepping!'
	  endif
          do i=1,nr
	    r(i)=r1+dr*dble(i-1)
	  enddo
	endif
        call getdata(10,dataline)
	read(dataline,*)nzs,zs1,zs2
	if(nzs.le.1)then
	  stop ' Error in edgmain: number of source depths < 2!'
	else if(nzs.gt.nzsmax)then
	  stop ' Error in edgmain: no of source depths > nzsmax!'
	else
	  dzs=(zs2-zs1)/dble(nzs-1)
	  if(dzs.le.0.d0)then
	    stop ' Error in edgmain: wrong source depth stepping!'
	  endif
	endif
	r0=0.5d0*dmax1(dzs,dr)
	do izs=1,nzs
	  zs=zs1+dble(izs-1)*dzs
	  if(dabs(zrec-zs).gt.0.d0
     &      .and.dabs(zrec-zs).le.zseps*dzs)then
	    zrec=zs
	    print *,'warning: an insignificant depth difference ',
     &              'between source and observation ignored!'
	  endif
	enddo
c
c	wavenumber integration parameters
c	=================================
c
	call getdata(10,dataline)
        read(dataline,*)srate
	if(srate.le.0.d0)srate=10.d0
	itty=1
c
c	output files
c	============
c
	call getdata(10,dataline)
        read(dataline,*)outdir,(grnfile0(i),i=1,3)
c
	len=index(outdir,' ')-1
c
	if(len.lt.1)then
	  stop ' Error in edkmain: wrong for output directory!'
	endif
c
	do i=1,3
	  grnfile(i)=outdir(1:len)//grnfile0(i)
	enddo
c
c	global model parameters
c	=======================
c
	do i=1,3
	  resolut(i)=5.d-02
	enddo
c
c	multilayered model parameters
c	=============================
c
	call getdata(10,dataline)
	read(dataline,*)l
	do i=1,l
	  call getdata(10,dataline)
	  read(dataline,*)j,h(i),vp(i),vs(i),ro(i)
	  if(vs(i).le.0.d0)vs(i)=1.0d-02*vp(i)
	enddo
c
c	end of inputs
c	=============
c
	close(10)
c
c	determine upper und lower parameter values of each layer
c
	l0=1
	do i=2,l
	  if(h(i).gt.h(i-1))then
	    z1(l0)=h(i-1)
	    vp1(l0)=vp(i-1)
	    vs1(l0)=vs(i-1)
	    ro1(l0)=ro(i-1)
c
	    z2(l0)=h(i)
	    vp2(l0)=vp(i)
	    vs2(l0)=vs(i)
	    ro2(l0)=ro(i)
	    l0=l0+1
	  else
	    z1(l0)=h(i)
	    vp1(l0)=vp(i)
	    vs1(l0)=vs(i)
	    ro1(l0)=ro(i)
	  endif
	enddo
	if(z1(l0).eq.0.d0)then
	    z1(l0)=h(l)
	    vp1(l0)=vp(l)
	    vs1(l0)=vs(l)
	    ro1(l0)=ro(l)
	endif
c
c       construction of sublayers at the cutoff frequency
c
	write(*,*)'   '
	if(itty.eq.1)then
	  write(*,*)'the multi-layered model used:'
	endif
	call edgsublay(resolut,itty,ierr)
	if(ierr.eq.1)then
	  stop 'the layer index (lmax) too small defined!'
	endif
c
      call edglayer(zs1,ls,zrec,lzrec,h,n0)
	mu=ro(nno(lzrec))*vs(nno(lzrec))*vs(nno(lzrec))
	lambda=ro(nno(lzrec))*vp(nno(lzrec))*vp(nno(lzrec))-2.d0*mu
	reports(1)='Source type: strike-slip'
	reports(2)='Source type: dip-slip'
	reports(3)='Source type: compensated linear vector dipole'
	len=index(inputfile,' ')-1
c
	do istype=1,3
c
c         open output file
c
	  unit=20+istype
	  write(*,'(a45)')reports(istype)
	  open(unit,file=grnfile(istype),status='unknown')
	  write(unit,'(a)')'# Green functions calculated with '
     &                     //'the program edgrn'
	  write(unit,'(a)')'# The input data file is '
     &                    //inputfile(1:len)
	  write(unit,'(a,a45,a)')'# ',reports(istype),
     &                    '   Dislocation: 1 meter'
	  write(unit,'(a)')'# The 1. data line includes the parameters:'
	  write(unit,'(a)')'#'
	  write(unit,'(a,$)')'# nr, r1[m], r2[m]; '
	  write(unit,'(a,$)')'nzs, zs1[m], zs2[m]; obs.depth[m];'
	  write(unit,'(a)')' lambda[Pa], mu[Pa] (at obs. depth)'
	  write(unit,'(a)')'#'
	  write(unit,'(a)')'# The following data lines are'
	  write(unit,'(a)')'#'
	  if(istype.le.2)then
	    write(unit,'(a)')'#   uz[m]         ur[m]         ut[m] '
     &        //'        ezz           err           ett   '
     &        //'        ezr           ert           etz   '
     &        //'        duz/dr'
	  else
	    write(unit,'(a)')'#   uz[cm]        ur[cm]'
     &        //'        ezz           err           ett   '
     &        //'        ezr           duz/dr'
	  endif
	  write(unit,'(a)')'#'
	  write(unit,1001)nr,r1,r2,nzs,zs1,zs2,zrec,lambda,mu
c
c	  calculate Bessel function tables
c
	  call edgbstab(3-istype)
c
	  do izs=1,nzs
	    zs=zs1+dble(izs-1)*dzs
          call edglayer(zs,ls,zrec,lzrec,h,n0)
	    moment=ro(nno(ls))*vs(nno(ls))*vs(nno(ls))
	    call edgmoment(istype,moment,ro(nno(ls)),
     &                     vp(nno(ls)),vs(nno(ls)))
c
            call edgwvint(u,r,nr,srate,lambda,mu,itty)
	    if(istype.le.2)then
	      do j=1,nr
	        write(unit,'(10E14.6)')(u(i,j),i=1,10)
	      enddo
	    else
	      do j=1,nr
	        write(unit,'(10E14.6)')(u(i,j),i=1,2),(u(i,j),i=4,7)
     &                               ,u(10,j)
	      enddo
	    endif
	  enddo
	  close(unit)
	enddo
	print *,'######################################################'
	print *,'#                                                    #'
	print *,'#        Successful computations with EDGRN          #'
	print *,'#                                                    #'
	print *,'######################################################'
1001	format(2(i4,2E13.5),4E13.5)
 500    stop
        end

      program qpmain
      use qpalloc
      implicit none
c
      include 'qpglobal.h'
c
c     work space
c
      integer i,j,ig,ldegcut,ierr,runtime
      integer time
      character*128 arg,inputindex,inputfile,leftpart,rightpart
c     
c
c
      write(*,'(a)') 'Please enter the input file name:'
      read(*,'(a)') inputfile
      open(10,file=inputfile,status='old')
      call qpgetinp(10)
      close(10)
c
      call qpsublayer(ierr)
c
      call qpdocu(ierr)
c
      call qpbounds(ldegcut)
      allocate (plm(0:ldegcut,0:2,nr),stat=ierr)
      allocate (lylwsh(0:ldegcut),stat=ierr)
      allocate (lylwpsv(0:ldegcut),stat=ierr)
      allocate (lyupatm(0:ldegcut),stat=ierr)
      allocate (zjup(0:ldegcut,ly0,3),stat=ierr)
      allocate (zjlw(0:ldegcut,ly0,3),stat=ierr)
      allocate (zhup(0:ldegcut,ly0,3),stat=ierr)
      allocate (zhlw(0:ldegcut,ly0,3),stat=ierr)
      allocate (wj(0:ldegcut,ly0,3),stat=ierr)
      allocate (wh(0:ldegcut,ly0,3),stat=ierr)
      allocate (zjupg(0:ldegcut),stat=ierr)
      allocate (zjlwg(0:ldegcut),stat=ierr)
      allocate (zhupg(0:ldegcut),stat=ierr)
      allocate (zhlwg(0:ldegcut),stat=ierr)
      allocate (wjg(0:ldegcut),stat=ierr)
      allocate (whg(0:ldegcut),stat=ierr)
      allocate (yr(0:ldegcut,4,0:ndmax),stat=ierr)
      allocate (yt(0:ldegcut,4,0:ndmax),stat=ierr)
      allocate (yp(0:ldegcut,4,0:ndmax),stat=ierr)
      allocate (vgrnr(nf,nr,4),stat=ierr)
      allocate (vgrnt(nf,nr,4),stat=ierr)
      allocate (vgrnp(nf,nr,4),stat=ierr)
c
      do ig=1,ngrn
        if(grnsel(ig).eq.1)then
          lys=lygrn(ig)
          call qpgrnspec(ig,ldegcut)
        endif
      enddo
      call qpwvint(ldegcut)
c
      deallocate (plm,stat=ierr)
      deallocate (lylwsh,stat=ierr)
      deallocate (lylwpsv,stat=ierr)
      deallocate (lyupatm,stat=ierr)
      deallocate (zjup,stat=ierr)
      deallocate (zjlw,stat=ierr)
      deallocate (zhup,stat=ierr)
      deallocate (zhlw,stat=ierr)
      deallocate (wj,stat=ierr)
      deallocate (wh,stat=ierr)
      deallocate (zjupg,stat=ierr)
      deallocate (zjlwg,stat=ierr)
      deallocate (zhupg,stat=ierr)
      deallocate (zhlwg,stat=ierr)
      deallocate (wjg,stat=ierr)
      deallocate (whg,stat=ierr)
      deallocate (yr,stat=ierr)
      deallocate (yt,stat=ierr)
      deallocate (yp,stat=ierr)
      deallocate (vgrnr,stat=ierr)
      deallocate (vgrnt,stat=ierr)
      deallocate (vgrnp,stat=ierr)
c
      stop
      end

      subroutine cdgemp(a,b,n,n1,eps,key)
      implicit none
c-------------------------------------------------------------------------------
c     subroutine gemp to solve linear equation system                          i
c     a: coefficient matrix(n,n);                                              i
c     b: right-hand matrix(n,n1) by input,                                     i
c        solution matrix(n,n1) by return;                                      i
c     eps: control constant;                                                   i
c     key: if the main term of a column is                                     i
c          smaller than eps, key=0: anormal return,                            i
c          else key=1: normal return.                                          i
c-------------------------------------------------------------------------------
      integer*4 n,n1,key
      real*8 eps
      complex*16 a(n,n),b(n,n1)
c
      integer*4 i,j,k,l,m
      real*8 p
      complex*16 q
c
      do m=1,n
        p=0.d0
        do i=m,n
          do j=1,n
            if(cdabs(a(i,j)).le.p)goto 10
            p=cdabs(a(i,j))
            k=i
            l=j
10        continue
          enddo
        enddo
        key=0
        if(p.le.eps)return
        do j=1,n
          q=a(k,j)
          a(k,j)=a(m,j)
          a(m,j)=q
        enddo
        do j=1,n1
          q=b(k,j)
          b(k,j)=b(m,j)
          b(m,j)=q
        enddo
        do i=1,n
          q=-a(i,l)/a(m,l)
          if(i.eq.m)goto 20
          do j=1,n
            a(i,j)=a(i,j)+a(m,j)*q
          enddo
          do j=1,n1
            b(i,j)=b(i,j)+b(m,j)*q
          enddo
20        continue
        enddo
        q=a(m,l)
        do j=1,n
          a(m,j)=a(m,j)/q
        enddo
        do j=1,n1
          b(m,j)=b(m,j)/q
        enddo
      enddo
      do j=1,n
        do i=1,n
          if(cdabs(a(i,j)).lt.0.5d0)goto 30
          do k=1,n
            q=a(i,k)
            a(i,k)=a(j,k)
            a(j,k)=q
          enddo
          do k=1,n1
            q=b(i,k)
            b(i,k)=b(j,k)
            b(j,k)=q
          enddo
30        continue
        enddo
      enddo
      key=1
      return
      end

        subroutine edgwvint(u,r,nr,srate,lambda,mu,itty)
        implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
        integer nr,itty
        double precision srate,lambda,mu
c
	include 'edgglobal.h'
c
        double precision r(nrmax)
        double precision u(10,nrmax)
c
c 	table of J_n(x), dJ_n(x)/dx and n*J_n(x)/x
c	all multiplied by sqrt(x)
c
	double precision bsdx,bsfct(0:nnbess1,3)
	common /bessels/ bsdx,bsfct
c
        double precision eps,eps0
        data eps,eps0/1.0d-08,1.0d-03/
	double precision pi,pi2
	data pi,pi2/3.14159265358979d0,6.28318530717959d0/
c
        integer lp,nno(nzmax)
        double precision hp(nzmax)
        common /sublayer/ hp,lp,nno
c
c       zrec: receiver depth
c       lzrec: sublayer no of receiver
c
        integer lzrec
        double precision zrec
        common /receiver/ zrec,lzrec
c       
c       model parameter:
c       n0: number of model layers
c
        integer n0
        double precision h(lmax),ro(lmax),vp(lmax),vs(lmax)
        common /model/ h,ro,vp,vs,n0
c
c       source parameters
c
        integer ls,ms,ics
        integer kpower(6)
        double precision zs,r0
        double precision sfct(6)
        common /source/ zs,r0,sfct,ls,ms,ics,kpower
c
c       parameters for hankel integrations
c
        integer i,ir,ir1,ncall,ik,nk,nx
        double precision k,k0,klimit,dk,x,wl,wr
        double precision cs,fps,fsh,fac,yabs,dyabs,ymax
        double precision y(6),y0(6),u0(6),uk0(6),bs(3),bs1(3)
	double precision r00(nrmax)
        logical ps,sh,analytic
c
c	ics = 1  when the azmuth-factor is cos(ms*theta) for poloidal mode
c	         (psv) and sin(ms*theta) for the toroidal mode (sh);
c	ics = -1 otherwise.
c
        cs=dble(ics)
	fps=0.d0
	do i=1,4
	  fps=fps+dabs(sfct(i))
	enddo
	if(fps.gt.0.d0)then
	  ps=.true.
	else
	  ps=.false.
	endif
	fsh=0.d0
	do i=5,6
	  fsh=fsh+dabs(sfct(i))
	enddo
	if(fsh.gt.0.d0)then
	  sh=.true.
	else
	  sh=.false.
	endif
c
c	u: 1=uz, 2=ur, 3=ut, 4=ezz, 5=err, 6=ett, 7=ezr, 8=ert, 9=etz
c	  10=duz/dr
c	NOTE: uz, ur, ezz, err, ett, ezr duz/dr have the same azimuth-factor
c	      as the poloidal mode (p-sv);
c	      ut, ert and etz have the same azimuth-factor as the
c	      toroidal mode (sh);
c
        do ir=1,nr
	  r00(ir)=dmax1(r0,1.0d-02*dabs(zs-zrec),1.0d-02*r(ir))
          do i=1,10
            u(i,ir)=0.d0
          enddo
        enddo
	do i=1,6
	  u0(i)=0.d0
	  uk0(i)=0.d0
	enddo
	do i=1,6
	  y0(i)=0.d0
	enddo
c
c	determine wavenumber limit
c
c	determine limits of y(i), i=1,...,6
c
        ncall=0
	if(zs.eq.zrec)then
	  k0=eps0*pi2/(r0+dabs(zs-zrec)+r(nr))
          ymax=0.d0
10        yabs=0.d0
          call edgkern(y,k0,ps,sh,eps)
          ncall=ncall+1
          do i=1,5,2
            yabs=yabs+y(i)*y(i)
          enddo
	  yabs=k0*dsqrt(k0*yabs)*dexp(-(k0*r0)**2)
	  ymax=dmax1(ymax,yabs)
          if(yabs.gt.eps0*ymax)then
            k0=1.25d0*k0
            goto 10
          endif
c
	  analytic=.true.
c
	  k=eps0*pi2/(r0+dabs(zs-zrec)+r(nr))
20	  call edgkern(y,k,ps,sh,eps)
          ncall=ncall+1
	  do i=2,6,2
	    y(i)=y(i)/(k*mu)
	  enddo
	  yabs=0.d0
	  dyabs=0.d0
	  do i=1,6
	    yabs=yabs+y(i)**2
	    dyabs=dyabs+(y(i)-y0(i))**2
	    y0(i)=y(i)
	  enddo
	  if(dyabs.gt.eps*yabs)then
	    if(k.ge.k0)then
	      analytic=.false.
	      do i=1,6
	        y0(i)=0.d0
	      enddo
	    else
	      k=1.25d0*k
	      goto 20
	    endif
	  endif
	  do i=2,6,2
	    y0(i)=y0(i)*mu
	  enddo
	else
	  analytic=.false.
	endif
c
	klimit=eps*pi2/(r0+dabs(zs-zrec)+r(nr))
        ymax=0.d0
30      yabs=0.d0
        call edgkern(y,klimit,ps,sh,eps)
        ncall=ncall+1
        do i=1,5,2
          yabs=yabs+(y(i)-y0(i))**2
        enddo
	yabs=klimit*dsqrt(klimit*yabs)*dexp(-(klimit*r00(1))**2)
	ymax=dmax1(ymax,yabs)
        if(yabs.gt.eps0*ymax)then
          klimit=1.2d0*klimit
          goto 30
        endif
c
c	determine wavenumber sampling rate
c
	dk=pi2/(srate*(r00(1)+r(nr))+dabs(zs-zrec))
	nk=500+idnint(klimit/dk)
	dk=klimit/dble(nk)
c
c	too small distances will be treated as r = 0!
c
	if(r(1).gt.0.d0)then
	  ir1=1
	else
	  ir1=2
	endif
c
        do ik=1,nk
          k=dble(ik)*dk
          call edgkern(y,k,ps,sh,eps)
	  if(analytic)then
	    do i=1,5,2
	      y(i)=y(i)-y0(i)
	    enddo
	    do i=2,6,2
	      y(i)=y(i)-y0(i)*k
	    enddo
	  else if(ir1.eq.2)then
c
c	  for r=0
c
	    fac=k*dexp(-(k*r00(1))**2)*dk
	    do i=1,6
	      u0(i)=u0(i)+y(i)*fac
	      uk0(i)=uk0(i)+y(i)*k*fac
	    enddo
	  endif
          do ir=ir1,nr
	    fac=dsqrt(k)*dk*dexp(-(k*r00(ir))**2)/dsqrt(r(ir))
	    x=k*r(ir)
c
c	    bessels functions from pre-calculated tables
c
	    nx=idint(x/bsdx)
	    wr=x/bsdx-dble(nx)
	    wl=1.d0-wr
	    if(nx.gt.nnbess)then
	      nx=nnbess+mod(nx-nnbess,ndbess)
	      do i=1,3
	        bs(i)=fac*(wl*bsfct(nx,i)+wr*bsfct(nx+1,i))
	      enddo
	      bs(3)=bs(3)*(dble(nx)+wr)*bsdx/x
	    else
	      do i=1,3
	        bs(i)=fac*(wl*bsfct(nx,i)+wr*bsfct(nx+1,i))
	      enddo
	    endif
c
c	    u1-3 are displacement components:
c	    u4 = normal stress: szz
c	    u5 = surface strain: err+ett
c	    u6 will be derived later
c	    u7 = shear stress: szr
c	    u8 = strain component: dut/dr - (dur/dt)/r + ut/r
c	    u9 = shear stress: szt
c	    u10 = tilt: duz/dr
c
	    u(1,ir)=u(1,ir)+y(1)*bs(1)
	    u(2,ir)=u(2,ir)+y(3)*bs(2)+cs*y(5)*bs(3)
	    u(3,ir)=u(3,ir)-cs*y(3)*bs(3)-y(5)*bs(2)
	    u(4,ir)=u(4,ir)+y(2)*bs(1)
	    u(5,ir)=u(5,ir)-y(3)*k*bs(1)
	    u(7,ir)=u(7,ir)+y(4)*bs(2)+cs*y(6)*bs(3)
	    u(8,ir)=u(8,ir)+y(5)*k*bs(1)
	    u(9,ir)=u(9,ir)-cs*y(4)*bs(3)-y(6)*bs(2)
	    u(10,ir)=u(10,ir)+y(1)*k*bs(2)
	  enddo
        enddo
c
c       end of total integral
c
        if(itty.eq.1)then
          write(*,'(a,i7,a,i7)')'   wavenumber samples: ',ncall+nk,
     &                          ', really used: ',nk
        endif
c
	if(ir1.eq.2.and..not.analytic)then
c
c	  for very small r including r=0
c
	  if(ms.eq.0)then
	    u(1,1)=u0(1)
	    u(4,1)=u0(2)
	    u(5,1)=-0.5d0*uk0(3)
	    u(6,1)=u(5,1)
	  else if(ms.eq.1)then
	    u(2,1)=0.5d0*(u0(3)+cs*u0(5))
	    u(3,1)=-0.5d0*(cs*u0(3)+u0(5))
	    u(7,1)=0.5d0*(u0(4)+cs*u0(6))
	    u(9,1)=-0.5d0*(cs*u0(4)+u0(6))
	    u(10,1)=0.5d0*uk0(1)
	  else if(ms.eq.2)then
	    u(5,1)=0.25d0*(uk0(3)+cs*uk0(5))
	    u(6,1)=-u(5,1)
	    u(8,1)=-0.25d0*(cs*uk0(3)+uk0(5))
	  endif
	endif
	do ir=ir1,nr
	  if(analytic)then
	    if(ms.eq.0)then
	      bs(1)=0.d0
	      bs(2)=-1.d0/r(ir)**2
	      bs(3)=0.d0
	      bs1(1)=-1.d0/r(ir)**3
	      bs1(2)=0.d0
	      bs1(3)=0.d0
	    else if(ms.eq.1)then
	      bs(1)=1.d0/r(ir)**2
	      bs(2)=-1.d0/r(ir)**2
	      bs(3)=1.d0/r(ir)**2
	      bs1(1)=0.d0
	      bs1(2)=-2.d0/r(ir)**3
	      bs1(3)=1.d0/r(ir)**3
	    else if(ms.eq.2)then
	      bs(1)=2.d0/r(ir)**2
	      bs(2)=-1.d0/r(ir)**2
	      bs(3)=2.d0/r(ir)**2
	      bs1(1)=3.d0/r(ir)**3
	      bs1(2)=-4.d0/r(ir)**3
	      bs1(3)=4.d0/r(ir)**3
	    endif
	    u(1,ir)=u(1,ir)+y0(1)*bs(1)
	    u(2,ir)=u(2,ir)+y0(3)*bs(2)+cs*y0(5)*bs(3)
	    u(3,ir)=u(3,ir)-y0(5)*bs(2)-cs*y0(3)*bs(3)
	    u(4,ir)=u(4,ir)+y0(2)*bs1(1)
	    u(5,ir)=u(5,ir)-y0(3)*bs1(1)
	    u(7,ir)=u(7,ir)+y0(4)*bs1(2)+cs*y0(6)*bs1(3)
	    u(8,ir)=u(8,ir)+y0(5)*bs1(1)
	    u(9,ir)=u(9,ir)-y0(6)*bs1(2)-cs*y0(4)*bs1(3)
	    u(10,ir)=u(10,ir)+y0(1)*bs1(2)
	  endif
c
c	  u6 is ett = ur/r + (dut/dt)/r
c
	  u(6,ir)=(u(2,ir)+cs*dble(ms)*u(3,ir))/r(ir)
c
c	  u5 now is err = u5(before) - ett
c
	  u(5,ir)=u(5,ir)-u(6,ir)
c
c	  u8 now is ert = 0.5 * u8(before) + (dur/dt)/r - ut/r
c	                = 0.5 * (dut/dr + (dur/dt)/r - ut/r)
c
	  u(8,ir)=0.5d0*u(8,ir)-(cs*dble(ms)*u(2,ir)+u(3,ir))/r(ir)
	enddo
	do ir=1,nr
	  u(4,ir)=(u(4,ir)-lambda*(u(5,ir)+u(6,ir)))/(lambda+2.d0*mu)
	  u(7,ir)=u(7,ir)/(2.d0*mu)
	  u(9,ir)=u(9,ir)/(2.d0*mu)
	enddo
c
        return
        end

      real*8 function taper(k,kcut1,kcut2,kcut3,kcut4)
      implicit none
c
      real*8 k,kcut1,kcut2,kcut3,kcut4
      real*8 pid2
c
      pid2=2.d0*datan(1.d0)
      if(k.gt.kcut1.and.k.lt.kcut2)then
c
c       within the lower end taper
c
        taper=dcos(pid2*(kcut2-k)/(kcut2-kcut1))
      else if(k.gt.kcut3.and.k.lt.kcut4)then
c
c       within the higher end taper
c
        taper=dcos(pid2*(k-kcut3)/(kcut4-kcut3))
      else if(k.ge.kcut2.and.k.le.kcut3)then
        taper=1.d0
      else
        taper=0.d0
      endif
c
      return
      end

      subroutine qpgetinp(unit)
      implicit none
      integer unit
c
      include 'qpglobal.h'
c
c     work space
c
      integer i,j,l,ir,ig,isg,is,is1,flen,iswap,nhypo
      double precision twindow,twinout,suppress,r1,r2,dr,dr1,dr2
      double precision dswap(11)
      character*128 fswap
      character*180 comments
c
c     uniform receiver depth
c     ======================
c
      call getdata(unit,comments)
      read(comments,*)dpr
      dpr=KM2M*dpr
c
c     time (frequency) sampling
c     =========================
c
      call getdata(unit,comments)
      read(comments,*)twindow,dt
      ntcut=1+idnint(twindow/dt)
      nt=2
100   nt=2*nt
      if(nt.lt.ntcut)goto 100
      nf=nt/2
      if(nf.gt.nfmax)then
        stop 'Error: nfmax defined in qpglobal.h too small!'
      endif
      df=1.d0/(dble(nt)*dt)
c
      call getdata(unit,comments)
      read(comments,*)fcut
      nfcut=min0(nf,1+idnint(fcut/df))
      fcut=dble(nfcut-1)*df
      call getdata(unit,comments)
      read(comments,*)slwmax
      slwmax=slwmax/KM2M
c
      call getdata(unit,comments)
      read(comments,*)suppress
      if(suppress.le.0.d0.or.suppress.ge.1.d0)then
        fi=0.d0
      else
        fi=dlog(suppress)*df/PI2
      endif
c
c     cutoffs of spectra
c     ==================
c
      call getdata(unit,comments)
      read(comments,*)fgr,ldeggr
      if(fgr.lt.0.d0)fgr=0.d0
      if(ldeggr.lt.0)ldeggr=0
      if(fgr.gt.0.d0.and.ldeggr.le.0.or.
     &   fgr.le.0.d0.and.ldeggr.gt.0)then
        stop ' Bad fgr and ldeggr combination!'
      endif
      nogravity=fgr*dble(ldeggr).le.0.d0
c
      call getdata(unit,comments)
      read(comments,*)i,j
      selpsv=i.eq.1
      selsh=j.eq.1
      if(.not.(selpsv.or.selsh))then
        stop ' Error: none of PSV and SH is selected!'
      endif
c
c     Green's function files
c     ======================
c
      call getdata(unit,comments)
      read(comments,*)spcgrndir
      call getdata(unit,comments)
      read(comments,*)ngrn
      if(ngrn.le.0)then
        stop ' bad number of source depths!'
      else if(ngrn.gt.ngrnmax)then
        stop ' number of source depths exceeds the maximum!'
      endif
c
      do ig=1,ngrn
        call getdata(unit,comments)
        read(comments,*)grndep(ig),rr0(ig),grnfile(ig),grnsel(ig)
        if(grnsel(ig).lt.0.or.grnsel(ig).gt.1)then
          stop ' bad Green function selection!'
        endif
        grndep(ig)=grndep(ig)*KM2M
        rr0(ig)=rr0(ig)*KM2M
      enddo
c
c     sort green function files by source depth
c
      do i=1,ngrn
        do j=i+1,ngrn
          if(grndep(j).lt.grndep(i))then
            dswap(1)=grndep(i)
            fswap=grnfile(i)
            iswap=grnsel(i)
c
            grndep(i)=grndep(j)
            grnfile(i)=grnfile(j)
            grnsel(i)=grnsel(j)
c
            grndep(j)=dswap(1)
            grnfile(j)=fswap
            grnsel(j)=iswap
          endif
        enddo
      enddo
c
      do flen=128,1,-1
        if(spcgrndir(flen:flen).ne.' ')goto 200
      enddo
200   continue
      do ig=1,ngrn
        rgrnfile(ig)=spcgrndir(1:flen)//'R_'//grnfile(ig)
        tgrnfile(ig)=spcgrndir(1:flen)//'T_'//grnfile(ig)
        pgrnfile(ig)=spcgrndir(1:flen)//'P_'//grnfile(ig)
      enddo
c
c     receiver parameters
c     ===================
c
      call getdata(unit,comments)
      read(comments,*)stdgrndir
c
      do flen=128,1,-1
        if(stdgrndir(flen:flen).ne.' ')goto 300
      enddo
300   continue
      do ig=1,ngrn
        stdgrnfile(ig)=stdgrndir(1:flen)//grnfile(ig)
      enddo
c
      call getdata(unit,comments)
      read(comments,*)infofile
      infofile=stdgrndir(1:flen)//infofile
c
      call getdata(unit,comments)
      read(comments,*)twinout,dtout
      if(twinout.gt.twindow)then
        stop ' Error: too large time window for space-time domain!'
      endif
      if(dtout.le.0.d0)then
        stop ' Error: wrong time sampling for space-time domain!'
      else if(dtout.lt.dt)then
        stop ' Error: too small time interval for space-time domain!'
      endif
      ntout=1+idnint(twinout/dtout)
c
      call getdata(unit,comments)
      read(comments,*)tstart,vreduc
      if(vreduc.le.0.d0)then
        stop ' Error in qpgetinp: wrong time reduction parameter!'
      endif
      vreduc=vreduc*KM2M
c
      call getdata(unit,comments)
      read(comments,*)tau
      call getdata(unit,comments)
      read(comments,*)nlpf,fcorner
      call getdata(unit,comments)
      read(comments,*)r1,r2,dr1,dr2
      if(r1.lt.0.d0.or.r1.gt.r2.or.dr1.le.0.d0.or.dr1.gt.dr2)then
        stop ' Error: wrong epidistance sampling for Green functions!'
      else
        r1=r1*KM2M
        r2=r2*KM2M
        dr1=dr1*KM2M
        dr2=dr2*KM2M
        nr=1+idnint(2.d0*(r2-r1)/(dr1+dr2))
        if(nr.gt.nrmax)then
          stop ' Error in qpgetinp: nrmax defined too small!'
        endif
        dism(1)=r1
        dism(nr)=r2
        if(nr.gt.2)then
          dr=(r2-r1)/dble(nr-1)
          dr1=dr1*2.d0*dr/(dr1+dr2)
          dr2=dr2*2.d0*dr/(dr1+dr2)
          do i=2,nr-1
            dr=dr1+(dr2-dr1)*dble(i-2)/dble(nr-2)
            dism(i)=dism(i-1)+dr
          enddo
        endif
        do i=1,nr
c
c         rounded to meter
c
          dism(i)=dble(idnint(dism(i)))
          disrad(i)=dism(i)/REARTH
        enddo
      endif
c
c     multilayered model parameters
c     =============================
c
      call getdata(unit,comments)
      read(comments,*)l,i
      if(l.ge.lymax-2)then
        stop ' Error: lymax defined too small!'
      endif
      if(i.eq.1)then
        dispersion=.true.
      else
        dispersion=.false.
      endif
c
      qsmin=10000.d0
      depatmos=0.d0
      rratmos=REARTH
      do i=1,l
        call getdata(unit,comments)
        read(comments,*)j,dp0(i),vp0(i),vs0(i),ro0(i),qp0(i),qs0(i)
c
c       input units:    -,km,  km/s, km/s, g/cm^3,-,-
c
        if(i.eq.1)then
          depatmos=-KM2M*dp0(1)
          rratmos=REARTH+depatmos
        endif
        dp0(i)=KM2M*dp0(i)+depatmos
        vp0(i)=KM2M*vp0(i)
        vs0(i)=KM2M*vs0(i)
        ro0(i)=KM2M*ro0(i)
        if(vs0(i).gt.0.d0)qsmin=dmin1(qsmin,qs0(i))
        if(i.gt.1)then
          if(dp0(i).lt.dp0(i-1))then
            stop ' Error: bad layering of earth model!'
          endif
        endif
      enddo
c
      dpr=dpr+depatmos
      do i=1,ngrn
        grndep(i)=grndep(i)+depatmos
      enddo
c
      if(dp0(1).ne.0.d0)then
        stop ' Error: bad start depth!'
      else if(dp0(l).gt.rratmos)then
        stop ' Error: bad definition of earth radius!'
      else if(dp0(l).lt.rratmos)then
        l=l+1
        if(l.ge.lymax-2)stop ' Error: lymax defined too small!'
        dp0(l)=rratmos
        vp0(l)=vp0(l-1)
        vs0(l)=vs0(l-1)
        ro0(l)=ro0(l-1)
        qp0(l)=qp0(l-1)
        qs0(l)=qs0(l-1)
      endif
c
      l0=0
      do i=2,l
        if(dp0(i).gt.dp0(i-1))then
          l0=l0+1
          dp0up(l0)=dp0(i-1)
          vp0up(l0)=vp0(i-1)
          vs0up(l0)=vs0(i-1)
          ro0up(l0)=ro0(i-1)
          qp0up(l0)=qp0(i-1)
          qs0up(l0)=qs0(i-1)
c
          dp0lw(l0)=dp0(i)
          vp0lw(l0)=vp0(i)
          vs0lw(l0)=vs0(i)
          ro0lw(l0)=ro0(i)
          qp0lw(l0)=qp0(i)
          qs0lw(l0)=qs0(i)
        endif
      enddo
c
c     end of inputs
c     =============
c
      return
      end

	subroutine edcgrn(ns,nrec,grndir,grnss0,grnds0,grncl0)
	implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	integer ns,nrec
	character*80 grndir,grnss0,grnds0,grncl0
c
	include 'edcglobal.h'
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	RECTANGULAR SOURCE PLANES
c	=========================
c
c	(xs,ys,zs) = coordinates of the start point of strike
c	with x = north, y = east, z = downward.
c	all angles in degree.
c	NSMAX = the max. number of source rectangles
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision dislocation(NSMAX)
	double precision xs(NSMAX),ys(NSMAX),zs(NSMAX)
	double precision length(NSMAX),width(NSMAX)
	double precision strike(NSMAX),dip(NSMAX),rake(NSMAX)
c
	common/rectangles/dislocation,xs,ys,zs,length,width,
     &                    strike,dip,rake
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	OBSERVATION POSITIONS AND OBSERVABLES
c	=====================================
c
c	(xrec(i),yrec(i),zrec0)=coordinates of the observation positions
c	(Note that zrec0 is fixed)
c	disp = the 3 displcement vector components: ux,uy,uz
c	strain = the 6 strain tensor components: exx,eyy,ezz,exy,eyz,ezx
c	tilt = the two vertical tilt components: dux/dz, duy/dz
c	NRECMAX = the max. number of observation positions
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision xrec(NRECMAX),yrec(NRECMAX)
	double precision zrec0
	double precision disp(NRECMAX,3),strain(NRECMAX,6)
	double precision tilt(NRECMAX,2)
c
	common/obsarray/xrec,yrec,zrec0,disp,strain,tilt
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	DISTRETE POINT SOURCES
c	======================
c
c	(xs,ys,zs) = coordinates of the discrete point sources
c	with x = north, y = east, z = downward
c	angles in degree.
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision pxs(NPSMAX),pys(NPSMAX),pzs(NPSMAX)
	double precision pmoment(5,NPSMAX)
c
	common/pointsources/pxs,pys,pzs,pmoment
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	ELASTIC PARAMETERS AT OBSERVATION DEPTH
c	=======================================
c
c	lambda,mu = the two Lame constants in pascal
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision lambda,mu
c
	common/elasticity/lambda,mu
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	WARNING STATISTICS
c	==================
c
c	nwarn = total number of warnings
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	integer nwarn
c
	common/warnings/nwarn
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	LOCAL CONSTANTS
c	==============
c	pi, parameter for transforming degree to radian
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision PI,PI2
	data PI,PI2/3.14159265358979d0,6.28318530717959d0/
	double precision DEGTORAD,ZSEPS
	data DEGTORAD,ZSEPS/1.745329252d-02,1.0d-02/
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	GREEN'S FUNNCTIONN PARAMETERS
c	=============================
c
c	Green's function source types:
c	  1 = strike-slip (m12=m21=1)
c	  2 = dip-slip (m13=m31=1)
c	  3 = compensated linear vector dipole (CLVD)
c	      (m11=m22=-1/2, m33=1) (no tangential component)
c	Green's function coordinate system:
c	  (z,r,t) = cylindrical with z being downward(!)
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	integer nr,nz
	double precision r1,r2,z1,z2
	double precision ssdisp(3,NRMAX+2,NZMAX+2)
	double precision ssstrn(6,NRMAX+2,NZMAX+2)
	double precision ssuzr(NRMAX+2,NZMAX+2)
	double precision dsdisp(3,NRMAX+2,NZMAX+2)
	double precision dsstrn(6,NRMAX+2,NZMAX+2)
	double precision dsuzr(NRMAX+2,NZMAX+2)
	double precision cldisp(2,NRMAX+2,NZMAX+2)
	double precision clstrn(4,NRMAX+2,NZMAX+2)
	double precision cluzr(NRMAX+2,NZMAX+2)
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	LOCAL WORK SPACES
c	=================
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	integer i,irec,ips,nps,ir,iz,lendir,nx,ny,idis
	double precision ur,ut,uz,err,ett,ezz,ert,etz,ezr
	double precision x1,x2,y1,y2,zobs,si,co,si2,co2,dis,ddis,azi
	double precision dr,dz,dzs,w00,w10,w01,w11
	double precision uzr,uzt,uzx,uzy,ps,sh
	double precision la1,mu1
	character*160 grnss,grnds,grncl
	character*180 dataline
c
c	INITIALIZATION
c	==============
c
	do irec=1,nrec
	  do i=1,3
	    disp(irec,i)=0.d0
	  enddo
	  do i=1,6
	    strain(irec,i)=0.d0
	  enddo
	  do i=1,2
	    tilt(irec,i)=0.d0
	  enddo
	enddo
c
c	READ IN GREEN'S FUNCTIONS
c	=========================
c
	lendir=index(grndir,' ')-1
	grnss=grndir(1:lendir)//grnss0
	grnds=grndir(1:lendir)//grnds0
	grncl=grndir(1:lendir)//grncl0
c
c	READ GREEN'S FUNCTIONS
c	======================
c
c	for point strike-slip source
c
c	ssdisp(1-3): Uz, Ur, Ut
c	ssstrn(1-6): Ezz,Err,Ett,Ezr=Erz,Ert=Etr,Etz=Ezt
c
	print *,'... read Green fcts for the strike-slip source ...'
	open(21,file=grnss,status='old')
	call getdata(21,dataline)
        read(dataline,*)nr,r1,r2,nz,z1,z2,zrec0,lambda,mu
	if(nr.gt.NRMAX)then
	  stop ' Error in edcgrn: to large no of Green fct distantces!'
	else if(nz.gt.NZMAX)then
	  stop ' Error in edcgrn: to large no of Green fct depths!'
	endif
	read(21,*)(((ssdisp(i,ir,iz),i=1,3),(ssstrn(i,ir,iz),i=1,6),
     &            ssuzr(ir,iz),ir=1,nr),iz=1,nz)
	close(21)
c
c	for point dip-slip source
c
c	dsdisp(1-3): Uz, Ur, Ut
c	dsstrn(1-6): Ezz,Err,Ett,Ezr=Erz,Ert=Etr,Etz=Ezt
c
	print *,'... read Green fcts for the dip-slip source ...'
	open(22,file=grnds,status='old')
	call getdata(22,dataline)
        read(dataline,*)nx,x1,x2,ny,y1,y2,zobs,la1,mu1
	if(nx.ne.nr.or.x1.ne.r1.or.x2.ne.r2.or.
     &     ny.ne.nz.or.y1.ne.z1.or.y2.ne.z2)then
	  stop ' Error in edcgrn: different grids in Green functions!'
	endif
	if(la1.ne.lambda.or.mu1.ne.mu)then
	  stop ' Error in edcgrn: different Lame const. in Green fcts!'
	endif
	if(zobs.ne.zrec0)then
	  stop ' Error in edcgrn: different obs.depth in Green fcts!'
	endif
	read(22,*)(((dsdisp(i,ir,iz),i=1,3),(dsstrn(i,ir,iz),i=1,6),
     &            dsuzr(ir,iz),ir=1,nr),iz=1,nz)
	close(22)
c
c	for point clvd source
c
c
c	cldisp(1-2): Uz, Ur (Ut=0)
c	clstrn(1-4): Ezz,Err,Ett,Ezr=Erz (Ert=Etr=Etz=Ezt=0)
c
	print *,'... read Green fcts for the clvd source ...'
	open(23,file=grncl,status='old')
	call getdata(23,dataline)
        read(dataline,*)nx,x1,x2,ny,y1,y2,zobs,la1,mu1
	if(nx.ne.nr.or.x1.ne.r1.or.x2.ne.r2.or.
     &     ny.ne.nz.or.y1.ne.z1.or.y2.ne.z2)then
	  stop ' Error in edcgrn: different grids in Green functions!'
	endif
	if(la1.ne.lambda.or.mu1.ne.mu)then
	  stop ' Error in edcgrn: different Lame const. in Green fcts!'
	endif
	if(zobs.ne.zrec0)then
	  stop ' Error in edcgrn: different obs.depth in Green fcts!'
	endif
	read(23,*)(((cldisp(i,ir,iz),i=1,2),(clstrn(i,ir,iz),i=1,4),
     &            cluzr(ir,iz),ir=1,nr),iz=1,nz)
	close(23)
c
	do iz=nz+1,nz+2
	  do ir=nr+1,nr+2
	    do i=1,3
	      ssdisp(i,ir,iz)=0.d0
	      dsdisp(i,ir,iz)=0.d0
	    enddo
	    do i=1,2
	      cldisp(i,ir,iz)=0.d0
	    enddo
	    do i=1,6
	      ssstrn(i,ir,iz)=0.d0
	      dsstrn(i,ir,iz)=0.d0
	    enddo
	    do i=1,4
	      clstrn(i,ir,iz)=0.d0
	    enddo
	    ssuzr(ir,iz)=0.d0
	    dsuzr(ir,iz)=0.d0
	    cluzr(ir,iz)=0.d0
	  enddo
	enddo
c
	print *,'... read in Green fcts successful ...'
c
c	DISCRETISATION OF RECTANGULAR PLANE SOURCES
c	===========================================
c
	print *,'... discretise the finite sources ...'
c
	dr=(r2-r1)/dble(nr-1)
	dz=(z2-z1)/dble(nz-1)
	if(zrec0.ge.z1.and.zrec0.le.z2.and.r1.eq.0.d0)then
	  iz=idnint((zrec0-z1)/dz)+1
	  dzs=(zrec0-(z1+dz*dble(iz-1)))/dz
	  if(dabs(dzs).le.ZSEPS)then
	    do i=1,3
	      ssdisp(i,1,iz)=ssdisp(i,2,iz)
	      dsdisp(i,1,iz)=dsdisp(i,2,iz)
	    enddo
	    do i=1,2
	      cldisp(i,1,iz)=cldisp(i,2,iz)
	    enddo
	    do i=1,6
	      ssstrn(i,1,iz)=ssstrn(i,2,iz)
	      dsstrn(i,1,iz)=dsstrn(i,2,iz)
	    enddo
	    do i=1,4
	      clstrn(i,1,iz)=clstrn(i,2,iz)
	    enddo
	    ssuzr(1,iz)=ssuzr(2,iz)
	    dsuzr(1,iz)=dsuzr(2,iz)
	    cluzr(1,iz)=cluzr(2,iz)
	  endif
	endif
c
	call edcdisc(ns,nz,z1,z2,dr,dz,nps)
c
c	SUPERPOSITION OF ALL DISCRETE POINT SOURCES
c	===========================================
c
c	disp(1-3): Ux,Uy,Uz
c	strain(1-6): Exx,Eyy,Ezz,Exy=Eyx,Eyz=Ezy,Ezx=Exz
c
	print *,'... superposition of all discrete point sources ...'
	do irec=1,nrec
	  uzx=0.d0
	  uzy=0.d0
	  do ips=1,nps
	    dis=dsqrt((xrec(irec)-pxs(ips))**2
     &               +(yrec(irec)-pys(ips))**2)
	    if(dis.le.0.d0)then
	      azi=0.d0
	    else
	      azi=datan2(yrec(irec)-pys(ips),
     &                   xrec(irec)-pxs(ips))
	    endif
c
	    if(dis.gt.r2)then
	      print *,' Warning: too large distances ignored!'
	      nwarn=nwarn+1
	    else if(pzs(ips).lt.z1)then
	      print *,' Warning: too shallow sources ignored!'
	      nwarn=nwarn+1
	    else if(pzs(ips).gt.z2)then
	      print *,' Warning: too deep sources ignored!'
	      nwarn=nwarn+1
	    else
	      iz=idint((pzs(ips)-z1)/dz)+1
	      dzs=(pzs(ips)-(z1+dz*dble(iz-1)))/dz
	      if(dis.le.r1)then
	        idis=1
	        ddis=0.d0
	      else
	        idis=idint((dis-r1)/dr)+1
	        ddis=(dis-(r1+dr*dble(idis-1)))/dr
	      endif
c
c	      weighting factors for the interpolation
c
	      w00=(1.d0-ddis)*(1.d0-dzs)
	      w10=ddis*(1.d0-dzs)
	      w01=(1.d0-ddis)*dzs
	      w11=ddis*dzs
c
	      co=dcos(azi)
	      si=dsin(azi)
	      co2=dcos(2.d0*azi)
	      si2=dsin(2.d0*azi)
c
c	      pmoment(1-5):
c	        1 = weight for strike-slip: m12=m21=1;
c	        poloidal*sin(2 * theta), toroidal*cos(2 * theta)
c
c	        2 = weight for dip-slip: m13=m31=1
c	        poloidal * cos(theta), toroidal * sin(theta)
c
c	        3 = weight for clvd: m33=-m11=-m22=1
c	        axisymmetric
c
c	        4 = weight for 45 deg strike-slip: m11=-m22=1
c	        greenfct4(theta) = green1(theta + 45 deg)
c
c	        5 = weight for 45 deg dip-slip: m23=m32=1
c	        greenfct5(theta) = green2(theta - 90 deg)
c
c	      contributions from the strike-slip components
c
	      ps=pmoment(1,ips)*si2+pmoment(4,ips)*co2
	      sh=pmoment(1,ips)*co2-pmoment(4,ips)*si2
	      uz=ps*(w00*ssdisp(1,idis,iz)+w10*ssdisp(1,idis+1,iz)
     &           +w01*ssdisp(1,idis,iz+1)+w11*ssdisp(1,idis+1,iz+1))
	      ur=ps*(w00*ssdisp(2,idis,iz)+w10*ssdisp(2,idis+1,iz)
     &           +w01*ssdisp(2,idis,iz+1)+w11*ssdisp(2,idis+1,iz+1))
	      ut=sh*(w00*ssdisp(3,idis,iz)+w10*ssdisp(3,idis+1,iz)
     &           +w01*ssdisp(3,idis,iz+1)+w11*ssdisp(3,idis+1,iz+1))
c
	      ezz=ps*(w00*ssstrn(1,idis,iz)+w10*ssstrn(1,idis+1,iz)
     &            +w01*ssstrn(1,idis,iz+1)+w11*ssstrn(1,idis+1,iz+1))
	      err=ps*(w00*ssstrn(2,idis,iz)+w10*ssstrn(2,idis+1,iz)
     &            +w01*ssstrn(2,idis,iz+1)+w11*ssstrn(2,idis+1,iz+1))
	      ett=ps*(w00*ssstrn(3,idis,iz)+w10*ssstrn(3,idis+1,iz)
     &            +w01*ssstrn(3,idis,iz+1)+w11*ssstrn(3,idis+1,iz+1))
	      ezr=ps*(w00*ssstrn(4,idis,iz)+w10*ssstrn(4,idis+1,iz)
     &            +w01*ssstrn(4,idis,iz+1)+w11*ssstrn(4,idis+1,iz+1))
	      ert=sh*(w00*ssstrn(5,idis,iz)+w10*ssstrn(5,idis+1,iz)
     &            +w01*ssstrn(5,idis,iz+1)+w11*ssstrn(5,idis+1,iz+1))
	      etz=sh*(w00*ssstrn(6,idis,iz)+w10*ssstrn(6,idis+1,iz)
     &            +w01*ssstrn(6,idis,iz+1)+w11*ssstrn(6,idis+1,iz+1))
c
	      uzr=ps*(w00*ssuzr(idis,iz)+w10*ssuzr(idis+1,iz)
     &           +w01*ssuzr(idis,iz+1)+w11*ssuzr(idis+1,iz+1))
	      uzt=sh*(w00*ssdisp(1,idis,iz)+w10*ssdisp(1,idis+1,iz)
     &           +w01*ssdisp(1,idis,iz+1)+w11*ssdisp(1,idis+1,iz+1))
     &           *2.d0/dis
c
c	      contributions from the dip-slip components
c
	      ps=pmoment(2,ips)*co+pmoment(5,ips)*si
	      sh=pmoment(2,ips)*si-pmoment(5,ips)*co
	      uz=uz+ps*(w00*dsdisp(1,idis,iz)+w10*dsdisp(1,idis+1,iz)
     &           +w01*dsdisp(1,idis,iz+1)+w11*dsdisp(1,idis+1,iz+1))
	      ur=ur+ps*(w00*dsdisp(2,idis,iz)+w10*dsdisp(2,idis+1,iz)
     &           +w01*dsdisp(2,idis,iz+1)+w11*dsdisp(2,idis+1,iz+1))
	      ut=ut+sh*(w00*dsdisp(3,idis,iz)+w10*dsdisp(3,idis+1,iz)
     &           +w01*dsdisp(3,idis,iz+1)+w11*dsdisp(3,idis+1,iz+1))
c
	      ezz=ezz+ps*(w00*dsstrn(1,idis,iz)+w10*dsstrn(1,idis+1,iz)
     &            +w01*dsstrn(1,idis,iz+1)+w11*dsstrn(1,idis+1,iz+1))
	      err=err+ps*(w00*dsstrn(2,idis,iz)+w10*dsstrn(2,idis+1,iz)
     &            +w01*dsstrn(2,idis,iz+1)+w11*dsstrn(2,idis+1,iz+1))
	      ett=ett+ps*(w00*dsstrn(3,idis,iz)+w10*dsstrn(3,idis+1,iz)
     &            +w01*dsstrn(3,idis,iz+1)+w11*dsstrn(3,idis+1,iz+1))
	      ezr=ezr+ps*(w00*dsstrn(4,idis,iz)+w10*dsstrn(4,idis+1,iz)
     &            +w01*dsstrn(4,idis,iz+1)+w11*dsstrn(4,idis+1,iz+1))
	      ert=ert+sh*(w00*dsstrn(5,idis,iz)+w10*dsstrn(5,idis+1,iz)
     &            +w01*dsstrn(5,idis,iz+1)+w11*dsstrn(5,idis+1,iz+1))
	      etz=etz+sh*(w00*dsstrn(6,idis,iz)+w10*dsstrn(6,idis+1,iz)
     &            +w01*dsstrn(6,idis,iz+1)+w11*dsstrn(6,idis+1,iz+1))
c
	      uzr=uzr+ps*(w00*dsuzr(idis,iz)+w10*dsuzr(idis+1,iz)
     &         +w01*dsuzr(idis,iz+1)+w11*dsuzr(idis+1,iz+1))
	      uzt=uzt+sh*(w00*dsdisp(1,idis,iz)+w10*dsdisp(1,idis+1,iz)
     &           +w01*dsdisp(1,idis,iz+1)+w11*dsdisp(1,idis+1,iz+1))
     &           *(-1.d0/dis)
c
c	      contributions from the clvd components
c
	      ps=pmoment(3,ips)
	      uz=uz+ps*(w00*cldisp(1,idis,iz)+w10*cldisp(1,idis+1,iz)
     &           +w01*cldisp(1,idis,iz+1)+w11*cldisp(1,idis+1,iz+1))
	      ur=ur+ps*(w00*cldisp(2,idis,iz)+w10*cldisp(2,idis+1,iz)
     &           +w01*cldisp(2,idis,iz+1)+w11*cldisp(2,idis+1,iz+1))
c
	      ezz=ezz+ps*(w00*clstrn(1,idis,iz)+w10*clstrn(1,idis+1,iz)
     &            +w01*clstrn(1,idis,iz+1)+w11*clstrn(1,idis+1,iz+1))
	      err=err+ps*(w00*clstrn(2,idis,iz)+w10*clstrn(2,idis+1,iz)
     &            +w01*clstrn(2,idis,iz+1)+w11*clstrn(2,idis+1,iz+1))
	      ett=ett+ps*(w00*clstrn(3,idis,iz)+w10*clstrn(3,idis+1,iz)
     &            +w01*clstrn(3,idis,iz+1)+w11*clstrn(3,idis+1,iz+1))
	      ezr=ezr+ps*(w00*clstrn(4,idis,iz)+w10*clstrn(4,idis+1,iz)
     &            +w01*clstrn(4,idis,iz+1)+w11*clstrn(4,idis+1,iz+1))
c
	      uzr=uzr+ps*(w00*cluzr(idis,iz)+w10*cluzr(idis+1,iz)
     &           +w01*cluzr(idis,iz+1)+w11*cluzr(idis+1,iz+1))
c
c	      transform to cartesian coordinates
c
	      disp(irec,1)=disp(irec,1)+ur*co-ut*si
	      disp(irec,2)=disp(irec,2)+ur*si+ut*co
	      disp(irec,3)=disp(irec,3)+uz
c
	      strain(irec,1)=strain(irec,1)+err*co*co+ett*si*si-ert*si2
	      strain(irec,2)=strain(irec,2)+err*si*si+ett*co*co+ert*si2
	      strain(irec,3)=strain(irec,3)+ezz
	      strain(irec,4)=strain(irec,4)+0.5d0*(err-ett)*si2+ert*co2
	      strain(irec,5)=strain(irec,5)+ezr*si+etz*co
	      strain(irec,6)=strain(irec,6)+ezr*co-etz*si
c
	      uzx=uzx+uzr*co-uzt*si
	      uzy=uzy+uzr*si+uzt*co
	    endif
	  enddo
c
c	  transform of hrizontal tilts to vertical tilts
c
	  tilt(irec,1)=2.d0*strain(irec,6)-uzx
	  tilt(irec,2)=2.d0*strain(irec,5)-uzy
	enddo
c
	return
	end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Subroutine: spbjh                                                         c
c     calculates spherical Bessel functions for complex argument                c
c     zj(x)=x*j_(n+1)(x)/[j_n(x)+ix*j_(n+1)(x)], x = xa,xb                      c
c     wj(xa,xb)=ln{[j_n(xa)+i*xa*j_(n+1)(xa)]/[j_n(xb)+i*xb*j_(n+1)(xb)]}       c
c     zh(x)=x*h_(n+1)(x)/h_n(x), x=xa,xb                                        c
c     wh(xa,xb)=ln[h_n(xa)/h_n(xb)], where h_n(x) = j_n(x) + sign[im(x)]iy_n(x) c
c     where xa = ck*ra, xb = ck*rb                                              c
c     for harmonic degree nn                                                    c
c                                                                               c
c     Input:                                                                    c
c     nn = max. order                                                           c
c     xa,xb = complex arguments                                                 c
c                                                                               c
c     Output:                                                                   c
c     complex zja(n,xa), zjb(n,xb), wj(n,xa,xb)                                 c
c             zha(n,xa), zhb(n,xb), wh(n,xa,xb)                                 c
c             for n = 0, ..., nn                                                c
c                                                                               c
c     First implemention: 17 June 2007                                          c
c     Rongjiang Wang                                                            c
c     GeoForschungsZentrum Potsdam, Germany                                     c
c     Email: wang@gfz-potsdam.de                                                c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine spbjh(nn,ck,ra,rb,zja,zjb,wj,zha,zhb,wh)
      implicit none
      integer*4 nn
      real*8 ra,rb
      complex*16 ck
      complex*16 zja(0:nn),zjb(0:nn),wj(0:nn)
      complex*16 zha(0:nn),zhb(0:nn),wh(0:nn)
c
c     local memory
c
      integer*4 n,nx,nmax
      real*8 xra,xrb,xia,xib
      complex*16 xa,xb,xa2,xb2,ga,gb,gn,bda
      complex*16 zja1,zjb1,zja2,zjb2
      complex*16 cep0,cep1,cem0,cem1,cfac
      complex*16 c2xj0,c2x2j1
c
      real*8 pi,eps
      complex*16 ci,c1,c2
      data pi,eps/3.14159265358979d0,1.0d-08/
      data ci,c1,c2/(0.d0,1.d0),(1.d0,0.d0),(2.d0,0.d0)/
c
      xa=ck*dcmplx(ra,0.d0)
      xb=ck*dcmplx(rb,0.d0)
c
      xra=dreal(xa)
      xrb=dreal(xb)
      xia=dimag(xa)
      xib=dimag(xb)
      xa2=xa*xa
      xb2=xb*xb
c
      cep0=cdexp(dcmplx(0.d0,xra))
      cem0=c1/cep0
      cfac=dcmplx(dexp(-2.d0*dabs(xia)),0.d0)
      if(xia.ge.0.d0)then
        c2xj0=(cfac*cep0-cem0)/ci
        c2x2j1=c2xj0-(cfac*cep0+cem0)*xa
        zja(0)=c1-c1/(c1+ci+xa*(cfac*cep0+cem0)/(cfac*cep0-cem0))
      else
        c2xj0=(cep0-cfac*cem0)/ci
        c2x2j1=c2xj0-(cep0+cfac*cem0)*xa
        zja(0)=c1-c1/(c1+ci+xa*(cep0+cfac*cem0)/(cep0-cfac*cem0))
      endif
      wj(0)=c2xj0+ci*c2x2j1
c
      if(nn.le.0)goto 101
c
      zja2=(0.d0,0.d0)
      nx=10+nn/4
100   nmax=nn+nx
      gn=dcmplx(dble(2*nmax+3),0.d0)
      zja1=ci*xa2/(gn+ci*xa2)
      do n=nmax-1,nn,-1
        ga=dcmplx(dble(2*n+3),0.d0)+ci*xa2
        zja1=ci*xa2*(c1-zja1)/(ga*(c1-zja1)+ci*zja1)
      enddo
      if(cdabs(zja1-zja2).gt.eps*cdabs(zja1))then
        zja2=zja1
        nx=2*nx
        goto 100
      endif
      zja(nn)=zja1
c
      do n=nn-1,1,-1
        ga=dcmplx(dble(2*n+3),0.d0)+ci*xa2
        zja(n)=ci*xa2*(c1-zja(n+1))/(ga*(c1-zja(n+1))+ci*zja(n+1))
      enddo
c
101   continue
c
      if(rb.le.0.d0)return
c
      bda=dcmplx(dlog(rb/ra),0.d0)
c
      cep0=cdexp(dcmplx(0.d0,xrb))
      cem0=c1/cep0
      cfac=dcmplx(dexp(-2.d0*dabs(xib)),0.d0)
      if(xib.ge.0.d0)then
        c2xj0=(cfac*cep0-cem0)/ci
        c2x2j1=c2xj0-(cfac*cep0+cem0)*xb
        zjb(0)=c1-c1/(c1+ci+xb*(cfac*cep0+cem0)/(cfac*cep0-cem0))
      else
        c2xj0=(cep0-cfac*cem0)/ci
        c2x2j1=c2xj0-(cep0+cfac*cem0)*xb
        zjb(0)=c1-c1/(c1+ci+xb*(cep0+cfac*cem0)/(cep0-cfac*cem0))
      endif
      wj(0)=cdlog(wj(0)/(c2xj0+ci*c2x2j1))
     &     +bda+dcmplx(dabs(xia)-dabs(xib),0.d0)
c
      if(nn.le.0)goto 201
c
      zjb2=(0.d0,0.d0)
      nx=10+nn/4
200   nmax=nn+nx
      gn=dcmplx(dble(2*nmax+3),0.d0)
      zjb1=ci*xb2/(gn+ci*xb2)
      do n=nmax-1,nn,-1
        gb=dcmplx(dble(2*n+3),0.d0)+ci*xb2
        zjb1=ci*xb2*(c1-zjb1)/(gb*(c1-zjb1)+ci*zjb1)
      enddo
      if(cdabs(zjb1-zjb2).gt.eps*cdabs(zjb1))then
        zjb2=zjb1
        nx=2*nx
        goto 200
      endif
      zjb(nn)=zjb1
c
      do n=nn-1,1,-1
        gb=dcmplx(dble(2*n+3),0.d0)+ci*xb2
        zjb(n)=ci*xb2*(c1-zjb(n+1))/(gb*(c1-zjb(n+1))+ci*zjb(n+1))
      enddo
c
201   continue
c
      do n=1,nn
        ga=xa2+(c1-xa2+dcmplx(0.d0,dble(2*n+1)))*zja(n-1)
        gb=xb2+(c1-xb2+dcmplx(0.d0,dble(2*n+1)))*zjb(n-1)
        wj(n)=wj(n-1)+cdlog(ga/gb)+bda
      enddo
c
      if(xia+xib.ge.0.d0)then
        zha(0)=c1-ci*xa
        zhb(0)=c1-ci*xb
      else
        zha(0)=c1+ci*xa
        zhb(0)=c1+ci*xb
      endif
      wh(0)=zhb(0)-zha(0)+bda
c
      do n=1,nn
        gn=dcmplx(dble(2*n+1),0.d0)
        zha(n)=gn-xa2/zha(n-1)
        zhb(n)=gn-xb2/zhb(n-1)
        wh(n)=wh(n-1)+cdlog(zha(n-1)/zhb(n-1))+bda
      enddo
      return
      end

      subroutine qssh(y,k,lup,llw)
      implicit none
c
c     calculation of response to sh source
c     y(6,6): solution vector (complex)
c     k: wave number
c
      integer*4 lup,llw
      real*8 k
      complex*16 y(6,6)
c
      include 'qsglobal.h'
c
c     work space
c
      integer*4 i,istp,l,n,key
      complex*16 cnorm
      complex*16 y0(2),b(2,6),b0(2,6)
      complex*16 y1(2),yup(2),ylw(2)
      complex*16 hk(2,2,nzmax),coef(2,2),cinc(6),c0
      logical*4 rsite
c
c===============================================================================
c
c     matrix propagation from surface to source
c
      rsite=.false.
      do l=lup,ls-1
        n=nno(l)
        call qshksh(hk(1,1,l),hp(l),n,rsite)
      enddo
      do l=ls,llw-1
        n=nno(l)
        call qshksh(hk(1,1,l),-hp(l),n,rsite)
      enddo
c
c     yup: the starting solution vector
c
      yup(1)=(1.d0,0.d0)
      if(lup.eq.1.and.isurf.eq.0)then
        yup(2)=(0.d0,0.d0)
      else
        n=nno(lup)
        yup(2)=cmu(n)*ks(n)
      endif
      if(lup.eq.lzr)call cmemcpy(yup,y0,2)
c
      do l=lup+1,ls
        n=nno(l-1)
c
c       determination of propagation matrix
c
        call caxcb(hk(1,1,l-1),yup,2,2,1,y1)
        call cmemcpy(y1,yup,2)
c
c       normalization
c
        if(l.gt.lzr)then
          cnorm=cdexp(-ks(n)*dcmplx(hp(l-1),0.d0))
          y0(1)=y0(1)*cnorm
          y0(2)=y0(2)*cnorm
        else if(l.eq.lzr)then
          call cmemcpy(yup,y0,2)
        endif
      enddo
c
c===============================================================================
c
c     matrix propagation from half-space to source
c
c     ylw: the starting solution vector
c
      n=nno(llw)
      ylw(1)=(1.d0,0.d0)
      if(sh(llw))then
        ylw(2)=-cmu(n)*ks(n)
      else
        ylw(2)=(0.d0,0.d0)
      endif
      if(llw.gt.ls.and.llw.eq.lzr)call cmemcpy(ylw,y0,2)
c
      do l=llw-1,ls,-1
        n=nno(l)
c
c       determination of propagation matrix
c
        call caxcb(hk(1,1,l),ylw,2,2,1,y1)
        call cmemcpy(y1,ylw,2)
        if(l.lt.lzr)then
          cnorm=cdexp(-ks(n)*dcmplx(hp(l),0.d0))
          y0(1)=y0(1)*cnorm
          y0(2)=y0(2)*cnorm
        else if(l.gt.ls.and.l.eq.lzr)then
          call cmemcpy(ylw,y0,2)
        endif
      enddo
c
c===============================================================================
c     source function
c===============================================================================
c
      do istp=1,6
        do i=1,2
          b(i,istp)=dcmplx(sfct0(i+4,istp)+k*sfct1(i+4,istp),0.d0)
        enddo
      enddo
      do i=1,2
        coef(i,1)=yup(i)
        coef(i,2)=-ylw(i)
      enddo
      if(ipath.eq.1)call cmemcpy(b,b0,12)
      key=0
      call cdgemp(coef,b,2,6,0.d0,key)
      if(key.eq.0)then
        print *,'warning in qssh: anormal exit from cdgemp!'
        return
      endif
      if(lzr.le.ls)then
        do istp=1,6
          do i=1,2
            y(i+4,istp)=b(1,istp)*y0(i)
          enddo
        enddo
      else
        do istp=1,6
          do i=1,2
            y(i+4,istp)=b(2,istp)*y0(i)
          enddo
        enddo
      endif
      if(ipath.eq.1)then
        n=nno(lpath)
        ylw(1)=(1.d0,0.d0)
        if(sh(lpath))then
          ylw(2)=-cmu(n)*ks(n)
        else
          ylw(2)=(0.d0,0.d0)
        endif
        if(lpath.gt.ls.and.lpath.eq.lzr)call cmemcpy(ylw,y0,2)
        do l=lpath-1,ls,-1
          n=nno(l)
c
c         determination of propagation matrix
c
          call caxcb(hk(1,1,l),ylw,2,2,1,y1)
          call cmemcpy(y1,ylw,2)
c
          if(l.lt.lzr)then
            cnorm=cdexp(-ks(n)*dcmplx(hp(l),0.d0))
            y0(1)=y0(1)*cnorm
            y0(2)=y0(2)*cnorm
          else if(l.gt.ls.and.l.eq.lzr)then
            call cmemcpy(ylw,y0,2)
          endif
        enddo
        do i=1,2
          coef(i,1)=yup(i)
          coef(i,2)=-ylw(i)
        enddo
        key=0
        call cdgemp(coef,b0,2,6,0.d0,key)
        if(key.eq.0)then
          print *,'warning in qssh: anormal exit from cdgemp!'
          return
        endif
        if(lzr.le.ls)then
          do istp=1,6
            do i=1,2
              y(i+4,istp)=y(i+4,istp)-b0(1,istp)*y0(i)
            enddo
          enddo
        else
          do istp=1,6
            do i=1,2
              y(i+4,istp)=y(i+4,istp)-b0(2,istp)*y0(i)
            enddo
          enddo
        endif
      endif
c
      if(n0rs.gt.0)then
c
c       for receiver-site structure different from source-site structure
c
        n=nno(lzr)
        do istp=1,6
          cinc(istp)=(0.5d0,0.d0)*(y(5,istp)+y(6,istp)/(cmu(n)*ks(n)))
        enddo
        rsite=.true.
        do l=1,lprs-1
          n=nnors(l)
          call qshksh(hk(1,1,l),hprs(l),n,rsite)
        enddo
c
c       yup: the starting solution vector
c
        yup(1)=(1.d0,0.d0)
        if(isurf.eq.0)then
          yup(2)=(0.d0,0.d0)
        else
          yup(2)=cmurs(1)*ksrs(1)
        endif
        if(lzrrs.eq.1)call cmemcpy(yup,y0,2)
c
        do l=2,lprs
          n=nnors(l-1)
c
c         determination of propagation matrix
c
          call caxcb(hk(1,1,l-1),yup,2,2,1,y1)
          call cmemcpy(y1,yup,2)
c
c         normalization
c
          if(l.gt.lzrrs)then
            cnorm=cdexp(-ksrs(n)*dcmplx(hprs(l-1),0.d0))
            y0(1)=y0(1)*cnorm
            y0(2)=y0(2)*cnorm
          else if(l.eq.lzrrs)then
            call cmemcpy(yup,y0,2)
          endif
        enddo
        n=nnors(lprs)
        c0=(0.5d0,0.d0)*(yup(1)+yup(2)/(cmurs(n)*ksrs(n)))
        do istp=1,6
          y(5,istp)=y0(1)*cinc(istp)/c0
          y(6,istp)=y0(2)*cinc(istp)/c0
        enddo
      endif
      if(isurf.eq.2)then
c
c       free surface corrections
c
        do istp=1,6
          y(5,istp)=(2.d0,0.d0)*y(5,istp)
          y(6,istp)=(0.d0,0.d0)
        enddo
      endif
      return
      end

	subroutine edglayer(zs,ls,zrec,lzrec,h,n0)
        implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
        integer ls,lzrec,n0
        double precision zs,zrec,h(n0)
c
	include 'edgglobal.h'
c
        integer lp,nno(nzmax)
        double precision hp(nzmax)
        common /sublayer/ hp,lp,nno
c
        integer l,n,li,lp0
        double precision z1
        double precision z(nzmax),z0(nzmax)
c
        lp0=1
        z0(lp0)=0.d0
        do n=1,n0-1
          lp0=lp0+1
          z0(lp0)=z0(lp0-1)+h(n)
        enddo
        lp0=lp0+1
        z0(lp0)=zrec
        lp0=lp0+1
        z0(lp0)=zs
c
c       sort the z0-profile
c
        do l=1,lp0-1
          do li=l+1,lp0
            if(z0(li).lt.z0(l))then
              z1=z0(l)
              z0(l)=z0(li)
              z0(li)=z1
            endif
          enddo
        enddo
c
c       delete duplicates
c
        lp=1
        z(lp)=0.d0
        do l=2,lp0
          if(z0(l).gt.z(lp))then
            hp(lp)=z0(l)-z(lp)
            lp=lp+1
            z(lp)=z0(l)
          endif
        enddo
        hp(lp)=0.d0
c
c       determine ls,lzrec
c
        do l=1,lp
          if(z(l).eq.zs)ls=l
          if(z(l).eq.zrec)lzrec=l
        enddo
c
c       determine layer no of each depth
c
        li=1
        z1=h(1)
        nno(1)=1
        do l=2,lp
          if(z(l).ge.z1.and.li.lt.n0)then
            li=li+1
            z1=z1+h(li)
          endif
          nno(l)=li
        enddo
c
        return
        end

      subroutine qpstart2t(ldeg,ly,jh,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c
      integer*4 ldeg,ly,jh
      complex*16 cy(2)
c
      real*8 teps
      complex*16 clm1,ca,cb
c
      real*8 eps
      data eps/1.0d-08/
c
      clm1=dcmplx(dble(ldeg-1),0.d0)
c
      if(jh.eq.1.and.ly.ge.lys)then
        cy(1)=(1.d0,0.d0)
        cy(2)=cmu(ly)*(clm1-zh12sh(ldeg,1,ly))
c
        teps=dabs(dimag(zh12sh(ldeg,1,ly)))/cdabs(zh12sh(ldeg,1,ly))
        if(teps.lt.eps)then
          ca=dcmplx((teps/eps)**2,0.d0)
          cb=(1.d0,0.d0)-ca
          cy(1)=mat2x2up(1,1,ly)
          cy(2)=ca*cy(2)*mat2x2up(1,1,ly)+cb*mat2x2up(2,1,ly)
        endif
      else if(jh.eq.2.and.ly.le.lys)then
        cy(1)=(1.d0,0.d0)
        cy(2)=cmu(ly)*(clm1-zh12sh(ldeg,2,ly))
      else
        stop ' Error in qpstart2t: bad jh value!'
      endif
      return
      end

      subroutine qswvint(srate)
      implicit none
c
      real*8 srate
c
      include 'qsglobal.h'
c
      integer*4 istp,n,nrec,l,lf,lf1,i,ir,nrr,nrs
      integer*4 ik,ik1,ik2,nk1,nk2,nbsj,idtrans
      real*8 f,fcut,k,kc,dk,slwn
      real*8 pi,pi2,rr,rs,delta,cmax,ymax,yabs
      real*8 fac,zdis,rsdis,thickness,wvlen
      real*8 kcut(4),kcut1(4),kcut2(4)
      real*8 rdisk(nrmax)
      complex*16 carec,cbrec,clar,cmur,cr
      complex*16 ck,ck2,cdk,c2dk,cdk2,cfac,czdis2,cm
      complex*16 swap(nbsjmax+ndtransmax)
      complex*16 y0(9,6,nbsjmax+ndtransmax)
      complex*16 y(10,6,nbsjmax+ndtransmax)
      complex*16 cy(6,6),yb(11),cics(6),cm2(9,6)
      complex*16 jmm1,jm0,jmp1 ! bsj
      real*8 taper
c
      complex*16 c1,c2,c3
      data c1,c2,c3/(1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0)/
c
c     ics = 1  when the azmuth-factor is cos(ms*theta) for poloidal mode
c             (psv) and sin(ms*theta) for the toroidal mode (sh);
c     ics = -1 otherwise.
c
      pi=4.d0*datan(1.d0)
      pi2=2.d0*pi
c
      do istp=1,6
        cics(istp)=dcmplx(dble(ics(istp)),0.d0)
        cm2(1,istp)=dcmplx(dble(ms(istp)**2),0.d0)
        cm2(2,istp)=dcmplx(dble((ms(istp)-1)**2),0.d0)
        cm2(3,istp)=dcmplx(dble((ms(istp)+1)**2),0.d0)
        cm2(4,istp)=cm2(1,istp)
        cm2(5,istp)=dcmplx(dble(ms(istp)**2),0.d0)
        cm2(6,istp)=dcmplx(dble((ms(istp)-1)**2),0.d0)
        cm2(7,istp)=dcmplx(dble((ms(istp)+1)**2),0.d0)
        cm2(8,istp)=cm2(1,istp)
        cm2(9,istp)=cm2(1,istp)
      enddo
c
      nrec=nno(lzr)
      carec=dcmplx(1.d0/(ro(nrec)*vp(nrec)**2),0.d0)
      cbrec=dcmplx(2.d0*(vs(nrec)/vp(nrec))**2,0.d0)
      cmur=dcmplx(ro(nrec)*vs(nrec)**2,0.d0)
      clar=dcmplx(ro(nrec)*vp(nrec)**2,0.d0)-2*cmur
c
      l=min0(ls,lzr)
      n=nno(l)
      if(vs(n).le.vspmin*vp(n).or.
     &   .not.(svup(l).or.svdw(l)))then
        cmax=vp(n)
      else
        cmax=vs(n)
      endif
      do l=min0(ls,lzr)+1,max0(ls,lzr,lpath)-1
        n=nno(l)
        if(vs(n).le.vspmin*vp(n).or.
     &     .not.(svup(l).or.svdw(l)))then
          cmax=dmax1(cmax,vp(n))
        else
          cmax=dmax1(cmax,vs(n))
        endif
      enddo
c
      rsdis=0.d0
      do l=1,max0(ls,lzr,lpath)-1
        rsdis=rsdis+hp(l)
      enddo
c
      fcut=dble(nf)*df
c
      zdis=dabs(zr-zs)
      if(zdis.le.0.d0.and.r(1).le.0.d0)then
        stop 'Error in qswvint: identical '
     &     //'location of receiver and source!'
      endif
      czdis2=dcmplx(zdis*zdis,0.d0)
c
      thickness=0.d0
      do l=1,lp-1
        thickness=thickness+hp(l)
      enddo
c
      dk=pi/dmax1(srate*r(nr),3.d0*thickness)
      cdk=dcmplx(dk,0.d0)
      c2dk=dcmplx(2.d0*dk,0.d0)
      cdk2=dcmplx(dk*dk,0.d0)
c
      if(fullwave)then
        f=0.d0
        rdisk(1)=rd2r*dsqrt(zdis*zdis+r(1)*r(1))
        call qsqmodel(f)
        kc=0.d0
        ik1=1
        ymax=0.d0
101     k=dble(ik1)*dk
        call qskern(cy,f,k)
        yabs=0.d0
        do istp=1,4
          do i=1,3
            yabs=yabs+cdabs(cy(2*i-1,istp))**2
          enddo
        enddo
        yabs=dsqrt(yabs)*k*dexp(-0.5d0*(k*rdisk(1))**2)
        ymax=dmax1(ymax,yabs)
        if(yabs.gt.epswv*ymax.and.yabs.gt.0.d0.and.
     &     ik1.lt.nk0max)then
          ik1=ik1+1
          goto 101
        endif
        kcut1(1)=0.d0
        kcut1(2)=0.d0
        kcut1(3)=0.8d0*k
        kcut1(4)=k
        ! kcut1(3)=k
        ! kcut1(4)=1.25*k
c
        f=fcut
        n=nno(ls)
        wvlen=vp(n)/(f+df)
        rdisk(1)=rd2r*dmin1(dsqrt(zdis*zdis+r(1)*r(1)),wvlen)
        ik2=ik1
        ymax=0.d0
102     k=dble(ik2)*dk
        call qskern(cy,f,k)
        yabs=0.d0
        do istp=1,4
          do i=1,3
            yabs=yabs+cdabs(cy(2*i-1,istp))**2
          enddo
        enddo
        yabs=dsqrt(yabs)*k*dexp(-0.5d0*(k*rdisk(1))**2)
        ymax=dmax1(ymax,yabs)
        if(yabs.gt.epswv*ymax.and.yabs.gt.0.d0.and.
     &     ik2.lt.(nbsjmax+nk0max)/2)then
          ik2=ik2+1
          goto 102
        endif
c
        kcut2(1)=0.d0
        kcut2(2)=0.d0
        kcut2(3)=0.8d0*k
        kcut2(4)=k
        ! kcut2(3)=k
        ! kcut2(4)=1.25*k
        lf1=1
      else
        kcut1(1)=0.d0
        kcut1(2)=0.d0
        kcut1(3)=0.d0
        kcut1(4)=0.d0
        do i=1,4
          kcut2(i)=pi2*fcut*slw(i)
        enddo
        lf1=2
      endif
c
      nbsj=2+idint(dmax1(kcut1(4),kcut2(4))/dk)+ndtrans
      print *, kcut1(4)/dk, kcut2(4)/dk, ndtrans
      print *, nbsj
c
      if(nbsj.gt.nbsjmax)then
        stop ' parameter nbsjmax defined too small'
      else
        print *,' Calculate Bessel functions for x up to ',
     &       dble(nbsj)*dk*r(nr)
        print *,'nbsj',nbsj
        do ir=1,nr
          geospr(ir)=1.d0/(zdis*zdis+r(ir)*r(ir))**ndtrans
        enddo
        call qsbsj(dk,nbsj)
      endif
c
      do lf=1,nf
        do istp=1,6
          do i=1,19
            do ir=1,nr
              grns(lf,i,ir,istp)=(0.d0,0.d0)
             enddo
          enddo
        enddo
      enddo
c
      write(*,'(a,2(f10.7,a))')' Min./max. slowness at f_cut: ',
     &     1000.d0*kcut2(1)/(pi2*fcut),' / ',
     &     1000.d0*kcut2(4)/(pi2*fcut),' s/km'
c
      do lf=lf1,nf
        f=dble(lf-1)*df
        n=nno(ls)
        wvlen=vp(n)/(f+df)
        do ir=1,nr
          rdisk(ir)=rd2r*dmin1(dsqrt(zdis*zdis+r(ir)*r(ir)),wvlen)
        enddo
        call qsqmodel(f)
c
        do i=1,4
          kcut(i)=kcut1(i)
     &           +(kcut2(i)-kcut1(i))*dsqrt(f**2+(pi*fi)**2)/fcut
        enddo
c
        nk2=min0(2+idint(kcut(4)/dk),nbsj-ndtrans)
        nk1=min0(1+idint(kcut(1)/dk),nk2)
c
        ik1=max0(1,nk1-ndtrans)
        ik2=nk2+ndtrans
        do ik=ik1,ik2
          k=dble(ik)*dk
          ck=dcmplx(k,0.d0)
          call qskern(cy,f,k)
          do istp=1,6
            y0(1,istp,ik)=cy(1,istp)
            y0(2,istp,ik)=( cy(3,istp)+cics(istp)*cy(5,istp))/c2
            y0(3,istp,ik)=( cy(3,istp)-cics(istp)*cy(5,istp))/c2
            y0(4,istp,ik)=carec*cy(2,istp)-cbrec*ck*cy(3,istp)
            y0(5,istp,ik)=cy(2,istp)
            y0(6,istp,ik)=( cy(4,istp)+cics(istp)*cy(6,istp))/c2
            y0(7,istp,ik)=( cy(4,istp)-cics(istp)*cy(6,istp))/c2
            y0(8,istp,ik)=ck*cy(3,istp)
            y0(9,istp,ik)=ck*cy(5,istp)
          enddo
        enddo
c
        do ir=1,nr
          cr=dcmplx(r(ir),0.d0)
          ik1=max0(1,nk1-ndtrans)
          ik2=nk2+ndtrans
          do ik=ik1,ik2
            k=dble(ik)*dk
            do istp=1,6
              do i=1,9
                y(i,istp,ik)=y0(i,istp,ik)
     &                   *dcmplx(dexp(-0.5d0*(k*rdisk(ir))**2),0.d0)
              enddo
            enddo
          enddo
          do idtrans=1,ndtrans
            ik1=max0(1,nk1-ndtrans)+idtrans
            ik2=nk2+ndtrans-idtrans
            do istp=1,6
              do i=1,9
                do ik=ik1-1,ik2+1
                  swap(ik)=y(i,istp,ik)
                enddo
                do ik=ik1,ik2
                  ck=dcmplx(dble(ik)*dk,0.d0)
                  ck2=ck*ck
                  y(i,istp,ik)=swap(ik)*(czdis2+cm2(i,istp)/ck2)
     &              -(swap(ik+1)-swap(ik-1))/c2dk/ck
     &              -(swap(ik+1)-c2*swap(ik)+swap(ik-1))/cdk2
                enddo
              enddo
            enddo
          enddo
c
          ik1=max0(1,nk1+ndtrans)
          ik2=nk2
          do ik=ik1,ik2
            k=dble(ik)*dk
            ck=dcmplx(k,0.d0)
            cfac=dcmplx(k*dk
     &                 *taper(k,kcut(1),kcut(2),kcut(3),kcut(4)),0.d0)
c
            do istp=1,6
              do i=1,9
                y(i,istp,ik)=y(i,istp,ik)*cfac
              enddo
              jmm1 = dcmplx(bsj(ik,ms(istp)-1,ir),0.d0)
              jm0  = dcmplx(bsj(ik,ms(istp),ir),0.d0)
              jmp1 = dcmplx(bsj(ik,ms(istp)+1,ir),0.d0)
              cm=dcmplx(ms(istp), 0.d0)
c
              yb(1)=y(1,istp,ik)*jm0
              yb(2)=y(2,istp,ik)*jmm1
              yb(3)=y(3,istp,ik)*jmp1
              yb(4)=y(4,istp,ik)*jm0
              yb(5)=y(5,istp,ik)*jm0
              yb(6)=y(6,istp,ik)*jmm1
              yb(7)=y(7,istp,ik)*jmp1
              yb(8)=y(8,istp,ik)*jm0
              yb(9)=y(9,istp,ik)*jm0
              yb(10)=y(1,istp,ik)*jmm1
              yb(11)=y(1,istp,ik)*jmp1
c
c tz,tr,tt disp
              if(outsel(1).eq.1)then
                grns(lf,1,ir,istp)=grns(lf,1,ir,istp)+yb(1)
                grns(lf,2,ir,istp)=grns(lf,2,ir,istp)+yb(2)-yb(3)
                grns(lf,3,ir,istp)=grns(lf,3,ir,istp)
     &           -cics(istp)*(yb(2)+yb(3))
              endif
c tv volume
              if(outsel(2).eq.1)then
                grns(lf,4,ir,istp)=grns(lf,4,ir,istp)+yb(4)
              endif
c ezz,ezr,ezt strain
              if(outsel(3).eq.1)then
                grns(lf,5,ir,istp)=grns(lf,5,ir,istp)
     &           +(yb(5)-clar*yb(4))/(c2*cmur)
                grns(lf,6,ir,istp)=grns(lf,6,ir,istp)
     &           +(yb(6)-yb(7))/(c2*cmur)
                grns(lf,7,ir,istp)=grns(lf,7,ir,istp)
     &           -cics(istp)*(yb(6)+yb(7))/(c2*cmur)
c ett, err, ert strain
                if (r(ir).gt.0.d0)then
                  grns(lf,8,ir,istp)=grns(lf,8,ir,istp)
     &             -((cm-c1)*yb(2)+(cm+c1)*yb(3))/cr
                  grns(lf,9,ir,istp)=grns(lf,9,ir,istp)
     &             -yb(8)+((cm-c1)*yb(2)+(cm+c1)*yb(3))/cr
                  grns(lf,10,ir,istp)=grns(lf,10,ir,istp)+yb(9)/c2
     &                 -(cics(istp)*cm*(yb(2)-yb(3))
     &                 +(-cics(istp))*(yb(2)+yb(3)))/cr
                else if(ms(istp).eq.0.d0)then
                  grns(lf,8,ir,istp)=grns(lf,8,ir,istp)
     &             -ck/c2*(y(2,istp,ik)+y(3,istp,ik))
                  grns(lf,9,ir,istp)=grns(lf,9,ir,istp)
     &             -y(8,istp,ik)+ck/c2*(y(2,istp,ik)+y(3,istp,ik))
                  grns(lf,10,ir,istp)=grns(lf,10,ir,istp)
     &             +y(9,istp,ik)/c2
     &             +cics(istp)*ck/c2*(y(2,istp,ik)+y(3,istp,ik))
                else if(ms(istp).eq.1.d0)then
                  grns(lf,8,ir,istp)=grns(lf,8,ir,istp)+(0.d0,0.d0)
                  grns(lf,9,ir,istp)=grns(lf,9,ir,istp)+(0.d0,0.d0)
                  grns(lf,10,ir,istp)=grns(lf,10,ir,istp)+(0.d0,0.d0)
                else if(ms(istp).eq.2.d0)then
                  grns(lf,8,ir,istp)=grns(lf,8,ir,istp)
     &             -ck/c2*y(2,istp,ik)
                  grns(lf,9,ir,istp)=grns(lf,9,ir,istp)
     &             +ck/c2*y(2,istp,ik)
                  grns(lf,10,ir,istp)=grns(lf,10,ir,istp)
     &             -cics(istp)*ck/c2*y(2,istp,ik)
                endif
              endif
c szz,szr,szt stress
              if(outsel(4).eq.1)then
                grns(lf,11,ir,istp)=grns(lf,11,ir,istp)+yb(5)
                grns(lf,12,ir,istp)=grns(lf,12,ir,istp)+yb(6)-yb(7)
                grns(lf,13,ir,istp)=grns(lf,13,ir,istp)
     &           -cics(istp)*(yb(6)+yb(7))
c stt, srr, srt stress
                if (r(ir).gt.0.d0)then
                  grns(lf,14,ir,istp)=grns(lf,14,ir,istp)+clar*yb(4)
     &             +2*cmur*(-((cm-c1)*yb(2)+(cm+c1)*yb(3))/cr)
                  grns(lf,15,ir,istp)=grns(lf,15,ir,istp)+clar*yb(4)
     &             +2*cmur*(-yb(8)+((cm-c1)*yb(2)+(cm+c1)*yb(3))/cr)
                  grns(lf,16,ir,istp)=grns(lf,16,ir,istp)+2*cmur*(yb(9)/c2
     &              -(cics(istp)*cm*(yb(2)-yb(3))
     &              +(-cics(istp)*(yb(2)+yb(3))))/cr)
                else if(ms(istp).eq.0.d0)then
                  grns(lf,14,ir,istp)=grns(lf,14,ir,istp)+clar*yb(4)
     &              +2*cmur*(-ck/c2*(y(2,istp,ik)+y(3,istp,ik)))
                  grns(lf,15,ir,istp)=grns(lf,15,ir,istp)+clar*yb(4)
     &          +2*cmur*(-y(8,istp,ik)+ck/c2*(y(2,istp,ik)+y(3,istp,ik)))
                  grns(lf,16,ir,istp)=grns(lf,16,ir,istp)+2*cmur*
     &              (y(9,istp,ik)/c2+cics(istp)*ck/c2*(y(2,istp,ik)
     &              +y(3,istp,ik)))
                else if(ms(istp).eq.1.d0)then
                  grns(lf,14,ir,istp)=grns(lf,14,ir,istp)+dcmplx(0.d0,0.d0)
                  grns(lf,15,ir,istp)=grns(lf,15,ir,istp)+dcmplx(0.d0,0.d0)
                  grns(lf,16,ir,istp)=grns(lf,16,ir,istp)+dcmplx(0.d0,0.d0)
                else if(ms(istp).eq.2.d0)then
                  grns(lf,14,ir,istp)=grns(lf,14,ir,istp)+2*cmur*
     &               (-ck/c2*y(2,istp,ik))
                  grns(lf,15,ir,istp)=grns(lf,15,ir,istp)+2*cmur*
     &               (+ck/c2*y(2,istp,ik))
                  grns(lf,16,ir,istp)=grns(lf,16,ir,istp)+2*cmur*
     &              (-cics(istp)*ck/c2*y(2,istp,ik))
                endif
              endif
c oz,or,ot rotation
            if(outsel(5).eq.1)then
              grns(lf,17,ir,istp)=grns(lf,17,ir,istp)+yb(9)/c2
              grns(lf,18,ir,istp)=grns(lf,18,ir,istp)
     &         -c1/c2*cics(istp)*ck*(yb(10)+yb(11))
     &         +cics(istp)*(yb(6)+yb(7))/(2*cmur)
              grns(lf,19,ir,istp)=grns(lf,19,ir,istp)
     &         -c1/c2*ck*(yb(10)-yb(11))
     &         +(yb(6)-yb(7))/(2*cmur)
            endif
            enddo
          enddo
        enddo
c
        write(*,'(i6,a,E13.6,a,i7)')lf,'.',f,
     &      'Hz: slowness samples = ',1+nk2-nk1-ndtrans
      enddo
c
      if(iflat.eq.1)then
c
c       amplitude correction when using the flat-earth transform
c       see Mueller (1977) for n = -2
c
        rs=rr0*dexp(-zs/rr0)
        rr=rr0*dexp(-zrrs/rr0)
        nrs=5-ndens
        nrr=3-ndens
        do ir=1,nr
          if(r(ir).gt.0.d0)then
            delta=r(ir)/rr0
            fac=delta/dsin(delta)
          else
            fac=1.d0
          endif
          cfac=dcmplx(dsqrt((rr0/rr)**nrr*(rr0/rs)**nrs*fac),0.d0)
          do istp=1,6
            do i=1,19
              do lf=lf1,nf
                grns(lf,i,ir,istp)=grns(lf,i,ir,istp)*cfac
              enddo
            enddo
          enddo
        enddo
      endif
c
      return
      end

      subroutine qpdifmat4(ly,ldeg,rr,mat)
      use qpalloc
      implicit none
      integer*4 ly,ldeg
      real*8 rr
      complex*16 mat(6,6)
c
      real*8 alfa
      complex*16 cldeg,clp1,cll1
      complex*16 crr,crorr,clarr,cgrrr,cgarr
c
      complex*16 c1,c2,c4
      data c1,c2,c4/(1.d0,0.d0),(2.d0,0.d0),(4.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      clp1=cldeg+c1
      cll1=cldeg*clp1
c
      crr=dcmplx(rr,0.d0)
c
      alfa=(rr-rrlw(ly))/(rrup(ly)-rrlw(ly))
      crorr=dcmplx(rolw(ly)
     &     *dexp((dlog(roup(ly))-dlog(rolw(ly)))*alfa),0.d0)
      clarr=clalw(ly)+(claup(ly)-clalw(ly))*dcmplx(alfa,0.d0)
      cgarr=cgalw(ly)+(cgaup(ly)-cgalw(ly))*dcmplx(alfa,0.d0)
      cgrrr=cgrlw(ly)+(cgrup(ly)-cgrlw(ly))*dcmplx(alfa,0.d0)
c
      mat(1,1)=crorr*cgrrr/clarr-c1/crr
      mat(1,2)=cll1/crr-crorr*comi2*crr/clarr
      mat(1,3)=-crorr*crr/clarr
      mat(1,4)=(0.d0,0.d0)
c
      mat(2,1)=c1/crr
      mat(2,2)=(0.d0,0.d0)
      mat(2,3)=(0.d0,0.d0)
      mat(2,4)=(0.d0,0.d0)
c
      mat(3,1)=cgarr/crr
      mat(3,2)=(0.d0,0.d0)
      mat(3,3)=-clp1/crr
      mat(3,4)=c1/crr
c
      mat(4,1)=cgarr*clp1/crr
      mat(4,2)=-cgarr*cll1/crr
      mat(4,3)=(0.d0,0.d0)
      mat(4,4)=cldeg/crr
      return
      end

      subroutine qppsvkerng(f,ldeg,ypsv)
      use qpalloc
      implicit none
c
c     calculation of response function in frequency-wavelength domain
c     ldeg: harmonic degree
c     ypsv(6,4): psv solution vector (complex) with gravity effect
c
      integer*4 ldeg
      real*8 f
      complex*16 ypsv(6,4)
c
      integer*4 i,ia,na,ly,istp,lyup,lylw,lwup
      integer*4 lya(4)
      real*8 xmin
      complex*16 cldeg,cruplw,cxp,cxs
c
      complex*16 c1,c2
      data c1,c2/(1.d0,0.d0),(2.d0,0.d0)/
c
      do istp=1,4
        do i=1,6
          ypsv(i,istp)=(0.d0,0.d0)
        enddo
      enddo
c
      lyup=min0(lyupp(ldeg),lyups(ldeg))
      lylw=min0(lylwb,max0(lylwp(ldeg),lylws(ldeg)))
c
      if(cdabs(comi).le.0.d0)then
        if(vsup(lys).le.0.d0)return
        if(lys.ge.lyob.and.lys.lt.lycm)then
          lyup=max0(lyup,lyob)
          lylw=min0(lylw,lycm)
        else if(lys.ge.lycc)then
          lyup=max0(lyup,lycc)
          lylw=min0(lylw,ly0)
        endif
      endif
c
      if(lyr.lt.lyup.or.lyr.gt.lylw.or.lylw.lt.lylwa)return
c
      cldeg=dcmplx(dble(ldeg),0.d0)
c
      xmin=dsqrt(2.d0*dble(2*ldeg+1))
c
      if(.not.setzh12a)then
        do ly=1,ly0
          cxp=kp(ly)*crrup(ly)
          call spbh12(ldegpsv(ly),ldegmax,cxp,zh12p(0,1,ly))
          if(vsup(ly).gt.0.d0)then
            cxs=ks(ly)*crrup(ly)
            call spbh12(ldegpsv(ly),ldegmax,cxs,zh12sv(0,1,ly))
          endif
        enddo
        setzh12a=.true.
      endif
c
      na=0
      if(.not.freesurf.or.lyup.gt.1)then
        na=na+1
        lya(na)=lyup
      endif
      if(lylwa.gt.0)then
        na=na+1
        lya(na)=lylwa
      endif
      if(lylwb.le.ly0)then
        na=na+1
        lya(na)=lylwb
      endif
      if(lylw.ne.lylwa.and.lylw.ne.lylwb)then
        na=na+1
        lya(na)=lylw
      endif
c
      lwup=-1
c
      do ia=1,na
        ly=lya(ia)
        if(rrlw(ly).gt.0.d0)then
          cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
        else
          cruplw=(0.d0,0.d0)
        endif
        if(xp(ly).le.xmin)then
          ksmallp(ly)=.true.
          wj(ldeg,ly,1)=cldeg*cruplw
          wh(ldeg,ly,1)=-(cldeg+c1)*cruplw
        else if(ksmallp(ly))then
          ksmallp(ly)=.false.
          call spbjh(ldegpsv(ly),kp(ly),rrup(ly),rrlw(ly),
     &               zjup(0,ly,1),zjlw(0,ly,1),wj(0,ly,1),
     &               zhup(0,ly,1),zhlw(0,ly,1),wh(0,ly,1))
        endif
        if(vsup(ly).gt.0.d0)then
          if(xs(ly).le.xmin)then
            ksmalls(ly)=.true.
            wj(ldeg,ly,2)=(cldeg+c2)*cruplw
            wh(ldeg,ly,2)=-(cldeg-c1)*cruplw
          else if(ksmalls(ly))then
            ksmalls(ly)=.false.
            call spbjh(ldegpsv(ly),ks(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,2),zjlw(0,ly,2),wj(0,ly,2),
     &                 zhup(0,ly,2),zhlw(0,ly,2),wh(0,ly,2))
          endif
        endif
        if(ldeg.eq.0)then
          call qpsmat0(ly,lylw,lwup)
        else if(vsup(ly).gt.0.d0)then
          call qpsmat(ldeg,ly,lylw,lwup)
        else
          call qpsmatc(ldeg,ly,lylw,lwup)
        endif
      enddo
c
      if(ldeg.eq.0)then
        call qpspropg0(ypsv,lyup,lylw)
      else
        call qpspropg(ypsv,ldeg,lyup,lylw)
      endif
c
      return
      end

      subroutine qpstart4g(ldeg,ly,jh,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c
      integer*4 ldeg,ly,jh
      complex*16 cy(4,2)
c
      integer*4 i,j
c
      if(jh.eq.0.and.ly.ge.lys)then
        if(lylwa.gt.0.or.lylwb.le.ly0)then
          do j=1,2
            do i=1,4
              cy(i,j)=mas4x4up(i,2*j-1,ly)
            enddo
          enddo
c
c         y1 <- y1 (normal displacement)
c         y2 <- y3 (horizontal displacement)
c         y3 <- y5 (potential)
c         y4 <- y6 (gravity)
c
          do j=1,2
            cy(2,j)=(cy(1,j)*cgrup(ly)/crrup(ly)
     &              -cy(2,j)/(croup(ly)*crrup(ly)**2)
     &              -cy(3,j))/comi2
          enddo
        else
          call qpstart4(ldeg,ly,cy)
        endif
      else if(jh.eq.1.and.ly.ge.lys.or.jh.eq.2.and.ly.le.lys)then
        call qpstart4a(ldeg,ly,jh,cy)
c
c       y1 <- y1 (normal displacement)
c       y2 <- y3 (horizontal displacement)
c       y3 <- y5 (potential)
c       y4 <- y6 (gravity)
c
        do j=1,2
          cy(2,j)=(cy(1,j)*cgrup(ly)/crrup(ly)
     &            -cy(2,j)/(croup(ly)*crrup(ly)**2)
     &            -cy(3,j))/comi2
        enddo
      else
        stop ' Error in qpstart4g: bad jh value!'
      endif
c
      return
      end

      subroutine qspsv(y,k,lup,llw)
      implicit none
c
c     calculation of response to p-sv source
c     y(6,6): solution vector (complex)
c     k: wave number
c
      integer*4 lup,llw
      real*8 k
      complex*16 y(6,6)
c
      include 'qsglobal.h'
c
c     work space
c
      integer*4 i,istp,j,l,n,key
      complex*16 cfac,ck,ch0,pwave,swave
      complex*16 y0(4,2),c0(4,2),c1(4,2),b(4,6),b0(4,6)
      complex*16 cinc(4,6)
      complex*16 y1(4,2),yup(4,2),ylw(4,2),orth(2,2)
      complex*16 coef(4,4),cnorm(2),coefrs(2,2),brs(2,6)
      logical*4 rsite
      logical*4 dynamic(nzmax)
c
      complex*16 c2
	data c2/(2.d0,0.d0)/
c
      ck=dcmplx(k,0.d0)
c
c===============================================================================
c
c     matrix propagation from surface to source
c
c     determination of starting upper sublayer
c
      rsite=.false.
c
      do l=1,lp
        n=nno(l)
        dynamic(l)=isurf.ne.0.or.n0rs.gt.0.or.
     &             cdabs(kp(n)-ks(n)).gt.0.1d0*k.or.
     &             cdabs(kp(n)-ks(n))*hp(l).gt.0.1d0.or.
     &             .not.(pup(l).and.pdw(l).and.svup(l).and.svdw(l))
      enddo
      if(lup.eq.1.and.isurf.eq.0)then
        do j=1,2
          do i=1,4
            yup(i,j)=(0.d0,0.d0)
          enddo
        enddo
        yup(1,1)=(1.d0,0.d0)
        if(vpair.gt.0.d0)yup(2,1)=-accair/kpair
        yup(3,2)=(1.d0,0.d0)
      else
        n=nno(lup)
c
        yup(1,1)=kp(n)
        yup(2,1)=wa(n)
        yup(3,1)=ck
        yup(4,1)=wb(n)*kp(n)
c
        yup(1,2)=ck
        yup(2,2)=wb(n)*ks(n)
        yup(3,2)=ks(n)
        yup(4,2)=wa(n)
      endif
      if(lup.eq.lzr)call cmemcpy(yup,y0,8)
c
      do l=lup+1,ls
        ch0=dcmplx(hp(l-1),0.d0)
        n=nno(l-1)
c
c       determination of propagation matrix
c
        call qsve2am(n,ck,0.d0,dynamic(l-1),yup,c0,2,rsite)
        pwave=cdexp(-kp(n)*ch0)
        swave=cdexp(-ks(n)*ch0)
c
c       orthonormalization of the p-sv modes
c
        cfac=(1.d0,0.d0)/(c0(3,2)*c0(1,1)-c0(1,2)*c0(3,1))
        orth(1,1)=c0(3,2)*cfac
        orth(1,2)=-c0(1,2)*cfac
        orth(2,1)=-c0(3,1)*cfac
        orth(2,2)=c0(1,1)*cfac
        call caxcb(c0,orth,4,2,2,c1)
c
        if(l.gt.lzr)then
c
c         additional normalization to avoid overflow
c
          do i=1,2
            orth(i,1)=orth(i,1)*pwave
            orth(i,2)=orth(i,2)*swave
          enddo
          call caxcb(y0,orth,4,2,2,y1)
          call cmemcpy(y1,y0,8)
        endif
c
c       for partial solution only!
c
        if(.not.pup(l-1))then
          c1(2,1)=(0.d0,0.d0)
          c1(4,1)=(0.d0,0.d0)
          if(l.gt.lzr)then
            do j=1,4
              y0(j,1)=(0.d0,0.d0)
            enddo
          endif
        endif
        if(.not.svup(l-1))then
          c1(2,2)=(0.d0,0.d0)
          c1(4,2)=(0.d0,0.d0)
          if(l.gt.lzr)then
            do j=1,4
              y0(j,2)=(0.d0,0.d0)
            enddo
          endif
        endif
        if(.not.pdw(l-1))then
          c1(2,1)=(0.d0,0.d0)
          c1(2,2)=(0.d0,0.d0)
          if(l-1.eq.lzr)then
            call qsve2am(n,ck,0.d0,dynamic(l-1),y0,c0,2,rsite)
            c0(2,1)=(0.d0,0.d0)
            c0(2,2)=(0.d0,0.d0)
            call qsam2ve(n,ck,0.d0,dynamic(l-1),y0,c0,2,rsite)
          endif
        endif
        if(.not.svdw(l-1))then
          c1(4,1)=(0.d0,0.d0)
          c1(4,2)=(0.d0,0.d0)
          if(l-1.eq.lzr)then
            call qsve2am(n,ck,0.d0,dynamic(l-1),y0,c0,2,rsite)
            c0(4,1)=(0.d0,0.d0)
            c0(4,2)=(0.d0,0.d0)
            call qsam2ve(n,ck,0.d0,dynamic(l-1),y0,c0,2,rsite)
          endif
        endif
c
c       end partial solution procedure!
c
c        c1(1,1)=c1(1,1)
        c1(2,1)=c1(2,1)*pwave*pwave
        c1(3,1)=(0.d0,0.d0)
        c1(4,1)=c1(4,1)*pwave*swave
c
        c1(1,2)=(0.d0,0.d0)
        c1(2,2)=c1(2,2)*swave*pwave
c        c1(3,2)=c1(3,2)
        c1(4,2)=c1(4,2)*swave*swave
c
        call qsam2ve(n,ck,hp(l-1),dynamic(l-1),yup,c1,2,rsite)
c
        if(l.eq.lzr)call cmemcpy(yup,y0,8)
      enddo
c
c===============================================================================
c
c     matrix propagation from half-space to source
c
      n=nno(llw)
      ylw(1,1)=-kp(n)
      ylw(2,1)=wa(n)
      ylw(3,1)=ck
      ylw(4,1)=-wb(n)*kp(n)
c
      ylw(1,2)=ck
      ylw(2,2)=-wb(n)*ks(n)
      ylw(3,2)=-ks(n)
      ylw(4,2)=wa(n)
c
      if(llw.gt.ls.and.llw.eq.lzr)call cmemcpy(ylw,y0,8)
c
      do l=llw-1,ls,-1
        ch0=dcmplx(hp(l),0.d0)
        n=nno(l)
c
c       determination of propagation matrix
c
        call qsve2am(n,ck,0.d0,dynamic(l),ylw,c0,2,rsite)
        pwave=cdexp(-kp(n)*ch0)
        swave=cdexp(-ks(n)*ch0)
c
c       orthonormalization of the p-sv modes
c
        cfac=(1.d0,0.d0)/(c0(4,2)*c0(2,1)-c0(2,2)*c0(4,1))
        orth(1,1)=c0(4,2)*cfac
        orth(1,2)=-c0(2,2)*cfac
        orth(2,1)=-c0(4,1)*cfac
        orth(2,2)=c0(2,1)*cfac
        call caxcb(c0,orth,4,2,2,c1)
c
        if(l.lt.lzr)then
c
c         additional normalization to avoid overflow
c
          do i=1,2
            orth(i,1)=orth(i,1)*pwave
            orth(i,2)=orth(i,2)*swave
          enddo
          call caxcb(y0,orth,4,2,2,y1)
          call cmemcpy(y1,y0,8)
        endif
c
c       for partial solution only!
c
        if(.not.pup(l))then
          c1(1,1)=(0.d0,0.d0)
          c1(1,2)=(0.d0,0.d0)
          if(l+1.eq.lzr)then
            call qsve2am(n,ck,0.d0,dynamic(l),y0,c0,2,rsite)
            c0(1,1)=(0.d0,0.d0)
            c0(1,2)=(0.d0,0.d0)
            call qsam2ve(n,ck,0.d0,dynamic(l),y0,c0,2,rsite)
          endif
        endif
        if(.not.svup(l))then
          c1(3,1)=(0.d0,0.d0)
          c1(3,2)=(0.d0,0.d0)
          if(l+1.eq.lzr)then
            call qsve2am(n,ck,0.d0,dynamic(l),y0,c0,2,rsite)
            c0(3,1)=(0.d0,0.d0)
            c0(3,2)=(0.d0,0.d0)
            call qsam2ve(n,ck,0.d0,dynamic(l),y0,c0,2,rsite)
          endif
        endif
        if(.not.pdw(l))then
          c1(1,1)=(0.d0,0.d0)
          c1(3,1)=(0.d0,0.d0)
          if(l.lt.lzr)then
            do j=1,4
              y0(j,1)=(0.d0,0.d0)
            enddo
          endif
        endif
        if(.not.svdw(l))then
          c1(1,2)=(0.d0,0.d0)
          c1(3,2)=(0.d0,0.d0)
          if(l.lt.lzr)then
            do j=1,4
              y0(j,2)=(0.d0,0.d0)
            enddo
          endif
        endif
c
c       end partial solution procedure!
c
        c1(1,1)=c1(1,1)*pwave*pwave
c        c1(2,1)=c1(2,1)
        c1(3,1)=c1(3,1)*pwave*swave
        c1(4,1)=(0.d0,0.d0)
c
        c1(1,2)=c1(1,2)*swave*pwave
        c1(2,2)=(0.d0,0.d0)
        c1(3,2)=c1(3,2)*swave*swave
c        c1(4,2)=c1(4,2)
c
        call qsam2ve(n,ck,-hp(l),dynamic(l),ylw,c1,2,rsite)
        if(l.gt.ls.and.l.eq.lzr)call cmemcpy(ylw,y0,8)
      enddo
c
c===============================================================================
c     source function
c===============================================================================
c
      do istp=1,6
        do i=1,4
          b(i,istp)=dcmplx(sfct0(i,istp)+k*sfct1(i,istp),0.d0)
        enddo
      enddo
      do i=1,4
        do j=1,2
          coef(i,j)=yup(i,j)
          coef(i,j+2)=-ylw(i,j)
        enddo
      enddo
      if(ipath.eq.1)call cmemcpy(b,b0,24)
      key=0
      call cdgemp(coef,b,4,6,0.d0,key)
      if(key.eq.0)then
        print *,'warning in qspsv: anormal exit from cdgemp!'
        return
      endif
      if(lzr.le.ls)then
        do istp=1,6
          do i=1,4
            y(i,istp)=(0.d0,0.d0)
            do j=1,2
              y(i,istp)=y(i,istp)+b(j,istp)*y0(i,j)
            enddo
          enddo
        enddo
      else
        do istp=1,6
          do i=1,4
            y(i,istp)=(0.d0,0.d0)
            do j=1,2
              y(i,istp)=y(i,istp)+b(j+2,istp)*y0(i,j)
            enddo
          enddo
        enddo
      endif
c
      if(ipath.eq.1)then
        n=nno(lpath)
        ylw(1,1)=-kp(n)
        ylw(2,1)=wa(n)
        ylw(3,1)=ck
        ylw(4,1)=-wb(n)*kp(n)
c
        ylw(1,2)=ck
        ylw(2,2)=-wb(n)*ks(n)
        ylw(3,2)=-ks(n)
        ylw(4,2)=wa(n)
c
        if(lpath.gt.ls.and.lpath.eq.lzr)call cmemcpy(ylw,y0,8)
        do l=lpath-1,ls,-1
          ch0=dcmplx(hp(l),0.d0)
          n=nno(l)
c
c         determination of propagation matrix
c
          call qsve2am(n,ck,0.d0,dynamic(l),ylw,c0,2,rsite)
          pwave=cdexp(-kp(n)*ch0)
          swave=cdexp(-ks(n)*ch0)
c
c         orthonormalization of the p-sv modes
c
          cfac=(1.d0,0.d0)/(c0(4,2)*c0(2,1)-c0(2,2)*c0(4,1))
          orth(1,1)=c0(4,2)*cfac
          orth(1,2)=-c0(2,2)*cfac
          orth(2,1)=-c0(4,1)*cfac
          orth(2,2)=c0(2,1)*cfac
c
          call caxcb(c0,orth,4,2,2,c1)
          if(l.lt.lzr)then
c
c           additional normalization to avoid overflow
c
            do i=1,2
              orth(i,1)=orth(i,1)*pwave
              orth(i,2)=orth(i,2)*swave
            enddo
            call caxcb(y0,orth,4,2,2,y1)
            call cmemcpy(y1,y0,8)
          endif
c
c         for partial solution only!
c
          if(.not.pup(l))then
            c1(1,1)=(0.d0,0.d0)
            c1(1,2)=(0.d0,0.d0)
            if(l+1.eq.lzr)then
              call qsve2am(n,ck,0.d0,dynamic(l),y0,c0,2,rsite)
              c0(1,1)=(0.d0,0.d0)
              c0(1,2)=(0.d0,0.d0)
              call qsam2ve(n,ck,0.d0,dynamic(l),y0,c0,2,rsite)
            endif
          endif
          if(.not.svup(l))then
            c1(3,1)=(0.d0,0.d0)
            c1(3,2)=(0.d0,0.d0)
            if(l+1.eq.lzr)then
              call qsve2am(n,ck,0.d0,dynamic(l),y0,c0,2,rsite)
              c0(3,1)=(0.d0,0.d0)
              c0(3,2)=(0.d0,0.d0)
              call qsam2ve(n,ck,0.d0,dynamic(l),y0,c0,2,rsite)
            endif
          endif
          if(.not.pdw(l))then
            c1(1,1)=(0.d0,0.d0)
            c1(3,1)=(0.d0,0.d0)
            if(l.lt.lzr)then
              do j=1,4
                  y0(j,1)=(0.d0,0.d0)
                enddo
              endif
            endif
          if(.not.svdw(l))then
            c1(1,2)=(0.d0,0.d0)
            c1(3,2)=(0.d0,0.d0)
            if(l.lt.lzr)then
              do j=1,4
                y0(j,2)=(0.d0,0.d0)
             enddo
            endif
          endif
c
c         end partial solution procedure!
c
          c1(1,1)=c1(1,1)*pwave*pwave
c          c1(2,1)=c1(2,1)
          c1(3,1)=c1(3,1)*pwave*swave
          c1(4,1)=(0.d0,0.d0)
c
          c1(1,2)=c1(1,2)*swave*pwave
          c1(2,2)=(0.d0,0.d0)
          c1(3,2)=c1(3,2)*swave*swave
c          c1(4,2)=c1(4,2)
c
          call qsam2ve(n,ck,-hp(l),dynamic(l),ylw,c1,2,rsite)
          if(l.gt.ls.and.l.eq.lzr)call cmemcpy(ylw,y0,8)
        enddo
        do i=1,4
          do j=1,2
            coef(i,j)=yup(i,j)
            coef(i,j+2)=-ylw(i,j)
          enddo
        enddo
        key=0
        call cdgemp(coef,b0,4,6,1.d-30,key)
        if(key.eq.0)then
          print *,'warning in qspsv: anormal exit from cdgemp!'
          return
        endif
        if(lzr.le.ls)then
          do istp=1,6
            do i=1,4
              do j=1,2
                y(i,istp)=y(i,istp)-b0(j,istp)*y0(i,j)
              enddo
            enddo
          enddo
        else
          do istp=1,6
            do i=1,4
              do j=1,2
                y(i,istp)=y(i,istp)-b0(j+2,istp)*y0(i,j)
              enddo
            enddo
          enddo
        endif
      endif
c
      if(n0rs.gt.0)then
c
c       for receiver-site structure different from source-site structure
c
        n=nno(lzr)
        do istp=1,6
          call qsve2am(n,ck,0.d0,.true.,y(1,istp),cinc(1,istp),1,rsite)
        enddo
c
c       determination of starting upper sublayer
c
        rsite=.true.
c
        if(isurf.eq.0)then
          do j=1,2
            do i=1,4
              yup(i,j)=(0.d0,0.d0)
            enddo
          enddo
          yup(1,1)=(1.d0,0.d0)
          if(vpair.gt.0.d0)yup(2,1)=-accair/kpair
          yup(3,2)=(1.d0,0.d0)
        else
          n=nnors(lup)
c
          yup(1,1)=kprs(n)
          yup(2,1)=wars(n)
          yup(3,1)=ck
          yup(4,1)=wbrs(n)*kprs(n)
c
          yup(1,2)=ck
          yup(2,2)=wbrs(n)*ksrs(n)
          yup(3,2)=ksrs(n)
          yup(4,2)=wars(n)
        endif
        if(lzrrs.eq.1)call cmemcpy(yup,y0,8)
c
        do l=2,lprs
          ch0=dcmplx(hprs(l-1),0.d0)
          n=nnors(l-1)
c
c
c         determination of propagation matrix
c
          call qsve2am(n,ck,0.d0,.true.,yup,c0,2,rsite)
          pwave=cdexp(-kprs(n)*ch0)
          swave=cdexp(-ksrs(n)*ch0)
c
c         orthonormalization of the p-sv modes
c
          cfac=(1.d0,0.d0)/(c0(3,2)*c0(1,1)-c0(1,2)*c0(3,1))
          orth(1,1)=c0(3,2)*cfac
          orth(1,2)=-c0(1,2)*cfac
          orth(2,1)=-c0(3,1)*cfac
          orth(2,2)=c0(1,1)*cfac
c
          call caxcb(c0,orth,4,2,2,c1)
          if(l.gt.lzrrs)then
c
c           additional normalization to avoid overflow
c
            do i=1,2
              orth(i,1)=orth(i,1)*pwave
              orth(i,2)=orth(i,2)*swave
            enddo
            call caxcb(y0,orth,4,2,2,y1)
            call cmemcpy(y1,y0,8)
          endif
c          c1(1,1)=c1(1,1)
          c1(2,1)=c1(2,1)*pwave*pwave
          c1(3,1)=(0.d0,0.d0)
          c1(4,1)=c1(4,1)*pwave*swave
c
          c1(1,2)=(0.d0,0.d0)
          c1(2,2)=c1(2,2)*swave*pwave
c          c1(3,2)=c1(3,2)
          c1(4,2)=c1(4,2)*swave*swave
c
          call qsam2ve(n,ck,hprs(l-1),.true.,yup,c1,2,rsite)
          if(l.eq.lzrrs)call cmemcpy(yup,y0,8)
        enddo
        n=nnors(lprs)
        call qsve2am(n,ck,0.d0,.true.,yup,c0,2,rsite)
        do istp=1,6
          brs(1,istp)=cinc(1,istp)
          brs(2,istp)=cinc(3,istp)
        enddo
        coefrs(1,1)=c0(1,1)
        coefrs(1,2)=c0(1,2)
        coefrs(2,1)=c0(3,1)
        coefrs(2,2)=c0(3,2)
        key=0
        call cdgemp(coefrs,brs,2,6,0.d0,key)
        if(key.eq.0)then
          print *,'warning in qspsv: anormal exit from cdgemp!'
          return
        endif
        do istp=1,6
          do i=1,4
            y(i,istp)=(0.d0,0.d0)
            do j=1,2
              y(i,istp)=y(i,istp)+brs(j,istp)*y0(i,j)
            enddo
          enddo
        enddo
      endif
      if(isurf.eq.2)then
c
c       free surface corrections
c
        n=1
        if(rsite)then
          yup(1,1)=kprs(n)
          yup(2,1)=wars(n)
          yup(3,1)=ck
          yup(4,1)=wbrs(n)*kprs(n)
c
          yup(1,2)=ck
          yup(2,2)=wbrs(n)*ksrs(n)
          yup(3,2)=ksrs(n)
          yup(4,2)=wars(n)
c
          ylw(1,1)=-kprs(n)
          ylw(2,1)=wars(n)
          ylw(3,1)=ck
          ylw(4,1)=-wbrs(n)*kprs(n)
c
          ylw(1,2)=ck
          ylw(2,2)=-wbrs(n)*ksrs(n)
          ylw(3,2)=-ksrs(n)
          ylw(4,2)=wars(n)
        else
          yup(1,1)=kp(n)
          yup(2,1)=wa(n)
          yup(3,1)=ck
          yup(4,1)=wb(n)*kp(n)
c
          yup(1,2)=ck
          yup(2,2)=wb(n)*ks(n)
          yup(3,2)=ks(n)
          yup(4,2)=wa(n)
c
          ylw(1,1)=-kp(n)
          ylw(2,1)=wa(n)
          ylw(3,1)=ck
          ylw(4,1)=-wb(n)*kp(n)
c
          ylw(1,2)=ck
          ylw(2,2)=-wb(n)*ks(n)
          ylw(3,2)=-ks(n)
          ylw(4,2)=wa(n)
        endif
c
        do istp=1,6
          call qsve2am(1,ck,0.d0,.true.,y(1,istp),b0(1,istp),1,rsite)

          b(1,istp)=-yup(2,1)*b0(1,istp)-yup(2,2)*b0(3,istp)
          b(2,istp)=-yup(4,1)*b0(1,istp)-yup(4,2)*b0(3,istp)
          orth(1,1)=ylw(2,1)
          orth(1,2)=ylw(2,2)
          orth(2,1)=ylw(4,1)
          orth(2,2)=ylw(4,2)
          key=0
          call cdgemp(orth,b(1,istp),2,1,0.d0,key)
          if(key.eq.0)then
            print *,'warning in qspsv: anormal exit from cdgemp!'
            return
          endif
          b0(2,istp)=b(1,istp)
          b0(4,istp)=b(2,istp)
          call qsam2ve(1,ck,0.d0,.true.,y(1,istp),b0(1,istp),1,rsite)
        enddo
      endif
      return
      end

      program qssp
      use qpalloc
      implicit none
c
c     work space
c
      integer*4 ig,ierr,runtime
      integer*4 time
      character*100 inputfile
c
c     read input file file
c
      print *,'######################################################'
      print *,'#                                                    #'
      print *,'#               Welcome to the program               #'
      print *,'#                                                    #'
      print *,'#    QQQQ         SSSSS        SSSSS       PPPPP     #'
      print *,'#   Q    Q       S            S            P    P    #'
      print *,'#   Q    Q        SSSS         SSSS        PPPPP     #'
      print *,'#   Q   QQ            S            S       P         #'
      print *,'#    QQQQQ       SSSSS        SSSSS        P         #'
      print *,'#                                                    #'
      print *,'#          Complete synthetic seismograms            #'
      print *,'#      (displacement/strain/stress/rotation)         #' 
      print *,'#                     based on                       #'
      print *,'#          a spherically symmetric earth model       #'
      print *,'#                                                    #'
      print *,'#                  (Version 2020)                    #'
      print *,'#   Last update (correction of errors): 2020-04-14   #'
      print *,'#                                                    #'
      print *,'#                      by                            #'
      print *,'#                 Rongjiang Wang                     #'
      print *,'#              (wang@gfz-potsdam.de)                 #'
      print *,'#                                                    #'
      print *,'#              Helmholtz Centre Potsdam              #'
      print *,'#    GFZ German Research Centre for Geosciences      #'
      print *,'#           Last modified: September 2017            #'
      print *,'#                                                    #'
      print *,'######################################################'
      print *,'                                                      '
      write(*,'(a,$)')' the input data file is '
      read(*,'(a)')inputfile
      runtime=time()
c
      open(10,file=inputfile,status='old')
      call qpgetinp(10)
      close(10)
c
      call qpsublayer(ierr)
c
      igfirst=0
      do ig=ngrn,1,-1
        if(grnsel(ig).eq.1)igfirst=ig
      enddo
      iglast=ngrn+1
      do ig=1,ngrn
        if(grnsel(ig).eq.1)iglast=ig
      enddo
c
      do ig=1,ngrn
        if(grnsel(ig).eq.1)then
          lys=lygrn(ig)
          call qpgrnspec(ig)
        endif
      enddo
      call qpwvint(ierr)
      call qpfftinv(ierr)
c
      runtime=time()-runtime
      write(*,'(a)')' #############################################'
      write(*,'(a)')' #                                           #'
      write(*,'(a)')' #      End of computations with qssp2020    #'
      write(*,'(a)')' #                                           #'
      write(*,'(a,i10,a)')' #       Run time: ',runtime,
     +                                           ' sec            #'
      write(*,'(a)')' #############################################'
      stop
      end

      subroutine qpstart6(ldeg,ly,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c
      integer*4 ldeg,ly
      complex*16 cy(6,3)
c
      integer*4 i,j
      complex*16 cldeg,cgl,ca2,cb2,cxi,c2mu,cgrdr
      complex*16 kpg,ksg,cfp,cfs,chp,chs,spa,spb,cxup,cx2
      complex*16 cllm1,cllp1,c2lp1,c2lp3,c22lp3
      complex*16 ph0,ph1,ps0,ps1
      complex*16 spbphj,spbpsj
c
      complex*16 ci,c1,c2,c3,c4
      data ci,c1,c2,c3,c4/(0.d0,1.d0),
     &     (1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0),(4.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      c2mu=c2*cmu(ly)
      cxi=cla(ly)+c2mu
      cllm1=cldeg*(cldeg-c1)
      cllp1=cldeg*(cldeg+c1)
      c2lp1=c2*cldeg+c1
      c2lp3=c2*cldeg+c3
      c22lp3=c2*(c2*cldeg+c3)
      cgrdr=cgrup(ly)/crrup(ly)
c
      ca2=(comi2+cga(ly)+cgrdr)/cvp(ly)**2
      cb2=comi2/cvs(ly)**2
      cgl=c4*cllp1*(cgrdr/(cvp(ly)*cvs(ly)))**2
c
      kpg=cdsqrt((ca2+cb2-cdsqrt((cb2-ca2)**2+cgl))/c2)
      cfp=((kpg*cvs(ly))**2-comi2)/cgrdr
      chp=cfp-cldeg-c1
c
      ksg=cdsqrt((ca2+cb2+cdsqrt((cb2-ca2)**2+cgl))/c2)
      cfs=((ksg*cvs(ly))**2-comi2)/cgrdr
      chs=cfs-cldeg-c1
c
      if(cdabs(kpg*crrup(ly))**2.lt.0.5d0*dble(ldeg))then
c
        cxup=kpg*crrup(ly)
        ph0=spbphj(ldeg,cxup)
        ph1=spbphj(ldeg+1,cxup)
        ps0=spbpsj(ldeg,cxup)
        ps1=spbpsj(ldeg+1,cxup)
c
        cy(1,1)=-(cldeg*chp*ps0/c2+cfp*ph1)/c2lp3
        cy(2,1)=-cxi*cfp*ph0+cmu(ly)*(-cllm1*chp*ps0
     &         +c2*(c2*cfp+cllp1)*ph1)/c2lp3
        cy(3,1)=-(chp*ps0/c2-ph1)/c2lp3
        cy(4,1)=cmu(ly)*(ph0-((cldeg-c1)*chp*ps0
     &         +c2*(cfp+c1)*ph1)/c2lp3)
        cy(5,1)=(cfp*cvp(ly)**2-(cldeg+c1)*cvs(ly)**2)/crrup(ly)**2
     &         -cga(ly)*cfp*ps0/c22lp3
        cy(6,1)=c2lp1*cy(5,1)+cga(ly)*cldeg*chp*ps0/c22lp3
      else
        call spbjh(ldeg,kpg,rrup(ly),rrlw(ly),
     &             zjupg(0),zjlwg(0),wjg(0),
     &             zhupg(0),zhlwg(0),whg(0))
c
        spa=c1-zjupg(ldeg)
        spb=-ci*zjupg(ldeg)
        cx2=(kpg*crrup(ly))**2
c
        cy(1,1)=cldeg*chp*spa-cfp*spb
        cy(2,1)=(-cxi*cfp*cx2+c2mu*cllm1*chp)*spa
     &         +c2mu*(c2*cfp+cllp1)*spb
        cy(3,1)=chp*spa+spb
        cy(4,1)=cmu(ly)*(cx2+c2*(cldeg-c1)*chp)*spa
     &         -c2mu*(cfp+c1)*spb
        cy(5,1)=cga(ly)*cfp*spa
        cy(6,1)=cga(ly)*(c2lp1*cfp-cldeg*chp)*spa
      endif
c
      if(cdabs(ksg*crrup(ly))**2.lt.0.5d0*dble(ldeg))then
c
        cxup=ksg*crrup(ly)
        ph0=spbphj(ldeg,cxup)
        ph1=spbphj(ldeg+1,cxup)
        ps0=spbpsj(ldeg,cxup)
        ps1=spbpsj(ldeg+1,cxup)
c
        cy(1,2)=-(cldeg*chs*ps0/c2+cfs*ph1)/c2lp3
        cy(2,2)=-cxi*cfs*ph0+cmu(ly)*(-cllm1*chs*ps0
     &         +c2*(c2*cfs+cllp1)*ph1)/c2lp3
        cy(3,2)=-(chs*ps0/c2-ph1)/c2lp3
        cy(4,2)=cmu(ly)*(ph0-((cldeg-c1)*chs*ps0
     &         +c2*(cfs+c1)*ph1)/c2lp3)
        cy(5,2)=(cfs*cvp(ly)**2-(cldeg+c1)*cvs(ly)**2)/crrup(ly)**2
     &         -cga(ly)*cfs*ps0/c22lp3
        cy(6,2)=c2lp1*cy(5,2)+cga(ly)*cldeg*chs*ps0/c22lp3
      else
c
        call spbjh(ldeg,ksg,rrup(ly),rrlw(ly),
     &             zjupg(0),zjlwg(0),wjg(0),
     &             zhupg(0),zhlwg(0),whg(0))
c
        spa=c1-zjupg(ldeg)
        spb=-ci*zjupg(ldeg)
        cx2=(ksg*crrup(ly))**2
c
        cy(1,2)=cldeg*chs*spa-cfs*spb
        cy(2,2)=(-cxi*cfs*cx2+c2mu*cllm1*chs)*spa
     &       +c2mu*(c2*cfs+cllp1)*spb
        cy(3,2)=chs*spa+spb
        cy(4,2)=cmu(ly)*(cx2+c2*(cldeg-c1)*chs)*spa
     &       -c2mu*(cfs+c1)*spb
        cy(5,2)=cga(ly)*cfs*spa
        cy(6,2)=cga(ly)*(c2lp1*cfs-cldeg*chs)*spa
      endif
c
      cy(1,3)=cldeg
      cy(2,3)=c2mu*cllm1
      cy(3,3)=c1
      cy(4,3)=c2mu*(cldeg-c1)
      cy(5,3)=cldeg*cgrdr-comi2
      cy(6,3)=c2lp1*(cldeg*cgrdr-comi2)-cga(ly)*cldeg
      return
      end

      subroutine qssource(ros,vps,vss)
      implicit none
c
      real*8 ros,vps,vss
c
      include 'qsglobal.h'
c
      integer*4 i,istp
      real*8 pi,pi2
c
      do istp=1,6
        do i=1,6
          sfct0(i,istp)=0.d0
          sfct1(i,istp)=0.d0
        enddo
      enddo
c
      pi=4.d0*datan(1.d0)
      pi2=2.d0*pi
c
c     istp = 1
c     explosion source (m11=m22=m33=1)
c
      ms(1)=0
      ics(1)=1
      sfct0(1,1)=-1.d0/(pi2*ros*vps*vps)
      sfct1(4,1)=-(vss/vps)**2/pi
c
c     istype = 2
c     strike-slip (m12=m21=1)
c
      ms(2)=2
      ics(2)=-1
      sfct1(4,2)=1.d0/pi2
      sfct1(6,2)=-sfct1(4,2)
c
c     istype = 3
c     dip-slip (m13=m31=1)
c
      ms(3)=1
      ics(3)=1
      sfct0(3,3)=-1.d0/(pi2*ros*vss*vss)
      sfct0(5,3)=sfct0(3,3)
c
c     istp = 4
c     compensated linear vector dipole (CLVD) (m11=m22=-1/2, M33=1)
c
      ms(4)=0
      ics(4)=1
      sfct0(1,4)=-1.d0/(pi2*ros*vps*vps)
      sfct1(4,4)=(3.d0-4.d0*(vss/vps)**2)/(2.d0*pi2)
c
c     istp = 5
c     vertical-single-force (fz=1)
c
      ms(5)=0
      ics(5)=1
      sfct0(2,5)=1.d0/pi2
c
c     istp = 6
c     horizontal-single-force (fx=1)
c
      ms(6)=1
      ics(6)=1
      sfct0(4,6)=1.d0/pi2
      sfct0(6,6)=sfct0(4,6)
c
      return
      end

      subroutine bandpass(n,f1,f2,df,nf,h)
      implicit none
      integer*4 n,nf
      real*8 f1,f2,df
      complex*16 h(nf)
c
      integer*4 l,k
      real*8 w,w1,w2,delt,arg
c
      real*8 PI
      data PI/3.14159265358979d0/
c
      if(n.le.0.or.f1.ge.f2)then
        do l=1,nf
          h(l)=(1.d0,0.d0)
        enddo
      else if(f1.le.0.d0)then
        w2=2.d0*PI*f2
        do l=1,nf
          w=2.d0*PI*dble(l-1)*df
          delt=w2-w1
          h(l)=(1.d0,0.d0)
          do k=1,n
            arg=PI*dble(2*k-1)/dble(2*n)
            h(l)=h(l)*dcmplx(0.d0,-delt)
     &          /dcmplx(w-delt*dcos(arg),-delt*dsin(arg))
          enddo
        enddo
      else
        w1=2.d0*PI*f1
        w2=2.d0*PI*f2
        do l=1,nf
          w=2.d0*PI*dble(l-1)*df
          delt=w*(w2-w1)
          h(l)=(1.d0,0.d0)
          do k=1,n
            arg=PI*dble(2*k-1)/dble(2*n)
            h(l)=h(l)*dcmplx(0.d0,-delt)
     &          /dcmplx(w*w-w1*w2-delt*dcos(arg),-delt*dsin(arg))
          enddo
        enddo
      endif
      return
      end

      subroutine qptprop(ysh,lylw)
      use qpalloc
      implicit none
c
c     calculation of response to sh source
c     ysh(2,2): solution vector (complex)
c
      integer*4 lylw
      complex*16 ysh(2,2)
c
c     work space
c
      integer*4 i,istp,ly,key
      complex*16 y0(2),yup(2),ylw(2),c(2)
      complex*16 coef(2,2),b(2,2)
c
c===============================================================================
c
c     propagation from surface to source
c
      if(lys.lt.lyob)then
        do istp=1,2
          do i=1,2
            ysh(i,istp)=(0.d0,0.d0)
          enddo
        enddo
        return
      endif
c
      yup(1)=(1.d0,0.d0)
      yup(2)=(0.d0,0.d0)
c
      if(lyr.eq.lyob)call cmemcpy(yup,y0,2)
c
      do ly=lyob,lys-1
        call caxcb(mat2x2inv(1,1,ly),yup,2,2,1,c)
c
	  c(1)=c(1)*cdexp(cpt(1,ly))
        c(2)=c(2)*cdexp(cpt(2,ly))
c
        call caxcb(mat2x2lw(1,1,ly),c,2,2,1,yup)
        if(ly.eq.lyr-1)call cmemcpy(yup,y0,2)
      enddo
      yup(1)=yup(1)/crrup(lys)
      yup(2)=yup(2)/crrup(lys)**2
c
c===============================================================================
c
c     propagation from bottom to source
c
      if(lylw.eq.lycm)then
        ylw(1)=(1.d0,0.d0)
        ylw(2)=(0.d0,0.d0)
      else
        ylw(1)=mat2x2up(1,1,lylw)
        ylw(2)=mat2x2up(2,1,lylw)
      endif
      if(lylw.eq.lyr.and.lylw.gt.lys)then
        call cmemcpy(ylw,y0,2)
      endif
c
      do ly=lylw-1,lys,-1
        call caxcb(mat2x2inv(1,1,ly),ylw,2,2,1,c)
c
        c(1)=c(1)*cdexp(cpt(1,ly))
        c(2)=c(2)*cdexp(cpt(2,ly))
c
        call caxcb(mat2x2up(1,1,ly),c,2,2,1,ylw)
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,2)
      enddo
      ylw(1)=ylw(1)/crrup(lys)
      ylw(2)=ylw(2)/crrup(lys)**2
c
      y0(1)=y0(1)/crrup(lyr)
      y0(2)=y0(2)/crrup(lyr)**2
c
c===============================================================================
c     source function
c===============================================================================
c
      b(1,1)=(1.d0,0.d0)
      b(2,1)=(0.d0,0.d0)
      b(1,2)=(0.d0,0.d0)
      b(2,2)=(1.d0,0.d0)
      do i=1,2
        coef(i,1)=yup(i)
        coef(i,2)=-ylw(i)
      enddo
      key=0
      call cdsvd(coef,b,2,2,0.d0,key)
      if(key.eq.0)then
        print *,' Warning in qptprop: anormal exit from cdgemp!'
        return
      endif
      if(lyr.le.lys)then
        do istp=1,2
          do i=1,2
            ysh(i,istp)=b(1,istp)*y0(i)
          enddo
        enddo
      else
        do istp=1,2
          do i=1,2
            ysh(i,istp)=b(2,istp)*y0(i)
          enddo
        enddo
      endif
      return
      end

      subroutine qpgrnspec(ig)
      use qpalloc
      implicit none
      integer*4 ig
c
      integer*4 i,il,istp,ly,lf,ldeg,ldeglw,ldegup,ldegf,ierr
      real*8 f,ksp2,dll1,omi,expo,slwgrn,ray,raymin
      real*8 fl,depst1,depst2,dys2,dxs
      complex*16 ca,cb,cag,cs1,cs2,cs3,cs4,ct1,ct2,cll1
      complex*16 ys1(4,0:2),ys2(4,0:2),yt1(4,0:2)
      complex*16 ypsv(6,4),ypsvg(6,4),ysh(2,2)
c
      complex*16 c2,c3,c4
      data c2,c3,c4/(2.d0,0.d0),(3.d0,0.d0),(4.d0,0.d0)/
c
      if(ig.eq.igfirst)then
        allocate(ksmallpsv(ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ksmallpsv not allocated!'
        allocate(ksmallsh(ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ksmallsh not allocated!'
c
        allocate(ldegpsv(ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ldegpsv not allocated!'
        allocate(ldegsh(ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ldegsh not allocated!'
c
        allocate(kp(ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: kp not allocated!'
        allocate(ks(ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ks not allocated!'
        allocate(kt(ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: kt not allocated!'
        allocate(cps(6,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: cps not allocated!'
        allocate(cpt(2,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: cpt not allocated!'
c
        allocate(mat2x2up(2,2,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mat2x2up not allocated!'
        allocate(mat2x2lw(2,2,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mat2x2lw not allocated!'
        allocate(mat2x2inv(2,2,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mat2x2inv not allocated!'
        allocate(mas2x2up(2,2,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas2x2up not allocated!'
        allocate(mas2x2lw(2,2,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas2x2lw not allocated!'
        allocate(mas2x2inv(2,2,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas2x2inv not allocated!'
        allocate(mas4x4up(4,4,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas4x4up not allocated!'
        allocate(mas4x4lw(4,4,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas4x4lw not allocated!'
        allocate(mas4x4inv(4,4,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas4x4inv not allocated!'
        allocate(mas6x6up(6,6,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas6x6up not allocated!'
        allocate(mas6x6lw(6,6,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas6x6lw not allocated!'
        allocate(mas6x6inv(6,6,ly0),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas6x6inv not allocated!'
c
        allocate(disk(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: disk not allocated!'
        allocate(fdisk(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: fdisk not allocated!'
c
        allocate(lylwsh(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: lylwsh not allocated!'
        allocate(lylwpsv(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: lylwpsv not allocated!'
        allocate(lyupatm(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: lylwatm not allocated!'
c
        allocate(zjup(0:ldegmax,ly0,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zjup not allocated!'
        allocate(zjlw(0:ldegmax,ly0,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zjlw not allocated!'
        allocate(zhup(0:ldegmax,ly0,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zhup not allocated!'
        allocate(zhlw(0:ldegmax,ly0,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zhlw not allocated!'
        allocate(wj(0:ldegmax,ly0,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: wj not allocated!'
        allocate(wh(0:ldegmax,ly0,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: wh not allocated!'
c
        if(.not.nogravity)then
          allocate(zjupg(0:ldegmax),stat=ierr)
          if(ierr.ne.0)stop 'Error in qpgrnspec: zjupg not allocated!'
          allocate(zjlwg(0:ldegmax),stat=ierr)
          if(ierr.ne.0)stop 'Error in qpgrnspec: zjlwg not allocated!'
          allocate(zhupg(0:ldegmax),stat=ierr)
          if(ierr.ne.0)stop 'Error in qpgrnspec: zhupg not allocated!'
          allocate(zhlwg(0:ldegmax),stat=ierr)
          if(ierr.ne.0)stop 'Error in qpgrnspec: zhlwg not allocated!'
          allocate(wjg(0:ldegmax),stat=ierr)
          if(ierr.ne.0)stop 'Error in qpgrnspec: wjg not allocated!'
          allocate(whg(0:ldegmax),stat=ierr)
          if(ierr.ne.0)stop 'Error in qpgrnspec: whg not allocated!'
        endif
c
        allocate(dplm1(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: dplm1 not allocated!'
      endif
c
c     tappered disk source:
c     2*[cos(theta)-cos(alpha)]/[1-cos(alpha)]^2
c
      if(rr0(ig).le.0.d0)then
        do ldeg=0,ldegmax
          fdisk(ldeg)=1.d0
        enddo
      else
        dxs=dcos(rr0(ig)/rrup(lys))
        dys2=(dsin(0.5d0*rr0(ig)/rrup(lys)))**2
        call legendre(ldegmax,rr0(ig)/rrup(lys),dplm1)
        fdisk(0)=1.d0
        fdisk(1)=(2.d0+dxs)/3.d0
        do ldeg=2,ldegmax
          fdisk(ldeg)=0.5d0/dys2**2
     &               /dble(ldeg)/dble(ldeg+1)/dble(ldeg+2)
     &               *(2.d0*dys2*(2.d0*dble(ldeg)*dys2+1.d0)
     &                +dble(ldeg)*dxs**2*dplm1(ldeg)
     &                -dble(2*ldeg+1)*dxs*dplm1(ldeg-1)
     &                +dble(ldeg+1)*dplm1(ldeg-2))
        enddo
      endif
      do ldeg=0,ldegmax
        disk(ldeg)=fdisk(ldeg)*dble(2*ldeg+1)/(4.d0*PI*rrup(lys)**2)
      enddo
c
      do ldeg=0,ldegmax
        fdisk(ldeg)=dabs(fdisk(ldeg))
        do il=ldeg+1,ldegmax
          fdisk(ldeg)=dmax1(fdisk(ldeg),dabs(fdisk(il)))
        enddo
      enddo
c
c     Initiation
c
      do istp=1,4
        do i=1,6
          ypsv(i,istp)=(0.d0,0.d0)
        enddo
      enddo
      do istp=1,2
        do i=1,2
          ysh(i,istp)=(0.d0,0.d0)
        enddo
      enddo
c
      open(21,file=rgrnfile(ig),
     &     form='unformatted',status='unknown')
      open(22,file=tgrnfile(ig),
     &     form='unformatted',status='unknown')
      open(23,file=pgrnfile(ig),
     &     form='unformatted',status='unknown')
c
      if(fullwave)then
        do ldeg=1+ndmax,ldegmin-1
          dll1=dble(ldeg)*dble(ldeg+1)
          expo=0.d0
          do ly=min0(lys,lyr),max0(lys,lyr)-1
            expo=expo+dsqrt(dll1)*dlog(rrup(ly)/rrlw(ly))
          enddo
          if(expo.gt.expol+dlog(fdisk(ldeg)))goto 10
        enddo
10      ldeglw=ldeg
c
        raymin=0.d0
        do ly=min0(lyr,lys),max0(lyr,lys)
          if(vsup(ly).gt.0.d0)then
            ray=rrup(ly)/vsup(ly)
          else
            ray=rrup(ly)/vpup(ly)
          endif
          if(raymin.le.0.d0.or.raymin.gt.ray)raymin=ray
          if(ly.gt.1)then
            if(vslw(ly-1).gt.0.d0)then
              ray=rrup(ly)/vslw(ly-1)
            else
              ray=rrup(ly)/vplw(ly-1)
            endif
            if(raymin.le.0.d0.or.raymin.gt.ray)raymin=ray
          endif
        enddo
        slwgrn=dmin1(slwmax,slwfac*raymin/rrup(lys))
      else
        ldeglw=ldegmin
        slwgrn=slwmax
      endif
      ldegup=min0(ldegmax-1,
     &       ldeglw+idint(rrup(min0(lyr,lys))*PI2*fcut*slwgrn))
c
      write(*,*)' '
      write(*,'(a,i3,a,f7.2,a)')' ... calculate Green functions for ',
     &        ig,'. source at depth ',(grndep(ig)-depatmos)/KM2M,' km'
	write(*,'(a,i5)')'   max. harmonic degree: L_max = ',ldegup
c
      write(21)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(22)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(23)nt,ntcut,dt,nf,nfcut,df,ldegup
c
      do istp=1,4
        do ldeg=0,1
          yr(ldeg,istp,0)=(0.d0,0.d0)
          yt(ldeg,istp,0)=(0.d0,0.d0)
          yp(ldeg,istp,0)=(0.d0,0.d0)
        enddo
      enddo
c
      do lf=1,nfcut
        f=dble(lf-1)*df
        omi=PI2*f
        ldegf=min0(ldegmax-1,ldeglw+idnint(dble(ldegup-ldeglw)*f/fcut))
c
        call qpqmodel(f)
        do ldeg=0,ldegf+1
          dll1=dble(ldeg)*dble(ldeg+1)
c
c         determine degree dependent starting layer number
c         of sh solution
c
          lylwsh(ldeg)=min0(lycm,ly0)
          expo=0.d0
          do ly=max0(lys,lyr,lyob)+1,min0(lycm,ly0)-1
            ksp2=(omi*rrup(ly)/vsup(ly))**2
            if(dll1.gt.ksp2)then
              expo=expo+dsqrt(dll1-ksp2)*dlog(rrup(ly)/rrlw(ly))
            endif
            if(expo.gt.expos)then
              lylwsh(ldeg)=ly
              goto 100
            endif
          enddo
100       continue
c
c         determine degree dependent starting layer number
c         of psv solution
c
          lylwpsv(ldeg)=ly0
          expo=0.d0
          do ly=max0(lys,lyr,lyob)+1,min0(lycm,ly0)-1
            ksp2=(omi*rrup(ly)/vsup(ly))**2
            if(dll1.gt.ksp2)then
              expo=expo+dsqrt(dll1-ksp2)*dlog(rrup(ly)/rrlw(ly))
            endif
            if(expo.gt.expos)then
              lylwpsv(ldeg)=ly
              goto 200
            endif
          enddo
          do ly=lycm,min0(lycc,ly0)-1
            ksp2=(omi*rrup(ly)/vpup(ly))**2
            if(dll1.gt.ksp2)then
              expo=expo+dsqrt(dll1-ksp2)*dlog(rrup(ly)/rrlw(ly))
            endif
            if(expo.gt.expos)then
              lylwpsv(ldeg)=ly
              goto 200
            endif
          enddo
          do ly=lycc,ly0-1
            ksp2=(omi*rrup(ly)/vsup(ly))**2
            if(dll1.gt.ksp2)then
              expo=expo+dsqrt(dll1-ksp2)*dlog(rrup(ly)/rrlw(ly))
            endif
            if(expo.gt.expos)then
              lylwpsv(ldeg)=ly
              goto 200
            endif
          enddo
200       continue
c
          lyupatm(ldeg)=1
          expo=0.d0
          do ly=lyob-1,1,-1
            ksp2=(omi*rrup(ly)/vpup(ly))**2
            if(dll1.gt.ksp2)then
              expo=expo+dsqrt(dll1-ksp2)*dlog(rrup(ly)/rrlw(ly))
            endif
            if(expo.gt.expoa)then
              lyupatm(ldeg)=ly
              goto 300
            endif
          enddo
300       continue
        enddo
c
        if(selpsv.or.lys.lt.lyob)then
          depst1=(rratmos-depatmos-rrup(lylwpsv(0)))/KM2M
          depst2=(rratmos-depatmos-rrup(lylwpsv(ldegf+1)))/KM2M
        else
          depst1=(rratmos-depatmos-rrup(lylwsh(1)))/KM2M
          depst2=(rratmos-depatmos-rrup(lylwsh(ldegf+1)))/KM2M
        endif
c
c       determine layer dependent max. harmonic degree
c       of sh solution
c
        do ly=lyob,min0(lycm-1,ly0)
          ldegsh(ly)=1
          do ldeg=1,ldegf+1
            if(lylwsh(ldeg).ge.ly)then
              ldegsh(ly)=ldeg
            endif
          enddo
        enddo
c
c       determine layer dependent max. harmonic degree
c       of psv solution
c
        do ly=1,lyob-1
          ldegpsv(ly)=0
          do ldeg=0,ldegf+1
            if(lyupatm(ldeg).le.ly)then
              ldegpsv(ly)=ldeg
            endif
          enddo
        enddo
c
        do ly=lyob,ly0
          ldegpsv(ly)=0
          do ldeg=0,ldegf+1
            if(lylwpsv(ldeg).ge.ly)then
              ldegpsv(ly)=ldeg
            endif
          enddo
        enddo
c
        do ly=1,ly0
          ksmallpsv(ly)=.true.
          ksmallsh(ly)=.true.
        enddo
c
        do il=0,2
          do istp=1,4
            ys1(istp,il)=(0.d0,0.d0)
            ys2(istp,il)=(0.d0,0.d0)
            yt1(istp,il)=(0.d0,0.d0)
          enddo
        enddo
c
        do ldeg=0,ldegf+1
          do istp=1,4
            ys1(istp,0)=ys1(istp,1)
            ys2(istp,0)=ys2(istp,1)
c
            ys1(istp,1)=ys1(istp,2)
            ys2(istp,1)=ys2(istp,2)
c
            yt1(istp,0)=yt1(istp,1)
c
            yt1(istp,1)=yt1(istp,2)
          enddo
c
          if(.not.selpsv)then
            do istp=1,4
	        do i=1,6
                ypsv(i,istp)=(0.d0,0.d0)
              enddo
            enddo
          else if(nogravity)then
            call qppsvkern(f,ldeg,ypsv)
          else
            fl=fgr*dble(ldeg)/dble(ldeggr)
            if(f.le.fgr-fl)then
              call qppsvkerng(f,ldeg,ypsv)
            else if(f.ge.fgr*(1.d0+FLTAPER)-fl)then
              call qppsvkern(f,ldeg,ypsv)
            else
              call qppsvkerng(f,ldeg,ypsvg)
              call qppsvkern(f,ldeg,ypsv)
              ca=dcmplx(dsin(((f+fl)/fgr-1.d0)/FLTAPER)**2,0.d0)
              cb=(1.d0,0.d0)-ca
              do istp=1,4
                do i=1,6
                  ypsv(i,istp)=ca*ypsv(i,istp)+cb*ypsvg(i,istp)
                enddo
              enddo
            endif
          endif
c
          if(.not.selsh.or.lys.lt.lyob)then
            do istp=1,2
	        do i=1,2
                ysh(i,istp)=(0.d0,0.d0)
              enddo
            enddo
          else
            call qpshkern(f,ldeg,ysh)
          endif
c
c         1. Explosion (M11=M22=M33=1)
c
          cs1=dcmplx( disk(ldeg)/(roup(lys)*vpup(lys)**2),0.d0)
          cs2=dcmplx(-disk(ldeg)*4.d0*(vsup(lys)/vpup(lys))**2
     &                /rrup(lys),0.d0)
          cs4=dcmplx( disk(ldeg)*2.d0*(vsup(lys)/vpup(lys))**2
     &                /rrup(lys),0.d0)
          ys1(1,2)=cs1*ypsv(1,1)+cs2*ypsv(1,2)+cs4*ypsv(1,4)
          ys2(1,2)=cs1*ypsv(3,1)+cs2*ypsv(3,2)+cs4*ypsv(3,4)
          yt1(1,2)=(0.d0,0.d0)
c
c         2. Strike-slip (M12=M21=1)
c
          if(ldeg.lt.2.or.lys.lt.lyob)then
            ys1(2,2)=(0.d0,0.d0)
            ys2(2,2)=(0.d0,0.d0)
            yt1(2,2)=(0.d0,0.d0)
          else
            ct2=dcmplx(disk(ldeg)
     &                /(dble(ldeg)*dble(ldeg+1)*rrup(lys)),0.d0)
            cs4=-ct2
            ys1(2,2)=cs4*ypsv(1,4)
            ys2(2,2)=cs4*ypsv(3,4)
            yt1(2,2)=ct2*ysh(1,2)
          endif
c
c         3. Dip-slip (M13=M31=1)
c
          if(ldeg.lt.1.or.lys.lt.lyob)then
            ys1(3,2)=(0.d0,0.d0)
            ys2(3,2)=(0.d0,0.d0)
            yt1(3,2)=(0.d0,0.d0)
          else
            ct1=dcmplx(disk(ldeg)/(dble(ldeg)*dble(ldeg+1)
     &                *roup(lys)*vsup(lys)**2),0.d0)
            cs3=ct1
            ys1(3,2)=cs3*ypsv(1,3)
            ys2(3,2)=cs3*ypsv(3,3)
            yt1(3,2)=ct1*ysh(1,1)
          endif
c
c         4. CLVD (M33=1,M11=M22=-0.5)
c
          if(lys.lt.lyob)then
            ys1(4,2)=(0.d0,0.d0)
            ys2(4,2)=(0.d0,0.d0)
          else
            cs1=dcmplx( disk(ldeg)/(roup(lys)*vpup(lys)**2),0.d0)
            cs2=dcmplx( disk(ldeg)*(3.d0-4.d0*(vsup(lys)/vpup(lys))**2)
     &                  /rrup(lys),0.d0)
            cs4=-(0.5d0,0.d0)*cs2
            ys1(4,2)=cs1*ypsv(1,1)+cs2*ypsv(1,2)+cs4*ypsv(1,4)
            ys2(4,2)=cs1*ypsv(3,1)+cs2*ypsv(3,2)+cs4*ypsv(3,4)
          endif
          yt1(4,2)=(0.d0,0.d0)
c
c         convert to (r,t,p,g)-system
c         ===========================
c
c         1. Explosion (M11=M22=M33=1)
c            yr normalized by Plm(l,0,cos(t))
c            yt normalized by Plm(l,1,cos(t)) = -dPlm/dt
c
          yr(ldeg,1,0)=ys1(1,2)
          yt(ldeg,1,0)=-ys2(1,2)
c
c         2. Strike-slip (M12=M21=1)
c            yr normalized by Plm(l,2,cos(t))*sin(2p)
c            yt normalized by Plm(l,2,cos(t))*sin(2p)/sin(t)
c            yp normalized by Plm(l,2,cos(t))*cos(2p)/sin(t)
c
          yr(ldeg,2,0)=ys1(2,2)
          if(ldeg.ge.3)then
            ca=dcmplx(dble(ldeg-2)*dble(ldeg-3)/dble(2*ldeg-3),0.d0)
            cb=dcmplx(dble(ldeg+1)*dble(ldeg+2)/dble(2*ldeg+1),0.d0)
            yt(ldeg-1,2,0)= ca*ys2(2,0)-cb*ys2(2,2)-(2.d0,0.d0)*yt1(2,1)
            yp(ldeg-1,2,0)=-ca*yt1(2,0)+cb*yt1(2,2)+(2.d0,0.d0)*ys2(2,1)
          endif
c
c         3. Dip-slip (M13=M31=1)
c            yr normalized by Plm(l,1,cos(t))*cos(p)
c            yt normalized by Plm(l,1,cos(t))*cos(p)/sin(t)
c            yp normalized by Plm(l,1,cos(t))*sin(p)/sin(t)
c
          yr(ldeg,3,0)=ys1(3,2)
          if(ldeg.ge.2)then
            ca=dcmplx(dble(ldeg-2)*dble(ldeg-2)/dble(2*ldeg-3),0.d0)
            cb=dcmplx(dble(ldeg+1)*dble(ldeg+1)/dble(2*ldeg+1),0.d0)
            yt(ldeg-1,3,0)= ca*ys2(3,0)-cb*ys2(3,2)+yt1(3,1)
            yp(ldeg-1,3,0)=-ca*yt1(3,0)+cb*yt1(3,2)-ys2(3,1)
          endif
c
c         4. CLVD (M33=1,M11=M22=-0.5)
c            yr normalized by Plm(l,0,cos(t))
c            yt normalized by Plm(l,0,cos(t)) = -dPlm/dt
c
          yr(ldeg,4,0)=ys1(4,2)
          yt(ldeg,4,0)=-ys2(4,2)
        enddo
c
        write(*,'(i6,a,f12.4,a,i5,a,2(f7.2,a))')lf,'.',1.0d+03*f,
     &       ' mHz: cut-off degree = ',ldegf,
     &       ', start depth = ',depst1,' - ',depst2,' km'
c
        write(21)ldegf
        write(22)ldegf
        write(23)ldegf
        write(21)((yr(ldeg,istp,0),ldeg=0,ldegf),istp=1,4)
        write(22)((yt(ldeg,istp,0),ldeg=0,ldegf),istp=1,4)
        write(23)((yp(ldeg,istp,0),ldeg=0,ldegf),istp=2,3)
      enddo
      close(21)
      close(22)
      close(23)
c
      if(ig.eq.iglast)then
        deallocate(ksmallpsv,ksmallsh,kp,ks,cps,cpt,
     &    mat2x2up,mat2x2lw,mat2x2inv,mas2x2up,mas2x2lw,mas2x2inv,
     &    mas4x4up,mas4x4lw,mas4x4inv,mas6x6up,mas6x6lw,mas6x6inv,
     &    disk,fdisk,lylwsh,lylwpsv,lyupatm,
     &    zjup,zjlw,zhup,zhlw,wj,wh,dplm1)
        if(.not.nogravity)then
          deallocate(zjupg,zjlwg,zhupg,zhlwg,wjg,whg)
        endif
      endif
c
      return
      end

      subroutine qpsmatc(ldeg,ly,lylw,lwup)
      use qpalloc
      implicit none
c
c     calculate 4x4 spheroidal layer matrix for a solid shell
c
      integer*4 ldeg,ly,lylw,lwup
c
      integer*4 i,j,key
      complex*16 cldeg,cllm1,cllp1,c2lp1,c2lm1,c2lp3,cxp2,acc
      complex*16 ph0jup,ph1jup,ph0yup,ph1yup
      complex*16 ph0jlw,ph1jlw,ph0ylw,ph1ylw
      complex*16 spb(2,2),mas(4,4)
      complex*16 spbphj,spbphy
c
      complex*16 ci,c1,c2,c3
      data ci,c1,c2,c3/(0.d0,1.d0),(1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      cllm1=cldeg*(cldeg-c1)
      cllp1=cldeg*(cldeg+c1)
      c2lp1=c2*cldeg+c1
      c2lm1=c2*cldeg-c1
      c2lp3=c2*cldeg+c3
      acc=cro(ly)*comi2
c
c     for upper radius
c
      cxp2=(kp(ly)*crrup(ly))**2
      if(ksmallpsv(ly))then
        ph0jup=spbphj(ldeg,kp(ly)*crrup(ly))
        ph1jup=spbphj(ldeg+1,kp(ly)*crrup(ly))
c
        ph0yup=spbphy(ldeg,kp(ly)*crrup(ly))
        ph1yup=spbphy(ldeg+1,kp(ly)*crrup(ly))
c
        mas4x4up(1,1,ly)=cldeg*ph0jup-cxp2*ph1jup/c2lp3
        mas4x4up(2,1,ly)=-acc*crrup(ly)**2*ph0jup
        mas4x4up(3,1,ly)=cga(ly)*ph0jup
        mas4x4up(4,1,ly)=cga(ly)*(cldeg+c1)*ph0jup
c
        mas4x4up(1,2,ly)=cldeg*ph0yup-ph1yup*c2lp1
        mas4x4up(2,2,ly)=-acc*crrup(ly)**2*ph0yup
        mas4x4up(3,2,ly)=cga(ly)*ph0yup
        mas4x4up(4,2,ly)=cga(ly)*(cldeg+c1)*ph0yup
      else
        spb(1,1)=c1-zjup(ldeg,ly,1)
        spb(2,1)=-ci*zjup(ldeg,ly,1)
        spb(1,2)=c1
        spb(2,2)=zhup(ldeg,ly,1)
        do j=1,2
          mas4x4up(1,j,ly)=cldeg*spb(1,j)-spb(2,j)
          mas4x4up(2,j,ly)=-acc*crrup(ly)**2*spb(1,j)
          mas4x4up(3,j,ly)=cga(ly)*spb(1,j)
          mas4x4up(4,j,ly)=cga(ly)*(cldeg+c1)*spb(1,j)
        enddo
      endif
c
      do j=3,4
        do i=1,2
          mas4x4up(i,j,ly)=(0.d0,0.d0)
        enddo
      enddo
      mas4x4up(3,3,ly)=c1
      mas4x4up(4,3,ly)=c2lp1
      mas4x4up(3,4,ly)=c1
      mas4x4up(4,4,ly)=(0.d0,0.d0)
c
      if(ly.eq.lylw)return
      if(dreal(comi).le.0.d0)then
        stop 'No static deformation within nongravitational liquid!'
      endif
c
c     for lower radius
c
      cxp2=(kp(ly)*crrlw(ly))**2
      if(ksmallpsv(ly))then
        ph0jlw=spbphj(ldeg,kp(ly)*crrlw(ly))
        ph1jlw=spbphj(ldeg+1,kp(ly)*crrlw(ly))
c
        ph0ylw=spbphy(ldeg,kp(ly)*crrlw(ly))
        ph1ylw=spbphy(ldeg+1,kp(ly)*crrlw(ly))
c
        mas4x4lw(1,1,ly)=cldeg*ph0jlw-cxp2*ph1jlw/c2lp3
        mas4x4lw(2,1,ly)=-acc*crrlw(ly)**2*ph0jlw
        mas4x4lw(3,1,ly)=cga(ly)*ph0jlw
        mas4x4lw(4,1,ly)=cga(ly)*(cldeg+c1)*ph0jlw
c
        mas4x4lw(1,2,ly)=cldeg*ph0ylw-ph1ylw*c2lp1
        mas4x4lw(2,2,ly)=-acc*crrlw(ly)**2*ph0ylw
        mas4x4lw(3,2,ly)=cga(ly)*ph0ylw
        mas4x4lw(4,2,ly)=cga(ly)*(cldeg+c1)*ph0ylw
      else
        spb(1,1)=c1-zjlw(ldeg,ly,1)
        spb(2,1)=-ci*zjlw(ldeg,ly,1)
        spb(1,2)=c1
        spb(2,2)=zhlw(ldeg,ly,1)
        do j=1,2
          mas4x4lw(1,j,ly)=cldeg*spb(1,j)-spb(2,j)
          mas4x4lw(2,j,ly)=-acc*crrlw(ly)**2*spb(1,j)
          mas4x4lw(3,j,ly)=cga(ly)*spb(1,j)
          mas4x4lw(4,j,ly)=cga(ly)*(cldeg+c1)*spb(1,j)
        enddo
      endif
c
      do j=3,4
        do i=1,4
          mas4x4lw(i,j,ly)=mas4x4up(i,j,ly)
        enddo
      enddo
c
      if(lwup.eq.0)then
c
c       calculate inverse matrix at upper radius
c
        do j=1,4
          do i=1,4
            mas(i,j)=mas4x4up(i,j,ly)
            mas4x4inv(i,j,ly)=(0.d0,0.d0)
          enddo
          mas4x4inv(j,j,ly)=c1
        enddo
      else
c
c       calculate inverse matrix at lower radius
c
        do j=1,4
          do i=1,4
            mas(i,j)=mas4x4lw(i,j,ly)
            mas4x4inv(i,j,ly)=(0.d0,0.d0)
          enddo
          mas4x4inv(j,j,ly)=c1
        enddo
      endif
      key=0
      call cdsvd(mas,mas4x4inv(1,1,ly),4,4,0.d0,key)
      if(key.eq.0)then
        print *,' Warning in qpsmatc: anormal exit from cdgemp!'
        return
      endif
c
      return
      end

      subroutine brunewvlet(tau,df,mm2,wvf)
      implicit none
      integer*4 mm2
      real*8 tau,df,fi
      complex*16 wvf(mm2)
c
      integer*4 l
      real*8 f
c
      real*8 pi2
      complex*16 c1
      data pi2/6.28318530717959d0/
      data c1/(1.d0,0.d0)/
c
c     for wavelet: Brune's source time function
c
      do l=1,mm2
        f=df*dble(l-1)
        wvf(l)=c1/dcmplx(1.d0,pi2*f*tau)**2
      enddo
      return
      end

      subroutine taper(ldeg,ldegmax,tap)
      implicit none
      integer*4 ldeg(4),ldegmax
      real*8 tap(0:ldegmax)
c
      integer*4 l
      real*8 fac
c
      real*8 PI
      data PI/3.14159265358979d0/
c
      do l=0,ldeg(1)-1
        tap(l)=0.d0
      enddo
      fac=0.5d0*PI/dble(1+ldeg(2)-ldeg(1))
      do l=ldeg(1),ldeg(2)-1
        tap(l)=dsin(fac*dble(l-ldeg(1)))**2
      enddo
      do l=ldeg(2),ldeg(3)
        tap(l)=1.d0
      enddo
      fac=0.5d0*PI/dble(1+ldeg(4)-ldeg(3))
      do l=ldeg(3)+1,ldeg(4)
        tap(l)=dcos(fac*dble(l-ldeg(3)))**2
      enddo
      do l=ldeg(4)+1,ldegmax
        tap(l)=0.d0
      enddo
c
      return
      end

      subroutine qpsmat0(ly,lylw,lwup)
      use qpalloc
      implicit none
c
c     calculate 3x3 spheroidal layer matrix for a solid shell in case of degree l = 0
c
      integer*4 ly,lylw,lwup
c
      integer*4 j
      complex*16 c2mu,cxi,cx,cx2,cdet
      complex*16 ph0jup,ph1jup,ph0yup,ph1yup,ps0jup,ps0yup
      complex*16 ph0jlw,ph1jlw,ph0ylw,ph1ylw,ps0jlw,ps0ylw
      complex*16 spb(2,2)
      complex*16 spbphj,spbphy,spbpsj
c
      complex*16 ci,c1,c2,c3,c6
      data ci,c1,c2,c3,c6/(0.d0,1.d0),(1.d0,0.d0),(2.d0,0.d0),
     &                    (3.d0,0.d0),(6.d0,0.d0)/
c
      c2mu=c2*cmu(ly)
      cxi=cla(ly)+c2mu
c
      cx=kp(ly)*crrup(ly)
      cx2=cx*cx
      if(ksmallp(ly))then
        ph0jup=spbphj(0,cx)
        ph1jup=spbphj(1,cx)
c
        ph0yup=spbphy(0,cx)
        ph1yup=spbphy(1,cx)
c
        mas3x3up(1,1,ly)=cx2*ph1jup/c3
        mas3x3up(2,1,ly)=cx2*(cxi*ph0jup-c2*c2mu*ph1jup/c3)
        mas3x3up(3,1,ly)=-cga(ly)*ph0jup
        mas3x3up(1,2,ly)=ph1yup
        mas3x3up(2,2,ly)=cxi*cx2*ph0yup-c2*c2mu*ph1yup
        mas3x3up(3,2,ly)=-cga(ly)*ph0yup
      else
        spb(1,1)=c1-zjup(0,ly,1)
        spb(2,1)=-ci*zjup(0,ly,1)
        spb(1,2)=c1
        spb(2,2)=zhup(0,ly,1)
c
        do j=1,2
          mas3x3up(1,j,ly)=spb(2,j)
          mas3x3up(2,j,ly)=cxi*cx2*spb(1,j)-c2*c2mu*spb(2,j)
          mas3x3up(3,j,ly)=-cga(ly)*spb(1,j)
        enddo
      endif
      mas3x3up(1,3,ly)=(0.d0,0.d0)
      mas3x3up(2,3,ly)=(0.d0,0.d0)
      mas3x3up(3,3,ly)=c1
c
      if(ly.eq.lylw.or.lwup.lt.0)return
c
      cx=kp(ly)*crrlw(ly)
      cx2=cx*cx
      if(ksmallp(ly))then
        ph0jlw=spbphj(0,cx)
        ph1jlw=spbphj(1,cx)
c
        ph0ylw=spbphy(0,cx)
        ph1ylw=spbphy(1,cx)
c
        mas3x3lw(1,1,ly)=cx2*ph1jlw/c3
        mas3x3lw(2,1,ly)=cx2*(cxi*ph0jlw-c2*c2mu*ph1jlw/c3)
        mas3x3lw(3,1,ly)=-cga(ly)*ph0jlw
        mas3x3lw(1,2,ly)=ph1ylw
        mas3x3lw(2,2,ly)=cxi*cx2*ph0ylw-c2*c2mu*ph1ylw
        mas3x3lw(3,2,ly)=-cga(ly)*ph0ylw
      else
        spb(1,1)=c1-zjlw(0,ly,1)
        spb(2,1)=-ci*zjlw(0,ly,1)
        spb(1,2)=c1
        spb(2,2)=zhlw(0,ly,1)
c
        do j=1,2
          mas3x3lw(1,j,ly)=spb(2,j)
          mas3x3lw(2,j,ly)=cxi*cx2*spb(1,j)-c2*c2mu*spb(2,j)
          mas3x3lw(3,j,ly)=-cga(ly)*spb(1,j)
        enddo
      endif
      mas3x3lw(1,3,ly)=(0.d0,0.d0)
      mas3x3lw(2,3,ly)=(0.d0,0.d0)
      mas3x3lw(3,3,ly)=c1
c
      if(lwup.eq.0)then
c
c       calculate inverse masrix at upper radius
c
        cdet=mas3x3up(1,1,ly)*mas3x3up(2,2,ly)
     &      -mas3x3up(1,2,ly)*mas3x3up(2,1,ly)
        mas3x3inv(1,1,ly)=mas3x3up(2,2,ly)/cdet
        mas3x3inv(1,2,ly)=-mas3x3up(1,2,ly)/cdet
        mas3x3inv(1,3,ly)=(0.d0,0.d0)
        mas3x3inv(2,1,ly)=-mas3x3up(2,1,ly)/cdet
        mas3x3inv(2,2,ly)=mas3x3up(1,1,ly)/cdet
        mas3x3inv(2,3,ly)=(0.d0,0.d0)
        mas3x3inv(3,1,ly)=(mas3x3up(2,1,ly)*mas3x3up(3,2,ly)
     &                   -mas3x3up(3,1,ly)*mas3x3up(2,2,ly))/cdet
        mas3x3inv(3,2,ly)=(mas3x3up(1,2,ly)*mas3x3up(3,1,ly)
     &                   -mas3x3up(1,1,ly)*mas3x3up(3,2,ly))/cdet
        mas3x3inv(3,3,ly)=c1
      else
c
c       calculate inverse masrix at lower radius
c
        cdet=mas3x3lw(1,1,ly)*mas3x3lw(2,2,ly)
     &      -mas3x3lw(1,2,ly)*mas3x3lw(2,1,ly)
        mas3x3inv(1,1,ly)=mas3x3lw(2,2,ly)/cdet
        mas3x3inv(1,2,ly)=-mas3x3lw(1,2,ly)/cdet
        mas3x3inv(1,3,ly)=(0.d0,0.d0)
        mas3x3inv(2,1,ly)=-mas3x3lw(2,1,ly)/cdet
        mas3x3inv(2,2,ly)=mas3x3lw(1,1,ly)/cdet
        mas3x3inv(2,3,ly)=(0.d0,0.d0)
        mas3x3inv(3,1,ly)=(mas3x3lw(2,1,ly)*mas3x3lw(3,2,ly)
     &                   -mas3x3lw(3,1,ly)*mas3x3lw(2,2,ly))/cdet
        mas3x3inv(3,2,ly)=(mas3x3lw(1,2,ly)*mas3x3lw(3,1,ly)
     &                   -mas3x3lw(1,1,ly)*mas3x3lw(3,2,ly))/cdet
        mas3x3inv(3,3,ly)=c1
      endif
c
      return
      end

      real*8 function bessj(n,x)
      implicit none
      integer*4 n
      real*8 x
c
      integer*4 iacc
      parameter(iacc=40)
      real*8 bigno,bigni
      parameter(bigno=1.d+10,bigni=1.d-10)
c
      integer*4 j,jsum,m
      real*8 ax,bj,bjm,bjp,sum,tox,bessj0,bessj1
      if(n.lt.2)pause 'bad argument n in bessj'
      ax=dabs(x)
      if(ax.eq.0.d0)then
        bessj=0.d0
      else if(ax.gt.dble(n))then
        tox=2.d0/ax
        bjm=bessj0(ax)
        bj=bessj1(ax)
        do 11 j=1,n-1
          bjp=dble(j)*tox*bj-bjm
          bjm=bj
          bj=bjp
11      continue
        bessj=bj
      else
        tox=2.d0/ax
        m=2*((n+idint(dsqrt(dble(iacc*n))))/2)
        bessj=0.d0
        jsum=0
        sum=0.d0
        bjp=0.d0
        bj=1.d0
        do 12 j=m,1,-1
          bjm=dble(j)*tox*bj-bjp
          bjp=bj
          bj=bjm
          if(dabs(bj).gt.bigno)then
            bj=bj*bigni
            bjp=bjp*bigni
            bessj=bessj*bigni
            sum=sum*bigni
          endif
          if(jsum.ne.0)sum=sum+bj
          jsum=1-jsum
          if(j.eq.n)bessj=bjp
12      continue
        sum=2.d0*sum-bj
        bessj=bessj/sum
      endif
      if(x.lt.0.d0.and.mod(n,2).eq.1)bessj=-bessj
      return
      end

      subroutine qppsvkerng(f,ldeg,ypsv)
      use qpalloc
      implicit none
c
c     calculation of response function in frequency-wavelength domain
c     ldeg: harmonic degree
c     ypsv(6,4): psv solution vector (complex) with gravity effect
c
      integer*4 ldeg
      real*8 f
      complex*16 ypsv(6,4)
c
      integer*4 i,istp,lyup,lylw
c
      do istp=1,4
        do i=1,6
          ypsv(i,istp)=(0.d0,0.d0)
        enddo
      enddo
      lyup=lyupatm(ldeg)
      lylw=lylwpsv(ldeg)
      if(lylw.lt.max0(lys,lyr))return
      comi=dcmplx(PI2*f,PI2*fi)
      comi2=comi*comi
c
      if(ldeg.eq.0)then
        call qpspropg0(ypsv,lyup,lylw)
      else if(ldeg.eq.1)then
        call qpspropg1(ypsv,lyup,lylw)
      else
        call qpspropg(ypsv,ldeg,lyup,lylw)
      endif
      return
      end

      subroutine qpstart0(ly,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c     for n = 0
c
      integer*4 ly
      complex*16 cy(2)
c
      complex*16 c2mu,cgrdr,kpg,cxup,spa,spb
      complex*16 spbphj
c
      complex*16 ci,c1,c2,c3
      data ci,c1,c2,c3/(0.d0,1.d0),(1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0)/
c
      c2mu=c2*cmu(ly)
      cgrdr=cgrup(ly)/crrup(ly)
c
      kpg=cdsqrt(comi2+cga(ly)+cgrdr)/cvp(ly)
      cxup=kpg*rrup(ly)
c
      if(cdabs(cxup).gt.0.1d0)then
        call spbjh(0,kpg,rrup(ly),rrlw(ly),
     &             zjupg(0),zjlwg(0),wjg(0),
     &             zhupg(0),zhlwg(0),whg(0))
c
        spa=c1-zjupg(0)
        spb=-ci*zjupg(0)
      else
        spa=spbphj(0,cxup)
        spb=spbphj(1,cxup)*cxup**2/c3
      endif
c
      cy(1)=spb
      cy(2)=(cla(ly)+c2mu)*cxup**2*spa+c2*c2mu*spb
      return
      end

      subroutine qpgrnspec(ig)
      use qpalloc
      implicit none
      integer*4 ig
c
      integer*4 i,nn,il,istp,ly,lf,ldeg,ldeg0,ldegf,ldegup,ierr
      real*8 f,ksp,xlw,xup,dll,omi,expo,rpath,slwcut
      real*8 fac,fl,depst1,depst2,dys2,rr0a,a,b,rrs,x
      real*8 kcut1(4),kcut2(4)
      complex*16 ca,cb,cag,cs1,cs2,cs3,cs4,ct1,ct2,cll1
      complex*16 cmur,ys3d,yt1d,cg1,cg5
      complex*16 ypsv(6,4),ypsvg(6,4),ysh(2,2)
      logical*2 forruku
c
      real*8 fsimpson
c
      real*8 expos
      complex*16 c2,c3,c4
      data expos/48.d0/
      data c2,c3,c4/(2.d0,0.d0),(3.d0,0.d0),(4.d0,0.d0)/
c
      if(ig.eq.igfirst)then
        allocate(disk(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: disk not allocated!'
c
        allocate(ksmallp(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ksmallp not allocated!'
        allocate(ksmalls(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ksmalls not allocated!'
        allocate(ksmallt(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ksmallt not allocated!'
        allocate(xp(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: xp not allocated!'
        allocate(xs(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: xs not allocated!'
        allocate(xt(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: xt not allocated!'
        allocate(kp(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: kp not allocated!'
        allocate(ks(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: ks not allocated!'
        allocate(kt(lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: kt not allocated!'
        allocate(cps(6,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: cps not allocated!'
        allocate(cpt(2,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: cpt not allocated!'
c
        allocate(mat2x2up(2,2,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mat2x2up not allocated!'
        allocate(mat2x2lw(2,2,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mat2x2lw not allocated!'
        allocate(mat2x2inv(2,2,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mat2x2inv not allocated!'
c
        allocate(mas3x3up(3,3,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas3x3up not allocated!'
        allocate(mas3x3lw(3,3,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas3x3lw not allocated!'
        allocate(mas3x3inv(3,3,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas3x3inv not allocated!'
c
        allocate(mas4x4up(4,4,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas4x4up not allocated!'
        allocate(mas4x4lw(4,4,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas4x4lw not allocated!'
        allocate(mas4x4inv(4,4,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas4x4inv not allocated!'
c
        allocate(mas6x6up(6,6,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas6x6up not allocated!'
        allocate(mas6x6lw(6,6,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas6x6lw not allocated!'
        allocate(mas6x6inv(6,6,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: mas6x6inv not allocated!'
c
        allocate(zjup(0:ldegmax,lymax,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zjup not allocated!'
        allocate(zjlw(0:ldegmax,lymax,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zjlw not allocated!'
        allocate(zhup(0:ldegmax,lymax,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zhup not allocated!'
        allocate(zhlw(0:ldegmax,lymax,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zhlw not allocated!'
        allocate(wj(0:ldegmax,lymax,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: wj not allocated!'
        allocate(wh(0:ldegmax,lymax,3),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: wh not allocated!'
        allocate(zh12p(0:ldegmax,2,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zh12p not allocated!'
        allocate(zh12sv(0:ldegmax,2,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zh12sv not allocated!'
        allocate(zh12sh(0:ldegmax,2,lymax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zh12sh not allocated!'
c
        allocate(zjupg(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zjupg not allocated!'
        allocate(zjlwg(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zjlwg not allocated!'
        allocate(zhupg(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zhupg not allocated!'
        allocate(zhlwg(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: zhlwg not allocated!'
        allocate(wjg(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: wjg not allocated!'
        allocate(whg(0:ldegmax),stat=ierr)
        if(ierr.ne.0)stop 'Error in qpgrnspec: whg not allocated!'
      endif
c
c     Initiation
c
      rrs=rrup(lys)
c
      if(rr0.gt.0.d0)then
        x=dcos(rr0/rrs)
        disk(0)=1.d0
        disk(1)=(3.d0+x)/4.d0
        do ldeg=2,ldegmax
          disk(ldeg)=(dble(2*ldeg-1)*x*disk(ldeg-1)
     &               +dble(4-ldeg)*disk(ldeg-2))
     &              /dble(ldeg+3)
        enddo
        do ldeg=0,ldegmax
          disk(ldeg)=disk(ldeg)*dble(2*ldeg+1)/(4.d0*PI*rrs**2)
        enddo
      else
        do ldeg=0,ldegmax
          disk(ldeg)=dble(2*ldeg+1)/(4.d0*PI*rrs**2)
        enddo
      endif
c
      open(21,file=uspecfile(ig),form='unformatted',status='unknown')
      open(22,file=vspecfile(ig),form='unformatted',status='unknown')
      open(23,file=wspecfile(ig),form='unformatted',status='unknown')
      open(24,file=especfile(ig),form='unformatted',status='unknown')
      open(25,file=fspecfile(ig),form='unformatted',status='unknown')
      open(26,file=gspecfile(ig),form='unformatted',status='unknown')
      open(27,file=pspecfile(ig),form='unformatted',status='unknown')
      open(28,file=qspecfile(ig),form='unformatted',status='unknown')
c
      ldeg0=10+ndmax
      if(vsup(lys).gt.0.d0)then
        slwcut=1.d0/vsup(lys)
      else
        slwcut=1.d0/vpup(lys)
      endif
      if(vsup(lyr).gt.0.d0)then
        slwcut=dmin1(slwcut,1.d0/vsup(lyr))
      else
        slwcut=dmin1(slwcut,1.d0/vpup(lyr))
      endif
      if(slwmax.ge.slwcut)then
        do ldeg0=10+ndmax,ldegmin
          dll=dsqrt(dble(ldeg0)*dabs(dble(ldeg0-1)))
          expo=0.d0
          do ly=min0(lys,lyr),max0(lys,lyr)-1
            expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
          enddo
          if(expo.gt.expos)goto 10
        enddo
10      continue
      endif
c
      lylwa=0
      if(ipatha.eq.1)then
        rpath=rratmos-minpath
        do ly=max0(lys,lyr),ly0
          if(rrup(ly).ge.rpath.and.rrlw(ly).lt.rpath)then
            lylwa=ly
            goto 20
          endif
        enddo
20      continue
      endif
c
      lylwb=ly0+1
      if(ipathb.eq.1)then
        rpath=rratmos-maxpath
        do ly=max0(lys,lyr,lylwa+1),ly0
          if(rrup(ly).ge.rpath.and.rrlw(ly).lt.rpath)then
            lylwb=ly
            goto 30
          endif
        enddo
30      continue
      endif
c
      omi=PI2*dble(nfcut-1)*df
      slwcut=slwmax
c
      if(lylwa.gt.lys+1)then
        fac=(1.d0+0.5d0*(rrup(lylwa)/rearth)**2)*rrup(lylwa)/rearth
        if(vsup(lylwa).gt.0.d0)then
          slwcut=dmin1(slwcut,fac/vsup(lylwa))
        else
          slwcut=dmin1(slwcut,fac/vpup(lylwa))
        endif
      endif
c
      ldegup=min0(ldegcut,max0(ldeg0,idint(rearth*omi*slwcut)))
c
      if(fgr.gt.0.d0.or.ldeggr.gt.0)then
        do ly=1,ly0
          do ldeg=0,ldegup
            nruku(ldeg,ly)=10
          enddo
        enddo
      endif
c
      write(*,*)' '
      write(*,'(a,i3,a,f7.2,a)')' ... calculate Green functions for ',
     &        ig,'. source at depth ',(grndep(ig)-depatmos)/KM2M,' km'
	write(*,'(a,i5)')'   max. harmonic degree: L_max = ',ldegup
c
      write(21)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(22)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(23)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(24)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(25)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(26)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(27)nt,ntcut,dt,nf,nfcut,df,ldegup
      write(28)nt,ntcut,dt,nf,nfcut,df,ldegup
c
      if(.not.nogravity)then
        do ly=1,ly0
          do ldeg=0,ldegup
            nruku(ldeg,ly)=0
          enddo
        enddo
      endif
c
      do istp=1,6
        do ldeg=0,ldegmax
          ul0(ldeg,istp)=(0.d0,0.d0)
          vl0(ldeg,istp)=(0.d0,0.d0)
          wl0(ldeg,istp)=(0.d0,0.d0)
          el0(ldeg,istp)=(0.d0,0.d0)
          fl0(ldeg,istp)=(0.d0,0.d0)
          gl0(ldeg,istp)=(0.d0,0.d0)
          pl0(ldeg,istp)=(0.d0,0.d0)
          ql0(ldeg,istp)=(0.d0,0.d0)
        enddo
      enddo
c
      do lf=1,nfcut
        f=dble(lf-1)*df
        omi=PI2*f
        comi=dcmplx(PI2*f,PI2*fi)
        comi2=comi*comi
        call qpqmodel(f)
c
        do ly=1,ly0
          kp(ly)=comi/cvp(ly)
          if(vsup(ly).gt.0.d0)then
            ks(ly)=comi/cvs(ly)
            kt(ly)=comi/cvs(ly)
          else
            ks(ly)=(0.d0,0.d0)
            kt(ly)=(0.d0,0.d0)
          endif
          if(rrlw(ly).gt.0.d0)then
            xp(ly)=cdabs(kp(ly))*rrlw(ly)
            xs(ly)=cdabs(ks(ly))*rrlw(ly)
            xt(ly)=cdabs(kt(ly))*rrlw(ly)
          else
            xp(ly)=cdabs(kp(ly))*rrup(ly)
            xs(ly)=cdabs(ks(ly))*rrup(ly)
            xt(ly)=cdabs(kt(ly))*rrup(ly)
          endif
          ksmallp(ly)=.true.
          ksmalls(ly)=.true.
          ksmallt(ly)=.true.
        enddo
c
        ldegf=min0(ldegup,ldeg0+idint(dble(ldegup-ldeg0)*f/fcut))
        setzh12a=.false.
        setzh12t=.false.
c
        do ldeg=0,ldegf
          if(nogravity.or.lylwa.gt.0.or.lylwb.le.ly0.or.
     &      .not.freesurf)then
            forruku=.false.
          else
            fac=dsqrt((f/fgr)**2+(dble(ldeg)/dble(ldeggr))**2)
            forruku=fac.lt.1.d0+FLTAPER
          endif
          dll=dsqrt(dble(ldeg)*dabs(dble(ldeg-1)))
c
c         determine degree dependent starting layer number
c         of sh solution
c
          lyupt(ldeg)=ly0+1
          lylwt(ldeg)=0
          if(lys.ge.lyob.and.lys.le.min0(lycm-1,ly0).and.
     &       lyr.ge.lyob.and.lyr.le.min0(lycm-1,ly0))then
            lyupt(ldeg)=lyob
            expo=0.d0
            do ly=min0(lys,lyr)-1,lyob,-1
              ksp=omi/vsup(ly)
              if(ksp.le.0.d0)then
                expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
              else if(dll.gt.ksp*rrlw(ly))then
                xlw=ksp*rrlw(ly)
                xup=dmin1(dll,ksp*rrup(ly))
                expo=expo+fsimpson(xlw,xup,dll)
              endif
              if(expo.gt.expos)then
                lyupt(ldeg)=ly+1
                goto 101
              endif
            enddo
101         continue
c
            lylwt(ldeg)=min0(lycm,ly0)
            expo=0.d0
            do ly=max0(lys,lyr)+1,min0(lycm,ly0)-1
              ksp=omi/vsup(ly)
              if(ksp.le.0.d0)then
                expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
              else if(dll.gt.ksp*rrlw(ly))then
                xlw=ksp*rrlw(ly)
                xup=dmin1(dll,ksp*rrup(ly))
                expo=expo+fsimpson(xlw,xup,dll)
              endif
              if(expo.gt.expos)then
                lylwt(ldeg)=ly
                goto 102
              endif
            enddo
102         continue
          endif
c
          if(lys.ge.lycc.and.lyr.ge.lycc)then
            lyupt(ldeg)=lycc
            expo=0.d0
            do ly=min0(lys,lyr)-1,lycc,-1
              ksp=omi/vsup(ly)
              if(ksp.le.0.d0)then
                expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
              else if(dll.gt.ksp*rrlw(ly))then
                xlw=ksp*rrlw(ly)
                xup=dmin1(dll,ksp*rrup(ly))
                expo=expo+fsimpson(xlw,xup,dll)
              endif
              if(expo.gt.expos)then
                lyupt(ldeg)=ly+1
                goto 103
              endif
            enddo
103         continue
c
            lylwt(ldeg)=ly0
            expo=0.d0
            do ly=max0(lys,lyr)+1,ly0-1
              ksp=omi/vsup(ly)
              if(ksp.le.0.d0)then
                expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
              else if(dll.gt.ksp*rrlw(ly))then
                xlw=ksp*rrlw(ly)
                xup=dmin1(dll,ksp*rrup(ly))
                expo=expo+fsimpson(xlw,xup,dll)
              endif
              if(expo.gt.expos)then
                lylwt(ldeg)=ly
                goto 104
              endif
            enddo
104         continue
          endif
c
c         determine degree dependent starting layer number
c         of psv solution
c
          lyupp(ldeg)=1
          expo=0.d0
          do ly=min0(lys,lyr)-1,1,-1
            if(vsup(ly).gt.0.d0)then
              ksp=omi/vsup(ly)
            else
              ksp=omi/vpup(ly)
            endif
            if(ksp.le.0.d0)then
              expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
            else if(dll.gt.ksp*rrlw(ly))then
              xlw=ksp*rrlw(ly)
              xup=dmin1(dll,ksp*rrup(ly))
              expo=expo+fsimpson(xlw,xup,dll)
            endif
            if(expo.gt.expos)then
              lyupp(ldeg)=ly
              goto 201
            endif
          enddo
201       continue
c
          lylwp(ldeg)=ly0
          expo=0.d0
          do ly=max0(lys,lyr)+1,ly0-1
            if(vsup(ly).gt.0.d0)then
              ksp=omi/vsup(ly)
            else
              ksp=omi/vpup(ly)
            endif
            if(ksp.le.0.d0)then
              expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
            else if(dll.gt.ksp*rrlw(ly))then
              xlw=ksp*rrlw(ly)
              xup=dmin1(dll,ksp*rrup(ly))
              expo=expo+fsimpson(xlw,xup,dll)
            endif
            if(expo.gt.expos)then
              lylwp(ldeg)=ly+1
              goto 202
            endif
          enddo
202       continue
c
          lyups(ldeg)=lyob
          expo=0.d0
          do ly=min0(lys,lyr)-1,lyob,-1
            if(vsup(ly).gt.0.d0)then
              ksp=omi/vsup(ly)
            else
              ksp=omi/vpup(ly)
            endif
            if(ksp.le.0.d0)then
              expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
            else if(dll.gt.ksp*rrlw(ly))then
              xlw=ksp*rrlw(ly)
              xup=dmin1(dll,ksp*rrup(ly))
              expo=expo+fsimpson(xlw,xup,dll)
            endif
            if(expo.gt.expos)then
              lyups(ldeg)=ly
              goto 301
            endif
          enddo
301       continue
c
          lylws(ldeg)=ly0
          expo=0.d0
          do ly=max0(lys,lyr)+1,ly0-1
            if(vsup(ly).gt.0.d0)then
              ksp=omi/vsup(ly)
            else
              ksp=omi/vpup(ly)
            endif
            if(ksp.le.0.d0)then
              expo=expo+dll*dlog(rrup(ly)/rrlw(ly))
            else if(dll.gt.ksp*rrlw(ly))then
              xlw=ksp*rrlw(ly)
              xup=dmin1(dll,ksp*rrup(ly))
              expo=expo+fsimpson(xlw,xup,dll)
            endif
            if(expo.gt.expos)then
              lylws(ldeg)=ly+1
              goto 302
            endif
          enddo
302       continue
        enddo
c
        if(selpsv.or.lys.lt.lyob.or.lys.ge.lycm.and.lys.lt.lycc)then
          ly=max0(lylwa,min0(lylwb,lylwp(0),lylws(0)))
          depst1=(rratmos-depatmos-rrup(ly))/KM2M
          ly=max0(lylwa,min0(lylwb,lylwp(ldegf),lylws(ldegf)))
          depst2=(rratmos-depatmos-rrup(ly))/KM2M
        else
          ly=max0(lylwa,min0(lylwb,lylwt(1)))
          depst1=(rratmos-depatmos-rrup(ly))/KM2M
          ly=max0(lylwa,min0(lylwb,lylwt(ldegf)))
          depst2=(rratmos-depatmos-rrup(ly))/KM2M
        endif
c
c       determine layer dependent max. harmonic degree
c       of sh solution
c
        if(lys.ge.lyob.and.lys.le.min0(lycm-1,ly0))then
          do ly=lyob,min0(lycm-1,ly0)
            ldegsh(ly)=1
            do ldeg=1,ldegf
              if(ly.ge.lyupt(ldeg).and.ly.le.lylwt(ldeg))then
                ldegsh(ly)=ldeg
              endif
            enddo
          enddo
        else if(lys.ge.lycc)then
          do ly=lycc,ly0
            ldegsh(ly)=1
            do ldeg=1,ldegf
              if(ly.ge.lyupt(ldeg).and.ly.le.lylwt(ldeg))then
                ldegsh(ly)=ldeg
              endif
            enddo
          enddo
        endif
c
c       determine layer dependent max. harmonic degree
c       of psv solution
c
        do ly=1,ly0
          ldegpsv(ly)=0
          do ldeg=0,ldegf
            if(ly.ge.min0(lyupp(ldeg),lyups(ldeg)).and.
     &         ly.le.max0(lylwp(ldeg),lylws(ldeg)))then
              ldegpsv(ly)=ldeg
            endif
          enddo
        enddo
c
        if(lylwa.gt.0)then
          ldegf=min0(ldegf,max0(ldegsh(lylwa),ldegpsv(lylwa)))
        endif
c
        do ldeg=0,ldegf
c
          if(.not.selpsv.or.ldeg.gt.ldegcut.or.
     &       max0(lylwp(ldeg),lylws(ldeg)).lt.max0(lylwa,lyr,lys).or.
     &       min0(lyupp(ldeg),lyups(ldeg)).gt.min0(lyr,lys))then
            do istp=1,4
              do i=1,6
                ypsv(i,istp)=(0.d0,0.d0)
              enddo
            enddo
          else if(nogravity)then
            call qppsvkern(f,ldeg,ypsv)
          else
            fac=dsqrt((f/fgr)**2+(dble(ldeg)/dble(ldeggr))**2)
            if(fac.le.1.d0)then
              call qppsvkerng(f,ldeg,ypsv)
            else if(fac.ge.1.d0+FLTAPER)then
              call qppsvkern(f,ldeg,ypsv)
            else
              call qppsvkerng(f,ldeg,ypsvg)
              call qppsvkern(f,ldeg,ypsv)
              ca=dcmplx(dsin(0.5d0*PI*(fac-1.d0)/FLTAPER)**2,0.d0)
              cb=(1.d0,0.d0)-ca
              do istp=1,4
                do i=1,6
                  ypsv(i,istp)=ca*ypsv(i,istp)+cb*ypsvg(i,istp)
                enddo
              enddo
            endif
          endif
c
          if(.not.selsh.or.ldeg.gt.ldegcut.or.ldeg.eq.0.or.
     &       lys.lt.lyob.or.lys.ge.lycm.and.lys.lt.lycc.or.
     &       lylwt(ldeg).lt.max0(lylwa,lyr,lys).or.
     &       lyupt(ldeg).gt.min0(lyr,lys))then
            do istp=1,2
              do i=1,2
                ysh(i,istp)=(0.d0,0.d0)
              enddo
            enddo
          else
            call qpshkern(f,ldeg,ysh)
          endif
c
          if(lyr.gt.1)then
            cg1=cgalw(lyr-1)
          else
            cg1=(0.d0,0.d0)
          endif
          cg5=dcmplx(dble(ldeg+1)/rrup(lyr),0.d0)
c
c         1. Vertical single force (F3=1)
c
          if(lys.lt.lyob)then
            ul0(ldeg,1)=(0.d0,0.d0)
            vl0(ldeg,1)=(0.d0,0.d0)
            wl0(ldeg,1)=(0.d0,0.d0)
            el0(ldeg,1)=(0.d0,0.d0)
            fl0(ldeg,1)=(0.d0,0.d0)
            gl0(ldeg,1)=(0.d0,0.d0)
            pl0(ldeg,1)=(0.d0,0.d0)
            ql0(ldeg,1)=(0.d0,0.d0)
          else
            cs2=dcmplx(-disk(ldeg),0.d0)
            ul0(ldeg,1)=cs2*ypsv(1,2)
            vl0(ldeg,1)=cs2*ypsv(3,2)
            wl0(ldeg,1)=(0.d0,0.d0)
            el0(ldeg,1)=cs2*ypsv(2,2)
            fl0(ldeg,1)=cs2*ypsv(4,2)
            gl0(ldeg,1)=(0.d0,0.d0)
            pl0(ldeg,1)=cs2*ypsv(5,2)
            ql0(ldeg,1)=cs2*(cg1*ypsv(1,2)-cg5*ypsv(5,2)+ypsv(6,2))
          endif
c
c         2. Explosion (M11=M22=M33=1)
c
          cs1=dcmplx( disk(ldeg)/roup(lys),0.d0)/cvpup(lys)**2
          cs2=dcmplx(-disk(ldeg)*4.d0/rrup(lys),0.d0)
     &       *(cvsup(lys)/cvpup(lys))**2
          cs4=dcmplx( disk(ldeg)*2.d0/rrup(lys),0.d0)
     &       *(cvsup(lys)/cvpup(lys))**2
          ul0(ldeg,2)=cs1*ypsv(1,1)+cs2*ypsv(1,2)+cs4*ypsv(1,4)
          vl0(ldeg,2)=cs1*ypsv(3,1)+cs2*ypsv(3,2)+cs4*ypsv(3,4)
          wl0(ldeg,2)=(0.d0,0.d0)
          el0(ldeg,2)=cs1*ypsv(2,1)+cs2*ypsv(2,2)+cs4*ypsv(2,4)
          fl0(ldeg,2)=cs1*ypsv(4,1)+cs2*ypsv(4,2)+cs4*ypsv(4,4)
          gl0(ldeg,2)=(0.d0,0.d0)
          pl0(ldeg,2)=cs1*ypsv(5,1)+cs2*ypsv(5,2)+cs4*ypsv(5,4)
          ql0(ldeg,2)=cs1*(cg1*ypsv(1,1)-cg5*ypsv(5,1)+ypsv(6,1))
     &               +cs2*(cg1*ypsv(1,2)-cg5*ypsv(5,2)+ypsv(6,2))
     &               +cs4*(cg1*ypsv(1,4)-cg5*ypsv(5,4)+ypsv(6,4))
c
c         3. CLVD (M33=1,M11=M22=-0.5)
c
          if(lys.lt.lyob)then
            ul0(ldeg,3)=(0.d0,0.d0)
            vl0(ldeg,3)=(0.d0,0.d0)
            wl0(ldeg,3)=(0.d0,0.d0)
            el0(ldeg,3)=(0.d0,0.d0)
            fl0(ldeg,3)=(0.d0,0.d0)
            gl0(ldeg,3)=(0.d0,0.d0)
            pl0(ldeg,3)=(0.d0,0.d0)
            ql0(ldeg,3)=(0.d0,0.d0)
          else
            cs1=dcmplx( disk(ldeg)/roup(lys),0.d0)/cvpup(lys)**2
            cs2=dcmplx( disk(ldeg)/rrup(lys),0.d0)
     &         *((3.d0,0.d0)-(4.d0,0.d0)*(cvsup(lys)/cvpup(lys))**2)
            cs4=-(0.5d0,0.d0)*cs2
            ul0(ldeg,3)=cs1*ypsv(1,1)+cs2*ypsv(1,2)+cs4*ypsv(1,4)
            vl0(ldeg,3)=cs1*ypsv(3,1)+cs2*ypsv(3,2)+cs4*ypsv(3,4)
            wl0(ldeg,3)=(0.d0,0.d0)
            el0(ldeg,3)=cs1*ypsv(2,1)+cs2*ypsv(2,2)+cs4*ypsv(2,4)
            fl0(ldeg,3)=cs1*ypsv(4,1)+cs2*ypsv(4,2)+cs4*ypsv(4,4)
            gl0(ldeg,3)=(0.d0,0.d0)
            pl0(ldeg,3)=cs1*ypsv(5,1)+cs2*ypsv(5,2)+cs4*ypsv(5,4)
            ql0(ldeg,3)=cs1*(cg1*ypsv(1,1)-cg5*ypsv(5,1)+ypsv(6,1))
     &                 +cs2*(cg1*ypsv(1,2)-cg5*ypsv(5,2)+ypsv(6,2))
     &                 +cs4*(cg1*ypsv(1,4)-cg5*ypsv(5,4)+ypsv(6,4))
          endif
c
c         4. Horizontal single force (F1=1)
c
          if(ldeg.lt.1.or.lys.lt.lyob)then
            ul0(ldeg,4)=(0.d0,0.d0)
            vl0(ldeg,4)=(0.d0,0.d0)
            wl0(ldeg,4)=(0.d0,0.d0)
            el0(ldeg,4)=(0.d0,0.d0)
            fl0(ldeg,4)=(0.d0,0.d0)
            gl0(ldeg,4)=(0.d0,0.d0)
            pl0(ldeg,4)=(0.d0,0.d0)
            ql0(ldeg,4)=(0.d0,0.d0)
          else
            cs4=dcmplx(-disk(ldeg)/(dble(ldeg)*dble(ldeg+1)),0.d0)
            ct2=cs4
            ul0(ldeg,4)=cs4*ypsv(1,4)
            vl0(ldeg,4)=cs4*ypsv(3,4)
            wl0(ldeg,4)=ct2*ysh(1,2)
            el0(ldeg,4)=cs4*ypsv(2,4)
            fl0(ldeg,4)=cs4*ypsv(4,4)
            gl0(ldeg,4)=ct2*ysh(2,2)
            pl0(ldeg,4)=cs4*ypsv(5,4)
            ql0(ldeg,4)=cs4*(cg1*ypsv(1,4)-cg5*ypsv(5,4)+ypsv(6,4))
          endif
c
c         5. Dip-slip (M13=M31=1)
c
          if(ldeg.lt.1.or.lys.lt.lyob)then
            ul0(ldeg,5)=(0.d0,0.d0)
            vl0(ldeg,5)=(0.d0,0.d0)
            wl0(ldeg,5)=(0.d0,0.d0)
            el0(ldeg,5)=(0.d0,0.d0)
            fl0(ldeg,5)=(0.d0,0.d0)
            gl0(ldeg,5)=(0.d0,0.d0)
            pl0(ldeg,5)=(0.d0,0.d0)
            ql0(ldeg,5)=(0.d0,0.d0)
          else
            ct1=dcmplx(disk(ldeg)/(dble(ldeg)*dble(ldeg+1)
     &          *roup(lys)),0.d0)/cvsup(lys)**2
            cs3=ct1
            ul0(ldeg,5)=cs3*ypsv(1,3)
            vl0(ldeg,5)=cs3*ypsv(3,3)
            wl0(ldeg,5)=ct1*ysh(1,1)
            el0(ldeg,5)=cs3*ypsv(2,3)
            fl0(ldeg,5)=cs3*ypsv(4,3)
            gl0(ldeg,5)=ct1*ysh(2,1)
            pl0(ldeg,5)=cs3*ypsv(5,3)
            ql0(ldeg,5)=cs3*(cg1*ypsv(1,3)-cg5*ypsv(5,3)+ypsv(6,3))
          endif
c
c         6. Strike-slip (M12=M21=1)
c
          if(ldeg.lt.2.or.lys.lt.lyob)then
            ul0(ldeg,6)=(0.d0,0.d0)
            vl0(ldeg,6)=(0.d0,0.d0)
            wl0(ldeg,6)=(0.d0,0.d0)
            el0(ldeg,6)=(0.d0,0.d0)
            fl0(ldeg,6)=(0.d0,0.d0)
            gl0(ldeg,6)=(0.d0,0.d0)
            pl0(ldeg,6)=(0.d0,0.d0)
            ql0(ldeg,6)=(0.d0,0.d0)
          else
            ct2=dcmplx(disk(ldeg)
     &                /(dble(ldeg)*dble(ldeg+1)*rrup(lys)),0.d0)
            cs4=-ct2
            ul0(ldeg,6)=cs4*ypsv(1,4)
            vl0(ldeg,6)=cs4*ypsv(3,4)
            wl0(ldeg,6)=ct2*ysh(1,2)
            el0(ldeg,6)=cs4*ypsv(2,4)
            fl0(ldeg,6)=cs4*ypsv(4,4)
            gl0(ldeg,6)=ct2*ysh(2,2)
            pl0(ldeg,6)=cs4*ypsv(5,4)
            ql0(ldeg,6)=cs4*(cg1*ypsv(1,4)-cg5*ypsv(5,4)+ypsv(6,4))
          endif
        enddo
c
        write(*,'(i6,a,f12.4,a,i5,a,2(f7.2,a))')lf,'.',1.0d+03*f,
     &       ' mHz: cut-off degree = ',ldegf,
     &       ', start depth = ',depst1,' - ',depst2,' km'
c
        write(21)ldegf
        write(22)ldegf
        write(23)ldegf
        write(24)ldegf
        write(25)ldegf
        write(26)ldegf
        write(27)ldegf
        write(28)ldegf
        write(21)((ul0(ldeg,istp),ldeg=0,ldegf),istp=1,6)               ! Ypsv1
        write(22)((vl0(ldeg,istp),ldeg=0,ldegf),istp=1,6)               ! Ypsv3
        write(23)((wl0(ldeg,istp),ldeg=0,ldegf),istp=4,6)               ! Ysh1 (or Y7)
        write(24)((el0(ldeg,istp),ldeg=0,ldegf),istp=1,6)               ! Ypsv2
        write(25)((fl0(ldeg,istp),ldeg=0,ldegf),istp=1,6)               ! Ypsv4
        write(26)((gl0(ldeg,istp),ldeg=0,ldegf),istp=4,6)               ! Ysh2 (or Y8)
        write(27)((pl0(ldeg,istp),ldeg=0,ldegf),istp=1,6)               ! Ypsv5
        write(28)((ql0(ldeg,istp),ldeg=0,ldegf),istp=1,6)               ! dYpsv5/dr
      enddo
      close(21)
      close(22)
      close(23)
      close(24)
      close(25)
      close(26)
      close(27)
      close(28)
c
      if(ig.eq.iglast)then
        deallocate(disk)
        deallocate(xp,xs,xt,kp,ks,kt,cps,cpt)
        deallocate(mat2x2up,mat2x2lw,mat2x2inv,
     &             mas3x3up,mas3x3lw,mas3x3inv,
     &             mas4x4up,mas4x4lw,mas4x4inv,
     &             mas6x6up,mas6x6lw,mas6x6inv)
        deallocate(zjup,zjlw,zhup,zhlw,wj,wh,
     &             zh12p,zh12sv,zh12sh,
     &             zjupg,zjlwg,zhupg,zhlwg,wjg,whg)
      endif
      return
      end

      subroutine qswavelet(wvf,mm2)
      implicit none
      integer*4 mm2
      complex*16 wvf(mm2)
c
      include 'qsglobal.h'
c
      integer*4 l,n
      real*8 f,omi,x,dt0
      complex*16 alfa,beta,gamma,eta
c
      real*8 pi,pi2,eps
      data pi,pi2,eps/3.14159265358979d0,6.28318530717959d0,1.0d-04/
c
      if(wdeg.ne.0)then
c
c       for wavelet: normalized square half-sinus
c
        do l=1,mm2
          f=df*dble(l-1)
          x=f*tau
          if(x.eq.0.d0)then
            wvf(l)=(1.d0,0.d0)
          else if(x.ge.1.d0-eps.and.x.le.1.d0+eps)then
            wvf(l)=dcmplx(-1.d0/x/(1+x),0.d0)
          else
            wvf(l)=dcmplx(0.d0,1.d0/(pi2*x*(1.d0+x)*(1.d0-x)))
     &               *(cdexp(dcmplx(0.d0,-pi2*x))-(1.d0,0.d0))
          endif
        enddo
      else
c
c       user's own wavelet function
c
        dt0=tau/dble(nn0-1)
c
        wvf(1)=dcmplx(0.5d0*(wv0(1)+wv0(nn0)),0.d0)
        do n=2,nn0-1
          wvf(1)=wvf(1)+dcmplx(wv0(n),0.d0)
        enddo
        wvf(1)=wvf(1)*dcmplx(dt0,0.d0)
c
        do l=2,mm2
          wvf(l)=(0.d0,0.d0)
          omi=2.d0*pi*df*dble(l-1)
          alfa=cdexp(dcmplx(0.d0,-omi*dt0))
          beta=(alfa-(1.d0,0.d0))*dcmplx(0.d0,1.d0/omi)
          gamma=alfa*dcmplx(0.d0,1.d0/omi)
     &           -beta*dcmplx(0.d0,1.d0/omi/dt0)
          eta=(1.d0,0.d0)
          do n=1,nn0-1
            wvf(l)=wvf(l)+eta*(dcmplx(wv0(n),0.d0)*(beta-gamma)
     &            +dcmplx(wv0(n+1),0.d0)*gamma)
            eta=eta*alfa
          enddo
        enddo
      endif
      if(iexist.ne.1)iexist=1
      return
      end

      subroutine qptmat(ldeg,ly,lwup)
      use qpalloc
      implicit none
c
      integer*4 ldeg,ly,lwup
c
      complex*16 cldeg,clm1,cdet,cx2,c2lp1,c2lp3
      complex*16 ph0jup,ph1jup,ph0yup,ph1yup
      complex*16 ph0jlw,ph1jlw,ph0ylw,ph1ylw
      complex*16 spb(2,2)
      complex*16 spbphj,spbphy
c
      integer*4 i,j
      complex*16 ci,c1,c2,c3
      data ci,c1,c2,c3/(0.d0,1.d0),(1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      clm1=dcmplx(dble(ldeg-1),0.d0)
      c2lp1=c2*cldeg+c1
      c2lp3=c2*cldeg+c3
c
      if(ksmallsh(ly))then
        ph0jup=spbphj(ldeg,kt(ly)*crrup(ly))
        ph1jup=spbphj(ldeg+1,kt(ly)*crrup(ly))
c
        ph0yup=spbphy(ldeg,kt(ly)*crrup(ly))
        ph1yup=spbphy(ldeg+1,kt(ly)*crrup(ly))
c
        cx2=(kt(ly)*crrup(ly))**2
        mat2x2up(1,1,ly)=crrup(ly)*ph0jup
        mat2x2up(2,1,ly)=crrup(ly)*cmu(ly)*(clm1*ph0jup
     &                  -cx2*ph1jup/c2lp3)
        mat2x2up(1,2,ly)=crrup(ly)*ph0yup
        mat2x2up(2,2,ly)=crrup(ly)*cmu(ly)*(clm1*ph0yup
     &                  -ph1yup*c2lp1)
      else
        spb(1,1)=c1-zjup(ldeg,ly,3)
        spb(2,1)=-ci*zjup(ldeg,ly,3)
        spb(1,2)=c1
        spb(2,2)=zhup(ldeg,ly,3)
c
        do j=1,2
          mat2x2up(1,j,ly)=crrup(ly)*spb(1,j)
          mat2x2up(2,j,ly)=crrup(ly)*cmu(ly)*(clm1*spb(1,j)-spb(2,j))
        enddo
      endif
c
      if(ly.eq.lylwsh(ldeg))return
c
      if(ksmallsh(ly))then
        ph0jlw=spbphj(ldeg,kt(ly)*crrlw(ly))
        ph1jlw=spbphj(ldeg+1,kt(ly)*crrlw(ly))
c
        ph0ylw=spbphy(ldeg,kt(ly)*crrlw(ly))
        ph1ylw=spbphy(ldeg+1,kt(ly)*crrlw(ly))
c
        cx2=(kt(ly)*crrlw(ly))**2
        mat2x2lw(1,1,ly)=crrlw(ly)*ph0jlw
        mat2x2lw(2,1,ly)=crrlw(ly)*cmu(ly)*(clm1*ph0jlw
     &                  -cx2*ph1jlw/c2lp3)
        mat2x2lw(1,2,ly)=crrlw(ly)*ph0ylw
        mat2x2lw(2,2,ly)=crrlw(ly)*cmu(ly)*(clm1*ph0ylw
     &                  -ph1ylw*c2lp1)
      else
        spb(1,1)=c1-zjlw(ldeg,ly,3)
        spb(2,1)=-ci*zjlw(ldeg,ly,3)
        spb(1,2)=c1
        spb(2,2)=zhlw(ldeg,ly,3)
c
        do j=1,2
          mat2x2lw(1,j,ly)=crrlw(ly)*spb(1,j)
          mat2x2lw(2,j,ly)=crrlw(ly)*cmu(ly)*(clm1*spb(1,j)-spb(2,j))
        enddo
      endif
c
      if(lwup.eq.0)then
c
c       calculate inverse matrix at upper radius
c
        cdet=mat2x2up(1,1,ly)*mat2x2up(2,2,ly)
     &      -mat2x2up(1,2,ly)*mat2x2up(2,1,ly)
        mat2x2inv(1,1,ly)=mat2x2up(2,2,ly)/cdet
        mat2x2inv(1,2,ly)=-mat2x2up(1,2,ly)/cdet
        mat2x2inv(2,1,ly)=-mat2x2up(2,1,ly)/cdet
        mat2x2inv(2,2,ly)=mat2x2up(1,1,ly)/cdet
      else
c
c       calculate inverse matrix at lower radius
c
        cdet=mat2x2lw(1,1,ly)*mat2x2lw(2,2,ly)
     &      -mat2x2lw(1,2,ly)*mat2x2lw(2,1,ly)
        mat2x2inv(1,1,ly)=mat2x2lw(2,2,ly)/cdet
        mat2x2inv(1,2,ly)=-mat2x2lw(1,2,ly)/cdet
        mat2x2inv(2,1,ly)=-mat2x2lw(2,1,ly)/cdet
        mat2x2inv(2,2,ly)=mat2x2lw(1,1,ly)/cdet
      endif
c
      return
      end

      subroutine qpstart4a(ldeg,ly,jh,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c
      integer*4 ldeg,ly,jh
      complex*16 cy(4,2)
c
      integer*4 i
      real*8 peps
      complex*16 cldeg,cxp2,c2lp1,c2lp3,ca,cb,ya,yb
c
      real*8 eps
      complex*16 c0,c1,c2,c3
      data eps/1.0d-08/
      data c0,c1,c2,c3/(0.d0,0.d0),(1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      cxp2=(kp(ly)*crrup(ly))**2
      c2lp1=c2*cldeg+c1
      c2lp3=c2*cldeg+c3
c
      if(jh.eq.1.and.ly.ge.lys)then
        cy(1,1)=cldeg-zh12p(ldeg,1,ly)
        cy(2,1)=-cro(ly)*comi2*crrup(ly)**2
        cy(3,1)=cga(ly)
        cy(4,1)=cga(ly)*(cldeg+c1)
c
        peps=dabs(dimag(zh12p(ldeg,1,ly)))/cdabs(zh12p(ldeg,1,ly))
        if(peps.lt.eps)then
          ca=dcmplx((peps/eps)**2,0.d0)
          cb=(1.d0,0.d0)-ca
          ya=cy(1,1)
          yb=mas4x4up(1,1,ly)
          do i=1,4
            cy(i,1)=ca*cy(i,1)*yb+cb*mas4x4up(i,1,ly)*ya
          enddo
        endif
        cy(1,2)=c0
        cy(2,2)=c0
        cy(3,2)=c1
        cy(4,2)=c2lp1
      else if(jh.eq.2.and.ly.le.lys)then
        cy(1,1)=cldeg-zh12p(ldeg,2,ly)
        cy(2,1)=-cro(ly)*comi2*crrup(ly)**2
        cy(3,1)=cga(ly)
        cy(4,1)=cga(ly)*(cldeg+c1)
c
        cy(1,2)=c0
        cy(2,2)=c0
        cy(3,2)=c1
        cy(4,2)=c0
      else
        stop ' Error in qpstart4a: bad jh value!'
      endif
c
c     Note:
c       y1 <- y1 (normal displacement)
c       y2 <- y2 (normal stress)       !!! Note definition different to the case with self-gravitation !!!
c       y3 <- y5 (potential)
c       y4 <- y6 (gravity)
c
      return
      end

      subroutine qpstart0g(ly,jh,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c     for n = 0
c
      integer*4 ly,jh
      complex*16 cy(3)
c
      integer*4 i
c
      if(jh.eq.0.and.ly.ge.lys)then
        if(lylwa.gt.0.or.lylwb.le.ly0)then
          do i=1,3
            cy(i)=mas3x3up(i,1,ly)
          enddo
        else
          call qpstart0(ly,cy)
        endif
      else if(jh.eq.1.and.ly.ge.lys.or.jh.eq.2.and.ly.le.lys)then
        call qpstart0a(ly,jh,cy)
      else
        stop ' Error in qpstart0g: bad jh value!'
      endif
c
      return
      end

      subroutine qsqmodel(f)
      implicit none
c
c     calculate q based on the constant q model
c
c     f = frequency
c
      real*8 f
c
      include 'qsglobal.h'
c
      integer*4 n
      complex*16 cmp,cms
c
      real*8 pi2
      data pi2/6.28318530717959d0/
c
      comega=dcmplx(pi2*f,pi2*fi)
      cvpair=dcmplx(vpair,0.d0)
c
      do n=1,n0
        if(qp(n).le.0.d0)then
          cmp=(1.d0,0.d0)
        else
          cmp=dcmplx(1.d0,0.5d0/qp(n))
        endif
        if(qs(n).le.0.d0.or.vs(n).le.vspmin*vp(n))then
          cms=(1.d0,0.d0)
        else
          cms=dcmplx(1.d0,0.5d0/qs(n))
        endif
        cvp(n)=dcmplx(vp(n),0.d0)*cmp
        cvs(n)=dcmplx(vs(n),0.d0)*cms
        cmu(n)=dcmplx(ro(n)*vs(n)**2,0.d0)*cms**2
        cla(n)=dcmplx(ro(n)*vp(n)**2,0.d0)*cmp**2-(2.d0,0.d0)*cmu(n)
        acc(n)=dcmplx(ro(n),0.d0)*comega**2
      enddo
c
c     for receiver site
c
      do n=1,n0rs
        if(qprs(n).le.0.d0)then
          cmp=(1.d0,0.d0)
        else
          cmp=dcmplx(1.d0,0.5d0/qprs(n))
        endif
        if(qsrs(n).le.0.d0.or.vsrs(n).le.vspmin*vprs(n))then
          cms=(1.d0,0.d0)
        else
          cms=dcmplx(1.d0,0.5d0/qsrs(n))
        endif
        cvprs(n)=dcmplx(vprs(n),0.d0)*cmp
        cvsrs(n)=dcmplx(vsrs(n),0.d0)*cms
        cmurs(n)=dcmplx(rors(n)*vsrs(n)**2,0.d0)*cms**2
        clars(n)=dcmplx(rors(n)*vprs(n)**2,0.d0)*cmp**2
     &          -(2.d0,0.d0)*cmurs(n)
        accrs(n)=dcmplx(rors(n),0.d0)*comega**2
      enddo
c
      return
      end

      subroutine qsam2ve(n,ck,z,dynamic,y,c,nj,rsite)
      implicit none
c
c     converting wave amplitudes to displacement-stress vectors
c     by Langer block-diagonal decomposition technique for com-
c     putational efficiency
c
      integer*4 n,nj
      real*8 z
      complex*16 ck
      complex*16 y(4,nj),c(4,nj)
      logical*4 dynamic,rsite
c
      include 'qsglobal.h'
c
      integer*4 i,j,m
      complex*16 bp,bs
      complex*16 swap(4),a(4,4)
c
      if(rsite)then
        bp=wbrs(n)*kprs(n)
        bs=wbrs(n)*ksrs(n)
        do j=1,nj
          swap(1)= c(1,j)-c(2,j)
          swap(2)= c(1,j)+c(2,j)
          swap(3)=-c(3,j)+c(4,j)
          swap(4)= c(3,j)+c(4,j)
c
          y(1,j)=kprs(n)*swap(1)+ck*swap(4)
          y(2,j)=wars(n)*swap(2)-bs*swap(3)
          y(3,j)=ck*swap(2)-ksrs(n)*swap(3)
          y(4,j)=bp*swap(1)+wars(n)*swap(4)
        enddo
      else if(dynamic)then
        bp=wb(n)*kp(n)
        bs=wb(n)*ks(n)
        do j=1,nj
          swap(1)= c(1,j)-c(2,j)
          swap(2)= c(1,j)+c(2,j)
          swap(3)=-c(3,j)+c(4,j)
          swap(4)= c(3,j)+c(4,j)
c
          y(1,j)=kp(n)*swap(1)+ck*swap(4)
          y(2,j)=wa(n)*swap(2)-bs*swap(3)
          y(3,j)=ck*swap(2)-ks(n)*swap(3)
          y(4,j)=bp*swap(1)+wa(n)*swap(4)
        enddo
      else
        call qsmatrix0(a,ck,z,n)
        do j=1,nj
          do i=1,4
            y(i,j)=(0.d0,0.d0)
            do m=1,4
              y(i,j)=y(i,j)+a(i,m)*c(m,j)
            enddo
          enddo
        enddo
      endif
c
      return
      end

      subroutine qplegendre(ierr)
      use qpalloc
      implicit none
      integer*4 ierr
c
c     calculate associated Plm(l,m,x)/(1-x^2)^(m/2)
c     where Plm are Legendre polynomials
c
      integer*4 l,m,ir
      real*8 x
c
      do ir=1,nr
        x=dcos(disrad(ir))
        plm(0,0,ir)=1.d0
        plm(0,1,ir)=0.d0
        plm(1,1,ir)=1.d0
        plm(0,2,ir)=0.d0
        plm(1,2,ir)=0.d0
        plm(2,2,ir)=3.d0
        do m=0,2
          plm(m+1,m,ir)=dble(2*m+1)*x*plm(m,m,ir)
          do l=m+2,ldegmax
            plm(l,m,ir)=(dble(2*l-1)*x*plm(l-1,m,ir)
     &               -dble(l+m-1)*plm(l-2,m,ir))/dble(l-m)
          enddo
        enddo
      enddo
      return
      end

      subroutine qpwvint(ierr)
      use qpalloc
      implicit none
      integer*4 ierr
c
      integer*4 i,j,k,id,is,ir,ig,nd,nt0,nf0,ntcut0,nfcut0,ishift
      integer*4 lf,lf1,istp,ldeg,ldegf,ldeg0
      integer*4 istat,ldegup,ldeglw,ldegneed
      real*8 depsarc,dis0,anorm,slwcut
      real*8 f,dt0,df0,rn,re,azi,bazi,bazi0
      complex*16 cll1,cp0,cp1,cp2,wavelet,muer,lamr,ksir,rrr,srt,srp
      complex*16 cfac,ca,cb,dur,dut,dup,eii,dgr,dgt,dgp
      complex*16 urdr,urdt,urdp,utdr,utdt,utdp,updr,updt,updp
      complex*16 rot(3,3),rtz(3,3),enz(3,3),swp(3,3)
      logical*2 fullwave
c
      complex*16 c1,c2,c3
      data c1,c2,c3/(1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0)/
c
      allocate(tap(0:ldegmax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: tap not allocated!'
      allocate(ldegtap(4,ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ldegtap not allocated!'
      allocate(wvf(nf,ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: wvf not allocated!'
c
      allocate(expl(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: expl not allocated!'
      allocate(clvd(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: clvd not allocated!'
      allocate(ss12(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ss12 not allocated!'
      allocate(ss11(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ss11 not allocated!'
      allocate(ds31(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ds31 not allocated!'
      allocate(ds23(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ds23 not allocated!'
c
      allocate(ue(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ue not allocated!'
      allocate(un(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: un not allocated!'
      allocate(uz(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: uz not allocated!'
c
      allocate(ge(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ge not allocated!'
      allocate(gn(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: gn not allocated!'
      allocate(gz(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: gz not allocated!'
      allocate(gm(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: gm not allocated!'
c
      allocate(roe(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: roe not allocated!'
      allocate(ron(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ron not allocated!'
      allocate(roz(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: roz not allocated!'
c
      allocate(uee(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: uee not allocated!'
      allocate(uen(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: uen not allocated!'
      allocate(uez(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: uez not allocated!'
      allocate(unn(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: unn not allocated!'
      allocate(unz(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: unz not allocated!'
      allocate(uzz(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: uzz not allocated!'
c
      allocate(see(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: see not allocated!'
      allocate(sen(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: sen not allocated!'
      allocate(sez(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: sez not allocated!'
      allocate(snn(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: snn not allocated!'
      allocate(snz(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: snz not allocated!'
      allocate(szz(nf,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: szz not allocated!'
c
      allocate(idr(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: idr not allocated!'
      allocate(dis(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: dis not allocated!'
      allocate(ssa(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ssa not allocated!'
      allocate(csa(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: csa not allocated!'
      allocate(ssb(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ssb not allocated!'
      allocate(ssd(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ssd not allocated!'
      allocate(csd(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: csd not allocated!'
      allocate(csb(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: csb not allocated!'
      allocate(ssf(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ssf not allocated!'
      allocate(ss2a(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: ss2a not allocated!'
      allocate(cs2a(ns,nr),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: cs2a not allocated!'
c
      allocate(sf1(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: sf1 not allocated!'
      allocate(sf2(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: sf2 not allocated!'
      allocate(sf3(ns),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpwvint: sf3 not allocated!'
c
      do ldeg=0,ldegmax
        tap(ldeg)=1.d0
      enddo
c
      ldeg0=10+ndmax
c
      rrr=crrup(lyr)
c
      do is=1,ns
        depsarc=PI2/dble(ldegmax)+dmax1(minpath,deps(is))/rearth
        dis0=5.d0*depsarc
c
        do ir=1,nr
          call disazi(1.d0,lats(is),lons(is),
     &                     latr(ir),lonr(ir),rn,re)
c
          dis(is,ir)=dsqrt(rn**2+re**2)
c
c         determine order of differential transform
c
          if(dis(is,ir).le.dis0)then
            idr(is,ir)=0
          else
            idr(is,ir)=min0(ndmax,idint(dlog(dis(is,ir)/dis0)))
          endif
c
          ssd(is,ir)=dcmplx(dsin(dis(is,ir)),0.d0)
          csd(is,ir)=dcmplx(dcos(dis(is,ir)),0.d0)
          ssf(is,ir)=dcmplx(2.d0*dsin(0.5d0*dis(is,ir))**2,0.d0)
c
c         azi = receiver azimuth (from south to east)
c
          if(dsqrt(re*re+rn*rn).gt.0.d0)then
            azi=datan2(re,-rn)
          else
c
c           assume southern receiver in case of 0 distance
c
            azi=datan2(0.d0,1.d0)
          endif
          ssa(is,ir)=dcmplx(dsin(azi),0.d0)
          csa(is,ir)=dcmplx(dcos(azi),0.d0)
          ss2a(is,ir)=dcmplx(dsin(2.d0*azi),0.d0)
          cs2a(is,ir)=dcmplx(dcos(2.d0*azi),0.d0)
        enddo
      enddo
c
      do ir=1,nr
        do is=1,ns
          call disazi(1.d0,latr(ir),lonr(ir),
     &                     lats(is),lons(is),rn,re)
c
c         opposite vector receiver-source
c         azmuth from south to east
c
          if(dsqrt(re*re+rn*rn).gt.0.d0)then
            bazi=datan2(-re,rn)
          else
            bazi=datan2(0.d0,-1.d0)
          endif
          ssb(is,ir)=dcmplx(dsin(bazi),0.d0)
          csb(is,ir)=dcmplx(dcos(bazi),0.d0)
        enddo
      enddo
c
      do is=1,ns
        expl(is)=dcmplx((mtt(is)+mpp(is)+mrr(is))/3.d0,0.d0)
        clvd(is)=dcmplx(mrr(is),0.d0)-expl(is)
        ss12(is)=dcmplx(mtp(is),0.d0)
        ss11(is)=dcmplx((mtt(is)-mpp(is))/2.d0,0.d0)
        ds31(is)=dcmplx(mrt(is),0.d0)
        ds23(is)=dcmplx(mpr(is),0.d0)
        sf1(is)=dcmplx(sft(is),0.d0)
        sf2(is)=dcmplx(sfp(is),0.d0)
        sf3(is)=dcmplx(sfr(is),0.d0)
      enddo
c
c     initiation
c
      do is=1,ns
        call swavelet(trss(is),df,fi,nf,wvf(1,is))
      enddo
c
      do lf=1,nf
        do ir=1,nr
          ue(lf,ir)=(0.d0,0.d0)
          un(lf,ir)=(0.d0,0.d0)
          uz(lf,ir)=(0.d0,0.d0)
c
          ge(lf,ir)=(0.d0,0.d0)
          gn(lf,ir)=(0.d0,0.d0)
          gz(lf,ir)=(0.d0,0.d0)
          gm(lf,ir)=(0.d0,0.d0)
c
          roe(lf,ir)=(0.d0,0.d0)
          ron(lf,ir)=(0.d0,0.d0)
          roz(lf,ir)=(0.d0,0.d0)
c
          uee(lf,ir)=(0.d0,0.d0)
          uen(lf,ir)=(0.d0,0.d0)
          uez(lf,ir)=(0.d0,0.d0)
          unn(lf,ir)=(0.d0,0.d0)
          unz(lf,ir)=(0.d0,0.d0)
          uzz(lf,ir)=(0.d0,0.d0)
c
          see(lf,ir)=(0.d0,0.d0)
          sen(lf,ir)=(0.d0,0.d0)
          sez(lf,ir)=(0.d0,0.d0)
          snn(lf,ir)=(0.d0,0.d0)
          snz(lf,ir)=(0.d0,0.d0)
          szz(lf,ir)=(0.d0,0.d0)
        enddo
      enddo
c
      do ig=1,ngrn
        if(nsg(ig).le.0)goto 500
        write(*,'(a)')' '
        write(*,'(a,i4,a,f5.1,a)')' processing ',1+isg2(ig)-isg1(ig),
     &    ' point source(s) at depth ',(grndep(ig)-depatmos)/KM2M,' km'
        write(*,'(a)')' open Green function data base: '
     &              //specfile(ig)(1:40)
        write(*,'(a)')' ... please wait ...'
c
        open(21,file=uspecfile(ig),form='unformatted',status='old')
        open(22,file=vspecfile(ig),form='unformatted',status='old')
        open(23,file=wspecfile(ig),form='unformatted',status='old')
        open(24,file=especfile(ig),form='unformatted',status='old')
        open(25,file=fspecfile(ig),form='unformatted',status='old')
        open(26,file=gspecfile(ig),form='unformatted',status='old')
        open(27,file=pspecfile(ig),form='unformatted',status='old')
        open(28,file=qspecfile(ig),form='unformatted',status='old')
c
        read(21)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(22)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(23)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(24)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(25)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(26)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(27)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(28)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
c
        if(ntcut0.ne.ntcut.or.dabs(dt0-dt).gt.1.0d-06*dt.or.
     &     nfcut0.lt.nfcut.or.dabs(df0-df).gt.1.0d-06*df)then
          print *,' Error in qpwvint: t/f sampling'
     &          //' inconsistent with Green functions!'
          write(*,'(a)')'               '//'  ntcut             dt'
     &                                   //'  nfcut             df'
          write(*,'(a,2(i7,f16.8))')' Current input:',
     &                               ntcut,dt,nfcut,df
          write(*,'(a,2(i7,f16.8))')'     Data base:',
     &                               ntcut0,dt0,nfcut0,df0
          stop
        endif
c
        nd=0
        do is=isg1(ig),isg2(ig)
          do ir=1,nr
            nd=max0(nd,idr(is,ir))
          enddo
        enddo
c
        if(ldegup+nd.gt.ldegmax)then
          write(*,'(a,i6,a,i6)')' Error in qpwvint: '
     &     //'max. harmonic degree required = ',ldegup+nd,
     &     ' > ldegmax defined: ',ldegmax
          stop
        endif
c
        do istp=1,6
          do ldeg=0,ldegmax
            ul0(ldeg,istp)=(0.d0,0.d0)
            vl0(ldeg,istp)=(0.d0,0.d0)
            wl0(ldeg,istp)=(0.d0,0.d0)
            el0(ldeg,istp)=(0.d0,0.d0)
            fl0(ldeg,istp)=(0.d0,0.d0)
            gl0(ldeg,istp)=(0.d0,0.d0)
            pl0(ldeg,istp)=(0.d0,0.d0)
            ql0(ldeg,istp)=(0.d0,0.d0)
          enddo
        enddo
c
        lys=lygrn(ig)
        if(vsup(lys).gt.0.d0)then
          slwcut=1.d0/vsup(lys)
        else
          slwcut=1.d0/vpup(lys)
        endif
        fullwave=slwlwcut.le.0.d0.and.slwupcut.ge.dmin1(slwmax,slwcut)
c
        do lf=1,nfcut
          f=dble(lf-1)*df
c
          call qpqmodel(f)
          muer=cmuup(lyr)
          lamr=claup(lyr)
          ksir=lamr+c2*muer
c
          read(21)ldegf
          read(22)ldegf
          read(23)ldegf
          read(24)ldegf
          read(25)ldegf
          read(26)ldegf
          read(27)ldegf
          read(28)ldegf
c
          read(21)((ul0(ldeg,istp),ldeg=0,ldegf),istp=1,6)              !Y1
          read(22)((vl0(ldeg,istp),ldeg=0,ldegf),istp=1,6)              !Y3
          read(23)((wl0(ldeg,istp),ldeg=0,ldegf),istp=4,6)              !Y7
          read(24)((el0(ldeg,istp),ldeg=0,ldegf),istp=1,6)              !Y2
          read(25)((fl0(ldeg,istp),ldeg=0,ldegf),istp=1,6)              !Y4
          read(26)((gl0(ldeg,istp),ldeg=0,ldegf),istp=4,6)              !Y8
          read(27)((pl0(ldeg,istp),ldeg=0,ldegf),istp=1,6)              !Y5
          read(28)((ql0(ldeg,istp),ldeg=0,ldegf),istp=1,6)              !dY5/dr derived from Y1, Y5 and Y6
c
          ldegneed=0
          ldeglw=ldegmax
          do is=isg1(ig),isg2(ig)
            do ir=1,nr
              if(fullwave)then
                ldegtap(4,is,ir)=max0(0,ldegf-idr(is,ir)-1)
                ldegtap(3,is,ir)=ldegtap(4,is,ir)*4/5
                ldegtap(2,is,ir)=0
                ldegtap(1,is,ir)=0
              else
                ldegtap(4,is,ir)=min0(ldegf-idr(is,ir)-1,
     &                        ldeg0+idnint(rearth*PI2*f*slwupcut))
                ldegtap(3,is,ir)=ldegtap(4,is,ir)*4/5
                ldegtap(4,is,ir)=min0(ldegf-idr(is,ir)-1,
     &                                10+ldegtap(4,is,ir))
                ldegtap(2,is,ir)=min0(ldegtap(3,is,ir),
     &                           idnint(rearth*PI2*f*slwlwcut*1.25d0))
                ldegtap(1,is,ir)=ldegtap(2,is,ir)*4/5
              endif
              ldegneed=max0(ldegneed,ldegtap(4,is,ir))
              ldeglw=max0(0,min0(ldeglw,ldegtap(1,is,ir)-idr(is,ir)))
            enddo
          enddo
          ldegneed=min0(ldegneed+nd,ldegf)        
c
c         use differential filter to suppress spatial aliasing
c
c         vertical single force, explosion and clvd sources
c         ur,ut,up(=0)
c         err,ert,erp(=0),etr,ett,etp(=0),epr(=0),ept(=0),epp
c         gr,gt,gp(=0)
c
          do istp=1,3
            do ldeg=0,ldegf-1
              cll1=dcmplx(dble(ldeg*(ldeg+1)),0.d0)
              urlm(ldeg,istp,0)=ul0(ldeg,istp)                          !m=0,  1
              utlm(ldeg,istp,0)=-vl0(ldeg,istp)                         !m=1,  1
c
              grlm(ldeg,istp,0)=ql0(ldeg,istp)                          !m=0,  1
              gtlm(ldeg,istp,0)=-pl0(ldeg,istp)/rrr                     !m=1,  1
c
              errlm(ldeg,istp,0)=(el0(ldeg,istp)                        !m=0,  1
     &                     +(lamr/rrr)*(-c2*ul0(ldeg,istp)
     &                     +cll1*vl0(ldeg,istp)))/ksir
              ertlm(ldeg,istp,0)=(-ul0(ldeg,istp)                       !m=1,  1
     &                            +vl0(ldeg,istp))/rrr
c
              if(cdabs(muer).gt.0.d0)then
                srt=-fl0(ldeg,istp)
                etrlm(ldeg,istp,0)=srt/muer-ertlm(ldeg,istp,0)          !m=1,  1
              else
                etrlm(ldeg,istp,0)=ertlm(ldeg,istp,0)                   !m=1,  1
              endif
              ett0lm(ldeg,istp,0)=(ul0(ldeg,istp)
     &                        -cll1*vl0(ldeg,istp))/rrr                 !m=0,  1
              ettalm(ldeg,istp,0)=vl0(ldeg,istp)/rrr                    !m=1,  cos(t)/sin(t)
c
              epp0lm(ldeg,istp,0)= ul0(ldeg,istp)/rrr                   !m=0,  1
              eppalm(ldeg,istp,0)=-vl0(ldeg,istp)/rrr                   !m=1,  cos(t)/sin(t)
            enddo
          enddo
c
          do istp=4,6
            do ldeg=0,istp/6
              urlm(ldeg,istp,0)=(0.d0,0.d0)
              utlm(ldeg,istp,0)=(0.d0,0.d0)
              uplm(ldeg,istp,0)=(0.d0,0.d0)
              grlm(ldeg,istp,0)=(0.d0,0.d0)
              gtlm(ldeg,istp,0)=(0.d0,0.d0)
              gplm(ldeg,istp,0)=(0.d0,0.d0)
              errlm(ldeg,istp,0)=(0.d0,0.d0)
              ertlm(ldeg,istp,0)=(0.d0,0.d0)
              erplm(ldeg,istp,0)=(0.d0,0.d0)
              etrlm(ldeg,istp,0)=(0.d0,0.d0)
              ett0lm(ldeg,istp,0)=(0.d0,0.d0)
              ettalm(ldeg,istp,0)=(0.d0,0.d0)
              ettblm(ldeg,istp,0)=(0.d0,0.d0)
              etp0lm(ldeg,istp,0)=(0.d0,0.d0)
              etpalm(ldeg,istp,0)=(0.d0,0.d0)
              etpblm(ldeg,istp,0)=(0.d0,0.d0)
              eprlm(ldeg,istp,0)=(0.d0,0.d0)
              ept0lm(ldeg,istp,0)=(0.d0,0.d0)
              eptalm(ldeg,istp,0)=(0.d0,0.d0)
              eptblm(ldeg,istp,0)=(0.d0,0.d0)
              epp0lm(ldeg,istp,0)=(0.d0,0.d0)
              eppalm(ldeg,istp,0)=(0.d0,0.d0)
              eppblm(ldeg,istp,0)=(0.d0,0.d0)
            enddo
          enddo
c
c         horizontal single force and dip-slip
c
          do istp=4,5
            do ldeg=1,ldegf-1
              cll1=dcmplx(dble(ldeg*(ldeg+1)),0.d0)
              ca=dcmplx(dble(ldeg-1)**2/dble(2*ldeg-1),0.d0)
              cb=dcmplx(dble(ldeg+2)**2/dble(2*ldeg+3),0.d0)
              urlm(ldeg,istp,0)=ul0(ldeg,istp)                          !m=1,  1
              utlm(ldeg,istp,0)=ca*vl0(ldeg-1,istp)-cb*vl0(ldeg+1,istp) !m=1,  1/sin(t)
     &                       +wl0(ldeg,istp)
              uplm(ldeg,istp,0)=cb*wl0(ldeg+1,istp)-ca*wl0(ldeg-1,istp) !m=1,  1/sin(t)
     &                       -vl0(ldeg,istp)
c
              grlm(ldeg,istp,0)=ql0(ldeg,istp)                          !m=1,  1
              gtlm(ldeg,istp,0)=(ca*pl0(ldeg-1,istp)                    !m=1,  1/sin(t)
     &                          -cb*pl0(ldeg+1,istp))/rrr
              gplm(ldeg,istp,0)=-pl0(ldeg,istp)/rrr                     !m=1,  1/sin(t)
c
              errlm(ldeg,istp,0)=(el0(ldeg,istp)                        !m=1,  1
     &                       +(lamr/rrr)*(-c2*ul0(ldeg,istp)
     &                       +dble(ldeg*(ldeg+1))*vl0(ldeg,istp)))/ksir
c             ertlm(ldeg,istp,0) s. below
              erplm(ldeg,istp,0)=(-ul0(ldeg,istp)                       !m=1,  1/sin(t)
     &                          -uplm(ldeg,istp,0))/rrr
c
              if(cdabs(muer).gt.0.d0)then
                srt=(ca*fl0(ldeg-1,istp)
     &              -cb*fl0(ldeg+1,istp)+gl0(ldeg,istp))/muer
                etrlm(ldeg,istp,0)=srt+utlm(ldeg,istp,0)/rrr            !m=1,  1/sin(t)
     &             -(ca*ul0(ldeg-1,istp)-cb*ul0(ldeg+1,istp))/rrr
                ertlm(ldeg,istp,0)=srt-etrlm(ldeg,istp,0)               !m=1,  1/sin(t)
              else
                etrlm(ldeg,istp,0)=(ca*(ul0(ldeg-1,istp)                 !m=1,  1/sin(t)
     &                                 -vl0(ldeg-1,istp))
     &                             -cb*(ul0(ldeg+1,istp)
     &                                 -vl0(ldeg+1,istp)))/rrr
                ertlm(ldeg,istp,0)=etrlm(ldeg,istp,0)                   !m=1,  1/sin(t)
              endif
c
              ett0lm(ldeg,istp,0)=(ul0(ldeg,istp)                       !m=1,  1
     &                  +(c1-cll1)*vl0(ldeg,istp))/rrr
              ettalm(ldeg,istp,0)= vl0(ldeg,istp)/rrr                   !m=2,  cos(t)/sin(t)
              ettblm(ldeg,istp,0)=-wl0(ldeg,istp)/rrr                   !m=2,  1/sin(t)
c
              etp0lm(ldeg,istp,0)=-wl0(ldeg,istp)/rrr                   !m=1,  1
              etpalm(ldeg,istp,0)= vl0(ldeg,istp)/rrr                   !m=2,  1/sin(t)
              etpblm(ldeg,istp,0)=-wl0(ldeg,istp)/rrr                   !m=2,  cos(t)/sin(t)
c
              if(cdabs(muer).gt.0.d0)then
                srp=(cb*gl0(ldeg+1,istp)-ca*gl0(ldeg-1,istp)
     &             -fl0(ldeg,istp))/muer
                eprlm(ldeg,istp,0)=srp-erplm(ldeg,istp,0)               !m=1,  1/sin(t)
              else
                eprlm(ldeg,istp,0)=erplm(ldeg,istp,0)                   !m=1,  1/sin(t)
              endif
c
              ept0lm(ldeg,istp,0)=-(c1-cll1)*wl0(ldeg,istp)/rrr         !m=1,  1
              eptalm(ldeg,istp,0)=-wl0(ldeg,istp)/rrr                   !m=2,  cos(t)/sin(t)
              eptblm(ldeg,istp,0)= vl0(ldeg,istp)/rrr                   !m=2,  1/sin(t)
c
              epp0lm(ldeg,istp,0)=(ul0(ldeg,istp)-vl0(ldeg,istp))/rrr   !m=1,  1
              eppalm(ldeg,istp,0)=-vl0(ldeg,istp)/rrr                   !m=2,  cos(t)/sin(t)
              eppblm(ldeg,istp,0)= wl0(ldeg,istp)/rrr                   !m=2,  1/sin(t)
            enddo
          enddo
c
c         strike-slip
c
          do ldeg=2,ldegf-1
            cll1=dcmplx(dble(ldeg*(ldeg+1)),0.d0)
            ca=dcmplx(dble((ldeg-1)*(ldeg-2))/dble(2*ldeg-1),0.d0)
            cb=dcmplx(dble((ldeg+2)*(ldeg+3))/dble(2*ldeg+3),0.d0)
            urlm(ldeg,6,0)=ul0(ldeg,6)                                  !m=2,  1
            utlm(ldeg,6,0)= ca*vl0(ldeg-1,6)-cb*vl0(ldeg+1,6)           !m=2,  1/sin(t)
     &                     -c2*wl0(ldeg,6)
            uplm(ldeg,6,0)=-ca*wl0(ldeg-1,6)+cb*wl0(ldeg+1,6)           !m=2,  1/sin(t)
     &                     +c2*vl0(ldeg,6)
c
            grlm(ldeg,6,0)=ql0(ldeg,6)                                  !m=2,  1
            gtlm(ldeg,6,0)=(ca*pl0(ldeg-1,6)-cb*pl0(ldeg+1,6))/rrr      !m=2,  1/sin(t)
            gplm(ldeg,6,0)=c2*pl0(ldeg,6)/rrr                           !m=2,  1/sin(t)
c
            errlm(ldeg,6,0)=(el0(ldeg,6)                                !m=2,  1
     &                     +(lamr/rrr)*(-c2*ul0(ldeg,6)
     &                     +cll1*vl0(ldeg,6)))/ksir
c           ertlm(ldeg,6,0) s. below
            erplm(ldeg,6,0)=(c2*ul0(ldeg,6)-uplm(ldeg,6,0))/rrr         !m=2,  1/sin(t)
c
            if(cdabs(muer).gt.0.d0)then
              etrlm(ldeg,6,0)=ca*(fl0(ldeg-1,6)/muer                    !m=2,  1/sin(t)
     &                          +(vl0(ldeg-1,6)-ul0(ldeg-1,6))/rrr)
     &                       -cb*(fl0(ldeg+1,6)/muer
     &                          +(vl0(ldeg+1,6)-ul0(ldeg+1,6))/rrr)
     &                     -c2*(wl0(ldeg,6)/rrr+gl0(ldeg,6)/muer)
              srt=ca*fl0(ldeg-1,6)-cb*fl0(ldeg+1,6)-c2*gl0(ldeg,6)
              ertlm(ldeg,6,0)=srt/muer-etrlm(ldeg,6,0)                  !m=2,  1/sin(t)
            else
              etrlm(ldeg,6,0)=ca*(ul0(ldeg-1,6)-vl0(ldeg-1,6))/rrr      !m=2,  1/sin(t)
     &                       -cb*(ul0(ldeg+1,6)-vl0(ldeg+1,6))/rrr
              ertlm(ldeg,6,0)=etrlm(ldeg,6,0)                           !m=2  1/sin(t)
            endif
c
            ett0lm(ldeg,6,0)=(ul0(ldeg,6)                               !m=2,  1
     &                 -cll1*vl0(ldeg,6))/rrr
            ettalm(ldeg,6,0)=-utlm(ldeg,6,0)/rrr                        !m=2,  cos(t)/sin^2(t)
            ettblm(ldeg,6,0)=c2*uplm(ldeg,6,0)/rrr                      !m=2,  1/sin^2(t)
c
            etp0lm(ldeg,6,0)=c2*utlm(ldeg,6,0) /rrr                     !m=2,  1/sin^2(t)
            etpalm(ldeg,6,0)=-uplm(ldeg,6,0)/rrr                        !m=2,  cos(t)/sin^2(t)
c
            if(cdabs(muer).gt.0.d0)then
              srp=-ca*gl0(ldeg-1,6)+cb*gl0(ldeg+1,6)+c2*fl0(ldeg,6)
              eprlm(ldeg,6,0)=srp/muer-erplm(ldeg,6,0)                  !m=2,  1/sin(t)
            else
              eprlm(ldeg,6,0)=erplm(ldeg,6,0)                           !m=2,  1/sin(t)
            endif
c
            ept0lm(ldeg,6,0)=-dcmplx(dble(ldeg+2),0.d0)                 !m=2,  cos(t)/sin^2(t)
     &                      *uplm(ldeg,6,0)/rrr
            eptalm(ldeg,6,0)=dcmplx(dble(ldeg-2),0.d0)                  !m=2,  1/sin^2(t)
     &                      *uplm(ldeg-1,6,0)/rrr
c
            epp0lm(ldeg,6,0)=ul0(ldeg,6)/rrr                            !m=2,  1
            eppalm(ldeg,6,0)=utlm(ldeg,6,0)/rrr                         !m=2,  cos(t)/sin^2(t)
            eppblm(ldeg,6,0)=-c2*uplm(ldeg,6,0)/rrr                     !m=2,  1/sin^2(t)
          enddo
c
c         use differential transform to suppress spatial aliasing
c
          do id=1,nd
c
c           m = 0
c
            do istp=1,3
              urlm(0,istp,id)=urlm(0,istp,id-1)
     &                       -urlm(1,istp,id-1)/c3
              grlm(0,istp,id)=grlm(0,istp,id-1)
     &                       -grlm(1,istp,id-1)/c3
              errlm(0,istp,id)=errlm(0,istp,id-1)
     &                        -errlm(1,istp,id-1)/c3
              ett0lm(0,istp,id)=ett0lm(0,istp,id-1)
     &                         -ett0lm(1,istp,id-1)/c3
              epp0lm(0,istp,id)=epp0lm(0,istp,id-1)
     &                         -epp0lm(1,istp,id-1)/c3
            enddo
c
            do ldeg=1,ldegf-1-id
              ca=dcmplx(dble(ldeg+1)/dble(2*ldeg+3),0.d0)
              cb=dcmplx(dble(ldeg)/dble(2*ldeg-1),0.d0)
              do istp=1,3
                urlm(ldeg,istp,id)=urlm(ldeg,istp,id-1)
     &                         -ca*urlm(ldeg+1,istp,id-1)
     &                         -cb*urlm(ldeg-1,istp,id-1)
                grlm(ldeg,istp,id)=grlm(ldeg,istp,id-1)
     &                         -ca*grlm(ldeg+1,istp,id-1)
     &                         -cb*grlm(ldeg-1,istp,id-1)
                errlm(ldeg,istp,id)=errlm(ldeg,istp,id-1)
     &                         -ca*errlm(ldeg+1,istp,id-1)
     &                         -cb*errlm(ldeg-1,istp,id-1)
                ett0lm(ldeg,istp,id)=ett0lm(ldeg,istp,id-1)
     &                         -ca*ett0lm(ldeg+1,istp,id-1)
     &                         -cb*ett0lm(ldeg-1,istp,id-1)
                epp0lm(ldeg,istp,id)=epp0lm(ldeg,istp,id-1)
     &                         -ca*epp0lm(ldeg+1,istp,id-1)
     &                         -cb*epp0lm(ldeg-1,istp,id-1)
              enddo
            enddo
c
c           m = 1
c
            do istp=1,3
              utlm(0,istp,id)=(0.d0,0.d0)
              gtlm(0,istp,id)=(0.d0,0.d0)
              ertlm(0,istp,id)=(0.d0,0.d0)
              etrlm(0,istp,id)=(0.d0,0.d0)
              ettalm(0,istp,id)=(0.d0,0.d0)
              eppalm(0,istp,id)=(0.d0,0.d0)
            enddo
            do istp=4,5
              urlm(0,istp,id)=(0.d0,0.d0)
              utlm(0,istp,id)=(0.d0,0.d0)
              uplm(0,istp,id)=(0.d0,0.d0)
              grlm(0,istp,id)=(0.d0,0.d0)
              gtlm(0,istp,id)=(0.d0,0.d0)
              gplm(0,istp,id)=(0.d0,0.d0)
              errlm(0,istp,id)=(0.d0,0.d0)
              ertlm(0,istp,id)=(0.d0,0.d0)
              erplm(0,istp,id)=(0.d0,0.d0)
              etrlm(0,istp,id)=(0.d0,0.d0)
              ett0lm(0,istp,id)=(0.d0,0.d0)
              etp0lm(0,istp,id)=(0.d0,0.d0)
              eprlm(0,istp,id)=(0.d0,0.d0)
              ept0lm(0,istp,id)=(0.d0,0.d0)
              epp0lm(0,istp,id)=(0.d0,0.d0)
            enddo
c
            do ldeg=1,ldegf-1-id
              ca=dcmplx(dble(ldeg+2)/dble(2*ldeg+3),0.d0)
              cb=dcmplx(dble(ldeg-1)/dble(2*ldeg-1),0.d0)
              do istp=1,3
                utlm(ldeg,istp,id)=utlm(ldeg,istp,id-1)
     &                         -ca*utlm(ldeg+1,istp,id-1)
     &                         -cb*utlm(ldeg-1,istp,id-1)
                gtlm(ldeg,istp,id)=gtlm(ldeg,istp,id-1)
     &                         -ca*gtlm(ldeg+1,istp,id-1)
     &                         -cb*gtlm(ldeg-1,istp,id-1)
                ertlm(ldeg,istp,id)=ertlm(ldeg,istp,id-1)
     &                           -ca*ertlm(ldeg+1,istp,id-1)
     &                           -cb*ertlm(ldeg-1,istp,id-1)
                etrlm(ldeg,istp,id)=etrlm(ldeg,istp,id-1)
     &                           -ca*etrlm(ldeg+1,istp,id-1)
     &                           -cb*etrlm(ldeg-1,istp,id-1)
                ettalm(ldeg,istp,id)=ettalm(ldeg,istp,id-1)
     &                           -ca*ettalm(ldeg+1,istp,id-1)
     &                           -cb*ettalm(ldeg-1,istp,id-1)
                eppalm(ldeg,istp,id)=eppalm(ldeg,istp,id-1)
     &                           -ca*eppalm(ldeg+1,istp,id-1)
     &                           -cb*eppalm(ldeg-1,istp,id-1)
              enddo
              do istp=4,5
                urlm(ldeg,istp,id)=urlm(ldeg,istp,id-1)
     &                      -ca*urlm(ldeg+1,istp,id-1)
     &                      -cb*urlm(ldeg-1,istp,id-1)
                utlm(ldeg,istp,id)=utlm(ldeg,istp,id-1)
     &                      -ca*utlm(ldeg+1,istp,id-1)
     &                      -cb*utlm(ldeg-1,istp,id-1)
                uplm(ldeg,istp,id)=uplm(ldeg,istp,id-1)
     &                      -ca*uplm(ldeg+1,istp,id-1)
     &                      -cb*uplm(ldeg-1,istp,id-1)
                grlm(ldeg,istp,id)=grlm(ldeg,istp,id-1)
     &                      -ca*grlm(ldeg+1,istp,id-1)
     &                      -cb*grlm(ldeg-1,istp,id-1)
                gtlm(ldeg,istp,id)=gtlm(ldeg,istp,id-1)
     &                      -ca*gtlm(ldeg+1,istp,id-1)
     &                      -cb*gtlm(ldeg-1,istp,id-1)
                gplm(ldeg,istp,id)=gplm(ldeg,istp,id-1)
     &                      -ca*gplm(ldeg+1,istp,id-1)
     &                      -cb*gplm(ldeg-1,istp,id-1)
                errlm(ldeg,istp,id)=errlm(ldeg,istp,id-1)
     &                       -ca*errlm(ldeg+1,istp,id-1)
     &                       -cb*errlm(ldeg-1,istp,id-1)
                ertlm(ldeg,istp,id)=ertlm(ldeg,istp,id-1)
     &                       -ca*ertlm(ldeg+1,istp,id-1)
     &                       -cb*ertlm(ldeg-1,istp,id-1)
                erplm(ldeg,istp,id)=erplm(ldeg,istp,id-1)
     &                       -ca*erplm(ldeg+1,istp,id-1)
     &                       -cb*erplm(ldeg-1,istp,id-1)
                etrlm(ldeg,istp,id)=etrlm(ldeg,istp,id-1)
     &                       -ca*etrlm(ldeg+1,istp,id-1)
     &                       -cb*etrlm(ldeg-1,istp,id-1)
                ett0lm(ldeg,istp,id)=ett0lm(ldeg,istp,id-1)
     &                        -ca*ett0lm(ldeg+1,istp,id-1)
     &                        -cb*ett0lm(ldeg-1,istp,id-1)
                etp0lm(ldeg,istp,id)=etp0lm(ldeg,istp,id-1)
     &                        -ca*etp0lm(ldeg+1,istp,id-1)
     &                        -cb*etp0lm(ldeg-1,istp,id-1)
                eprlm(ldeg,istp,id)=eprlm(ldeg,istp,id-1)
     &                       -ca*eprlm(ldeg+1,istp,id-1)
     &                       -cb*eprlm(ldeg-1,istp,id-1)
                ept0lm(ldeg,istp,id)=ept0lm(ldeg,istp,id-1)
     &                        -ca*ept0lm(ldeg+1,istp,id-1)
     &                        -cb*ept0lm(ldeg-1,istp,id-1)
                epp0lm(ldeg,istp,id)=epp0lm(ldeg,istp,id-1)
     &                        -ca*epp0lm(ldeg+1,istp,id-1)
     &                        -cb*epp0lm(ldeg-1,istp,id-1)
              enddo
            enddo
c
c           m = 2
c
            do ldeg=0,1
              do istp=4,5
                ettalm(ldeg,istp,id)=(0.d0,0.d0)
                ettblm(ldeg,istp,id)=(0.d0,0.d0)
                etpalm(ldeg,istp,id)=(0.d0,0.d0)
                etpblm(ldeg,istp,id)=(0.d0,0.d0)
                eptalm(ldeg,istp,id)=(0.d0,0.d0)
                eptblm(ldeg,istp,id)=(0.d0,0.d0)
                eppalm(ldeg,istp,id)=(0.d0,0.d0)
                eppblm(ldeg,istp,id)=(0.d0,0.d0)
              enddo
c
              urlm(ldeg,6,id)=(0.d0,0.d0)
              utlm(ldeg,6,id)=(0.d0,0.d0)
              uplm(ldeg,6,id)=(0.d0,0.d0)
              grlm(ldeg,6,id)=(0.d0,0.d0)
              gtlm(ldeg,6,id)=(0.d0,0.d0)
              gplm(ldeg,6,id)=(0.d0,0.d0)
              errlm(ldeg,6,id)=(0.d0,0.d0)
              ertlm(ldeg,6,id)=(0.d0,0.d0)
              erplm(ldeg,6,id)=(0.d0,0.d0)
              etrlm(ldeg,6,id)=(0.d0,0.d0)
              ett0lm(ldeg,6,id)=(0.d0,0.d0)
              ettalm(ldeg,6,id)=(0.d0,0.d0)
              ettblm(ldeg,6,id)=(0.d0,0.d0)
              etp0lm(ldeg,6,id)=(0.d0,0.d0)
              etpalm(ldeg,6,id)=(0.d0,0.d0)
              eprlm(ldeg,6,id)=(0.d0,0.d0)
              ept0lm(ldeg,6,id)=(0.d0,0.d0)
              eptalm(ldeg,6,id)=(0.d0,0.d0)
              epp0lm(ldeg,6,id)=(0.d0,0.d0)
              eppalm(ldeg,6,id)=(0.d0,0.d0)
              eppblm(ldeg,6,id)=(0.d0,0.d0)
            enddo
c
            do ldeg=2,ldegf-1-id
              ca=dcmplx(dble(ldeg+3)/dble(2*ldeg+3),0.d0)
              cb=dcmplx(dble(ldeg-2)/dble(2*ldeg-1),0.d0)
              do istp=4,5
                ettalm(ldeg,istp,id)=ettalm(ldeg,istp,id-1)
     &                        -ca*ettalm(ldeg+1,istp,id-1)
     &                        -cb*ettalm(ldeg-1,istp,id-1)
                ettblm(ldeg,istp,id)=ettblm(ldeg,istp,id-1)
     &                        -ca*ettblm(ldeg+1,istp,id-1)
     &                        -cb*ettblm(ldeg-1,istp,id-1)
                etpalm(ldeg,istp,id)=etpalm(ldeg,istp,id-1)
     &                        -ca*etpalm(ldeg+1,istp,id-1)
     &                        -cb*etpalm(ldeg-1,istp,id-1)
                etpblm(ldeg,istp,id)=etpblm(ldeg,istp,id-1)
     &                        -ca*etpblm(ldeg+1,istp,id-1)
     &                        -cb*etpblm(ldeg-1,istp,id-1)
                eptalm(ldeg,istp,id)=eptalm(ldeg,istp,id-1)
     &                        -ca*eptalm(ldeg+1,istp,id-1)
     &                        -cb*eptalm(ldeg-1,istp,id-1)
                eptblm(ldeg,istp,id)=eptblm(ldeg,istp,id-1)
     &                        -ca*eptblm(ldeg+1,istp,id-1)
     &                        -cb*eptblm(ldeg-1,istp,id-1)
                eppalm(ldeg,istp,id)=eppalm(ldeg,istp,id-1)
     &                        -ca*eppalm(ldeg+1,istp,id-1)
     &                        -cb*eppalm(ldeg-1,istp,id-1)
                eppblm(ldeg,istp,id)=eppblm(ldeg,istp,id-1)
     &                        -ca*eppblm(ldeg+1,istp,id-1)
     &                        -cb*eppblm(ldeg-1,istp,id-1)
              enddo
c
              urlm(ldeg,6,id)=urlm(ldeg,6,id-1)
     &                    -ca*urlm(ldeg+1,6,id-1)
     &                    -cb*urlm(ldeg-1,6,id-1)
              utlm(ldeg,6,id)=utlm(ldeg,6,id-1)
     &                    -ca*utlm(ldeg+1,6,id-1)
     &                    -cb*utlm(ldeg-1,6,id-1)
              uplm(ldeg,6,id)=uplm(ldeg,6,id-1)
     &                    -ca*uplm(ldeg+1,6,id-1)
     &                    -cb*uplm(ldeg-1,6,id-1)
              grlm(ldeg,6,id)=grlm(ldeg,6,id-1)
     &                    -ca*grlm(ldeg+1,6,id-1)
     &                    -cb*grlm(ldeg-1,6,id-1)
              gtlm(ldeg,6,id)=gtlm(ldeg,6,id-1)
     &                    -ca*gtlm(ldeg+1,6,id-1)
     &                    -cb*gtlm(ldeg-1,6,id-1)
              gplm(ldeg,6,id)=gplm(ldeg,6,id-1)
     &                    -ca*gplm(ldeg+1,6,id-1)
     &                    -cb*gplm(ldeg-1,6,id-1)
              errlm(ldeg,6,id)=errlm(ldeg,6,id-1)
     &                     -ca*errlm(ldeg+1,6,id-1)
     &                     -cb*errlm(ldeg-1,6,id-1)
              ertlm(ldeg,6,id)=ertlm(ldeg,6,id-1)
     &                     -ca*ertlm(ldeg+1,6,id-1)
     &                     -cb*ertlm(ldeg-1,6,id-1)
              erplm(ldeg,6,id)=erplm(ldeg,6,id-1)
     &                     -ca*erplm(ldeg+1,6,id-1)
     &                     -cb*erplm(ldeg-1,6,id-1)
              etrlm(ldeg,6,id)=etrlm(ldeg,6,id-1)
     &                     -ca*etrlm(ldeg+1,6,id-1)
     &                     -cb*etrlm(ldeg-1,6,id-1)
              ett0lm(ldeg,6,id)=ett0lm(ldeg,6,id-1)
     &                      -ca*ett0lm(ldeg+1,6,id-1)
     &                      -cb*ett0lm(ldeg-1,6,id-1)
              ettalm(ldeg,6,id)=ettalm(ldeg,6,id-1)
     &                      -ca*ettalm(ldeg+1,6,id-1)
     &                      -cb*ettalm(ldeg-1,6,id-1)
              ettblm(ldeg,6,id)=ettblm(ldeg,6,id-1)
     &                      -ca*ettblm(ldeg+1,6,id-1)
     &                      -cb*ettblm(ldeg-1,6,id-1)
              etp0lm(ldeg,6,id)=etp0lm(ldeg,6,id-1)
     &                      -ca*etp0lm(ldeg+1,6,id-1)
     &                      -cb*etp0lm(ldeg-1,6,id-1)
              etpalm(ldeg,6,id)=etpalm(ldeg,6,id-1)
     &                      -ca*etpalm(ldeg+1,6,id-1)
     &                      -cb*etpalm(ldeg-1,6,id-1)
              eprlm(ldeg,6,id)=eprlm(ldeg,6,id-1)
     &                     -ca*eprlm(ldeg+1,6,id-1)
     &                     -cb*eprlm(ldeg-1,6,id-1)
              ept0lm(ldeg,6,id)=ept0lm(ldeg,6,id-1)
     &                      -ca*ept0lm(ldeg+1,6,id-1)
     &                      -cb*ept0lm(ldeg-1,6,id-1)
              eptalm(ldeg,6,id)=eptalm(ldeg,6,id-1)
     &                      -ca*eptalm(ldeg+1,6,id-1)
     &                      -cb*eptalm(ldeg-1,6,id-1)
              epp0lm(ldeg,6,id)=epp0lm(ldeg,6,id-1)
     &                      -ca*epp0lm(ldeg+1,6,id-1)
     &                      -cb*epp0lm(ldeg-1,6,id-1)
              eppalm(ldeg,6,id)=eppalm(ldeg,6,id-1)
     &                      -ca*eppalm(ldeg+1,6,id-1)
     &                      -cb*eppalm(ldeg-1,6,id-1)
              eppblm(ldeg,6,id)=eppblm(ldeg,6,id-1)
     &                      -ca*eppblm(ldeg+1,6,id-1)
     &                      -cb*eppblm(ldeg-1,6,id-1)
            enddo
          enddo
c
          do is=isg1(ig),isg2(ig)
            wavelet=wvf(lf,is)
     &             *cdexp(-dcmplx(-fi,f)*dcmplx(PI2*togs(is),0.d0))
            do ir=1,nr
              id=idr(is,ir)
c
              call taper(ldegtap(1,is,ir),ldegtap(4,is,ir),tap(0))
c
              call legendre(dis(is,ir),plm,ldegtap(4,is,ir),ldegmax)
c
              do ldeg=ldegtap(1,is,ir),ldegtap(4,is,ir)
c
                cfac=dcmplx(tap(ldeg),0.d0)*wavelet
                if(id.gt.0)cfac=cfac/ssf(is,ir)**id
c
                cp0=dcmplx(plm(ldeg,0),0.d0)*cfac
                cp1=dcmplx(plm(ldeg,1),0.d0)*cfac
                cp2=dcmplx(plm(ldeg,2),0.d0)*cfac
c
                dur=sf3(is)*urlm(ldeg,1,id)*cp0
     &             +expl(is)*urlm(ldeg,2,id)*cp0
     &             +clvd(is)*urlm(ldeg,3,id)*cp0
     &             +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &              *urlm(ldeg,4,id)*cp1*ssd(is,ir)
     &             +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &              *urlm(ldeg,5,id)*cp1*ssd(is,ir)
     &             +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &              *urlm(ldeg,6,id)*cp2*ssd(is,ir)**2
c
                dut=sf3(is)*utlm(ldeg,1,id)*cp1*ssd(is,ir)
     &             +expl(is)*utlm(ldeg,2,id)*cp1*ssd(is,ir)
     &             +clvd(is)*utlm(ldeg,3,id)*cp1*ssd(is,ir)
     &             +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &              *utlm(ldeg,4,id)*cp1
     &             +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &              *utlm(ldeg,5,id)*cp1
     &             +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &              *utlm(ldeg,6,id)*cp2*ssd(is,ir)
c
                dup=(sf1(is)*ssa(is,ir)-sf2(is)*csa(is,ir))
     &              *uplm(ldeg,4,id)*cp1
     &             +(ds31(is)*ssa(is,ir)-ds23(is)*csa(is,ir))
     &              *uplm(ldeg,5,id)*cp1
     &             +(ss12(is)*cs2a(is,ir)-ss11(is)*ss2a(is,ir))
     &              *uplm(ldeg,6,id)*cp2*ssd(is,ir)
c
                dgr=sf3(is)*grlm(ldeg,1,id)*cp0
     &             +expl(is)*grlm(ldeg,2,id)*cp0
     &             +clvd(is)*grlm(ldeg,3,id)*cp0
     &             +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &              *grlm(ldeg,4,id)*cp1*ssd(is,ir)
     &             +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &              *grlm(ldeg,5,id)*cp1*ssd(is,ir)
     &             +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &              *grlm(ldeg,6,id)*cp2*ssd(is,ir)**2
c
                dgt=sf3(is)*gtlm(ldeg,1,id)*cp1*ssd(is,ir)
     &             +expl(is)*gtlm(ldeg,2,id)*cp1*ssd(is,ir)
     &             +clvd(is)*gtlm(ldeg,3,id)*cp1*ssd(is,ir)
     &             +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &              *gtlm(ldeg,4,id)*cp1
     &             +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &              *gtlm(ldeg,5,id)*cp1
     &             +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &              *gtlm(ldeg,6,id)*cp2*ssd(is,ir)
c
                dgp=(sf1(is)*ssa(is,ir)-sf2(is)*csa(is,ir))
     &              *gplm(ldeg,4,id)*cp1
     &             +(ds31(is)*ssa(is,ir)-ds23(is)*csa(is,ir))
     &              *gplm(ldeg,5,id)*cp1
     &             +(ss12(is)*cs2a(is,ir)-ss11(is)*ss2a(is,ir))
     &              *gplm(ldeg,6,id)*cp2*ssd(is,ir)
c
                urdr=sf3(is)*errlm(ldeg,1,id)*cp0
     &              +expl(is)*errlm(ldeg,2,id)*cp0
     &              +clvd(is)*errlm(ldeg,3,id)*cp0
     &              +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &               *errlm(ldeg,4,id)*cp1*ssd(is,ir)
     &              +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &               *errlm(ldeg,5,id)*cp1*ssd(is,ir)
     &              +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &               *errlm(ldeg,6,id)*cp2*ssd(is,ir)**2
c
                urdt=sf3(is)*ertlm(ldeg,1,id)*cp1*ssd(is,ir)
     &              +expl(is)*ertlm(ldeg,2,id)*cp1*ssd(is,ir)
     &              +clvd(is)*ertlm(ldeg,3,id)*cp1*ssd(is,ir)
     &              +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &               *ertlm(ldeg,4,id)*cp1
     &              +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &               *ertlm(ldeg,5,id)*cp1
     &              +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &               *ertlm(ldeg,6,id)*cp2*ssd(is,ir)
c
                urdp=(sf1(is)*ssa(is,ir)-sf2(is)*csa(is,ir))
     &               *erplm(ldeg,4,id)*cp1
     &              +(ds31(is)*ssa(is,ir)-ds23(is)*csa(is,ir))
     &               *erplm(ldeg,5,id)*cp1
     &              +(ss12(is)*cs2a(is,ir)-ss11(is)*ss2a(is,ir))
     &               *erplm(ldeg,6,id)*cp2*ssd(is,ir)
c
                utdr=sf3(is)*etrlm(ldeg,1,id)*cp1*ssd(is,ir)
     &              +expl(is)*etrlm(ldeg,2,id)*cp1*ssd(is,ir)
     &              +clvd(is)*etrlm(ldeg,3,id)*cp1*ssd(is,ir)
     &              +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &               *etrlm(ldeg,4,id)*cp1
     &              +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &               *etrlm(ldeg,5,id)*cp1
     &              +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &               *etrlm(ldeg,6,id)*cp2*ssd(is,ir)
c
                utdt=sf3(is)*(ett0lm(ldeg,1,id)*cp0
     &                       +ettalm(ldeg,1,id)*cp1*csd(is,ir))
     &              +expl(is)*(ett0lm(ldeg,2,id)*cp0
     &                        +ettalm(ldeg,2,id)*cp1*csd(is,ir))
     &              +clvd(is)*(ett0lm(ldeg,3,id)*cp0
     &                        +ettalm(ldeg,3,id)*cp1*csd(is,ir))
     &              +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &               *(ett0lm(ldeg,4,id)*cp1*ssd(is,ir)
     &                +ettalm(ldeg,4,id)*cp2*ssd(is,ir)*csd(is,ir)
     &                +ettblm(ldeg,4,id)*cp2*ssd(is,ir))
     &              +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &               *(ett0lm(ldeg,5,id)*cp1*ssd(is,ir)
     &                +ettalm(ldeg,5,id)*cp2*ssd(is,ir)*csd(is,ir)
     &                +ettblm(ldeg,5,id)*cp2*ssd(is,ir))
     &              +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &               *(ett0lm(ldeg,6,id)*cp2*ssd(is,ir)**2
     &                +ettalm(ldeg,6,id)*cp2*csd(is,ir)
     &                +ettblm(ldeg,6,id)*cp2)
c
                utdp=(sf1(is)*ssa(is,ir)-sf2(is)*csa(is,ir))
     &               *(etp0lm(ldeg,4,id)*cp1*ssd(is,ir)
     &                +etpalm(ldeg,4,id)*cp2*ssd(is,ir)
     &                +etpblm(ldeg,4,id)*cp2*ssd(is,ir)*csd(is,ir))
     &              +(ds31(is)*ssa(is,ir)-ds23(is)*csa(is,ir))
     &               *(etp0lm(ldeg,5,id)*cp1*ssd(is,ir)
     &                +etpalm(ldeg,5,id)*cp2*ssd(is,ir)
     &                +etpblm(ldeg,5,id)*cp2*ssd(is,ir)*csd(is,ir))
     &              +(ss12(is)*cs2a(is,ir)-ss11(is)*ss2a(is,ir))
     &               *(etp0lm(ldeg,6,id)*cp2
     &                +etpalm(ldeg,6,id)*cp2*csd(is,ir))
c
                updr=(sf1(is)*ssa(is,ir)-sf2(is)*csa(is,ir))
     &               *eprlm(ldeg,4,id)*cp1
     &              +(ds31(is)*ssa(is,ir)-ds23(is)*csa(is,ir))
     &               *eprlm(ldeg,5,id)*cp1
     &              +(ss12(is)*cs2a(is,ir)-ss11(is)*ss2a(is,ir))
     &               *eprlm(ldeg,6,id)*cp2*ssd(is,ir)
c
                updt=(sf1(is)*ssa(is,ir)-sf2(is)*csa(is,ir))
     &               *(ept0lm(ldeg,4,id)*cp1*ssd(is,ir)
     &                +eptalm(ldeg,4,id)*cp2*ssd(is,ir)*csd(is,ir)
     &                +eptblm(ldeg,4,id)*cp2*ssd(is,ir))
     &              +(ds31(is)*ssa(is,ir)-ds23(is)*csa(is,ir))
     &               *(ept0lm(ldeg,5,id)*cp1*ssd(is,ir)
     &                +eptalm(ldeg,5,id)*cp2*ssd(is,ir)*csd(is,ir)
     &                +eptblm(ldeg,5,id)*cp2*ssd(is,ir))
     &              +(ss12(is)*cs2a(is,ir)-ss11(is)*ss2a(is,ir))
     &               *(ept0lm(ldeg,6,id)*cp2*csd(is,ir)
     &                +eptalm(ldeg,6,id)*cp2)
c
                updp=sf3(is)*(epp0lm(ldeg,1,id)*cp0
     &                       +eppalm(ldeg,1,id)*cp1*csd(is,ir))
     &              +expl(is)*(epp0lm(ldeg,2,id)*cp0
     &                        +eppalm(ldeg,2,id)*cp1*csd(is,ir))
     &              +clvd(is)*(epp0lm(ldeg,3,id)*cp0
     &                        +eppalm(ldeg,3,id)*cp1*csd(is,ir))
     &              +(sf1(is)*csa(is,ir)+sf2(is)*ssa(is,ir))
     &               *(epp0lm(ldeg,4,id)*cp1*ssd(is,ir)
     &                +eppalm(ldeg,4,id)*cp2*ssd(is,ir)*csd(is,ir)
     &                +eppblm(ldeg,4,id)*cp2*ssd(is,ir))
     &              +(ds31(is)*csa(is,ir)+ds23(is)*ssa(is,ir))
     &               *(epp0lm(ldeg,5,id)*cp1*ssd(is,ir)
     &                +eppalm(ldeg,5,id)*cp2*ssd(is,ir)*csd(is,ir)
     &                +eppblm(ldeg,5,id)*cp2*ssd(is,ir))
     &              +(ss12(is)*ss2a(is,ir)+ss11(is)*cs2a(is,ir))
     &               *(epp0lm(ldeg,6,id)*cp2*ssd(is,ir)**2
     &                +eppalm(ldeg,6,id)*cp2*csd(is,ir)
     &                +eppblm(ldeg,6,id)*cp2)
c
                ue(lf,ir)=ue(lf,ir)+dut*ssb(is,ir)+dup*csb(is,ir)
                un(lf,ir)=un(lf,ir)-dut*csb(is,ir)+dup*ssb(is,ir)
                uz(lf,ir)=uz(lf,ir)+dur
c
                ge(lf,ir)=ge(lf,ir)+dgt*ssb(is,ir)+dgp*csb(is,ir)
                gn(lf,ir)=gn(lf,ir)-dgt*csb(is,ir)+dgp*ssb(is,ir)
                gz(lf,ir)=gz(lf,ir)+dgr
c
                roe(lf,ir)=roe(lf,ir)+(0.5d0,0.d0)
     &              *( (urdp-updr)*ssb(is,ir)+(utdr-urdt)*csb(is,ir))
                ron(lf,ir)=ron(lf,ir)+(0.5d0,0.d0)
     &              *(-(urdp-updr)*csb(is,ir)+(utdr-urdt)*ssb(is,ir))
                roz(lf,ir)=roz(lf,ir)+(0.5d0,0.d0)*(updt-utdp)
c
                rot(1,1)=ssb(is,ir)
                rot(1,2)=csb(is,ir)
                rot(1,3)=(0.d0,0.d0)
                rot(2,1)=-csb(is,ir)
                rot(2,2)=ssb(is,ir)
                rot(2,3)=(0.d0,0.d0)
                rot(3,1)=(0.d0,0.d0)
                rot(3,2)=(0.d0,0.d0)
                rot(3,3)=(1.d0,0.d0)
c
                rtz(1,1)=utdt
                rtz(1,2)=(0.5d0,0.d0)*(utdp+updt)
                rtz(1,3)=(0.5d0,0.d0)*(utdr+urdt)
                rtz(2,1)=(0.5d0,0.d0)*(updt+utdp)
                rtz(2,2)=updp
                rtz(2,3)=(0.5d0,0.d0)*(updr+urdp)
                rtz(3,1)=(0.5d0,0.d0)*(urdt+utdr)
                rtz(3,2)=(0.5d0,0.d0)*(urdp+updr)
                rtz(3,3)=urdr
c
                do i=1,3
                  do j=1,3
                    swp(i,j)=(0.d0,0.d0)
                    do k=1,3
                      swp(i,j)=swp(i,j)+rot(i,k)*rtz(k,j)
                    enddo
                  enddo
                enddo
                do i=1,3
                  do j=1,3
                    enz(i,j)=(0.d0,0.d0)
                    do k=1,3
                      enz(i,j)=enz(i,j)+swp(i,k)*rot(j,k)
                    enddo
                  enddo
                enddo
c
                uee(lf,ir)=uee(lf,ir)+enz(1,1)
                uen(lf,ir)=uen(lf,ir)+enz(1,2)
                uez(lf,ir)=uez(lf,ir)+enz(1,3)
                unn(lf,ir)=unn(lf,ir)+enz(2,2)
                unz(lf,ir)=unz(lf,ir)+enz(2,3)
                uzz(lf,ir)=uzz(lf,ir)+enz(3,3)
c
                eii=enz(1,1)+enz(2,2)+enz(3,3)
c
                see(lf,ir)=see(lf,ir)
     &                    +lamr*eii+(2.d0,0.d0)*muer*enz(1,1)
                sen(lf,ir)=sen(lf,ir)
     &                    +(2.d0,0.d0)*muer*enz(1,2)
                sez(lf,ir)=sez(lf,ir)
     &                    +(2.d0,0.d0)*muer*enz(1,3)
                snn(lf,ir)=snn(lf,ir)
     &                    +lamr*eii+(2.d0,0.d0)*muer*enz(2,2)
                snz(lf,ir)=snz(lf,ir)
     &                    +(2.d0,0.d0)*muer*enz(2,3)
                szz(lf,ir)=szz(lf,ir)
     &                    +lamr*eii+(2.d0,0.d0)*muer*enz(3,3)
c
              enddo
            enddo
          enddo
          write(*,'(i6,a,f10.4,3(a,i5))')lf,'.',1.0d+03*f,
     &                        ' mHz: spectra read: ',ldegf,
     &                        ', used: ',ldeglw,' - ',ldegneed
        enddo
c
        close(21)
        close(22)
        close(23)
        close(24)
        close(25)
        close(26)
        close(27)
        close(28)
        write(*,'(i6,a)')lf-1,' spectra read from '
     &                      //specfile(ig)(1:40)
500     continue
      enddo
c
      deallocate(plm,tap,ldegtap,wvf,
     &           expl,clvd,ss12,ss11,ds31,ds23,sf1,sf2,sf3,sfr,sft,sfp,
     &           mrr,mtt,mpp,mrt,mtp,lats,lons,deps,togs,trss,
     &           ul0,vl0,wl0,el0,fl0,gl0,pl0,ql0,
     &           urlm,utlm,uplm,errlm,ertlm,erplm,
     &           ett0lm,ettalm,ettblm,etp0lm,etpalm,etpblm,eprlm,
     &           ept0lm,eptalm,eptblm,epp0lm,eppalm,eppblm,
     &           lyupp,lyups,lyupt,lylwp,lylws,lylwt,
     &           grndep,grnsel,lygrn,
     &           specfile,uspecfile,vspecfile,wspecfile,
     &           especfile,fspecfile,gspecfile,pspecfile,qspecfile,
     &           isg1,isg2,nsg)
c
      return
      end

c*******************************************************************************
c*******************************************************************************
        subroutine edghask(hk,m,k,z,n)
        implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
        integer m,n
        double precision k,z
        double precision hk(m,m)
c
	include 'edgglobal.h'
c
c
c       n0: number of model layer
c
        integer n0
        double precision h(lmax),ro(lmax),vp(lmax),vs(lmax)
        common /model/ h,ro,vp,vs,n0
c
	double precision eps0
	data eps0/1.0d-03/
c
	double precision k2,x,x2,la,mu
        double precision ex,ch,sh,eta
c
        k2=k*k
	x=k*z
	x2=x*x
	mu=ro(n)*vs(n)**2
	la=ro(n)*vp(n)**2-2.d0*mu
	ex=dexp(x)
c
c	ch=(e^x+1/e^x)/2
c	sh=(e^x-1/e^x)/2x
c
	ch=0.5d0*(ex+1.d0/ex)
	if(dabs(x).le.eps0)then
	  sh=1.d0+x2/6.d0*(1.d0+x2/20.d0)
	else
	  sh=0.5d0*(ex-1.d0/ex)/x
	endif
c
	if(m.eq.2)then
c
c	  propagator matrix for SH waves
c
	  hk(1,1)=ch
	  hk(1,2)=z*sh/mu
	  hk(2,1)=k*x*sh*mu
	  hk(2,2)=ch
	else if(m.eq.4)then
c
c	  propagatior matrix for P-SV waves.
c
	  eta=mu/(la+mu)
	  hk(1,1)=ch-x2*sh/(1.d0+eta)
	  hk(1,2)=0.5d0*z*(-ch+(1.d0+2.d0*eta)*sh)/(1.d0+eta)/mu
	  hk(1,3)=x*(ch-eta*sh)/(1.d0+eta)
	  hk(1,4)=x2*sh/(1.d0+eta)
	  hk(2,1)=2.d0*mu*k*x*(-ch+sh)/(1.d0+eta)
	  hk(2,2)=hk(1,1)
	  hk(2,3)=2.d0*mu*k*hk(1,4)
	  hk(2,4)=x*(ch+eta*sh)/(1.d0+eta)
	  hk(3,1)=-hk(2,4)
	  hk(3,2)=-0.5d0*x*z*sh/(1.d0+eta)/mu
	  hk(3,3)=ch+x2*sh/(1.d0+eta)
	  hk(3,4)=0.5d0*z*(ch+(1.d0+2.d0*eta)*sh)/(1.d0+eta)/mu
	  hk(4,1)=-hk(2,3)
	  hk(4,2)=-hk(1,3)
	  hk(4,3)=2.d0*mu*k*x*(ch+sh)/(1.d0+eta)
	  hk(4,4)=hk(3,3)
	else
	  stop ' Error in haskell: m schould be 2 or 4!'
	endif
c
	return
	end

	subroutine okada(ns,NSMAX,nrec,NRECMAX,lambda,mu,dislocations,
     &                 xs,ys,zs,lengths,widths,strikes,dips,rakes,
     &                 xrec,yrec,zrec0,disp,strain,tilt)
	implicit none
c
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
        integer ns,NSMAX,nrec,NRECMAX
        double precision lambda,mu
        double precision dislocations(NSMAX)
        double precision xs(NSMAX),ys(NSMAX),zs(NSMAX)
        double precision lengths(NSMAX),widths(NSMAX)
        double precision strikes(NSMAX),dips(NSMAX),rakes(NSMAX)
        double precision xrec(NRECMAX),yrec(NRECMAX)
        double precision zrec0
        double precision disp(NRECMAX,3)
        double precision strain(NRECMAX,6),tilt(NRECMAX,2)
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c       ns = the really used number of rectangular sources
c       NSMAX = the upper limit of ns
c       nrec = the really used number of observation positions
c       NRECMAX = the upper limit of nrec
c
c       lambda, mu = the two Lame constants in Pascal (SI unit)
c
c       (xs,ys,zs) = coordinates of the start point of strike
c       with x = north, y = east, z = downward.
c       all angles in degree.
c       (xrec,yrec,zrec0) = cartesian coordinates of observations
c             Note zrec0 is a fixed constant
c       disp = 3 displacement components: ux,uy,uz
c       strain = 6 strain components: exx,eyy,ezz,exy,eyz,ezx
c       tilt = 2 vertical tilt components: dux/dz, duy/dz
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c
c	from Okada's subroutine DC3D0:
c
	INTEGER IRET
	REAL*4 ALPHA,X,Y,Z,DEPTH,DIP,POT1,POT2,POT3,POT4,
     &         UX,UY,UZ,UXX,UYX,UZX,UXY,UYY,UZY,UXZ,UYZ,UZZ
c
c	more from Okada's subroutine DC3D:
c
	REAL*4 AL1,AL2,AW1,AW2,DISL1,DISL2,DISL3
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c
c	LOCAL CONSTANTS
c	===============
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision degtorad,eps
	data degtorad,eps/1.745329252E-02,1.0d-06/
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c
c	LOCAL WORK SPACES
c	=================
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	integer j,is,irec
	double precision st,di,ra
	double precision csst,ssst,csra,ssra,csdi,ssdi
	double precision cs2st,ss2st
	double precision disp0(3),tilt0(2),strain0(6)
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c
c	PROCESSING
c	==========
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c
c	receiver and source independent variables
c
	ALPHA=sngl((lambda+mu)/(lambda+2.d0*mu))
	POT3=0.0
	POT4=0.0
	DISL3=0.0
	AL1=0.0
	AW2=0.0
	Z=-zrec0
c
	do 901 irec=1,nrec
c
c	  initialization
c
	  do j=1,6
            strain(irec,j)=0.d0
	  enddo
	  do j=1,3
            disp(irec,j)=0.d0
	  enddo
	  do j=1,2
            tilt(irec,j)=0.d0
	  enddo
c
	  do 900 is=1,ns
c
	    st=strikes(is)*degtorad
            csst=dcos(st)
            ssst=dsin(st)
            cs2st=dcos(2.d0*st)
            ss2st=dsin(2.d0*st)
c
	    di=dips(is)*degtorad
            csdi=dcos(di)
            ssdi=dsin(di)
c
	    ra=rakes(is)*degtorad
            csra=dcos(ra)
            ssra=dsin(ra)
c
c	    transform from Aki's to Okada's system
c
            X=sngl((xrec(irec)-xs(is))*csst+(yrec(irec)-ys(is))*ssst)
            Y=sngl((xrec(irec)-xs(is))*ssst-(yrec(irec)-ys(is))*csst)
	    DEPTH=sngl(zs(is))
	    DIP=sngl(dips(is))
c
	    if(lengths(is).eq.0.d0.and.widths(is).eq.0.d0)then
c
c	      point source
c
	      POT1=sngl(dislocations(is)*csra)
	      POT2=sngl(dislocations(is)*ssra)
	      IRET=1
	      call DC3D0(ALPHA,X,Y,Z,DEPTH,DIP,POT1,POT2,POT3,POT4,
     *             UX,UY,UZ,UXX,UYX,UZX,UXY,UYY,UZY,UXZ,UYZ,UZZ,IRET)
c	      if(IRET.eq.1)then
c	        stop ' There is a problem in Okada subroutine!'
c	      endif
	    else
c
c	      finite source
c
	      AL2=sngl(lengths(is))
	      AW1=-sngl(widths(is))
	      DISL1=sngl(dislocations(is)*csra)
	      DISL2=sngl(dislocations(is)*ssra)
	      if(lengths(is).eq.0.d0)then
	        AL2=sngl(widths(is)*eps)
	        DISL1=DISL1/AL2
	        DISL2=DISL2/AL2
	      else if(widths(is).eq.0.d0)then
	        AW1=-sngl(lengths(is)*eps)
	        DISL1=DISL1/(-AW1)
	        DISL2=DISL2/(-AW1)
	      endif
	      IRET=1
	      call DC3D(ALPHA,X,Y,Z,DEPTH,DIP,AL1,AL2,AW1,AW2,
     *             DISL1,DISL2,DISL3,UX,UY,UZ,
     *             UXX,UYX,UZX,UXY,UYY,UZY,UXZ,UYZ,UZZ,IRET)
c	      if(IRET.eq.1)then
c	        stop ' There is a problem in Okada subroutine!'
c	      endif
	    endif
c
c	    transform from Okada's to Aki's system
c
            disp0(1)=dble(UX)*csst+dble(UY)*ssst
            disp0(2)=dble(UX)*ssst-dble(UY)*csst
	    disp0(3)=-dble(UZ)
c
            tilt0(1)=-(dble(UXZ)*csst+dble(UYZ)*ssst)
            tilt0(2)=-(dble(UXZ)*ssst-dble(UYZ)*csst)
c
            strain0(1)=dble(UXX)*csst*csst+dble(UYY)*ssst*ssst
     &                +0.5d0*dble(UXY+UYX)*ss2st
            strain0(2)=dble(UXX)*ssst*ssst+dble(UYY)*csst*csst
     &                -0.5d0*dble(UXY+UYX)*ss2st
            strain0(3)=dble(UZZ)
            strain0(4)=0.5d0*dble(UXX-UYY)*ss2st
     &                -0.5d0*dble(UXY+UYX)*cs2st
            strain0(5)=-0.5d0*dble(UZX+UXZ)*ssst
     &                 +0.5d0*dble(UYZ+UZY)*csst
            strain0(6)=-0.5d0*dble(UZX+UXZ)*csst
     &                 -0.5d0*dble(UYZ+UZY)*ssst
c
            do j=1,3
              disp(irec,j)=   disp(irec,j)   + disp0(j)
            enddo
            do j=1,2
              tilt(irec,j)=   tilt(irec,j)   + tilt0(j)
            enddo
            do j=1,6
              strain(irec,j)= strain(irec,j) + strain0(j)
            enddo
900	  continue
901     continue
c
	return
	end

      subroutine qpfftinv(ierr)
      use qpalloc
      implicit none
      integer*4 ierr
c
      integer*4 lf,mf,ir
      real*8 f,t
c
      real*8,allocatable:: y0(:),y(:),dswap(:)
      complex*16,allocatable:: cy(:,:),bpf(:),cswap(:)
c
      allocate(y0(nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpfftinv: y0 not allocated!'
      allocate(y(nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpfftinv: y not allocated!'
      allocate(cy(nf,nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpfftinv: cy not allocated!'
      allocate(bpf(nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpfftinv: bpf not allocated!'
      allocate(dswap(4*nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpfftinv: dswap not allocated!'
      allocate(cswap(2*nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpfftinv: cswap not allocated!'
c
      do lf=1,nf
        f=dble(lf-1)*df
        comi=dcmplx(PI2*f,PI2*fi)
        comi2=comi**2
        do ir=1,nr
          gm(lf,ir)=-gz(lf,ir)+(dcmplx(freeairgrd,0.d0)-comi2)*uz(lf,ir)
        enddo
      enddo
c
c     low-pass filter
c
      if(nbpf.gt.0)then
        if(f1corner.le.0.d0)then
          call butterworth(nbpf,f2corner,df,nf,cswap)
        else
          call bandpass(nbpf,f1corner,f2corner,df,nf,cswap)
        endif
        mf=1
        do lf=2*nf,nf+2,-1
          mf=mf+1
          cswap(lf)=dconjg(cswap(mf))
        enddo
        cswap(nf+1)=(0.d0,0.d0)
        call four1w(cswap,dswap,2*nf,+1)
        do lf=1,2*nf
          t=dble(lf-1)*dt
          cswap(lf)=cswap(lf)*dcmplx(dexp(PI2*fi*t)*df,0.d0)
        enddo
        call four1w(cswap,dswap,2*nf,-1)
        do lf=1,nf
          bpf(lf)=cswap(lf)*dcmplx(dt,0.d0)
        enddo
c
        do lf=1,nf
          do ir=1,nr
            ue(lf,ir)=ue(lf,ir)*bpf(lf)
            un(lf,ir)=un(lf,ir)*bpf(lf)
            uz(lf,ir)=uz(lf,ir)*bpf(lf)
c
            ge(lf,ir)=ge(lf,ir)*bpf(lf)
            gn(lf,ir)=gn(lf,ir)*bpf(lf)
            gz(lf,ir)=gz(lf,ir)*bpf(lf)
c
            roe(lf,ir)=roe(lf,ir)*bpf(lf)
            ron(lf,ir)=ron(lf,ir)*bpf(lf)
            roz(lf,ir)=roz(lf,ir)*bpf(lf)
c
            uee(lf,ir)=uee(lf,ir)*bpf(lf)
            uen(lf,ir)=uen(lf,ir)*bpf(lf)
            uez(lf,ir)=uez(lf,ir)*bpf(lf)
            unn(lf,ir)=unn(lf,ir)*bpf(lf)
            unz(lf,ir)=unz(lf,ir)*bpf(lf)
            uzz(lf,ir)=uzz(lf,ir)*bpf(lf)
c
            see(lf,ir)=see(lf,ir)*bpf(lf)
            sen(lf,ir)=sen(lf,ir)*bpf(lf)
            sez(lf,ir)=sez(lf,ir)*bpf(lf)
            snn(lf,ir)=snn(lf,ir)*bpf(lf)
            snz(lf,ir)=snz(lf,ir)*bpf(lf)
            szz(lf,ir)=szz(lf,ir)*bpf(lf)
c
            gm(lf,ir)=gm(lf,ir)*bpf(lf)
          enddo
        enddo
      endif
c
      if(icmp(1).eq.1)then
c
c       output seismograms: displacement vector
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,ue,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,dispout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,un,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,dispout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uz,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,dispout(3))
      endif
      if(icmp(2).eq.1)then
c
c       output seismograms: velocity vector
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,ue,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,veloout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,un,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,veloout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uz,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,veloout(3))
      endif
      if(icmp(3).eq.1)then
c
c       output seismograms: acceleration vector
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,ue,cy,cswap,
     &                 dswap,2,ntcutout,rname,y0,y,acceout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,un,cy,cswap,
     &                 dswap,2,ntcutout,rname,y0,y,acceout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uz,cy,cswap,
     &                 dswap,2,ntcutout,rname,y0,y,acceout(3))
      endif
c
      if(icmp(4).eq.1)then
c
c       output seismograms: strain tensor
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uee,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,strainout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uen,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,strainout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uez,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,strainout(3))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,unn,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,strainout(4))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,unz,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,strainout(5))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uzz,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,strainout(6))
      endif
c
      if(icmp(5).eq.1)then
c
c       output seismograms: strain rate tensor
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uee,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,strainrateout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uen,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,strainrateout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uez,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,strainrateout(3))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,unn,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,strainrateout(4))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,unz,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,strainrateout(5))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,uzz,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,strainrateout(6))
      endif
      if(icmp(6).eq.1)then
c
c       output seismograms: stress tensor
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,see,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,stressout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,sen,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,stressout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,sez,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,stressout(3))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,snn,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,stressout(4))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,snz,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,stressout(5))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,szz,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,stressout(6))
      endif
c
      if(icmp(7).eq.1)then
c
c       output seismograms: stress rate tensor
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,see,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,stressrateout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,sen,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,stressrateout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,sez,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,stressrateout(3))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,snn,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,stressrateout(4))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,snz,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,stressrateout(5))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,szz,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,stressrateout(6))
      endif
c
      if(icmp(8).eq.1)then
c
c       output seismograms: rotation vector
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,roe,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,rotaout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,ron,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,rotaout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,roz,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,rotaout(3))
      endif
c
      if(icmp(9).eq.1)then
c
c       output seismograms: rotation rate vector
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,roe,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,rotarateout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,ron,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,rotarateout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,roz,cy,cswap,
     &                 dswap,1,ntcutout,rname,y0,y,rotarateout(3))
      endif
      if(icmp(10).eq.1)then
c
c       output seismograms: local gravitational acceleration vector
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,ge,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,gravout(1))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,gn,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,gravout(2))
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,gz,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,gravout(3))
      endif
c
      if(icmp(11).eq.1)then
c
c       output seismograms: gravimeter response
c
        call transfs2t(nf,nr,df,togsmin,dt,dtout,fi,tred,gm,cy,cswap,
     &                 dswap,0,ntcutout,rname,y0,y,grmout)
          
      endif
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Function: spbdpsj                                                         c
c     calculates eq.(103) of Takeuchi & Saito related to spherical Bessel       c
c     functions for complex argument                                            c
c                                                                               c
c     Input:                                                                    c
c     n = order                                                                 c
c     x = complex argument                                                      c
c                                                                               c
c     Return:                                                                   c
c     dphj(n,xa,xb)=(phj(n,xa)-phj(n,xb))/(xa^2-xb^2)                           c
c     for |x/2|^2 << n                                                          c
c                                                                               c
c     First implemention: 17 June 2007                                          c
c     Rongjiang Wang                                                            c
c     GeoForschungsZentrum Potsdam, Germany                                     c
c     Email: wang@gfz-potsdam.de                                                c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      complex*16 function spbdphj(n,xa,xb)
      implicit none
	integer*4 n
	complex*16 xa,xb
c
c     local memory
c
      integer*4 i
      complex*16 cxa2,cxb2,fn,gn,ca,cy
c
      real*8 eps
      data eps/1.0d-08/
c
      cxa2=(0.5d0,0.d0)*xa*xa
      cxb2=(0.5d0,0.d0)*xb*xb
c
      i=1
      ca=(1.d0,0.d0)/dcmplx(dble(2*n+3),0.d0)
      gn=-ca
      fn=-ca
      cy=fn
100   i=i+1
      ca=(1.d0,0.d0)/dcmplx(dble((2*(n+i)+1)*i),0.d0)
      gn=-gn*cxb2*ca
      fn=gn-fn*cxa2*ca
      cy=cy+fn
      if(cdabs(fn).gt.eps*cdabs(cy))goto 100
      spbdphj=cy*(0.5d0,0.d0)
      return
      end

      subroutine qpspropg1(ypsv,lyup,lylw)
      use qpalloc
      implicit none
c
c     calculation of response (with gravity) to psv source (l=1)
c     ypsv(6,4): solution vector (complex)
c
      integer*4 lyup,lylw
      complex*16 ypsv(6,4)
c
c     work space
c
      integer*4 i,j,i0,j0,istp,ly,key
      real*8 y4max
      complex*16 cdet,alf,bet,cyabs,cyswap,ca,cb
      complex*16 y0(6,3),yc(6,3),uc(6)
      complex*16 yup(6,3),ylw(6,3),yupc(4,2),ylwc(4,2)
      complex*16 coef6(6,6),b6(6,4),coef4(4,4),b4(4,2)
      external qpdifmat4,qpdifmat6
c
      complex*16 c3
      data c3/(3.d0,0.d0)/
c
c===============================================================================
c
c     propagation from surface to atmosphere/ocean bottom
c
      if(lyob.gt.lyup)then
        do j=1,2
          do i=1,4
            yupc(i,j)=(0.d0,0.d0)
          enddo
        enddo
c
        yupc(1,1)=comi2*crrup(lyup)
        yupc(2,1)=cgrup(lyup)
c
        yupc(2,2)=(1.d0,0.d0)
        yupc(3,2)=-comi2
c
        if(lyr.eq.lyup)then
          do j=1,3
            do i=1,6
              y0(i,j)=(0.d0,0.d0)
            enddo
          enddo
c
          y0(1,1)=yupc(1,1)
          y0(3,1)=yupc(2,1)
c
          y0(3,2)=yupc(2,2)
          y0(5,2)=yupc(3,2)
c
        endif
c
        do j=1,3
          do i=1,6
            yc(i,j)=(0.d0,0.d0)
          enddo
        enddo
c
        yc(1,1)=yupc(1,1)
        yc(3,1)=yupc(2,1)
c
        yc(3,2)=yupc(2,2)
        yc(5,2)=yupc(3,2)
c
        do ly=lyup,min0(lys-1,lyob-1)
          if(ly.gt.lyup.and.ly.eq.lyos)then
c
c           interface ocean-atmosphere
c
            ca=yupc(1,1)*cgrup(ly)/crrup(ly)-yupc(3,1)
            cb=yupc(1,2)*cgrup(ly)/crrup(ly)-yupc(3,2)
            if(cdabs(ca).gt.cdabs(cb))then
              do i=1,4
                yupc(i,2)=yupc(i,1)*cb-yupc(i,2)*ca
              enddo
              yupc(2,2)=yupc(2,2)*crolw(ly-1)/croup(ly)
c
              yupc(1,1)=yupc(1,1)*comi2
              yupc(2,1)=(yupc(2,1)*crolw(ly-1)*comi2
     &                 +ca*(croup(ly)-crolw(ly-1)))/croup(ly)
              yupc(3,1)=yupc(3,1)*comi2
              yupc(4,1)=yupc(4,1)*comi2
              do i=1,6
                yc(i,2)=yc(i,1)*cb-yc(i,2)*ca
                yc(i,1)=yc(i,1)*comi2
              enddo
              if(ly.ge.lyr)then
                do i=1,6
                  y0(i,2)=y0(i,1)*cb-y0(i,2)*ca
                  y0(i,1)=y0(i,1)*comi2
                enddo
              endif
            else
              do i=1,4
                yupc(i,1)=yupc(i,1)*cb-yupc(i,2)*ca
              enddo
              yupc(2,1)=yupc(2,1)*crolw(ly-1)/croup(ly)
c
              yupc(1,2)=yupc(1,2)*comi2
              yupc(2,2)=(yupc(2,2)*crolw(ly-1)*comi2
     &                 +cb*(croup(ly)-crolw(ly-1)))/croup(ly)
              yupc(3,2)=yupc(3,2)*comi2
              yupc(4,2)=yupc(4,2)*comi2
              do i=1,6
                yc(i,1)=yc(i,1)*cb-yc(i,2)*ca
                yc(i,2)=yc(i,2)*comi2
              enddo
              if(ly.ge.lyr)then
                do i=1,6
                  y0(i,1)=y0(i,1)*cb-y0(i,2)*ca
                  y0(i,2)=y0(i,2)*comi2
                enddo
              endif
            endif
          endif
c
          cyabs=(0.d0,0.d0)
          do i=1,4
            cyabs=cyabs+yupc(i,1)*dconjg(yupc(i,1))/cypnorm(i,ly)**2
          enddo
          cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
          do i=1,4
            yupc(i,1)=yupc(i,1)*cyabs
          enddo
          do i=1,6
            yc(i,1)=yc(i,1)*cyabs
          enddo
          if(ly.ge.lyr)then
            do i=1,6
              y0(i,1)=y0(i,1)*cyabs
            enddo
          endif
c
          alf=(0.d0,0.d0)
          do i=1,4
            alf=alf+yupc(i,2)*dconjg(yupc(i,1))/cypnorm(i,ly)**2
          enddo
          do i=1,4
            yupc(i,2)=yupc(i,2)-alf*yupc(i,1)
          enddo
          do i=1,6
            yc(i,2)=yc(i,2)-alf*yc(i,1)
          enddo
          if(ly.ge.lyr)then
            do i=1,6
              y0(i,2)=y0(i,2)-alf*y0(i,1)
            enddo
          endif
c
          cyabs=(0.d0,0.d0)
          do i=1,4
            cyabs=cyabs+yupc(i,2)*dconjg(yupc(i,2))/cypnorm(i,ly)**2
          enddo
          cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
          do i=1,4
            yupc(i,2)=yupc(i,2)*cyabs
          enddo
          do i=1,6
            yc(i,2)=yc(i,2)*cyabs
          enddo
          if(ly.ge.lyr)then
            do i=1,6
              y0(i,2)=y0(i,2)*cyabs
            enddo
          endif
c
          call ruku(yupc,4,2,ly,1,qpdifmat4,rrup(ly),rrlw(ly))
          if(ly.eq.lyr-1)then
            do j=1,3
              do i=1,6
                y0(i,j)=(0.d0,0.d0)
              enddo
            enddo
            do j=1,2
              y0(1,j)=yupc(1,j)
              y0(2,j)=crolw(ly)*crrlw(ly)**2
     &                *(yupc(1,j)*cgrlw(ly)/crrlw(ly)
     &                -comi2*yupc(2,j)-yupc(3,j))
              y0(3,j)=yupc(2,j)
              y0(5,j)=yupc(3,j)
              y0(6,j)=yupc(4,j)
            enddo
          endif
        enddo
c
        ly=min0(lyob-1,lys-1)
        do j=1,2
          yup(1,j)=yupc(1,j)
          yup(2,j)=crolw(ly)*crrlw(ly)**2
     &            *(yupc(1,j)*cgrlw(ly)/crrlw(ly)
     &            -comi2*yupc(2,j)-yupc(3,j))
          yup(3,j)=(0.d0,0.d0)
          yup(4,j)=(0.d0,0.d0)
          yup(5,j)=yupc(3,j)
          yup(6,j)=yupc(4,j)
        enddo
        if(lys.ge.lyob)then
          yup(1,3)=(0.d0,0.d0)
          yup(2,3)=(0.d0,0.d0)
          yup(3,3)=(1.d0,0.d0)
          yup(4,3)=(0.d0,0.d0)
          yup(5,3)=(0.d0,0.d0)
          yup(6,3)=(0.d0,0.d0)
        endif
        if(lyr.eq.lyob.and.ly.eq.lyob-1)call cmemcpy(yup,y0,18)
      else
        do j=1,3
          do i=1,6
            yup(i,j)=(0.d0,0.d0)
          enddo
        enddo
        yup(1,1)=(1.d0,0.d0)
        yup(3,2)=(1.d0,0.d0)
        yup(5,3)=(1.d0,0.d0)
        call cmemcpy(yup,yc,18)
        if(lyr.eq.lyup)call cmemcpy(yup,y0,18)
      endif
c
c===============================================================================
c
c     propagation from atmosphere/ocean bottom to source
c
      do ly=lyob,lys-1
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+yup(i,1)*dconjg(yup(i,1))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          yup(i,1)=yup(i,1)*cyabs
        enddo
        do i=1,6
          yc(i,1)=yc(i,1)*cyabs
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,1)=y0(i,1)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        do i=1,6
          alf=alf+yup(i,2)*dconjg(yup(i,1))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          yup(i,2)=yup(i,2)-alf*yup(i,1)
        enddo
        do i=1,6
          yc(i,2)=yc(i,2)-alf*yc(i,1)
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)-alf*y0(i,1)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+yup(i,2)*dconjg(yup(i,2))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          yup(i,2)=yup(i,2)*cyabs
        enddo
        do i=1,6
          yc(i,2)=yc(i,2)*cyabs
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        bet=(0.d0,0.d0)
        do i=1,6
          alf=alf+yup(i,3)*dconjg(yup(i,1))/cypnorm(i,ly)**2
          bet=bet+yup(i,3)*dconjg(yup(i,2))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          yup(i,3)=yup(i,3)-alf*yup(i,1)-bet*yup(i,2)
        enddo
        do i=1,6
          yc(i,3)=yc(i,3)-alf*yc(i,1)-bet*yc(i,2)
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,3)=y0(i,3)-alf*y0(i,1)-bet*y0(i,2)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+yup(i,3)*dconjg(yup(i,3))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          yup(i,3)=yup(i,3)*cyabs
        enddo
        do i=1,6
          yc(i,3)=yc(i,3)*cyabs
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,3)=y0(i,3)*cyabs
          enddo
        endif
c
        call ruku(yup,6,3,ly,1,qpdifmat6,rrup(ly),rrlw(ly))
        if(ly.eq.lyr-1)call cmemcpy(yup,y0,18)
      enddo
c
      do j=1,3
        yup(1,j)=yup(1,j)/crrup(lys)
        yup(2,j)=yup(2,j)/crrup(lys)**2
        yup(3,j)=yup(3,j)/crrup(lys)
        yup(4,j)=yup(4,j)/crrup(lys)**2
c        yup(5,j)=yup(5,j)
        yup(6,j)=yup(6,j)/crrup(lys)
c
        yc(1,j)=yc(1,j)/crrup(lyup)
        yc(2,j)=yc(2,j)/crrup(lyup)**2
        yc(3,j)=yc(3,j)/crrup(lyup)
        yc(4,j)=yc(4,j)/crrup(lyup)**2
c        yc(5,j)=yc(5,j)
        yc(6,j)=yc(6,j)/crrup(lyup)
      enddo
c
c===============================================================================
c
c     propagation within inner core
c
      if(lylw.ge.lycc)then
c
c       lowest layer is within inner core
c
        call qpstart6(1,lylw,ylw)
        if(lylw.eq.lyr.and.lylw.gt.lys)then
          call cmemcpy(ylw,y0,12)
        endif
      endif
c
      do ly=lylw-1,lycc,-1
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,1)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,1)=ylw(i,1)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,1)=y0(i,1)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        do i=1,6
          alf=alf+ylw(i,2)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          ylw(i,2)=ylw(i,2)-alf*ylw(i,1)
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)-alf*y0(i,1)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,2)*dconjg(ylw(i,2))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,2)=ylw(i,2)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)*cyabs
          enddo
        endif
c
        call ruku(ylw,6,2,ly,1,qpdifmat6,rrlw(ly),rrup(ly))
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,12)
      enddo
c===============================================================================
c
c     propagation within outer core
c
      if(lylw.ge.lycc)then
c
c       interface conditions: solid to liquid
c
        ylwc(1,1)=ylw(4,2)*ylw(1,1)-ylw(4,1)*ylw(1,2)
        ylwc(2,1)=ylw(4,2)*ylw(2,1)-ylw(4,1)*ylw(2,2)
        ylwc(3,1)=ylw(4,2)*ylw(5,1)-ylw(4,1)*ylw(5,2)
        ylwc(4,1)=ylw(4,2)*ylw(6,1)-ylw(4,1)*ylw(6,2)
c
c       y2 = Ur
c
        ylwc(2,1)=-ylwc(2,1)/crolw(lycc-1)/crrlw(lycc-1)**2
     &         +ylwc(1,1)*cgrlw(lycc-1)/crrlw(lycc-1)-ylwc(3,1)
        ylwc(1,1)=ylwc(1,1)*comi2
        ylwc(3,1)=ylwc(3,1)*comi2
        ylwc(4,1)=ylwc(4,1)*comi2
        if(lycc.le.lyr.and.lycc.gt.lys)then
          do i=1,6
            y0(i,1)=(ylw(4,2)*y0(i,1)-ylw(4,1)*y0(i,2))*comi2
            y0(i,2)=(0.d0,0.d0)
          enddo
        endif
      else if(lylw.ge.lycm)then
c
c       lowest layer is within the liquid core
c
        if(cdabs(comi).gt.0.d0)then
c
c         compressible liquid for dynamic response
c
          call qpstart4(1,lylw,ylwc)
          do i=1,4
            ylwc(i,2)=(0.d0,0.d0)
          enddo
        else
c
c         incompressible liquid used for static response
c
          do j=1,2
            do i=1,4
              ylwc(i,j)=(0.d0,0.d0)
            enddo
          enddo
c
          ylwc(3,1)=(1.d0,0.d0)
          ylwc(4,1)=(3.d0,0.d0)
        endif
        if(lylw.eq.lyr.and.lylw.gt.lys)then
          y0(1,1)=ylwc(1,1)
          y0(2,1)=croup(lylw)*crrup(lylw)**2
     &            *(ylwc(1,1)*cgrup(lylw)/crrup(lylw)
     &            -comi2*ylwc(2,1)-ylwc(3,1))
          y0(3,1)=ylwc(2,1)
          y0(4,1)=(0.d0,0.d0)
          y0(5,1)=ylwc(3,1)
          y0(6,1)=ylwc(4,1)
          do i=1,6
            y0(i,2)=(0.d0,0.d0)
          enddo
        endif
      endif
c
      do ly=min0(lylw-1,lycc-1),lycm,-1
        call ruku(ylwc,4,1,ly,1,qpdifmat4,rrlw(ly),rrup(ly))
        if(ly.eq.lyr.and.ly.gt.lys)then
          y0(1,1)=ylwc(1,1)
          y0(2,1)=croup(ly)*crrup(ly)**2
     &           *(ylwc(1,1)*cgrup(ly)/crrup(ly)
     &           -comi2*ylwc(2,1)-ylwc(3,1))
          y0(3,1)=ylwc(2,1)
          y0(4,1)=(0.d0,0.d0)
          y0(5,1)=ylwc(3,1)
          y0(6,1)=ylwc(4,1)
          do i=1,6
            y0(i,2)=(0.d0,0.d0)
          enddo
        endif
      enddo
c===============================================================================
c
c     propagation from core-mantle boundary to source or ocean bottom
c
      if(lylw.ge.lycm)then
c
c       interface conditions: liquid to solid
c
        ylw(1,1)=ylwc(1,1)
        ylw(2,1)=croup(lycm)*crrup(lycm)**2
     &          *(ylwc(1,1)*cgrup(lycm)/crrup(lycm)
     &          -comi2*ylwc(2,1)-ylwc(3,1))
        ylw(3,1)=(0.d0,0.d0)
        ylw(4,1)=(0.d0,0.d0)
        ylw(5,1)=ylwc(3,1)
        ylw(6,1)=ylwc(4,1)
c
        ylw(1,2)=(0.d0,0.d0)
        ylw(2,2)=(0.d0,0.d0)
        ylw(3,2)=(1.d0,0.d0)
        ylw(4,2)=(0.d0,0.d0)
        ylw(5,2)=(0.d0,0.d0)
        ylw(6,2)=(0.d0,0.d0)
c
        if(lycm.eq.lyr.and.lycm.gt.lys)then
          call cmemcpy(ylw,y0,12)
        endif
      else if(lylw.ge.lyob)then
c
c       lowest layer is within the mantle
c
        call qpstart6(1,lylw,ylw)
c
        if(lylw.eq.lyr.and.lylw.gt.lys)then
          call cmemcpy(ylw,y0,12)
        endif
      endif
c
      do ly=min0(lylw-1,lycm-1),max0(lys,lyob),-1
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,1)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,1)=ylw(i,1)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,1)=y0(i,1)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        do i=1,6
          alf=alf+ylw(i,2)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          ylw(i,2)=ylw(i,2)-alf*ylw(i,1)
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)-alf*y0(i,1)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,2)*dconjg(ylw(i,2))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,2)=ylw(i,2)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)*cyabs
          enddo
        endif
c
        call ruku(ylw,6,2,ly,1,qpdifmat6,rrlw(ly),rrup(ly))
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,12)
      enddo
c
c===============================================================================
c
c     propagation from ocean bottom to source in atmosphere
c
      if(lylw.ge.lyob.and.lys.lt.lyob)then
c
c       interface conditions: solid to liquid
c
        ylwc(1,1)=ylw(4,2)*ylw(1,1)-ylw(4,1)*ylw(1,2)
        ylwc(2,1)=ylw(4,2)*ylw(2,1)-ylw(4,1)*ylw(2,2)
        ylwc(3,1)=ylw(4,2)*ylw(5,1)-ylw(4,1)*ylw(5,2)
        ylwc(4,1)=ylw(4,2)*ylw(6,1)-ylw(4,1)*ylw(6,2)
c
c       y2 = Ur
c
        ylwc(2,1)=-ylwc(2,1)/crolw(lycc-1)/crrlw(lycc-1)**2
     &         +ylwc(1,1)*cgrlw(lycc-1)/crrlw(lycc-1)-ylwc(3,1)
        ylwc(1,1)=ylwc(1,1)*comi2
        ylwc(3,1)=ylwc(3,1)*comi2
        ylwc(4,1)=ylwc(4,1)*comi2
        if(lyob.le.lyr.and.lyob.gt.lys)then
          do i=1,6
            y0(i,1)=ylw(4,2)*y0(i,1)-ylw(4,1)*y0(i,2)
            y0(i,2)=(0.d0,0.d0)
          enddo
        endif
      else if(lys.lt.lyob)then
c
c       lowest layer is within atmosphere
c
        if(cdabs(comi).gt.0.d0)then
c
c         compressible liquid for dynamic response
c
          call qpstart4(1,lylw,ylwc)
          do i=1,4
            ylwc(i,2)=(0.d0,0.d0)
          enddo
        else
c
c         incompressible liquid used for static response
c
          do j=1,2
            do i=1,4
              ylwc(i,j)=(0.d0,0.d0)
            enddo
          enddo
c
          ylwc(3,1)=(1.d0,0.d0)
          ylwc(4,1)=(3.d0,0.d0)
        endif
c
        if(lylw.eq.lyr.and.lylw.gt.lys)then
          y0(1,1)=ylwc(1,1)
          y0(2,1)=croup(lylw)*crrup(lylw)**2
     &            *(ylwc(1,1)*cgrup(lylw)/crrup(lylw)
     &            -comi2*ylwc(2,1)-ylwc(3,1))
          y0(3,1)=ylwc(2,1)
          y0(4,1)=(0.d0,0.d0)
          y0(5,1)=ylwc(3,1)
          y0(6,1)=ylwc(4,1)
          do i=1,6
            y0(i,2)=(0.d0,0.d0)
          enddo
        endif
      endif
c
      do ly=min0(lylw-1,lyob-1),lys,-1
        if(ly.eq.lyos-1)then
c
c         interface ocean-atmosphere
c
          ylwc(2,1)=(ylwc(2,1)*croup(ly+1)*comi2
     &          +(cgrlw(ly)*ylwc(1,1)/crrlw(ly)-ylwc(3,1))
     &          *(crolw(ly)-croup(ly+1)))/crolw(ly)
          ylwc(1,1)=ylwc(1,1)*comi2
          ylwc(3,1)=ylwc(3,1)*comi2
          ylwc(4,1)=ylwc(4,1)*comi2
          if(ly.lt.lyr)then
            do i=1,6
              y0(i,1)=y0(i,1)*comi2
            enddo
          endif
        endif
c
        call ruku(ylwc,4,1,ly,1,qpdifmat4,rrlw(ly),rrup(ly))
        if(ly.eq.lyr.and.ly.gt.lys)then
          y0(1,1)=ylwc(1,1)
          y0(2,1)=croup(ly)*crrup(ly)**2
     &            *(ylwc(1,1)*cgrup(ly)/crrup(ly)
     &            -comi2*ylwc(2,1)-ylwc(3,1))
          y0(3,1)=ylwc(2,1)
          y0(4,1)=(0.d0,0.d0)
          y0(5,1)=ylwc(3,1)
          y0(6,1)=ylwc(4,1)
          do i=1,6
            y0(i,2)=(0.d0,0.d0)
          enddo
        endif
      enddo
      if(lys.lt.lyob)then
        ylw(1,1)=ylwc(1,1)
        ylw(2,1)=croup(lys)*crrup(lys)**2
     &          *(ylwc(1,1)*cgrup(lys)/crrup(lys)
     &          -comi2*ylwc(2,1)-ylwc(3,1))
        ylw(3,1)=ylwc(2,1)
        ylw(4,1)=(0.d0,0.d0)
        ylw(5,1)=ylwc(3,1)
        ylw(6,1)=ylwc(4,1)
        do i=1,6
          ylw(i,2)=(0.d0,0.d0)
        enddo
      endif
c
      if(lys.lt.lyob)then
        j0=2
      else
        j0=3
      endif
      do j=1,j0-1
        ylw(1,j)=ylw(1,j)/crrup(lys)
        ylw(2,j)=ylw(2,j)/crrup(lys)**2
        ylw(3,j)=ylw(3,j)/crrup(lys)
        ylw(4,j)=ylw(4,j)/crrup(lys)**2
c        ylw(5,j)=ylw(5,j)
        ylw(6,j)=ylw(6,j)/crrup(lys)
      enddo
      ylw(1,j0)=(1.d0,0.d0)
      ylw(2,j0)=(0.d0,0.d0)
      ylw(3,j0)=(1.d0,0.d0)
      ylw(4,j0)=(0.d0,0.d0)
      ylw(5,j0)=cgrup(lys)-comi2*crrup(lys)
      ylw(6,j0)=-c3*comi2
c
      if(lyr.le.lys)then
        do j=1,j0
          y0(1,j)=y0(1,j)/crrup(lyr)
          y0(2,j)=y0(2,j)/crrup(lyr)**2
          y0(3,j)=y0(3,j)/crrup(lyr)
          y0(4,j)=y0(4,j)/crrup(lyr)**2
c          y0(5,j)=y0(5,j)
          y0(6,j)=y0(6,j)/crrup(lyr)
        enddo
      else
        do j=1,j0-1
          y0(1,j)=y0(1,j)/crrup(lyr)
          y0(2,j)=y0(2,j)/crrup(lyr)**2
          y0(3,j)=y0(3,j)/crrup(lyr)
          y0(4,j)=y0(4,j)/crrup(lyr)**2
c          y0(5,j)=y0(5,j)
          y0(6,j)=y0(6,j)/crrup(lyr)
        enddo
        y0(1,j0)=(1.d0,0.d0)
        y0(2,j0)=(0.d0,0.d0)
        y0(3,j0)=(1.d0,0.d0)
        y0(4,j0)=(0.d0,0.d0)
        y0(5,j0)=cgrup(lyr)-comi2*crrup(lyr)
        y0(6,j0)=-c3*comi2
      endif
c
c===============================================================================
c     source function
c===============================================================================
c
      if(lys.lt.lyob)then
        do istp=1,2
          do i=1,4
            b4(i,istp)=(0.d0,0.d0)
          enddo
          b4(istp,istp)=(1.d0,0.d0)
        enddo
        do j=1,2
          do i=1,2
            coef4(i,j)=yup(i,j)
            coef4(i,j+2)=-ylw(i,j)
          enddo
          do i=3,4
            coef4(i,j)=yup(i+2,j)
            coef4(i,j+2)=-ylw(i+2,j)
          enddo
        enddo
        key=0
        call cdsvd(coef4,b4,4,2,0.d0,key)
        if(key.eq.0)then
          print *,' Warning in qpspropg1: anormal exit from cdgemp!'
          return
        endif
c
c       uc = translational motion of earth's centre of mass
c
        do istp=1,2
          uc(istp)=(0.d0,0.d0)
          do j=1,2
            uc(istp)=uc(istp)+b4(j,istp)*yc(5,j)
          enddo
          uc(istp)=uc(istp)/cgrup(lyup)
        enddo
        if(lyr.le.lys)then
          do istp=1,2
            do i=1,6
              ypsv(i,istp)=(0.d0,0.d0)
              do j=1,2
                ypsv(i,istp)=ypsv(i,istp)+b4(j,istp)*y0(i,j)
              enddo
            enddo
          enddo
        else
          do istp=1,2
            do i=1,6
              ypsv(i,istp)=(0.d0,0.d0)
              do j=1,2
                ypsv(i,istp)=ypsv(i,istp)+b4(j+2,istp)*y0(i,j)
              enddo
            enddo
          enddo
        endif
        do istp=3,4
          uc(istp)=(0.d0,0.d0)
          do i=1,6
            ypsv(i,istp)=(0.d0,0.d0)
          enddo
        enddo
      else
        do istp=1,4
          do i=1,6
            b6(i,istp)=(0.d0,0.d0)
          enddo
          b6(istp,istp)=(1.d0,0.d0)
        enddo
        do j=1,3
          do i=1,6
            coef6(i,j)=yup(i,j)
            coef6(i,j+3)=-ylw(i,j)
          enddo
        enddo
        key=0
        call cdsvd(coef6,b6,6,4,0.d0,key)
        if(key.eq.0)then
          print *,' Warning in qpspropg1: anormal exit from cdgemp!'
          return
        endif
c
c       uc = translational motion of earth's centre of mass
c
        do istp=1,4
          uc(istp)=(0.d0,0.d0)
          do j=1,3
            uc(istp)=uc(istp)+b6(j,istp)*yc(5,j)
          enddo
          uc(istp)=uc(istp)/cgrup(lyup)
        enddo
        if(lyr.le.lys)then
          do istp=1,4
            do i=1,6
              ypsv(i,istp)=(0.d0,0.d0)
              do j=1,3
                ypsv(i,istp)=ypsv(i,istp)+b6(j,istp)*y0(i,j)
              enddo
            enddo
          enddo
        else
          do istp=1,4
            do i=1,6
              ypsv(i,istp)=(0.d0,0.d0)
              do j=1,3
                ypsv(i,istp)=ypsv(i,istp)+b6(j+3,istp)*y0(i,j)
              enddo
            enddo
          enddo
        endif
      endif
c
c     transform to motion relative to the centre of mass
c
      do istp=1,4
        ypsv(1,istp)=ypsv(1,istp)-uc(istp)
        ypsv(3,istp)=ypsv(3,istp)-uc(istp)
        ypsv(5,istp)=ypsv(5,istp)-uc(istp)*cgrup(lyr)
      enddo
      return
      end

      subroutine qpstart6a(ldeg,ly,jh,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c
      integer*4 ldeg,ly,jh
      complex*16 cy(6,3)
c
      integer*4 i,j
      real*8 peps,seps
      complex*16 cldeg,cxi,c2mu,cxp2,cxs2
      complex*16 cllp1,cllm1,c2lp1,c2lm1,c2lp3
      complex*16 ca,cb,ya,yb
c
      real*8 eps
      complex*16 c0,c1,c2,c3
      data eps/1.0d-08/
      data c0,c1,c2,c3/(0.d0,0.d0),(1.d0,0.d0),
     &                 (2.d0,0.d0),(3.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      c2mu=c2*cmu(ly)
      cxi=cla(ly)+c2mu
      cllm1=cldeg*(cldeg-c1)
      cllp1=cldeg*(cldeg+c1)
      c2lp1=c2*cldeg+c1
      c2lm1=c2*cldeg-c1
      c2lp3=c2*cldeg+c3
      cxp2=(kp(ly)*crrup(ly))**2
      cxs2=(ks(ly)*crrup(ly))**2
c
      if(jh.eq.1.and.ly.ge.lys)then
        cy(1,1)=cldeg-zh12p(ldeg,1,ly)
        cy(2,1)=-cxi*cxp2+c2mu*(cllm1+c2*zh12p(ldeg,1,ly))
        cy(3,1)=c1
        cy(4,1)=c2mu*(cldeg-c1-zh12p(ldeg,1,ly))
        cy(5,1)=cga(ly)
        cy(6,1)=cga(ly)*(cldeg+c1)
c
        peps=dabs(dimag(zh12p(ldeg,1,ly)))/cdabs(zh12p(ldeg,1,ly))
        if(peps.lt.eps)then
          ca=dcmplx((peps/eps)**2,0.d0)
          cb=(1.d0,0.d0)-ca
          ya=cdsqrt(cy(1,1)*dconjg(cy(1,1))+cy(3,1)*dconjg(cy(3,1)))
          yb=cdsqrt(mas6x6up(1,1,ly)*dconjg(mas6x6up(1,1,ly))
     &             +mas6x6up(3,1,ly)*dconjg(mas6x6up(3,1,ly)))
          do i=1,6
            cy(i,1)=ca*cy(i,1)*yb+cb*mas6x6up(i,1,ly)*ya
          enddo
        endif
c
        cy(1,2)=-cllp1
        cy(2,2)=c2mu*cllp1*(c1-cldeg+zh12sv(ldeg,1,ly))
        cy(3,2)=-(cldeg+c1)+zh12sv(ldeg,1,ly)
        cy(4,2)=cmu(ly)*(cxs2-c2*(cldeg**2-c1)-c2*zh12sv(ldeg,1,ly))
        cy(5,2)=c0
        cy(6,2)=cga(ly)*cllp1
c
        seps=dabs(dimag(zh12sv(ldeg,1,ly)))/cdabs(zh12sv(ldeg,1,ly))
        if(seps.lt.eps)then
          ca=dcmplx((seps/eps)**2,0.d0)
          cb=(1.d0,0.d0)-ca
          ya=cdsqrt(cy(1,2)*dconjg(cy(1,2))+cy(3,2)*dconjg(cy(3,2)))
          yb=cdsqrt(mas6x6up(1,3,ly)*dconjg(mas6x6up(1,3,ly))
     &             +mas6x6up(3,3,ly)*dconjg(mas6x6up(3,3,ly)))
          do i=1,6
            cy(i,2)=ca*cy(i,2)*yb+cb*mas6x6up(i,3,ly)*ya
          enddo
        endif
        cy(1,3)=c0
        cy(2,3)=c0
        cy(3,3)=c0
        cy(4,3)=c0
        cy(5,3)=c1
        cy(6,3)=c2lp1
      else if(jh.eq.2.and.ly.le.lys)then
        cy(1,1)=cldeg-zh12p(ldeg,2,ly)
        cy(2,1)=-cxi*cxp2+c2mu*(cllm1+c2*zh12p(ldeg,2,ly))
        cy(3,1)=c1
        cy(4,1)=c2mu*(cldeg-c1-zh12p(ldeg,2,ly))
        cy(5,1)=cga(ly)
        cy(6,1)=cga(ly)*(cldeg+c1)
c
        cy(1,2)=-cllp1
        cy(2,2)=c2mu*cllp1*(c1-cldeg+zh12sv(ldeg,2,ly))
        cy(3,2)=-(cldeg+c1)+zh12sv(ldeg,2,ly)
        cy(4,2)=cmu(ly)*(cxs2-c2*(cldeg**2-c1)-c2*zh12sv(ldeg,2,ly))
        cy(5,2)=c0
        cy(6,2)=cga(ly)*cllp1
c
        cy(1,3)=c0
        cy(2,3)=c0
        cy(3,3)=c0
        cy(4,3)=c0
        cy(5,3)=c1
        cy(6,3)=c0
      else
        stop ' Error in qpstart6a: bad jh value!'
      endif
c
      return
      end

        subroutine edgsh(y,k,eps)
        implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
c	calculation of response to sh source
c       y(6): solution vector
c       k: wave number
c       eps: relative accuracy
c
        double precision k,eps
        double precision y(6)
c
	include 'edgglobal.h'
c
        integer lp,nno(nzmax)
        double precision hp(nzmax)
        common /sublayer/ hp,lp,nno
c
c       zrec: receiver depth
c       lzrec: sublayer no of receiver
c
        integer lzrec
        double precision zrec
        common /receiver/ zrec,lzrec
c       
c       model parameter:
c       n0: number of model layers
c
        integer n0
        double precision h(lmax),ro(lmax),vp(lmax),vs(lmax)
        common /model/ h,ro,vp,vs,n0
c
c       source parameters
c
        integer ls,ms,ics
        integer kpower(6)
        double precision zs,r0
        double precision sfct(6)
        common /source/ zs,r0,sfct,ls,ms,ics,kpower
c
c       work space
c
        double precision eps0
        data eps0/1.0d-03/
c
        integer i,l,n,lup,llw,key
        double precision fac,exponent
        double precision y0(2),c0(2),b(2)
        double precision y1(2),yup(2),ylw(2)
        double precision hk(2,2),coef(2,2)
c
        do i=5,6
          y(i)=0.d0
        enddo
c
c===============================================================================
c
c       matrix propagation from surface to source
c
        do i=1,2
          c0(i)=0.d0
          y0(i)=0.d0
	  y1(i)=0.d0
          yup(i)=0.d0
        enddo
c
c       yup: the starting solution vector
c
        lup=1
c
	exponent=0.d0
        do l=ls-1,1,-1
          n=nno(l)
	  exponent=exponent-k*hp(l)
          if(exponent.le.dlog(eps))then
            lup=l+1
            if(lup.gt.lzrec)return
            goto 100
          endif
        enddo
100     continue
c
c       determination of starting sublayer for half-space
c
	exponent=0.d0
        llw=lp
        do l=ls,lp-1
          n=nno(l)
	  exponent=exponent-k*hp(l)
          if(exponent.le.dlog(eps))then
            llw=l
            goto 200
          endif
        enddo
200     continue
c
        yup(1)=1.d0
        if(lup.gt.1)then
          n=nno(lup-1)
	  yup(2)=ro(n)*vs(n)**2*k
        endif
        if(lup.eq.lzrec)call memcpy(yup,y0,2)
c
        do l=lup+1,ls
          n=nno(l-1)
c
c         determination of propagation matrix
c
	  call edghask(hk,2,k,hp(l-1),n)
	  call axb(hk,yup,2,2,1,y1)
	  fac=dexp(-k*hp(l-1))
	  do i=1,2
	    yup(i)=y1(i)*fac
	  enddo
c
	  if(l.gt.lzrec)then
	    do i=1,2
	      y0(i)=y0(i)*fac
	    enddo
	  else if(l.eq.lzrec)then
	    call memcpy(yup,y0,2)
	  endif
        enddo
c
c===============================================================================
c
c       matrix propagation from half-space to source
c
        do i=1,2
          c0(i)=0.d0
          y1(i)=0.d0
          ylw(i)=0.d0
        enddo
c
c       ylw: the starting solution vector
c
        n=nno(llw)
        ylw(1)=1.d0
        if(vs(n).lt.eps0*vp(n))then
c
c         the lowest layer is fluid
c
	  ylw(2)=0.d0
        else
c
c         the lowest layer is solid
c
          ylw(2)=-ro(n)*vs(n)**2*k
        endif
        if(llw.gt.ls.and.llw.eq.lzrec)call memcpy(ylw,y0,2)
c
        do l=llw-1,ls,-1
          n=nno(l)
c
c         determination of propagation matrix
c
	  call edghask(hk,2,k,-hp(l),n)
	  call axb(hk,ylw,2,2,1,y1)
	  fac=dexp(-k*hp(l))
	  do i=1,2
	    ylw(i)=y1(i)*fac
	  enddo
c
	  if(l.lt.lzrec)then
	    do i=1,2
	      y0(i)=y0(i)*fac
	    enddo
	  else if(l.gt.ls.and.l.eq.lzrec)then
	    call memcpy(ylw,y0,2)
	  endif
        enddo
c
c===============================================================================
c
c       conditions on the source surface
c
c
c       source function
c
        do i=1,2
          if(kpower(i+4).eq.1)then
            fac=k
          else
            fac=1.d0
          endif
          b(i)=sfct(i+4)*fac
          coef(i,1)=yup(i)
          coef(i,2)=-ylw(i)
        enddo
        key=0
        call gemp(coef,b,2,1,1.d-99,key)
        if(key.eq.0)then
          print *,'warning in edgsh: anormal exit from cgemp!'
          return
        endif
        if(lzrec.le.ls)then
          do i=1,2
            y(i+4)=b(1)*y0(i)
          enddo
        else
          do i=1,2
            y(i+4)=b(2)*y0(i)
          enddo
        endif
        return
        end

      subroutine caxcb(a,b,n,l,m,c)
      implicit none
c
c     calculate c=a*b
c
      integer*4 n,l,m
      complex*16 a(n,l),b(l,m),c(n,m)
c
      integer*4 i,j,k
c
      do j=1,m
        do i=1,n
          c(i,j)=(0.d0,0.d0)
          do k=1,l
            c(i,j)=c(i,j)+a(i,k)*b(k,j)
          enddo
        enddo
      enddo
      return
      end

      subroutine qpsprop0(ypsv,lyup,lylw)
      use qpalloc
      implicit none
c
c     calculation of response to psv source (l=0)
c     ypsv(6,4): solution vector (complex)
c
      integer*4 lyup,lylw
      complex*16 ypsv(6,4)
c
c     work space
c
      integer*4 i,istp,ly,key
      complex*16 y0(2),c(2),yup(2),ylw(2)
      complex*16 wave(2),coef(2,2),b(2,2)
c
c===============================================================================
c
c     propagation from surface to source
c
      yup(1)=(1.d0,0.d0)
      yup(2)=(0.d0,0.d0)
c
      if(lyr.eq.lyup)call cmemcpy(yup,y0,2)
c
      do ly=lyup,lys-1
        call caxcb(mas2x2inv(1,1,ly),yup,2,2,1,c)
        wave(1)=cdexp( cps(1,ly))
        wave(2)=cdexp(-cps(2,ly))
        if(ly.ge.lyr)then
          y0(1)=y0(1)*wave(2)
          y0(2)=y0(2)*wave(2)
        endif
c
	  c(1)=c(1)*wave(1)*wave(2)
c       c(2)=c(2)
c
        call caxcb(mas2x2lw(1,1,ly),c,2,2,1,yup)
        if(ly.eq.lyr-1)call cmemcpy(yup,y0,2)
      enddo
      yup(1)=yup(1)/crrup(lys)
      yup(2)=yup(2)/crrup(lys)**2
c
c===============================================================================
c
c     propagation from bottom to source
c
      ylw(1)=mas2x2up(1,1,lylw)
      ylw(2)=mas2x2up(2,1,lylw)
      if(lylw.eq.lyr.and.lylw.gt.lys)call cmemcpy(ylw,y0,2)
c
      do ly=lylw-1,lys,-1
        call caxcb(mas2x2inv(1,1,ly),ylw,2,2,1,c)
        wave(1)=cdexp(-cps(1,ly))
        wave(2)=cdexp( cps(2,ly))
        if(ly.lt.lyr)then
          y0(1)=y0(1)*wave(1)
          y0(2)=y0(2)*wave(1)
        endif
c
c       c(1)=c(1)
        c(2)=c(2)*wave(1)*wave(2)
c
        call caxcb(mas2x2up(1,1,ly),c,2,2,1,ylw)
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,2)
      enddo
      ylw(1)=ylw(1)/crrup(lys)
      ylw(2)=ylw(2)/crrup(lys)**2
c
      y0(1)=y0(1)/crrup(lyr)
      y0(2)=y0(2)/crrup(lyr)**2
c
c===============================================================================
c     source function
c===============================================================================
c
      b(1,1)=(1.d0,0.d0)
      b(2,1)=(0.d0,0.d0)
      b(1,2)=(0.d0,0.d0)
      b(2,2)=(1.d0,0.d0)
      do i=1,2
        coef(i,1)=yup(i)
        coef(i,2)=-ylw(i)
      enddo
      key=0
      call cdsvd(coef,b,2,2,0.d0,key)
      if(key.eq.0)then
        print *,' Warning in qpsprop0: anormal exit from cdgemp!'
        return
      endif
      if(lyr.le.lys)then
        do istp=1,2
          do i=1,2
            ypsv(i,istp)=b(1,istp)*y0(i)
          enddo
        enddo
      else
        do istp=1,2
          do i=1,2
            ypsv(i,istp)=b(2,istp)*y0(i)
          enddo
        enddo
      endif
      return
      end

      subroutine qpqmodel(f)
      implicit none
c
      include 'qpglobal.h'
c
c     calculate q based on the constant q model
c
c     f = frequency
c
      double precision f
c
      integer ly
      double precision fac,pup,plw,sup,slw,eup,elw
c
      if(f.le.0.d0)return
      if(.not.dispersion)then
        fac=0.d0
      else if(f.le.FSBLW)then
        fac=dlog(FSBLW/FSBREF)/PI
      else if(f.ge.FSBUP)then
        fac=dlog(FSBUP/FSBREF)/PI
      else
        fac=dlog(f/FSBREF)/PI
      endif
c
      if(1.d0+fac/qsmin.le.0.d0)then
        stop ' Error in qpqmodel: too small Qs value!'
      endif
      do ly=1,ly0
        if(ly.ge.lyob.and.ly.lt.lycm.or.ly.ge.lycc)then
          sup=1.d0+fac/qsup(ly)
          slw=1.d0+fac/qslw(ly)
          eup=(vsup(ly)/vpup(ly))**2*4.d0/3.d0
          elw=(vslw(ly)/vplw(ly))**2*4.d0/3.d0
          pup=1.d0+fac*eup/qsup(ly)
          plw=1.d0+fac*elw/qslw(ly)
          cvsup(ly)=dcmplx(vsup(ly)*sup,0.d0)
     &             *dcmplx(1.d0,0.5d0/qsup(ly))
          cvslw(ly)=dcmplx(vslw(ly)*slw,0.d0)
     &             *dcmplx(1.d0,0.5d0/qslw(ly))
          cvs(ly)=(0.5d0,0.d0)*(cvsup(ly)+cvslw(ly))
        else
          pup=1.d0
          plw=1.d0
          cvsup(ly)=(0.d0,0.d0)
          cvslw(ly)=(0.d0,0.d0)
          cvs(ly)=(0.d0,0.d0)
        endif
        cvpup(ly)=dcmplx(vpup(ly)*pup,0.d0)
     &           *dcmplx(1.d0,0.5d0/qpup(ly))
        cvplw(ly)=dcmplx(vplw(ly)*plw,0.d0)
     &           *dcmplx(1.d0,0.5d0/qplw(ly))
        cvp(ly)=(0.5d0,0.d0)*(cvpup(ly)+cvplw(ly))
c
        cmuup(ly)=croup(ly)*cvsup(ly)**2
        claup(ly)=croup(ly)*cvpup(ly)**2-(2.d0,0.d0)*cmuup(ly)
        cmulw(ly)=crolw(ly)*cvslw(ly)**2
        clalw(ly)=crolw(ly)*cvplw(ly)**2-(2.d0,0.d0)*cmulw(ly)
        cmu(ly)=(0.5d0,0.d0)*(cmuup(ly)+cmulw(ly))
        cla(ly)=(0.5d0,0.d0)*(claup(ly)+clalw(ly))
      enddo
      return
      end

        subroutine edgpsv(y,k,eps)
        implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
c	calculation of response to p-sv source
c       y(6): solution vector
c       k: wave number
c       eps: relative accuracy
c
	include 'edgglobal.h'
c
        double precision k,eps
        double precision y(6)
c
        integer lp,nno(nzmax)
        double precision hp(nzmax)
        common /sublayer/ hp,lp,nno
c
c       zrec: receiver depth
c       lzrec: sublayer no of receiver
c
        integer lzrec
        double precision zrec
        common /receiver/ zrec,lzrec
c       
c       model parameter:
c       n0: number of model layers
c
        integer n0
        double precision h(lmax),ro(lmax),vp(lmax),vs(lmax)
        common /model/ h,ro,vp,vs,n0
c
c       source parameters
c
        integer ls,ms,ics
        integer kpower(6)
        double precision zs,r0
        double precision sfct(6)
        common /source/ zs,r0,sfct,ls,ms,ics,kpower
c
c       work space
c
        double precision eps0
        data eps0/1.0d-03/
c
        integer i,j,l,n,lup,llw,key
        double precision h0,fac,exponent,wave,dro
        double precision norm(2)
        double precision y0(4,2),c0(4,2),c1(4,2),b(4)
        double precision y1(4,2),yup(4,2),ylw(4,2)
        double precision ma(4,4),mai(4,4),hk(4,4)
        double precision orth(2,2),coef(4,4)
c
        do i=1,4
          y(i)=0.d0
        enddo
c
c===============================================================================
c
c       matrix propagation from surface to source
c
        do j=1,2
          do i=1,4
            c0(i,j)=0.d0
            yup(i,j)=0.d0
            y0(i,j)=0.d0
          enddo
        enddo
c
c       y0(4,2,1): 2 starting solution vectors
c
        lup=1
c
	exponent=0.d0
        do l=ls-1,1,-1
          n=nno(l)
	  exponent=exponent-k*hp(l)
          if(exponent.le.dlog(eps))then
            lup=l+1
            if(lup.gt.lzrec)return
            goto 100
          endif
        enddo
100     continue
c
c       determination of starting sublayer for half-space
c
        llw=lp
	exponent=0.d0
        do l=ls,lp-1
          n=nno(l)
	  exponent=exponent-k*hp(l)
          if(exponent.le.dlog(eps))then
            llw=l
            if(llw.lt.lzrec)return
            goto 200
          endif
        enddo
200     continue
c
        if(lup.eq.1)then
          yup(1,1)=1.d0
	  dro=ro(1)
	  yup(2,1)=dro*g0*yup(1,1)
          yup(3,2)=1.d0
        else
          c0(1,1)=1.d0
          c0(3,2)=1.d0
	  n=nno(lup-1)
          call edgmatrix(ma,4,k,0.d0,n)
          call axb(ma,c0,4,4,2,yup)
	  dro=ro(nno(lup))-ro(nno(lup-1))
	  do j=1,2
	    yup(2,j)=yup(2,j)+dro*g0*yup(1,j)
	  enddo
        endif
        if(lup.eq.lzrec)call memcpy(yup,y0,8)
c
        do l=lup+1,ls
          h0=hp(l-1)
	  n=nno(l-1)
	  if(k*h0.le.eps0)then
	    call edghask(hk,4,k,h0,n)
	    call axb(hk,yup,4,4,2,y1)
	    call memcpy(y1,yup,8)    
	  else
c
c
c           determination of propagation matrix
c
            call edgmatinv(mai,4,k,0.d0,n)
            call edgmatrix(ma,4,k,h0,n)
            call axb(mai,yup,4,4,2,c0)
	    wave=dexp(-k*h0)
c
c           normalization of all modes
c
	    do j=1,2
              norm(j)=0.d0
              do i=1,4
                norm(j)=norm(j)+c0(i,j)*c0(i,j)
              enddo
	    enddo
	    fac=1.d0/dsqrt(norm(1)*norm(2))
c
c           orthogonalization of the p-sv modes
c
            orth(1,1)=c0(3,2)*fac
            orth(1,2)=-c0(1,2)*fac
            orth(2,1)=-c0(3,1)*fac
            orth(2,2)=c0(1,1)*fac
            call axb(c0,orth,4,2,2,c1)
            if(l.gt.lzrec)then
	      do j=1,2
	        do i=1,2
	          orth(i,j)=orth(i,j)*wave
	        enddo
	      enddo
              call axb(y0,orth,4,2,2,y1)
              call memcpy(y1,y0,8)
            endif
c
c           c1(1,1)=c1(1,1)
            c1(2,1)=c1(2,1)*wave*wave
            c1(3,1)=(0.d0,0.d0)
            c1(4,1)=c1(4,1)*wave*wave
c
            c1(1,2)=(0.d0,0.d0)
            c1(2,2)=c1(2,2)*wave*wave
c           c1(3,2)=c1(3,2)
            c1(4,2)=c1(4,2)*wave*wave
c
            call axb(ma,c1,4,4,2,yup)
	  endif
	  dro=ro(nno(l))-ro(nno(l-1))
	  do j=1,2
	    yup(2,j)=yup(2,j)+dro*g0*yup(1,j)
	  enddo
          if(l.eq.lzrec)call memcpy(yup,y0,8)
        enddo
c
c===============================================================================
c
c       matrix propagation from half-space to source
c
        do i=1,4
          do j=1,2
            c0(i,j)=0.d0
            ylw(i,j)=0.d0
          enddo
        enddo
c
c
c       c0(4,2): 2 coefficient vectors in the half-space
c
	n=nno(llw)
        if(vs(n).lt.eps0*vp(n))then
c
c         the lowest layer is fluid
c
	  ylw(1,1)=1.d0
          ylw(3,2)=1.d0
        else
c
c         the lowest layer is solid
c
          c0(2,1)=1.d0
          c0(4,2)=1.d0
          call edgmatrix(ma,4,k,0.d0,n)
          call axb(ma,c0,4,4,2,ylw)
        endif
        if(llw.gt.ls.and.llw.eq.lzrec)call memcpy(ylw,y0,8)
c
        do l=llw-1,ls,-1
          h0=hp(l)
          n=nno(l)
	  dro=ro(nno(l+1))-ro(nno(l))
	  do j=1,2
	    ylw(2,j)=ylw(2,j)-dro*g0*ylw(1,j)
	  enddo
	  if(k*h0.le.eps0)then
	    call edghask(hk,4,k,-h0,n)
	    call axb(hk,ylw,4,4,2,y1)
	    call memcpy(y1,ylw,8)
	  else
c
c
c           determination of propagation matrix
c
            call edgmatinv(mai,4,k,0.d0,n)
            call edgmatrix(ma,4,k,-h0,n)
            call axb(mai,ylw,4,4,2,c0)
	    wave=dexp(-k*h0)
c
c           normalization of all modes
c
	    do j=1,2
              norm(j)=0.d0
              do i=1,4
                norm(j)=norm(j)+c0(i,j)*c0(i,j)
              enddo
	    enddo
	    fac=1.d0/dsqrt(norm(1)*norm(2))
c
c           orthogonalization of the p-sv modes
c
            orth(1,1)=c0(4,2)*fac
            orth(1,2)=-c0(2,2)*fac
            orth(2,1)=-c0(4,1)*fac
            orth(2,2)=c0(2,1)*fac
            call axb(c0,orth,4,2,2,c1)
            if(l.lt.lzrec)then
	      do j=1,2
	        do i=1,2
	          orth(i,j)=orth(i,j)*wave
	        enddo
	      enddo
              call axb(y0,orth,4,2,2,y1)
              call memcpy(y1,y0,8)
            endif
c
	    c1(1,1)=c1(1,1)*wave*wave
c	    c1(2,1)=c1(2,1)
	    c1(3,1)=c1(3,1)*wave*wave
            c1(4,1)=(0.d0,0.d0)
c
            c1(1,2)=c1(1,2)*wave*wave
            c1(2,2)=(0.d0,0.d0)
            c1(3,2)=c1(3,2)*wave*wave
c           c1(4,2)=c1(4,2)
c
            call axb(ma,c1,4,4,2,ylw)
	  endif
          if(l.gt.ls.and.l.eq.lzrec)call memcpy(ylw,y0,8)
        enddo
c
c===============================================================================
c
c       conditions on the source surface
c
c
c       source function
c
        do i=1,4
          if(kpower(i).eq.1)then
            fac=k
          else
            fac=1.d0
          endif
          b(i)=sfct(i)*fac
          do j=1,2
            coef(i,j)=yup(i,j)
            coef(i,j+2)=-ylw(i,j)
          enddo
        enddo
        key=0
	call gemp(coef,b,4,1,1.d-99,key)
        if(key.eq.0)then
          print *,'warning in edgpsv: anormal exit from cgemp!'
          return
        endif
        if(lzrec.le.ls)then
          do i=1,4
            y(i)=0.d0
            do j=1,2
              y(i)=y(i)+b(j)*y0(i,j)
            enddo
          enddo
        else
          do i=1,4
            y(i)=0.d0
            do j=1,2
              y(i)=y(i)+b(j+2)*y0(i,j)
            enddo
          enddo
        endif
c
        return
        end

        subroutine cmemcpy(a,b,n)
        implicit none
c
c       copy complex array a to b
c
        integer*4 n
        complex*16 a(n),b(n)
c
        integer*4 i
c
        do i=1,n
          b(i)=a(i)
        enddo
        return
        end

      subroutine qsmultis(grnexist)
      implicit none
      logical*4 grnexist
      include 'qsglobal.h'
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     this program calculates convolution integral (summation)         c
c     of discrete sources to model the seismic ground motion of        c
c     an earthquake with arbitrary moment tensor distribution          c
c                                                                      c
c     The inputs are:                                                  c
c                                                                      c
c     1) Green's functions for surface movement (displacement          c
c        or velocity);                                                 c
c                                                                      c
c     2) source parameters including the source coordinates, the       c
c        strike, dip and rake angles as well as the released           c
c        energy (moment);                                              c
c                                                                      c
c     3) receiver parameters including the receiver coordinates.       c
c                                                                      c
c     The outputs are the surface motion at receiver sites.            c
c                                                                      c
c                                                                      c
c     ~~~~~~~~~~~~~~~~~~                                               c
c     Coordinate system:                                               c
c     ~~~~~~~~~~~~~~~~~~                                               c
c     cylindrical (z,r,t) with z = downward,                           c
c                t = azmuth angle from north;                          c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 ir,lf,icmp,istp,unit
      real*8 az1,az2
      real*8 weight(0:5)
      real*8 t(2*nfmax),y1(nrmax),y2(nrmax)
      character*110 textline
c
      real*8 deg2rad
      data deg2rad/1.745329251994328d-02/
c
      if(grnexist)then
        do istp=1,4
          do icmp=1,9
            if(ms(istp).eq.0.and.icmp.eq.3)then
              do lf=1,nf
                do ir=1,nr
                  grns(lf,icmp,ir,istp)=(0.d0,0.d0)
                enddo
              enddo
            else
              unit=istp*10+icmp
              open(unit,file=outfile(icmp,istp),status='old')
              read(unit,'(a1)')textline
              do lf=1,nf
                read(unit,*,end=100)t(2*lf-1),(y1(ir),ir=1,nr)
                read(unit,*,end=100)t(2*lf),(y2(ir),ir=1,nr)
                do ir=1,nr
                  grns(lf,icmp,ir,istp)=dcmplx(y1(ir),y2(ir))
                enddo
              enddo
100           close(unit)
            endif
          enddo
        enddo
      endif
c
      weight(0)=(mtensor(1)+mtensor(2)+mtensor(3))/3.d0
      weight(1)=mtensor(4)
      weight(2)=mtensor(6)
      weight(3)=mtensor(3)-weight(0)
      weight(4)=0.5d0*(mtensor(1)-mtensor(2))
      weight(5)=mtensor(5)
c
      do ir=1,nr
        az1=azimuth(ir)*deg2rad
        az2=2.d0*az1
        do lf=1,nf
         grns(lf,1,ir,7)=grns(lf,1,ir,1)*dcmplx(weight(0),0.d0)
     &                  +grns(lf,1,ir,2)
     &     *dcmplx(weight(1)*dsin(az2)+weight(4)*dcos(az2),0.d0)
     &                  +grns(lf,1,ir,3)
     &     *dcmplx(weight(2)*dcos(az1)+weight(5)*dsin(az1),0.d0)
     &                  +grns(lf,1,ir,4)*dcmplx(weight(3),0.d0)
c
         grns(lf,2,ir,7)=grns(lf,2,ir,1)*dcmplx(weight(0),0.d0)
     &                  +grns(lf,2,ir,2)
     &     *dcmplx(weight(1)*dsin(az2)+weight(4)*dcos(az2),0.d0)
     &                  +grns(lf,2,ir,3)
     &     *dcmplx(weight(2)*dcos(az1)+weight(5)*dsin(az1),0.d0)
     &                  +grns(lf,2,ir,4)*dcmplx(weight(3),0.d0)
c
         grns(lf,3,ir,7)=grns(lf,3,ir,2)
     &     *dcmplx(weight(1)*dcos(az2)-weight(4)*dsin(az2),0.d0)
     &                  +grns(lf,3,ir,3)
     &     *dcmplx(weight(2)*dsin(az1)-weight(5)*dcos(az1),0.d0)
c
         grns(lf,4,ir,7)=grns(lf,4,ir,1)*dcmplx(weight(0),0.d0)
     &                  +grns(lf,4,ir,2)
     &     *dcmplx(weight(1)*dsin(az2)+weight(4)*dcos(az2),0.d0)
     &                  +grns(lf,4,ir,3)
     &     *dcmplx(weight(2)*dcos(az1)+weight(5)*dsin(az1),0.d0)
     &                  +grns(lf,4,ir,4)*dcmplx(weight(3),0.d0)
        enddo
      enddo
      if(grnexist)then
        do icmp=1,9
          if(fsel(icmp,7).eq.1)then
            unit=40+icmp
            open(unit,file=outfile(icmp,7),status='unknown')
            write(unit,'(a,$)')'   T_sec    '
            do ir=1,nr-1
              write(unit,'(a4,a1,a1,2a4,$)')'   ',
     &             varbtxt,comptxt(icmp),rcvtxt(ir),'   '
            enddo
            write(unit,'(a4,a1,a1,2a4)')'   ',
     &             varbtxt,comptxt(icmp),rcvtxt(nr),'   '
            do lf=1,nf
              write(unit,'(f12.5,$)')t(2*lf-1)
              do ir=1,nr-1
                write(unit,'(E12.4,$)')dreal(grns(lf,icmp,ir,7))
              enddo
              write(unit,'(E12.4)')dreal(grns(lf,icmp,nr,7))
c
              write(unit,'(f12.5,$)')t(2*lf)
              do ir=1,nr-1
                write(unit,'(E12.4,$)')dimag(grns(lf,icmp,ir,7))
              enddo
              write(unit,'(E12.4)')dimag(grns(lf,icmp,nr,7))
            enddo
            close(unit)
          endif
        enddo
      endif
c
      return
      end
      

      subroutine qshksh(hk,z,n,rsite)
      implicit none
c
      integer*4 n
      real*8 z
      complex*16 hk(2,2)
      logical*4 rsite
c
      include 'qsglobal.h'
c
      complex*16 cx,cem,cch,csh
c
      if(rsite)then
        cx=ksrs(n)*dcmplx(2.d0*z,0.d0)
        if(z.gt.0.d0)then
          cem=cdexp(-cx)
          cch=(0.5d0,0.d0)*((1.d0,0.d0)+cem)
          csh=(0.5d0,0.d0)*((1.d0,0.d0)-cem)
        else
          cem=cdexp(cx)
          cch=(0.5d0,0.d0)*((1.d0,0.d0)+cem)
          csh=-(0.5d0,0.d0)*((1.d0,0.d0)-cem)
        endif
c
c       propagator matrix for SH waves
c
        hk(1,1)=cch
        hk(1,2)=csh/(cmurs(n)*ksrs(n))
        hk(2,1)=csh*cmurs(n)*ksrs(n)
        hk(2,2)=cch
      else
        cx=ks(n)*dcmplx(2.d0*z,0.d0)
        if(z.gt.0.d0)then
          cem=cdexp(-cx)
          cch=(0.5d0,0.d0)*((1.d0,0.d0)+cem)
          csh=(0.5d0,0.d0)*((1.d0,0.d0)-cem)
        else
          cem=cdexp(cx)
          cch=(0.5d0,0.d0)*((1.d0,0.d0)+cem)
          csh=-(0.5d0,0.d0)*((1.d0,0.d0)-cem)
        endif
c
c       propagator matrix for SH waves
c
        hk(1,1)=cch
        hk(1,2)=csh/(cmu(n)*ks(n))
        hk(2,1)=csh*cmu(n)*ks(n)
        hk(2,2)=cch
      endif
      return
      end

	subroutine edcdisc(ns,nz,z1,z2,dr,dz,nps)
	implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	integer ns,nz,nps
	double precision z1,z2,dr,dz
c
c	inputs:
c	ns = total number of source rectangles
c	nz,z1,z2 = number of depth samples, start and end depths used
c		in Green's functions
c	dlength, dwidth = grid size for discretisation
c
c	returned outputs:
c	nps = total number of discrete point sources
c	other outputs through common blocks
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	LOCAL CONSTANTS
c	===============
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision DEGTORAD
	data DEGTORAD/1.745329252E-02/
c
	include 'edcglobal.h'
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	RECTANGULAR SOURCE PLANES
c	=========================
c
c	(xs,ys,zs) = coordinates of the start point of strike
c	with x = north, y = east, z = downward.
c	all angles in degree.
c	NSMAX = the max. number of source rectangles
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision dislocation(NSMAX)
	double precision xs(NSMAX),ys(NSMAX),zs(NSMAX)
	double precision length(NSMAX),width(NSMAX)
	double precision strike(NSMAX),dip(NSMAX),rake(NSMAX)
c
	common/rectangles/dislocation,xs,ys,zs,length,width,
     &                    strike,dip,rake
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	DISTRETE POINT SOURCES
c	======================
c
c	(xs,ys,zs) = coordinates of the discrete point sources
c	with x = north, y = east, z = downward
c	angles in degree.
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision pxs(NPSMAX),pys(NPSMAX),pzs(NPSMAX)
	double precision pmoment(5,NPSMAX)
c
	common/pointsources/pxs,pys,pzs,pmoment
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	OBSERVATION POSITIONS AND OBSERVABLES
c	=====================================
c
c	(xrec(i),yrec(i),zrec0)=coordinates of the observation positions
c	(Note that zrec0 is fixed)
c	disp = the 3 displcement vector components: ux,uy,uz
c	strain = the 6 strain tensor components: exx,eyy,ezz,exy,eyz,ezx
c	NRECMAX = the max. number of observation positions
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision xrec(NRECMAX),yrec(NRECMAX)
	double precision zrec0
	double precision disp(NRECMAX,3),strain(NRECMAX,6)
	double precision tilt(NRECMAX,2)
c
	common/obsarray/xrec,yrec,zrec0,disp,strain,tilt
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	WARNING STATISTICS
c	==================
c
c	nwarn = total number of warnings
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	integer nwarn
c
	common/warnings/nwarn
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	LOCAL WORK SPACES
c	=================
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	integer is,ix,iy,nx,ny
	double precision x,y,dx,dy,st,di,ra,disarea
	double precision dlength,dwidth
	double precision sm(3,3)
c
	write(*,'(a)')' ... discretise rectangular plane sources:'
	dlength=dr
	nps=0
	do is=1,ns
c
	  st=strike(is)*DEGTORAD
	  di=dip(is)*DEGTORAD
	  ra=rake(is)*DEGTORAD
c
          if(di.gt.0.d0)then
	    dwidth=dmin1(dr,dz/dsin(di))
          else
            dwidth=dr
          endif
c
	  sm(1,1)=-dsin(di)*dcos(ra)*dsin(2.d0*st)
     &            -dsin(2.d0*di)*dsin(ra)*(dsin(st))**2
	  sm(2,2)= dsin(di)*dcos(ra)*sin(2.d0*st)
     &            -dsin(2.d0*di)*dsin(ra)*(dcos(st))**2
	  sm(3,3)=-(sm(1,1)+sm(2,2))
	  sm(1,2)= dsin(di)*dcos(ra)*dcos(2.d0*st)
     &            +0.5d0*dsin(2.d0*di)*dsin(ra)*dsin(2.d0*st)
	  sm(2,1)=sm(1,2)
	  sm(1,3)=-dcos(di)*dcos(ra)*dcos(st)
     &            -dcos(2.d0*di)*dsin(ra)*dsin(st)
	  sm(3,1)=sm(1,3)
	  sm(2,3)=-dcos(di)*dcos(ra)*dsin(st)
     &            +dcos(2.d0*di)*dsin(ra)*dcos(st)
	  sm(3,2)=sm(2,3)
c
	  nx=max0(1,idnint(length(is)/dlength))
	  ny=max0(1,idnint(width(is)/dwidth))
	  dx=length(is)/dble(nx)
	  dy=width(is)/dble(ny)
c
c	  if one of length and width = 0, then it is a line source
c	  if both length and width = 0, then it is a point source
c
	  disarea=dislocation(is)
	  if(dx.gt.0.d0)then
	    disarea=disarea*dx
	  endif
	  if(dy.gt.0.d0)then
	    disarea=disarea*dy
	  endif
c
	  do ix=1,nx
	    x=dx*(dble(ix)-0.5d0)
	    do iy=1,ny
	      y=dy*(dble(iy)-0.5d0)
	      nps=nps+1
	      if(nps.gt.NPSMAX)then
	        print *,' Warning: too large number for discrete ',
     &                  'point sources (i.e., NPSMAX too small)!'
	        nwarn=nwarn+1
	        nps=NPSMAX
	        return
	      endif
	      pxs(nps)=xs(is)+x*dcos(st)-y*dcos(di)*dsin(st)
	      pys(nps)=ys(is)+x*dsin(st)+y*dcos(di)*dcos(st)
	      pzs(nps)=zs(is)+y*dsin(di)
	      if(pzs(nps).lt.z1-dz)then
	        print *,' Warning: parts of source rectangles shallower'
	        print *,'          than the Green function grids!'
	        nwarn=nwarn+1
	      endif
	      if(pzs(nps).gt.z2+dz)then
	        print *,' Warning: parts of source rectangles deeper'
	        print *,'          than the Green function grids!'
	        nwarn=nwarn+1
	      endif
c
c	      1 = weight for strike-slip: m12=m21=1;
c	      2 = weight for dip-slip: m13=m31=1
c	      3 = weight for clvd: m33=-m11=-m22=1
c	      4 = weight for 45 deg strike-slip: m11=-m22=1
c	      5 = weight for 45 deg dip-slip: m23=m32=1
c
	      pmoment(1,nps)=sm(1,2)*disarea
	      pmoment(2,nps)=sm(1,3)*disarea
	      pmoment(3,nps)=sm(3,3)*disarea
	      pmoment(4,nps)=0.5d0*(sm(1,1)-sm(2,2))*disarea
	      pmoment(5,nps)=sm(2,3)*disarea
	    enddo
	  enddo
	  write(*,'(a,i2,a,i6,a)')' the ',is,'. rectangle => ',
     &                            nx*ny,' point sources.'
	enddo
	write(*,*)'------------------------------------------------'
	write(*,'(a,i7)')' the total number of point sources: ',nps
c
	return
	end

	subroutine edgsublay(resolut,itty,ierr)
	implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	integer itty,ierr
	double precision resolut(3)
c
	include 'edgglobal.h'
c       
c       model parameter:
c       n0: number of homogeneous layers
c
        integer n0
        double precision h(lmax),ro(lmax),vp(lmax),vs(lmax)
        common /model/ h,ro,vp,vs,n0
c
c	original model parameters
c
	integer l0
        double precision z1(lmax),z2(lmax),ro1(lmax),ro2(lmax)
	double precision vp1(lmax),vp2(lmax),vs1(lmax),vs2(lmax)
	common /model0/z1,z2,ro1,ro2,vp1,vp2,vs1,vs2,l0
c
c	work space
c
	double precision eps
	data eps/1.0d-02/
	integer i,i0,l
	double precision dh,dro,dvp,dvs,z,dz
c
	n0=0
	do l=1,l0-1
	  dz=z2(l)-z1(l)
	  dvp=2.d0*dabs(vp2(l)-vp1(l))/(vp2(l)+vp1(l))
	  dvs=2.d0*dabs(vs2(l)-vs1(l))/(vs2(l)+vs1(l))
	  dro=2.d0*dabs(ro2(l)-ro1(l))/(ro2(l)+ro1(l))
	  i0=idnint(dmax1(dro/resolut(1),
     &       dvp/resolut(2),dvs/resolut(3)))
	  i0=max0(1,i0)
	  dro=(ro2(l)-ro1(l))/dz
	  dvp=(vp2(l)-vp1(l))/dz
	  dvs=(vs2(l)-vs1(l))/dz
	  dh=dz/dble(i0)
	  do i=1,i0
	    n0=n0+1
	    if(n0.ge.lmax)then
	      ierr=1
	      return
	    endif
	    h(n0)=dh
	    z=(dble(i)-0.5d0)*dh
	    ro(n0)=ro1(l)+dro*z
	    vp(n0)=vp1(l)+dvp*z
	    vs(n0)=vs1(l)+dvs*z
	  enddo
	enddo
c
c	last layer is halfspace
c
	n0=n0+1
	h(n0)=0.d0
	ro(n0)=ro1(l0)
	vp(n0)=vp1(l0)
	vs(n0)=vs1(l0)
c
	if(itty.eq.1)then
	  write(*,'(7a)')' no ',' thick(m)  ','   vp(m/s) ',
     &    '  vs(m/s)  ',' ro(kg/m^3)'
	  do i=1,n0
	    write(*,1001)i,h(i),vp(i),vs(i),ro(i)
	  enddo
	endif
1001	format(i4,4f11.4)
	ierr=0
	return
	end

      subroutine qpwvint(ierr)
      use qpalloc
      implicit none
      integer*4 ierr
c
      integer*4 i,j,m,id,ir,it,ig,nd,nt0,nf0,ntcut0,nfcut0
      integer*4 lf,istp,ldeg,ldegf,ldegup,ldegcri
      real*4 tredr4
      real*8 depsarc,f,dt0,df0,rn,re,azi,t,tp2s
      real*8 a,b,slwcut,discri,twinred
      complex*16 cp0,cp1,cp2
      complex*16 cfac,ca,cb
c
      integer*4, allocatable:: idr(:),ldegtap(:,:)
      real*8, allocatable:: tap(:,:)
      complex*16, allocatable:: ssd(:),ssf(:),wvf(:),bpf(:)
c
      integer*4 fseek,ftell
c
      twinred=0.65d0*(dble(nt-1)*dt-tstart)
c
      ierr=0
      allocate(idr(nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: idr not allocated!'
      allocate(ldegtap(4,nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: ldegtap not allocated!'
      allocate(ssd(nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: ssd not allocated!'
      allocate(ssf(nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: ssf not allocated!'
      allocate(wvf(nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: wvf not allocated!'
      allocate(bpf(nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: ssd not allocated!'
      allocate(tap(0:ldegmax,nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: tap not allocated!'
      allocate(plm(0:ldegmax,0:2,nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: plm not allocated!'
      allocate(sgrn(nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: sgrn not allocated!'
      allocate(tgrn(2*nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: tgrn not allocated!'
      allocate(vgrnr(nf,nr,4),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: vgrnr not allocated!'
      allocate(vgrnt(nf,nr,4),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: vgrnt not allocated!'
      allocate(vgrnp(nf,nr,4),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: vgrnp not allocated!'
      allocate(cswap(2*nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: cswap not allocated!'
      allocate(dswap(4*nf),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpwvint: dswap not allocated!'
c
      call swavelet(tau,df,fi,nf,wvf)
c
c     band-pass filter
c
      if(nbpf.gt.0.and.f2corner.gt.f1corner.and.f1corner.gt.0.d0)then
        if(f1corner.le.0.d0)then
          call butterworth(nbpf,f2corner,df,nf,cswap)
        else
          call bandpass(nbpf,f1corner,f2corner,df,nf,cswap)
        endif
c
        m=1
        do lf=2*nf,nf+2,-1
          m=m+1
          cswap(lf)=dconjg(cswap(m))
        enddo
        cswap(nf+1)=(0.d0,0.d0)
        call four1w(cswap,dswap,2*nf,+1)
        do lf=1,2*nf
          t=dble(lf-1)*dt
          cswap(lf)=dcmplx(dswap(2*lf-1)*dexp(PI2*fi*t)*df,0.d0)
        enddo
        call four1w(cswap,dswap,2*nf,-1)
        do lf=1,nf
          bpf(lf)=cswap(lf)*dcmplx(dt,0.d0)
        enddo
        do lf=1,nf
          wvf(lf)=wvf(lf)*bpf(lf)
        enddo
      endif
c
      do ir=1,nr
        ssd(ir)=dcmplx(dsin(disrad(ir)),0.d0)
        ssf(ir)=dcmplx(2.d0*dsin(0.5d0*disrad(ir))**2,0.d0)
      enddo
c
      call qplegendre(ierr)
c
      do ig=1,ngrn
        lys=lygrn(ig)
        depsarc=grndep(ig)/REARTH
        do ir=1,nr
          if(slwmax.le.0.d0)then
            idr(ir)=0
          else
            idr(ir)=min0(ndmax,max0(0,
     &            idnint(dlog(disrad(ir)/depsarc)/dlog(50.d0))))
          endif
        enddo
c
        write(*,'(a)')' '
        write(*,'(a)')' open Green function data base: '
     &              //grnfile(ig)(1:40)
        write(*,'(a)')' ... please wait ...'
c
        open(21,file=rgrnfile(ig),
     &       form='unformatted',status='old')
        open(22,file=tgrnfile(ig),
     &       form='unformatted',status='old')
        open(23,file=pgrnfile(ig),
     &       form='unformatted',status='old')
c
        open(30,file=stdgrnfile(ig),
     &       form='unformatted',status='unknown')
c
        read(21)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(22)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
        read(23)nt0,ntcut0,dt0,nf0,nfcut0,df0,ldegup
c
        if(ntcut0.ne.ntcut.or.dt0.ne.dt.or.
     &     nfcut0.ne.nfcut.or.df0.ne.df)then
          print *,' Error in qpwvint: t/f sampling'
     &          //' inconsistent with Green functions!'
          write(*,'(a)')'               '//'  ntcut             dt'
     &                                   //'  nfcut             df'
          write(*,'(a,2(i7,f16.8))')' Current input:',
     &                               ntcut,dt,nfcut,df
          write(*,'(a,2(i7,f16.8))')'     Data base:',
     &                               ntcut0,dt0,nfcut0,df0
          stop
        endif
c
        nd=0
        do ir=1,nr
          nd=max0(nd,idr(ir))
        enddo
c
        do istp=1,4
          do ir=1,nr
            do lf=1,nf
              vgrnr(lf,ir,istp)=(0.d0,0.d0)
              vgrnt(lf,ir,istp)=(0.d0,0.d0)
            enddo
          enddo
        enddo
        do istp=2,3
          do ir=1,nr
            do lf=1,nf
              vgrnp(lf,ir,istp)=(0.d0,0.d0)
            enddo
          enddo
        enddo
c
        do lf=1,nfcut
          f=dble(lf-1)*df
          read(21)ldegf
          read(22)ldegf
          read(23)ldegf
c
          read(21)((yr(ldeg,istp,0),ldeg=0,ldegf),istp=1,4)
          read(22)((yt(ldeg,istp,0),ldeg=0,ldegf),istp=1,4)
          read(23)((yp(ldeg,istp,0),ldeg=0,ldegf),istp=2,3)
c
          do ir=1,nr
            ldegtap(1,ir)=0
            ldegtap(2,ir)=0
          enddo
c
          m=0
          do ir=1,nr
            tp2s=ts(ir,ig)-tp(ir,ig)
            if(tp2s.lt.twinred)then
              slwcut=0.d0
              ldegtap(4,ir)=ldegf-nd
              m=ir
            else
              slwcut=slwtp(ir,ig)
     &              +(slwts(ir,ig)-slwtp(ir,ig))*twinred/tp2s
              ldegtap(4,ir)=max0(10*nd,
     &                       nd+idint(rrup(min0(lyr,lys))*PI2*f*slwcut))
            endif
          enddo
c
          if(m.lt.nr)then
            do ir=1,m
              b=dism(ir)/dism(m+1)
              a=1.d0-b
              ldegtap(4,ir)=idnint(a*dble(ldegf-nd)
     &                            +b*dble(ldegtap(4,m+1)))
            enddo
          endif
c
          do ir=1,nr
            ldegtap(3,ir)=ldegtap(4,ir)*4/5
            call taper(ldegtap(1,ir),ldegf,tap(0,ir))
          enddo
c
c         use differential filter to suppress spatial aliasing
c
          do id=0,nd
            yt(0,1,id)=(0.d0,0.d0)
            yt(0,4,id)=(0.d0,0.d0)
c
            yr(0,3,id)=(0.d0,0.d0)
            yt(0,3,id)=(0.d0,0.d0)
            yp(0,3,id)=(0.d0,0.d0)
c
            yr(0,2,id)=(0.d0,0.d0)
            yt(0,2,id)=(0.d0,0.d0)
            yp(0,2,id)=(0.d0,0.d0)
c
            yr(1,2,id)=(0.d0,0.d0)
            yt(1,2,id)=(0.d0,0.d0)
            yp(1,2,id)=(0.d0,0.d0)
          enddo
c
          do id=1,nd
c
c           m = 0
c
            ca=dcmplx(1.d0/3.d0,0.d0)
            yr(0,1,id)=yr(0,1,id-1)-ca*yr(1,1,id-1)
            yr(0,4,id)=yr(0,4,id-1)-ca*yr(1,4,id-1)
            do ldeg=1,ldegf-id
              ca=dcmplx(dble(ldeg+1)/dble(2*ldeg+3),0.d0)
              cb=dcmplx(dble(ldeg)/dble(2*ldeg-1),0.d0)
              yr(ldeg,1,id)=yr(ldeg,1,id-1)-ca*yr(ldeg+1,1,id-1)
     &                     -cb*yr(ldeg-1,1,id-1)
              yr(ldeg,4,id)=yr(ldeg,4,id-1)-ca*yr(ldeg+1,4,id-1)
     &                     -cb*yr(ldeg-1,4,id-1)
            enddo
c
c           m = 1
c
            do ldeg=1,ldegf-id
              ca=dcmplx(dble(ldeg+2)/dble(2*ldeg+3),0.d0)
              cb=dcmplx(dble(ldeg-1)/dble(2*ldeg-1),0.d0)
              yt(ldeg,1,id)=yt(ldeg,1,id-1)-ca*yt(ldeg+1,1,id-1)
     &                     -cb*yt(ldeg-1,1,id-1)
              yt(ldeg,4,id)=yt(ldeg,4,id-1)-ca*yt(ldeg+1,4,id-1)
     &                     -cb*yt(ldeg-1,4,id-1)
              yr(ldeg,3,id)=yr(ldeg,3,id-1)-ca*yr(ldeg+1,3,id-1)
     &                     -cb*yr(ldeg-1,3,id-1)
              yt(ldeg,3,id)=yt(ldeg,3,id-1)-ca*yt(ldeg+1,3,id-1)
     &                     -cb*yt(ldeg-1,3,id-1)
              yp(ldeg,3,id)=yp(ldeg,3,id-1)-ca*yp(ldeg+1,3,id-1)
     &                     -cb*yp(ldeg-1,3,id-1)
            enddo
c
c           m = 2
c
            do ldeg=2,ldegf-id
              ca=dcmplx(dble(ldeg+3)/dble(2*ldeg+3),0.d0)
              cb=dcmplx(dble(ldeg-2)/dble(2*ldeg-1),0.d0)
              yr(ldeg,2,id)=yr(ldeg,2,id-1)-ca*yr(ldeg+1,2,id-1)
     &                     -cb*yr(ldeg-1,2,id-1)
              yt(ldeg,2,id)=yt(ldeg,2,id-1)-ca*yt(ldeg+1,2,id-1)
     &                     -cb*yt(ldeg-1,2,id-1)
              yp(ldeg,2,id)=yp(ldeg,2,id-1)-ca*yp(ldeg+1,2,id-1)
     &                     -cb*yp(ldeg-1,2,id-1)
            enddo
          enddo
c
          do ir=1,nr
            id=idr(ir)
            do ldeg=ldegtap(1,ir),ldegtap(4,ir)
              cp0=dcmplx(tap(ldeg,ir)*plm(ldeg,0,ir),0.d0)
              cp1=dcmplx(tap(ldeg,ir)*plm(ldeg,1,ir),0.d0)
              cp2=dcmplx(tap(ldeg,ir)*plm(ldeg,2,ir),0.d0)
              vgrnr(lf,ir,1)=vgrnr(lf,ir,1)+yr(ldeg,1,id)*cp0
              vgrnr(lf,ir,2)=vgrnr(lf,ir,2)+yr(ldeg,2,id)*cp2*ssd(ir)**2
              vgrnr(lf,ir,3)=vgrnr(lf,ir,3)+yr(ldeg,3,id)*cp1*ssd(ir)
              vgrnr(lf,ir,4)=vgrnr(lf,ir,4)+yr(ldeg,4,id)*cp0
c
              vgrnt(lf,ir,1)=vgrnt(lf,ir,1)+yt(ldeg,1,id)*cp1*ssd(ir)
              vgrnt(lf,ir,2)=vgrnt(lf,ir,2)+yt(ldeg,2,id)*cp2*ssd(ir)
              vgrnt(lf,ir,3)=vgrnt(lf,ir,3)+yt(ldeg,3,id)*cp1
              vgrnt(lf,ir,4)=vgrnt(lf,ir,4)+yt(ldeg,4,id)*cp1*ssd(ir)
c
              vgrnp(lf,ir,2)=vgrnp(lf,ir,2)+yp(ldeg,2,id)*cp2*ssd(ir)
              vgrnp(lf,ir,3)=vgrnp(lf,ir,3)+yp(ldeg,3,id)*cp1
            enddo
            if(id.gt.0)then
              cfac=(1.d0,0.d0)/ssf(ir)**id
              do istp=1,4
                vgrnr(lf,ir,istp)=vgrnr(lf,ir,istp)*cfac
                vgrnt(lf,ir,istp)=vgrnt(lf,ir,istp)*cfac
              enddo
              do istp=2,3
                vgrnp(lf,ir,istp)=vgrnp(lf,ir,istp)*cfac
              enddo
            endif
          enddo
          write(*,'(i6,a,f10.4,a,i5)')lf,'.',1.0d+03*f,
     &                        ' mHz: spectra read: ',ldegf
        enddo
        close(21)
        close(22)
        close(23)
        write(*,'(i6,a)')lf-1,' spectra read from '
     &                      //grnfile(ig)(1:40)
c
c       FFT
c
        do lf=nfcut+1,nf
          sgrn(lf)=(0.d0,0.d0)
        enddo
c
        do ir=1,nr
          tred=dble(idnint(tstart+tp(ir,ig)))
          tredr4=sngl(tred)
          write(30)tredr4
c
c         time domain Green's functions
c
c---------explosion source
c         vertival component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnr(lf,ir,1)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c         radial component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnt(lf,ir,1)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c---------strike-slip source
c         vertival component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnr(lf,ir,2)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c         radial component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnt(lf,ir,2)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c         tangential component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnp(lf,ir,2)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c---------dip-slip source
c         vertival component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnr(lf,ir,3)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c         radial component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnt(lf,ir,3)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c         tangential component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnp(lf,ir,3)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c---------clvd source
c         vertival component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnr(lf,ir,4)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
c
c         radial component
c
          do lf=1,nfcut
            sgrn(lf)=wvf(lf)*vgrnt(lf,ir,4)
          enddo
          call qpfftinv(ierr)
          write(30)(tgrn(it),it=1,ntout)
        enddo
c
        close(30)
c
      enddo
c
      deallocate(idr,ssd,ssf,wvf,bpf,tap,plm,
     &           sgrn,tgrn,vgrnr,vgrnt,vgrnp)
c
      return
      end

      double precision function fsimpson(xa,xb,c)
      implicit none
      real*8 xa,xb,c
c
c     integrate dsqrt(c^2-x^2)/x from xa to xb
c
      integer*4 i,n
      real*8 x,dx,y,f1,f2
c
      integer*4 nmax
      real*8 eps
      data nmax/2048/
      data eps/1.0d-03/
c
      n=1
      dx=xb-xa
      y=0.5d0*(dsqrt(c*c-xa*xa)/xa+dsqrt(c*c-xb*xb)/xb)
      f1=0.d0
      f2=y*dx
10    n=2*n
      dx=0.5d0*dx
      do i=1,n-1,2
        x=xa+dble(i)*dx
        y=y+dsqrt(c*c-x*x)/x
      enddo
      f2=y*dx
      if(dabs(f2-f1).gt.eps*f2.and.n.lt.nmax)then
        f1=f2
        goto 10
      endif
      fsimpson=f2
c
      return
      end

      subroutine qpstart0a(ly,jh,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c     for n = 0
c
      integer*4 ly,jh
      complex*16 cy(3)
c
      integer i
      real*8 peps
      complex*16 c2mu,cxi,cxp2,ca,cb,ya,yb
c
      real*8 eps
      complex*16 c2
      data eps/1.0d-08/
      data c2/(2.d0,0.d0)/
c
      c2mu=c2*cmu(ly)
      cxi=cla(ly)+c2mu
      cxp2=(kp(ly)*crrup(ly))**2
c
      if(jh.eq.1.and.ly.ge.lys)then
        cy(1)=zh12p(0,1,ly)
        cy(2)=cxi*cxp2-c2*c2mu*zh12p(0,1,ly)
        cy(3)=-cga(ly)
        peps=dabs(dimag(zh12p(0,1,ly)))/cdabs(zh12p(0,1,ly))
        if(peps.lt.eps)then
          ca=dcmplx((peps/eps)**2,0.d0)
          cb=(1.d0,0.d0)-ca
          ya=cy(1)
          yb=mas3x3up(1,1,ly)
          do i=1,3
            cy(i)=ca*cy(i)*yb+cb*mas3x3up(i,1,ly)*ya
          enddo
        endif
      else if(jh.eq.2.and.ly.le.lys)then
        cy(1)=zh12p(0,2,ly)
        cy(2)=cxi*cxp2-c2*c2mu*zh12p(0,2,ly)
        cy(3)=-cga(ly)
      else
        stop ' Error in qpstart0a: bad jh value!'
      endif
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Subroutine: spbjh                                                         c
c     calculates spherical Bessel functions for complex argument                c
c     zj(x)=x*j_(n+1)(x)/[j_n(x)+ix*j_(n+1)(x)], x = xa,xb                      c
c     wj(xa,xb)=ln{[j_n(xa)+i*xa*j_(n+1)(xa)]/[j_n(xb)+i*xb*j_(n+1)(xb)]}       c
c     zh(x)=x*h_(n+1)(x)/h_n(x), x=xa,xb                                        c
c     wh(xa,xb)=ln[h_n(xa)/h_n(xb)], where h_n(x) = j_n(x) + sign[im(x)]iy_n(x) c
c     where xa = ck*ra, xb = ck*rb                                              c
c     for harmonic degree nn                                                    c
c                                                                               c
c     Input:                                                                    c
c     nn = max. order                                                           c
c     xa,xb = complex arguments                                                 c
c                                                                               c
c     Output:                                                                   c
c     complex zja(n,xa), zjb(n,xb), wj(n,xa,xb)                                 c
c             zha(n,xa), zhb(n,xb), wh(n,xa,xb)                                 c
c             for n = 0, ..., nn                                                c
c                                                                               c
c     First implemention: 17 June 2007                                          c
c     Rongjiang Wang                                                            c
c     GeoForschungsZentrum Potsdam, Germany                                     c
c     Email: wang@gfz-potsdam.de                                                c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine spbjh(nn,ck,ra,rb,zja,zjb,wj,zha,zhb,wh)
      implicit none
      integer*4 nn
      real*8 ra,rb
      complex*16 ck
      complex*16 zja(0:nn),zjb(0:nn),wj(0:nn)
      complex*16 zha(0:nn),zhb(0:nn),wh(0:nn)
c
c     local memory
c
      integer*4 n,nx,nmax
      real*8 xra,xrb,xia,xib
      complex*16 xa,xb,xa2,xb2,ga,gb,gn,zja0,zjb0,zja1,zjb1
      complex*16 fs0,fc0,fs1,fc1,cep0,cep1,cem0,cem1,cfac
      complex*16 c2xj0,c2x2j1,phj0,phj1
      complex*16 spbphj
c
      real*8 pi,eps
      complex*16 ci,c1,c2
      data pi,eps/3.14159265358979d0,1.0d-06/
      data ci,c1,c2/(0.d0,1.d0),(1.d0,0.d0),(2.d0,0.d0)/
c
      xa=ck*dcmplx(ra,0.d0)
      xb=ck*dcmplx(rb,0.d0)
c
      xra=dreal(xa)
      xrb=dreal(xb)
      xia=dimag(xa)
      xib=dimag(xb)
      xa2=xa*xa
      xb2=xb*xb
c
      cep0=cdexp(dcmplx(0.d0,xra))
      cem0=c1/cep0
      cfac=dcmplx(dexp(-2.d0*dabs(xia)),0.d0)
      if(xia.ge.0.d0)then
        c2xj0=(cfac*cep0-cem0)/ci
        c2x2j1=c2xj0-(cfac*cep0+cem0)*xa
      else
        c2xj0=(cep0-cfac*cem0)/ci
        c2x2j1=c2xj0-(cep0+cfac*cem0)*xa
      endif
      wj(0)=c2xj0+ci*c2x2j1
c
      if(dble(nn).le.0.5d0*cdabs(xa))then
c
c       recursion upward to a large enough degree
c
        nmax=10+2*nn
        zja0=ci*c2x2j1/(c2xj0+ci*c2x2j1)
        do n=1,nmax
          ga=dcmplx(dble(2*n+1),0.d0)+ci*xa2
          zja0=(ga*zja0-ci*xa2)/((ga-ci)*zja0-ci*xa2)
        enddo
c
c       recursion downward to correct unstable
c       results from the upward-recursion
c
        do n=nmax-1,nn,-1
          ga=dcmplx(dble(2*n+3),0.d0)+ci*xa2
          zja0=ci*xa2*(c1-zja0)/(ga*(c1-zja0)+ci*zja0)
        enddo
        zja(nn)=zja0
      else
        if(dble(4*nn).ge.cdabs(xa)**2)then
          phj0=spbphj(nn,xa)
          phj1=spbphj(nn+1,xa)
          gn=dcmplx(dble(2*nn+3),0.d0)
          zja(nn)=ci*xa2*phj1/(gn*phj0+ci*xa2*phj1)
        else
          zja0=(0.d0,0.d0)
          nx=10+nn/4
100       nmax=nn+nx
          gn=dcmplx(dble(2*nmax+3),0.d0)
          if(dble(4*nmax).ge.cdabs(xa)**2)then
            phj0=spbphj(nmax,xa)
            phj1=spbphj(nmax+1,xa)
            zja1=ci*xa2*phj1/(gn*phj0+ci*xa2*phj1)
            do n=nmax-1,nn,-1
              ga=dcmplx(dble(2*n+3),0.d0)+ci*xa2
              zja1=ci*xa2*(c1-zja1)/(ga*(c1-zja1)+ci*zja1)
            enddo
          else
            zja1=ci*xa2/(gn+ci*xa2)
            do n=nmax-1,nn,-1
              ga=dcmplx(dble(2*n+3),0.d0)+ci*xa2
              zja1=ci*xa2*(c1-zja1)/(ga*(c1-zja1)+ci*zja1)
            enddo
            if(cdabs(zja1-zja0).gt.eps*cdabs(zja1))then
              zja0=zja1
              nx=2*nx
              goto 100
            endif
          endif
          zja(nn)=zja1
        endif
      endif
      do n=nn-1,0,-1
        ga=dcmplx(dble(2*n+3),0.d0)+ci*xa2
        zja(n)=ci*xa2*(c1-zja(n+1))/(ga*(c1-zja(n+1))+ci*zja(n+1))
      enddo
c
      if(rb.le.0.d0)return
c
      cep0=cdexp(dcmplx(0.d0,xrb))
      cem0=c1/cep0
      cfac=dcmplx(dexp(-2.d0*dabs(xib)),0.d0)
      if(xib.ge.0.d0)then
        c2xj0=(cfac*cep0-cem0)/ci
        c2x2j1=c2xj0-(cfac*cep0+cem0)*xb
      else
        c2xj0=(cep0-cfac*cem0)/ci
        c2x2j1=c2xj0-(cep0+cfac*cem0)*xb
      endif
      wj(0)=cdlog(wj(0)/(c2xj0+ci*c2x2j1))
     &     +dcmplx(dlog(rb/ra),0.d0)
     &     +dcmplx(dabs(xia)-dabs(xib),0.d0)
c
      if(dble(nn).le.0.5d0*cdabs(xb))then
c
c       recursion upward to a large enough degree
c
        nmax=10+2*nn
        zjb0=ci*c2x2j1/(c2xj0+ci*c2x2j1)
        do n=1,nmax
          gb=dcmplx(dble(2*n+1),0.d0)+ci*xb2
          zjb0=(gb*zjb0-ci*xb2)/((gb-ci)*zjb0-ci*xb2)
        enddo
c
c       recursion downward to correct unstable
c       results from the upward-recursion
c
        do n=nmax-1,nn,-1
          gb=dcmplx(dble(2*n+3),0.d0)+ci*xb2
          zjb0=ci*xb2*(c1-zjb0)/(gb*(c1-zjb0)+ci*zjb0)
        enddo
        zjb(nn)=zjb0
      else
        if(dble(4*nn).ge.cdabs(xb)**2)then
          phj0=spbphj(nn,xb)
          phj1=spbphj(nn+1,xb)
          gn=dcmplx(dble(2*nn+3),0.d0)
          zjb(nn)=ci*xb2*phj1/(gn*phj0+ci*xb2*phj1)
        else
          zjb0=(0.d0,0.d0)
          nx=10+nn/4
200       nmax=nn+nx
          gn=dcmplx(dble(2*nmax+3),0.d0)
          if(dble(4*nmax).ge.cdabs(xb)**2)then
            phj0=spbphj(nmax,xb)
            phj1=spbphj(nmax+1,xb)
            zjb1=ci*xb2*phj1/(gn*phj0+ci*xb2*phj1)
            do n=nmax-1,nn,-1
              gb=dcmplx(dble(2*n+3),0.d0)+ci*xb2
              zjb1=ci*xb2*(c1-zjb1)/(gb*(c1-zjb1)+ci*zjb1)
            enddo
          else
            zjb1=ci*xb2/(gn+ci*xb2)
            do n=nmax-1,nn,-1
              gb=dcmplx(dble(2*n+3),0.d0)+ci*xb2
              zjb1=ci*xb2*(c1-zjb1)/(gb*(c1-zjb1)+ci*zjb1)
            enddo
            if(cdabs(zjb1-zjb0).gt.eps*cdabs(zjb1))then
              zjb0=zjb1
              nx=2*nx
              goto 200
            endif
          endif
          zjb(nn)=zjb1
        endif
      endif
      do n=nn-1,0,-1
        gb=dcmplx(dble(2*n+3),0.d0)+ci*xb2
        zjb(n)=ci*xb2*(c1-zjb(n+1))/(gb*(c1-zjb(n+1))+ci*zjb(n+1))
      enddo
c
      do n=1,nn
        ga=xa2+(c1-xa2+dcmplx(0.d0,dble(2*n+1)))*zja(n-1)
        gb=xb2+(c1-xb2+dcmplx(0.d0,dble(2*n+1)))*zjb(n-1)
        wj(n)=wj(n-1)+cdlog(ga/gb)+dcmplx(dlog(rb/ra),0.d0)
      enddo
c
      if(xia+xib.ge.0.d0)then
        zha(0)=c1-ci*xa
        zhb(0)=c1-ci*xb
      else
        zha(0)=c1+ci*xa
        zhb(0)=c1+ci*xb
      endif
      wh(0)=zhb(0)-zha(0)+dcmplx(dlog(rb/ra),0.d0)
c
      do n=1,nn
        gn=dcmplx(dble(2*n+1),0.d0)
        zha(n)=gn-xa2/zha(n-1)
        zhb(n)=gn-xb2/zhb(n-1)
        wh(n)=wh(n-1)+cdlog(zha(n-1)/zhb(n-1))+dcmplx(dlog(rb/ra),0.d0)
      enddo
      return
      end

      program qseis
      implicit none
c
      include 'qsglobal.h'
c
c     work space
c
      integer*4 i,istp,nssel,runtime
      real*8 pi,srate
      logical*4 grnexist
      integer*4 time
c
c     read input file file
c
      print *,'######################################################'
      print *,'#                                                    #'
      print *,'#               Welcome to the program               #'
      print *,'#                                                    #'
      print *,'#                                                    #'
      print *,'#        QQQ     SSSS    EEEEE    III     SSSS       #'
      print *,'#       Q   Q   S        E         I     S           #'
      print *,'#       Q Q Q    SSS     EEEE      I      SSS        #'
      print *,'#       Q  QQ       S    E         I         S       #'
      print *,'#        QQQQ   SSSS     EEEEE    III    SSSS        #'
      print *,'#                                                    #'
      print *,'#                  (Version 2006a)                   #'
      print *,'#                                                    #'
      print *,'#                                                    #'
      print *,'#                      by                            #'
      print *,'#                 Rongjiang Wang                     #'
      print *,'#              (wang@gfz-potsdam.de)                 #'
      print *,'#                                                    #'
      print *,'#           GeoForschungsZentrum Potsdam             #'
      print *,'#           Last modified: October, 2006             #'
      print *,'######################################################'
      print *,'                          '
      write(*,'(a,$)')' the input data file is '
      read(*,'(a)')inputfile
      runtime=time()
c
      pi=4.d0*datan(1.d0)
c
      open(10,file=inputfile,status='old')
      call qsgetinp(10,srate,nssel)
      close(10)
c
      if(nssel-ssel(7).gt.0)then
        grnexist=.false.
        call qswvint(srate)
        call qsmultis(grnexist)
        iexist=0
        do istp=1,7
          do i=1,19
            if(fsel(i,istp).eq.1)then
              call qsfftinv(i,istp)
            endif
          enddo
        enddo
      else
        grnexist=.true.
        call qsmultis(grnexist)
      endif
c
      runtime=time()-runtime
      write(*,'(a)')' #############################################'
      write(*,'(a)')' #                                           #'
      write(*,'(a)')' #      End of computations with qseis06a    #'
      write(*,'(a)')' #                                           #'
      write(*,'(a,i10,a)')' #       Run time: ',runtime,
     +                                           ' sec            #'
      write(*,'(a)')' #############################################'
1001  format(2i7,E12.4,a)
1002  format(i4,a,E12.4,a,$)
1003  format(E12.5,$)
1004  format(2E12.4,$)
1005  format(2E12.4)
 500  stop
      end

      subroutine qslayer(ierr)
      implicit none
      integer*4 ierr
c
      include 'qsglobal.h'
c
      integer*4 l,n,li,lp0
      real*8 zswap
      real*8 z(nzmax),z0(nzmax)
c
      lp0=1
      z0(lp0)=0.d0
      do n=1,n0-1
        lp0=lp0+1
        z0(lp0)=z0(lp0-1)+h(n)
      enddo
      lp0=lp0+1
      z0(lp0)=zs
      lp0=lp0+1
      z0(lp0)=zr
c
c     sort the z0-profile
c
      do l=1,lp0-1
        do li=l+1,lp0
          if(z0(li).lt.z0(l))then
            zswap=z0(l)
            z0(l)=z0(li)
            z0(li)=zswap
          endif
        enddo
      enddo
c
c     delete duplicates
c
      lp=1
      z(lp)=0.d0
      do l=2,lp0
        if(z0(l).gt.z(lp))then
          hp(lp)=z0(l)-z(lp)
          lp=lp+1
          z(lp)=z0(l)
        endif
      enddo
      hp(lp)=0.d0
c
c     determine ls,lzr
c
      do l=1,lp
        if(z(l).eq.zs)ls=l
        if(z(l).eq.zr)lzr=l
      enddo
c
c     determine layer no of each depth
c
      li=1
      zswap=h(1)
      nno(1)=1
      do l=2,lp
        if(z(l).ge.zswap.and.li.lt.n0)then
          li=li+1
          zswap=zswap+h(li)
        endif
        nno(l)=li
      enddo
c
c     for the receiver site
c
      if(l0rs.le.0)then
        n0rs=0
      else
        lp0=1
        z0(lp0)=0.d0
        do n=1,n0rs-1
          lp0=lp0+1
          z0(lp0)=z0(lp0-1)+hrs(n)
        enddo
        lp0=lp0+1
        z0(lp0)=zrrs
c
c       sort the z0-profile
c
        do l=1,lp0-1
          do li=l+1,lp0
            if(z0(li).lt.z0(l))then
              zswap=z0(l)
              z0(l)=z0(li)
              z0(li)=zswap
            endif
          enddo
        enddo
c
c       delete duplicates
c
        lprs=1
        z(lprs)=0.d0
        do l=2,lp0
          if(z0(l).gt.z(lprs))then
            hprs(lprs)=z0(l)-z(lprs)
            lprs=lprs+1
            z(lprs)=z0(l)
          endif
        enddo
        hprs(lprs)=0.d0
c
c       determine lzrrs
c
        do l=1,lprs
          if(z(l).eq.zrrs)lzrrs=l
        enddo
c
c       determine layer no of each depth
c
        li=1
        zswap=hrs(1)
        nnors(1)=1
        do l=2,lprs
          if(z(l).ge.zswap.and.li.lt.n0rs)then
            li=li+1
            zswap=zswap+hrs(li)
          endif
          nnors(l)=li
        enddo
      endif
c
      ierr=0
      return
      end

      subroutine qpsmat0(ly,lwup)
      use qpalloc
      implicit none
c
c     calculate 2x2 spheroidal layer matrix for a solid shell in case of degree 2
c
      integer*4 ly,lwup
c
      integer*4 i,j
      complex*16 cmudr,c2mu,cxi,cx2,cr2,cdet
      complex*16 ph0jup,ph1jup,ph0yup,ph1yup
      complex*16 ph0jlw,ph1jlw,ph0ylw,ph1ylw
      complex*16 spb(2,2)
      complex*16 spbphj,spbphy
c
      complex*16 ci,c1,c2,c3
      data ci,c1,c2,c3/(0.d0,1.d0),(1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0)/
c
      c2mu=c2*cmu(ly)
      cxi=cla(ly)+c2mu
c
      cx2=(kp(ly)*crrup(ly))**2
      if(ksmallpsv(ly))then
        ph0jup=spbphj(0,kp(ly)*crrup(ly))
        ph1jup=spbphj(1,kp(ly)*crrup(ly))
c
        ph0yup=spbphy(0,kp(ly)*crrup(ly))
        ph1yup=spbphy(1,kp(ly)*crrup(ly))
c
        cr2=crrup(ly)**2
        mas2x2up(1,1,ly)=cr2*ph1jup/c3
        mas2x2up(2,1,ly)=cxi*cr2*ph0jup-c2*c2mu*cr2*ph1jup/c3
        mas2x2up(1,2,ly)=ph1yup
        mas2x2up(2,2,ly)=cxi*cx2*ph0yup-c2*c2mu*ph1yup
      else
        spb(1,1)=c1-zjup(0,ly,1)
        spb(2,1)=-ci*zjup(0,ly,1)
        spb(1,2)=c1
        spb(2,2)=zhup(0,ly,1)
c
        do j=1,2
          mas2x2up(1,j,ly)=spb(2,j)
          mas2x2up(2,j,ly)=cxi*cx2*spb(1,j)-c2*c2mu*spb(2,j)
        enddo
      endif
c
      if(ly.eq.lylwpsv(0))return
c
      cx2=(kp(ly)*crrlw(ly))**2
      if(ksmallpsv(ly))then
        ph0jlw=spbphj(0,kp(ly)*crrlw(ly))
        ph1jlw=spbphj(1,kp(ly)*crrlw(ly))
c
        ph0ylw=spbphy(0,kp(ly)*crrlw(ly))
        ph1ylw=spbphy(1,kp(ly)*crrlw(ly))
c
        cr2=crrlw(ly)**2
        mas2x2lw(1,1,ly)=cr2*ph1jlw/c3
        mas2x2lw(2,1,ly)=cxi*cr2*ph0jlw-c2*c2mu*cr2*ph1jlw/c3
        mas2x2lw(1,2,ly)=ph1ylw
        mas2x2lw(2,2,ly)=cxi*cx2*ph0ylw-c2*c2mu*ph1ylw
      else
        spb(1,1)=c1-zjlw(0,ly,1)
        spb(2,1)=-ci*zjlw(0,ly,1)
        spb(1,2)=c1
        spb(2,2)=zhlw(0,ly,1)
c
        do j=1,2
          mas2x2lw(1,j,ly)=spb(2,j)
          mas2x2lw(2,j,ly)=cxi*cx2*spb(1,j)-c2*c2mu*spb(2,j)
        enddo
      endif
c
      if(lwup.eq.0)then
c
c       calculate inverse masrix at upper radius
c
        cdet=mas2x2up(1,1,ly)*mas2x2up(2,2,ly)
     &      -mas2x2up(1,2,ly)*mas2x2up(2,1,ly)
        mas2x2inv(1,1,ly)=mas2x2up(2,2,ly)/cdet
        mas2x2inv(1,2,ly)=-mas2x2up(1,2,ly)/cdet
        mas2x2inv(2,1,ly)=-mas2x2up(2,1,ly)/cdet
        mas2x2inv(2,2,ly)=mas2x2up(1,1,ly)/cdet
      else
c
c       calculate inverse masrix at lower radius
c
        cdet=mas2x2lw(1,1,ly)*mas2x2lw(2,2,ly)
     &      -mas2x2lw(1,2,ly)*mas2x2lw(2,1,ly)
        mas2x2inv(1,1,ly)=mas2x2lw(2,2,ly)/cdet
        mas2x2inv(1,2,ly)=-mas2x2lw(1,2,ly)/cdet
        mas2x2inv(2,1,ly)=-mas2x2lw(2,1,ly)/cdet
        mas2x2inv(2,2,ly)=mas2x2lw(1,1,ly)/cdet
      endif
c
      return
      end

      subroutine getdata(unit,line)
      implicit none
      integer*4 unit
      character line*180,char*1
c
      integer*4 i
c
c     this subroutine reads over all comment lines starting with "#".
c
      char='#'
100   continue
      if(char.eq.'#')then
        read(unit,'(a)')line
        i=1
        char=line(1:1)
200     continue
        if(char.eq.' ')then
          i=i+1
          char=line(i:i)
          goto 200
        endif
        goto 100
      endif
c
      return
      end

	program edcmain
	implicit none
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	this program calculates convolution integral (summation)       c
c	of discrete sources to model the elastic deformations induced  c
c       by an eqrthquake.                                              c
c                                                                      c
c	The input data will be read from an input file                 c
c                                                                      c
c	First implemented in Potsdam, Feb, 1999                        c
c	Last modified: Potsdam, Nov, 2001, by R. Wang                  c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	BEGIN DECLARATIONS
c	==================
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	GLOBAL CONSTANTS
c	================
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	include 'edcglobal.h'
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	RECTANGULAR SOURCE PLANES
c	=========================
c
c	(xs,ys,zs) = coordinates of the start point of strike
c	with x = north, y = east, z = downward.
c	all angles in degree.
c	NSMAX = the max. number of source rectangles
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision dislocation(NSMAX)
	double precision xs(NSMAX),ys(NSMAX),zs(NSMAX)
	double precision length(NSMAX),width(NSMAX)
	double precision strike(NSMAX),dip(NSMAX),rake(NSMAX)
c
	common/rectangles/dislocation,xs,ys,zs,length,width,
     &                    strike,dip,rake
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	OBSERVATION POSITIONS AND OBSERVABLES
c	=====================================
c
c	(xrec(i),yrec(i),zrec0)=coordinates of the observation positions
c	(Note that zrec0 is fixed)
c	disp = the 3 displcement vector components: ux,uy,uz
c	strain = the 6 strain tensor components: exx,eyy,ezz,exy,eyz,ezx
c	tilt = the two vertical tilt components: dux/dz, duy/dz
c	NRECMAX = the max. number of observation positions
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision xrec(NRECMAX),yrec(NRECMAX)
	double precision zrec0
	double precision disp(NRECMAX,3),strain(NRECMAX,6)
	double precision tilt(NRECMAX,2)
c
	common/obsarray/xrec,yrec,zrec0,disp,strain,tilt
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	ELASTIC PARAMETERS AT OBSERVATION DEPTH
c	=======================================
c
c	lambda,mu = the two Lame constants in pascal
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision lambda,mu
c
	common/elasticity/lambda,mu
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	WARNING STATISTICS
c	==================
c
c	nwarn = total number of warnings
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	integer nwarn
c
	common/warnings/nwarn
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	MEMORIES FOR OUTPUTS
c	====================
c
c	1 = two displacement components: ux,uy,uz
c	2 = 6 strain components: exx,eyy,ezz,exy,eyz,ezx
c	3 = 6 stress components: sxx,syy,szz,sxy,syz,szx
c	4 = two vertical tilt components: dux/dz,duy/dz
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	character*80 outdir
	integer iouts(NFIELDS)
	character*80 outputs(NFIELDS)
c
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	LOCAL CONSTANTS
c	==============
c	pi, parameter for transforming degree to radian
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double precision PI,PI2
	data PI,PI2/3.14159265358979d0,6.28318530717959d0/
	double precision DEGTORAD
	data DEGTORAD/1.745329252E-02/
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	LOCAL WORK SPACES
c	=================
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	integer i,is,irec,ixyrec,ixrec,iyrec,nxrec,nyrec,imodel
	integer nrec,ns
	double precision xrec1,xrec2,yrec1,yrec2,dxrec,dyrec
	double complex cxyrec1,cxyrec2
	double complex cxyrec(NRECMAX)
	character*80 infile,grndir,grnss,grnds,grncl
	character*180 dataline
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	END DECLARATIONS
c	================
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c00000000000000000000000000000000000000000000000000000000000000000000000
c	BEGIN READ IN INPUT PARAMETERS
c	==============================
c00000000000000000000000000000000000000000000000000000000000000000000000
c
	nwarn=0
c
	print *,'######################################################'
	print *,'#                                                    #'
	print *,'#                  Welcome to                        #'
	print *,'#                                                    #'
	print *,'#                                                    #'
	print *,'#     EEEEE   DDDD     CCCC   M   M    PPPP          #'
	print *,'#     E       D   D   C       MM MM    P   P         #'
	print *,'#     EEEE    D   D   C       M M M    PPPP          #'
	print *,'#     E       D   D   C       M   M    P             #'
	print *,'#     EEEEE   DDDD     CCCC   M   M    P             #'
	print *,'#                                                    #'
	print *,'#                                                    #'
	print *,'#                      by                            #'
	print *,'#                                                    #'
	print *,'#                 Rongjiang Wang                     #'
	print *,'#              (wang@gfz-potsdam.de)                 #'
	print *,'#                                                    #'
	print *,'#                  Frank Roth                        #'
	print *,'#              (roth@gfz-potsdam.de)                 #'
	print *,'#                                                    #'
	print *,'#               Francisco Lorenzo                    #'
	print *,'#            (lorenzo@gfz-potsdam.de)                #'
	print *,'#                                                    #'
	print *,'#           GeoForschungsZentrum Potsdam             #'
	print *,'#           first implemented: Nov. 2001             #'
	print *,'#              last update: March 2006               #'
	print *,'######################################################'
	print *,'                                                      '
	write(*,'(a,$)')' Please type the file name of input data: '
	read(*,'(a)')infile
	open(10,file=infile,status='old')
c00000000000000000000000000000000000000000000000000000000000000000000000
c	READ IN PARAMETERS FOR OBSERVATION ARRAY
c	========================================
c00000000000000000000000000000000000000000000000000000000000000000000000
	call getdata(10,dataline)
        read(dataline,*)ixyrec
	if(ixyrec.eq.0)then
c
c	  irregular observation positions
c
	  call getdata(10,dataline)
          read(dataline,*)nrec
	  if(nrec.gt.NRECMAX)then
	    stop ' Error in input file: NRECMAX too small!'
	  endif
	  read(10,*)(cxyrec(irec),irec=1,nrec)
	  do irec=1,nrec
	    xrec(irec)=dreal(cxyrec(irec))
	    yrec(irec)=dimag(cxyrec(irec))
	  enddo
	else if(ixyrec.eq.1)then
c
c	  1D observation profile
c
	  call getdata(10,dataline)
          read(dataline,*)nrec
	  call getdata(10,dataline)
          read(dataline,*)cxyrec1,cxyrec2
	  if(nrec.lt.1)then
	    stop ' Error in input file: wrong input for nrec!'
	  else
	    xrec(1)=dreal(cxyrec1)
	    yrec(1)=dimag(cxyrec1)
	    if(nrec.gt.1)then
	      dxrec=dreal(cxyrec2-cxyrec1)/dble(nrec-1)
	      dyrec=dimag(cxyrec2-cxyrec1)/dble(nrec-1)
	    else
	      dxrec=0.d0
	      dyrec=0.d0
	    endif
	    do irec=1,nrec
	      xrec(irec)=dreal(cxyrec1)+dxrec*dble(irec-1)
	      yrec(irec)=dimag(cxyrec1)+dyrec*dble(irec-1)
	    enddo
	  endif
	else if(ixyrec.eq.2)then
c
c	  2D rectanglar observation array
c
	  call getdata(10,dataline)
          read(dataline,*)nxrec,xrec1,xrec2
	  call getdata(10,dataline)
          read(dataline,*)nyrec,yrec1,yrec2
	  nrec=nxrec*nyrec
	  if(nrec.gt.NRECMAX.or.nrec.lt.1)then
	    stop ' Error in input file: wrong input for nrec!'
	  endif
	  irec=0
	  if(nxrec.gt.1)then
	    dxrec=(xrec2-xrec1)/dble(nxrec-1)
	  else
	    dxrec=0.d0
	  endif
	  if(nyrec.gt.1)then
	    dyrec=(yrec2-yrec1)/dble(nyrec-1)
	  else
	    dyrec=0.d0
	  endif
	  do iyrec=1,nyrec
	    do ixrec=1,nxrec
	      irec=irec+1
	      xrec(irec)=xrec1+dxrec*dble(ixrec-1)
	      yrec(irec)=yrec1+dyrec*dble(iyrec-1)
	    enddo
	  enddo
	else
	  stop' Error in input file: wrong input for ixyrec!'
	endif
c00000000000000000000000000000000000000000000000000000000000000000000000
c	READ IN OUTPUT PARAMETERS
c	=========================
c00000000000000000000000000000000000000000000000000000000000000000000000
	call getdata(10,dataline)
        read(dataline,*)outdir
	call getdata(10,dataline)
        read(dataline,*)(iouts(i),i=1,NFIELDS)
	call getdata(10,dataline)
        read(dataline,*)(outputs(i),i=1,NFIELDS)
c00000000000000000000000000000000000000000000000000000000000000000000000
c	READ IN PARAMETERS FOR RECTANGULAR SOURCES
c	==========================================
c00000000000000000000000000000000000000000000000000000000000000000000000
	call getdata(10,dataline)
        read(dataline,*)ns
	if(ns.gt.NSMAX)then
	  stop ' Error in edcmain: to large no of source rectangles!'
	endif
	do is=1,ns
	  call getdata(10,dataline)
          read(dataline,*)i,dislocation(is),xs(is),ys(is),zs(is),
     &                    length(is),width(is),
     &                    strike(is),dip(is),rake(is)
	  if(length(is).lt.0.d0.or.width(is).lt.0.d0)then
	    stop ' Error in input data: source length or width < 0!'
	  endif
	  if(zs(is).lt.0.d0)then
	    stop ' Error in input data: source depth zs < 0!'
	  endif
	  if(length(is).eq.0.d0.and.width(is).eq.0.d0)then
	    write(*,'(a,i2,a)')' the ',is,'. rectangle is a point.'
	  else if(length(is).gt.0.d0.and.width(is).eq.0.d0)then
	    write(*,'(a,i2,a)')' the ',is,
     &                         '. rectangle is a horizontal line.'
	  else if(length(is).eq.0.d0.and.width(is).gt.0.d0)then
	    write(*,'(a,i2,a)')' the ',is,
     &                         '. rectangle is a vertical line.'
	  endif
	enddo
c00000000000000000000000000000000000000000000000000000000000000000000000
c	READ IN PARAMETERS FOR EARTH MODEL CHOICE
c	=========================================
c00000000000000000000000000000000000000000000000000000000000000000000000
	call getdata(10,dataline)
        read(dataline,*)imodel
	if(imodel.eq.0)then
	  call getdata(10,dataline)
          read(dataline,*)zrec0,lambda,mu
	else if(imodel.eq.1)then
	  call getdata(10,dataline)
          read(dataline,*)grndir,grnss,grnds,grncl
	else
	  stop ' Error in input file: wrong choice of earth model!'
	endif
	close(10)
c00000000000000000000000000000000000000000000000000000000000000000000000
c	END READ IN INPUT PARAMETERS
c	============================
c00000000000000000000000000000000000000000000000000000000000000000000000
	print *,'... input data successful ...'
c00000000000000000000000000000000000000000000000000000000000000000000000
c	BEGIN PROCESSING
c	================
c00000000000000000000000000000000000000000000000000000000000000000000000
	if(imodel.eq.1)then
	  print *,'... layered half-space model considered ...'
	  print *,'... use the Green function approach ...'
	  call edcgrn(ns,nrec,grndir,grnss,grnds,grncl)
	else
	  print *,'... homogeneous half-space model considered ...'
	  print *,'... use analytical solutions of Okada ...'
	  call okada(ns,NSMAX,nrec,NRECMAX,lambda,mu,dislocation,
     &               xs,ys,zs,length,width,strike,dip,rake,
     &               xrec,yrec,zrec0,disp,strain,tilt)
	endif
	print *,'... outputs ...'
	call edcoutput(nrec,infile,outdir,iouts,outputs)
c00000000000000000000000000000000000000000000000000000000000000000000000
c	END OF STANDARD PROCESSING
c	==========================
c00000000000000000000000000000000000000000000000000000000000000000000000
	if(nwarn.eq.0)then
	  print *,'####################################################'
	  print *,'#                                                  #'
	  print *,'#        Successful computations with EDCMP        #'
	  print *,'#                                                  #'
	  print *,'####################################################'
	else
	  print *,'####################################################'
	  print *,'     Sorry, there have been',nwarn,' warnings.      '
	  print *,'             Results may be inaccurate!             '
	  print *,'####################################################'
	endif
c
	stop
	end

      subroutine qskern(y,f,k)
      implicit none
c
c     calculation of response function in frequency-wavelength domain
c     y(6,6): solution vector (complex)
c     k: wave number
c     f: frequency. 2*pi*f = cyclar frequency
c     fi: imaginary part of the frequency
c
      real*8 f,k
      complex*16 y(6,6)
c
      include 'qsglobal.h'
c
      integer*4 i,istp,lup,llw
c
      call qswaveno(f,k)
c
      do istp=1,6
        do i=1,6
          y(i,istp)=(0.d0,0.d0)
        enddo
      enddo
c
c     determination of starting upper sublayer
c
      lup=1
      llw=lp
      call qspsv(y,k,lup,llw)
      if(calsh)call qssh(y,k,lup,llw)
c
      return
      end

      subroutine qppsvkern(f,ldeg,ypsv)
      use qpalloc
      implicit none
c
c     calculation of response function in frequency-wavelength domain
c     ldeg: harmonic degree
c     ypsv(6,4): psv solution vector (complex)
c
      integer*4 ldeg
      real*8 f
      complex*16 ypsv(6,4)
c
      integer*4 i,ly,istp,lyup,lylw,lwup
      real*8 xmin
      complex*16 cldeg,cruplw,delta
c
      complex*16 c1,c2
      data c1,c2/(1.d0,0.d0),(2.d0,0.d0)/
c
      do istp=1,4
        do i=1,6
          ypsv(i,istp)=(0.d0,0.d0)
        enddo
      enddo
      lyup=lyupatm(ldeg)
      lylw=lylwpsv(ldeg)
      if(lylw.lt.max0(lys,lyr).or.f.le.0.d0.and.ldeg.eq.1)return
c
      if(f.le.0.d0)then
        lylw=min0(lylw,lycm)
        lyup=lyob
      endif
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      comi=dcmplx(PI2*f,PI2*fi)
      comi2=comi*comi
      xmin=dsqrt(2.d0*dble(2*ldeg+1))
c
      do ly=lyup,min0(lyob-1,lylw)
        if(ldeg.le.ldegpsv(ly))then
          kp(ly)=comi/cvp(ly)
          if(cdabs(kp(ly))*rrup(ly).le.xmin)then
            ksmallpsv(ly)=.true.
            if(rrlw(ly).gt.0.d0)then
              cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
            else
              cruplw=(0.d0,0.d0)
            endif
            wj(ldeg,ly,1)=cldeg*cruplw
            wh(ldeg,ly,1)=-(cldeg+c1)*cruplw
          else if(ksmallpsv(ly))then
            ksmallpsv(ly)=.false.
            call spbjh(ldegpsv(ly),kp(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,1),zjlw(0,ly,1),wj(0,ly,1),
     &                 zhup(0,ly,1),zhlw(0,ly,1),wh(0,ly,1))
          endif
        endif
      enddo
      do ly=lyob,min0(lycm-1,lylw)
        if(ldeg.le.ldegpsv(ly))then
          kp(ly)=comi/cvp(ly)
          ks(ly)=comi/cvs(ly)
          if(cdabs(ks(ly))*rrup(ly).le.xmin)then
            ksmallpsv(ly)=.true.
            if(rrlw(ly).gt.0.d0)then
              cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
            else
              cruplw=(0.d0,0.d0)
            endif
            wj(ldeg,ly,1)=cldeg*cruplw
            wh(ldeg,ly,1)=-(cldeg+c1)*cruplw
            wj(ldeg,ly,2)=(cldeg+c2)*cruplw
            wh(ldeg,ly,2)=-(cldeg-c1)*cruplw
          else if(ksmallpsv(ly))then
            ksmallpsv(ly)=.false.
            call spbjh(ldegpsv(ly),kp(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,1),zjlw(0,ly,1),wj(0,ly,1),
     &                 zhup(0,ly,1),zhlw(0,ly,1),wh(0,ly,1))
            call spbjh(ldegpsv(ly),ks(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,2),zjlw(0,ly,2),wj(0,ly,2),
     &                 zhup(0,ly,2),zhlw(0,ly,2),wh(0,ly,2))
          endif
        endif
      enddo
      do ly=lycm,min0(lycc-1,lylw)
        if(ldeg.le.ldegpsv(ly))then
          kp(ly)=comi/cvp(ly)
          if(cdabs(kp(ly))*rrup(ly).le.xmin)then
            ksmallpsv(ly)=.true.
            if(rrlw(ly).gt.0.d0)then
              cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
            else
              cruplw=(0.d0,0.d0)
            endif
            wj(ldeg,ly,1)=cldeg*cruplw
            wh(ldeg,ly,1)=-(cldeg+c1)*cruplw
          else if(ksmallpsv(ly))then
            ksmallpsv(ly)=.false.
            call spbjh(ldegpsv(ly),kp(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,1),zjlw(0,ly,1),wj(0,ly,1),
     &                 zhup(0,ly,1),zhlw(0,ly,1),wh(0,ly,1))
          endif
        endif
      enddo
      do ly=lycc,min0(ly0,lylw)
        if(ldeg.le.ldegpsv(ly))then
          kp(ly)=comi/cvp(ly)
          ks(ly)=comi/cvs(ly)
          if(cdabs(ks(ly))*rrup(ly).le.xmin)then
            ksmallpsv(ly)=.true.
            if(rrlw(ly).gt.0.d0)then
              cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
            else
              cruplw=(0.d0,0.d0)
            endif
            wj(ldeg,ly,1)=cldeg*cruplw
            wh(ldeg,ly,1)=-(cldeg+c1)*cruplw
            wj(ldeg,ly,2)=(cldeg+c2)*cruplw
            wh(ldeg,ly,2)=-(cldeg-c1)*cruplw
          else if(ksmallpsv(ly))then
            ksmallpsv(ly)=.false.
            call spbjh(ldegpsv(ly),kp(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,1),zjlw(0,ly,1),wj(0,ly,1),
     &                 zhup(0,ly,1),zhlw(0,ly,1),wh(0,ly,1))
            call spbjh(ldegpsv(ly),ks(ly),rrup(ly),rrlw(ly),
     &                 zjup(0,ly,2),zjlw(0,ly,2),wj(0,ly,2),
     &                 zhup(0,ly,2),zhlw(0,ly,2),wh(0,ly,2))
          endif
        endif
      enddo
c
      if(ldeg.eq.0)then
        do ly=lyup,lylw
          if(ly.lt.lys)then
            lwup=0
            cps(1,ly)=-wj(ldeg,ly,1)
            cps(2,ly)=-wh(ldeg,ly,1)
          else
            lwup=1
            cps(1,ly)=wj(ldeg,ly,1)
            cps(2,ly)=wh(ldeg,ly,1)
          endif
          call qpsmat0(ly,lwup)
        enddo
        call qpsprop0(ypsv,lyup,lylw)
      else
        do ly=lyup,min0(lyob-1,lylw)
          if(rrlw(ly).gt.0.d0)then
            cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
          else
            cruplw=(0.d0,0.d0)
          endif
          lwup=0
          cps(1,ly)=-wj(ldeg,ly,1)
          cps(2,ly)=-wh(ldeg,ly,1)
          cps(3,ly)=-cldeg*cruplw
          cps(4,ly)=(cldeg+c1)*cruplw
          call qpsmatc(ldeg,ly,lylw,lwup)
        enddo
        do ly=lyob,min0(lycm-1,lylw)
          if(rrlw(ly).gt.0.d0)then
            cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
          else
            cruplw=(0.d0,0.d0)
          endif
          if(ly.lt.lys)then
            lwup=0
            cps(1,ly)=-wj(ldeg,ly,1)
            cps(2,ly)=-wh(ldeg,ly,1)
            cps(3,ly)=-wj(ldeg,ly,2)
            cps(4,ly)=-wh(ldeg,ly,2)
            cps(5,ly)=-cldeg*cruplw
            cps(6,ly)=(cldeg+c1)*cruplw
          else
            lwup=1
            cps(1,ly)=wj(ldeg,ly,1)
            cps(2,ly)=wh(ldeg,ly,1)
            cps(3,ly)=wj(ldeg,ly,2)
            cps(4,ly)=wh(ldeg,ly,2)
            cps(5,ly)=cldeg*cruplw
            cps(6,ly)=-(cldeg+c1)*cruplw
          endif
          call qpsmat(ldeg,ly,lylw,lwup)
        enddo
        do ly=lycm,min0(lycc-1,lylw)
          if(rrlw(ly).gt.0.d0)then
            cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
          else
            cruplw=(0.d0,0.d0)
          endif
          lwup=1
          cps(1,ly)=wj(ldeg,ly,1)
          cps(2,ly)=wh(ldeg,ly,1)
          cps(3,ly)=cldeg*cruplw
          cps(4,ly)=-(cldeg+c1)*cruplw
          call qpsmatc(ldeg,ly,lylw,lwup)
        enddo
        do ly=lycc,min0(ly0,lylw)
          if(rrlw(ly).gt.0.d0)then
            cruplw=dcmplx(dlog(rrup(ly)/rrlw(ly)),0.d0)
          else
            cruplw=(0.d0,0.d0)
          endif
          lwup=1
          cps(1,ly)=wj(ldeg,ly,1)
          cps(2,ly)=wh(ldeg,ly,1)
          cps(3,ly)=wj(ldeg,ly,2)
          cps(4,ly)=wh(ldeg,ly,2)
          cps(5,ly)=cldeg*cruplw
          cps(6,ly)=-(cldeg+c1)*cruplw
          call qpsmat(ldeg,ly,lylw,lwup)
        enddo
        if(ldeg.eq.1)then
          call qpsprop1(ypsv,lyup,lylw)
        else
          call qpsprop(ypsv,ldeg,lyup,lylw)
        endif
      endif
      return
      end

      subroutine ruku(y,i0,j0,ly,ldeg,difmat,rr1,rr2)
      implicit none
      integer*4 i0,j0,ly,ldeg
      real*8 rr1,rr2
      complex*16 y(i0,j0)
      external difmat
c
      integer*4 nrrmax
      parameter(nrrmax=4096)
c
      integer*4 i,j,k,irr,nrr
      real*8 rr,drr
      complex*16 cdrr,ra
      complex*16 y0(6,3),y1(6,3),y2(6,3),ya(6,3),yb(6,3)
      complex*16 yk(6,4),mat(6,6,3)
      logical again
c
      real*8 eps
      complex*16 c1,c2,c6
      data eps/1.0d-03/
      data c1,c2,c6/(1.d0,0.d0),(2.d0,0.d0),(6.d0,0.d0)/
c
      do j=1,j0
        do i=1,i0
          y1(i,j)=(0.d0,0.d0)
          y2(i,j)=y(i,j)
          yb(i,j)=y(i,j)
        enddo
      enddo
      nrr=1
100   continue
      drr=(rr2-rr1)/dble(nrr)
      cdrr=dcmplx(drr,0.d0)
      do j=1,j0
        do i=1,i0
          y0(i,j)=y1(i,j)
          y1(i,j)=y2(i,j)
          y2(i,j)=y(i,j)
          ya(i,j)=yb(i,j)
        enddo
      enddo
      do irr=1,nrr
        rr=rr1+dble(irr-1)*drr
        call difmat(ly,ldeg,rr,mat(1,1,1))
        call difmat(ly,ldeg,rr+0.5d0*drr,mat(1,1,2))
        call difmat(ly,ldeg,rr+drr,mat(1,1,3))
        do j=1,j0
          do i=1,i0
            yk(i,1)=(0.d0,0.d0)
            do k=1,i0
              yk(i,1)=yk(i,1)+cdrr*mat(i,k,1)*y2(k,j)
            enddo
          enddo
c
          do i=1,i0
            yk(i,2)=(0.d0,0.d0)
            do k=1,i0
              yk(i,2)=yk(i,2)+cdrr*mat(i,k,2)*(y2(k,j)+yk(k,1)/c2)
            enddo
          enddo
c
          do i=1,i0
            yk(i,3)=(0.d0,0.d0)
            do k=1,i0
              yk(i,3)=yk(i,3)+cdrr*mat(i,k,2)*(y2(k,j)+yk(k,2)/c2)
            enddo
          enddo
c
          do i=1,i0
            yk(i,4)=(0.d0,0.d0)
            do k=1,i0
              yk(i,4)=yk(i,4)+cdrr*mat(i,k,3)*(y2(k,j)+yk(k,3))
            enddo
          enddo
c
          do i=1,i0
            y2(i,j)=y2(i,j)+(yk(i,1)+c2*(yk(i,2)+yk(i,3))+yk(i,4))/c6
          enddo
        enddo
      enddo
c
      again=.false.
      if(nrr.le.64)then
        do j=1,j0
          do i=1,i0
            yb(i,j)=y2(i,j)
            if(cdabs(yb(i,j)-ya(i,j)).gt.eps*cdabs(yb(i,j)))again=.true.
          enddo
        enddo
      else if(nrr.le.nrrmax)then
        do j=1,j0
          do i=1,i0
            ra=c2*y1(i,j)-y0(i,j)-y2(i,j)
            if(cdabs(ra).gt.eps*cdabs(y2(i,j)))then
              yb(i,j)=y1(i,j)+(y2(i,j)-y1(i,j))*(y1(i,j)-y0(i,j))/ra
            else
              yb(i,j)=y2(i,j)
            endif
            if(cdabs(yb(i,j)-ya(i,j)).gt.eps*cdabs(yb(i,j)))again=.true.
          enddo
        enddo
      else
        print *, ' Warning in ruku: Convergence problem!'
      endif
      if(again)then
        nrr=2*nrr
        goto 100
      endif
c
      do j=1,j0
        do i=1,i0
          y(i,j)=yb(i,j)
        enddo
      enddo
c
      return
      end

      subroutine qplegendre(ldeg,raddis)
      use qpalloc
      implicit none
      integer*4 ldeg
      real*8 raddis
c
c     calculate Plm(l,m,x)/(1-x^2)^(m/2)
c     where Plm are the associated Legendre polynomials
c
      integer*4 l,m
      real*8 x
c
      x=dcos(raddis)
      plm(0,0)=1.d0
      plm(0,1)=0.d0
      plm(1,1)=1.d0
      plm(0,2)=0.d0
      plm(1,2)=0.d0
      plm(2,2)=3.d0
      do m=0,2
        plm(m+1,m)=dble(2*m+1)*x*plm(m,m)
        do l=m+2,ldeg
          plm(l,m)=(dble(2*l-1)*x*plm(l-1,m)
     &             -dble(l+m-1)*plm(l-2,m))/dble(l-m)
        enddo
      enddo
      return
      end

      subroutine ruku(y,i0,j0,ly,ldeg,difmat,rr1,rr2,nrr0)
      implicit none
      integer*4 i0,j0,ly,ldeg,nrr0
      real*8 rr1,rr2
      complex*16 y(i0,j0)
      external difmat
c
      integer*4 nrrmax
      parameter(nrrmax=512)
c
      integer*4 i,j,k,irr,nrr,nn
      real*8 rr,drr,epsilon
      real*8 yabs(6,3)
      complex*16 cdrr
      complex*16 y1(6,3),y2(6,3),yk(6,4),mat(6,6,3)
      save nn
c
      real*8 eps
      complex*16 c1,c2,c6
      data eps/1.0d-04/
      data c1,c2,c6/(1.d0,0.d0),(2.d0,0.d0),(6.d0,0.d0)/
c
      do j=1,j0
        do i=1,i0
          y2(i,j)=y(i,j)
        enddo
      enddo
      nrr=max0(2,nrr0/4)
100   continue
      drr=(rr2-rr1)/dble(nrr)
      cdrr=dcmplx(drr,0.d0)
      do j=1,j0
        do i=1,i0
          y1(i,j)=y2(i,j)
          y2(i,j)=y(i,j)
          yabs(i,j)=cdabs(y(i,j))
        enddo
      enddo
      do irr=1,nrr
        rr=rr1+dble(irr-1)*drr
        call difmat(ly,ldeg,rr,mat(1,1,1))
        call difmat(ly,ldeg,rr+0.5d0*drr,mat(1,1,2))
        call difmat(ly,ldeg,rr+drr,mat(1,1,3))
        do j=1,j0
          do i=1,i0
            yk(i,1)=(0.d0,0.d0)
            do k=1,i0
              yk(i,1)=yk(i,1)+cdrr*mat(i,k,1)*y2(k,j)
            enddo
          enddo
c
          do i=1,i0
            yk(i,2)=(0.d0,0.d0)
            do k=1,i0
              yk(i,2)=yk(i,2)+cdrr*mat(i,k,2)*(y2(k,j)+yk(k,1)/c2)
            enddo
          enddo
c
          do i=1,i0
            yk(i,3)=(0.d0,0.d0)
            do k=1,i0
              yk(i,3)=yk(i,3)+cdrr*mat(i,k,2)*(y2(k,j)+yk(k,2)/c2)
            enddo
          enddo
c
          do i=1,i0
            yk(i,4)=(0.d0,0.d0)
            do k=1,i0
              yk(i,4)=yk(i,4)+cdrr*mat(i,k,3)*(y2(k,j)+yk(k,3))
            enddo
          enddo
c
          do i=1,i0
            y2(i,j)=y2(i,j)+(yk(i,1)+c2*(yk(i,2)+yk(i,3))+yk(i,4))/c6
          enddo
        enddo
      enddo
c
      do j=1,j0
        do i=1,i0
          yabs(i,j)=dmax1(cdabs(y(i,j)),cdabs(y2(i,j)))
        enddo
      enddo
c
      if(nrr.lt.nrrmax)then
        do j=1,j0
          do i=1,i0
            epsilon=eps*(cdabs(y2(i,j)-y(i,j))+eps*yabs(i,j))
            if(cdabs(y2(i,j)-y1(i,j)).gt.epsilon)then
              nrr=nrr*2
              goto 100
            endif
          enddo
        enddo
      else
        print *, ' Warning in ruku: Convergence problem!'
      endif
c
      do j=1,j0
        do i=1,i0
          y(i,j)=y2(i,j)
        enddo
      enddo
c
      nrr0=nrr
c
      return
      end

      subroutine swavelet(tau,df,fi,nf,wvf)
      implicit none
      integer*4 nf
      real*8 tau,df,fi
      complex*16 wvf(nf)
c
      integer*4 l,n
      real*8 f,omi,dt0
      complex*16 alfa,beta,gamma,eta,cx
c
      real*8 pi,pi2,eps
      complex*16 c1,ci
      data pi,pi2,eps/3.14159265358979d0,6.28318530717959d0,1.0d-06/
      data c1,ci/(1.d0,0.d0),(0.d0,1.d0)/
c
c     for wavelet: normalized square half-sinusoid
c
      do l=1,nf
        f=df*dble(l-1)
        cx=dcmplx(f*tau,fi*tau)
        if(cdabs(cx).eq.0.d0)then
          wvf(l)=(1.d0,0.d0)
        else if(cdabs(cx-c1).le.eps)then
          wvf(l)=-c1/cx/(c1+cx)
        else
          wvf(l)=ci/(dcmplx(pi2,0.d0)*cx*(c1+cx)*(c1-cx))
     &          *(cdexp(dcmplx(0.d0,-pi2)*cx)-c1)
        endif
      enddo
      return
      end

      subroutine qpdocu(ierr)
      use qpalloc
      implicit none
      integer*4 ierr
c
      integer*4 i,j,k,ly,ig,flen,slen
      real*8 f
c      real, dimension (:,:,:), allocatable :: wdarray
      logical*2 head,diff
      character*24 fdate
c
      open(20,file=infofile,status='unknown')
      write(20,'(a)')'#  Space-time domain Green function database'
      write(20,'(a)')'#  calculated on '//fdate()
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#  data_type size: REAL*4'
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#  time_window[s] sampling[s] number_of_samples'
      write(20,'(2f10.2,i6)')dble(ntout-1)*dtout,dtout,ntout
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#  number of distances, list of distances[km]'
      write(20,'(i8)')nr
      j=0
      do i=1,nr/5
        write(20,'(5f10.3)')(dism(k)/KM2M,k=j+1,j+5)
        j=j+5
      enddo
      if(j.lt.nr)then
        write(20,'(5f10.3)')(dism(k)/KM2M,k=j+1,nr)
      endif
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#  each binary file includes all fundamental'
      write(20,'(a)')'#  velocity Green functions for a given source'
      write(20,'(a)')'#  depth data are stored in the following order:'
      write(20,'(a)')'#  {distance'
      write(20,'(a)')'#   {time_reduction,'
      write(20,'(a)')'#    mechanism(expl.,strike-slip,dip-slip,clvd)'
      write(20,'(a)')'#     {component(vertical,radial,tangential*)'
      write(20,'(a)')'#      {time_series}}}}'
      write(20,'(a)')'#  note: time reduction [s] needs (4)+4+(4)'
      write(20,'(a)')'#        bytes, each time series (seimogram)'
      write(20,'(a)')'#        needs (4)+number_of_samples*4+(4)'
      write(20,'(a)')'#        bytes, where (4) bytes are for the'
      write(20,'(a)')'#        reserved places before and after each'
      write(20,'(a)')'#        record'
      write(20,'(a)')'#        *)no tangential component for explosion'
      write(20,'(a)')'#          and clvd sources'
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#  number of source_depths / files,'
      write(20,'(a)')'#  list of source_depths / filenames'
      write(20,'(i10)')ngrn
      do ig=1,ngrn
        do flen=80,1,-1
          if(grnfile(ig)(flen:flen).ne.' ')goto 100
        enddo
100     continue
        write(20,'(f10.1,a)')grndep(ig)/KM2M,
     &                     '  '//''''//grnfile(ig)(1:flen)//''''
      enddo
      write(20,'(a)')'#  layered earth model:'
      write(20,'(a)')'#  number of layers'
      write(20,'(i5)')ly0
      write(20,'(a)')'#  no thickness[km]'
     &             //'      vp[km/s]      vs[km/s]'
     &             //'   rho[g/cm^3]        qp        qs'
      f=FSBREF
      call qpqmodel(f)
      do ly=1,ly0
        write(20,'(i5,4f14.4,2f10.2)')ly,(rrup(ly)-rrlw(ly))/km2m,
     &    dreal(cvp(ly))/km2m,dreal(cvs(ly))/km2m,dreal(cro(ly))/km2m,
     &    0.5d0*(qpup(ly)+qplw(ly)),0.5d0*(qsup(ly)+qslw(ly))
      enddo
c
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#  binary files of arrival time [s], takeoff'
      write(20,'(a)')'#  angle [deg] and slowness [s/m] for P and S'
      write(20,'(a)')'#  waves. data are stored in the following order:'
      write(20,'(a)')'#  {green_function_depth'
      write(20,'(a)')'#   {green_function_distance,'
      write(20,'(a)')'#      {onset,takeoff, slowness}}}'
      write(20,'(a)')'#  note: each table needs (4)+number_of_distances'
      write(20,'(a)')'#        number_of_depths*12+(4)bytes, where (4)'
      write(20,'(a)')'#        bytes are for the reserved places before'
      write(20,'(a)')'#         and after each record'
      write(20,'(a)')'#================================================'
      do slen=80,1,-1
        if(stdgrndir(slen:slen).ne.' ')goto 200
      enddo
200   continue
      do flen=80,1,-1
        if(tptable(flen:flen).ne.' ')goto 300
      enddo
300   continue
      write(20,'(a)')'  '//''''//tptable(slen+1:flen)//''''
      do flen=80,1,-1
        if(tstable(flen:flen).ne.' ')goto 400
      enddo
400   continue
      write(20,'(a)')'  '//''''//tstable(slen+1:flen)//''''
      close(20)
c
      head=.true.
      diff=.true.
c
      allocate (hpmod(ly0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: hpmod not allocated!'
      allocate (vpmod(ly0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: vpmod not allocated!'
      allocate (vsmod(ly0),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: vsmod not allocated!'
      do ly=1,ly0
        hpmod(ly)=rrup(ly)-rrlw(ly)
        vpmod(ly)=dreal(cvp(ly))
        vsmod(ly)=dreal(cvs(ly))
      enddo
      
      allocate (tp(nr,ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: tp not allocated!'
      allocate(tkftp(nr,ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: tkftp not allocated!'
      allocate(slwtp(nr,ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: slwtp not allocated!'
      allocate (ts(nr,ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: ts not allocated!'
      allocate(tkfts(nr,ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: tkfts not allocated!'
      allocate(slwts(nr,ngrn),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpdocu: slwts not allocated!'
c
      do ig=1,ngrn
        call tpssub(ly0,hpmod,vpmod,grndep(ig),REARTH,head,diff,
     &              nr,dism,tp(1,ig),tkftp(1,ig),slwtp(1,ig))
        call tpssub(ly0,hpmod,vsmod,grndep(ig),REARTH,head,diff,
     &              nr,dism,ts(1,ig),tkfts(1,ig),slwts(1,ig))
      enddo
      
C      allocate(wdarray(3,nr,ngrn))
C     
C      do i=1,nr
C          do ig=1,ngrn
C              wdarray(1,i,ig)=sngl(tp(i,ig))
C              wdarray(2,i,ig)=sngl(tkftp(i,ig))
C              wdarray(3,i,ig)=sngl(slwtp(i,ig))
C          enddo
C      enddo
C     
C      open(21,file=tptable,form='unformatted',status='unknown')
C      write(21)wdarray
C      close(21)
C
C      do i=1,nr
C          do ig=1,ngrn
C              wdarray(1,i,ig)=sngl(ts(i,ig))
C              wdarray(2,i,ig)=sngl(tkfts(i,ig))
C              wdarray(3,i,ig)=sngl(slwts(i,ig))
C          enddo
C      enddo
C     
C      open(22,file=tstable,form='unformatted',status='unknown')
C      write(22)wdarray
C      close(22)
C     
C      deallocate(wdarray)
      
      open(21,file=tptable,form='unformatted',status='unknown')
      write(21)((sngl(tp(i,ig)),sngl(tkftp(i,ig)),
     &            sngl(slwtp(i,ig)),i=1,nr),ig=1,ngrn)
      close(21)
      
      
      open(22,file=tstable,form='unformatted',status='unknown')
      write(22)((sngl(ts(i,ig)),sngl(tkfts(i,ig)),
     &            sngl(slwts(i,ig)),i=1,nr),ig=1,ngrn)
      close(22)
      
      return
      end

      subroutine qpgetinp(inpunit)
      use qpalloc
      implicit none
      integer*4 inpunit
c
c     work space
c
      integer*4 i,j,l,ir,ig,isg,is,is1,flen,iswap,nhypo,ierr
      real*8 suppress,r1,r2,dr,dr1,dr2,swap
      character*80 fswap
c
c     uniform receiver depth
c     ======================
c
      call skipdoc(inpunit)
      read(inpunit,*)dpr
      dpr=KM2M*dpr
c
c     time (frequency) sampling
c     =========================
c
      call skipdoc(inpunit)
      read(inpunit,*)twindow,dt
      ntcut=1+idnint(twindow/dt)
      nt=2
100   nt=2*nt
      if(nt.lt.ntcut)goto 100
      nf=nt/2
      df=1.d0/(dble(nt)*dt)
c
      call skipdoc(inpunit)
      read(inpunit,*)fcut
      nfcut=min0(nf,1+idnint(fcut/df))
      fcut=dble(nfcut-1)*df
      call skipdoc(inpunit)
      read(inpunit,*)slwmax
      slwmax=slwmax/KM2M
      fullwave=slwmax.le.0.d0
c
      call skipdoc(inpunit)
      read(inpunit,*)suppress
      if(suppress.le.0.d0.or.suppress.ge.1.d0)then
        fi=0.d0
      else
        fi=dlog(suppress)*df/PI2
      endif
c
c     cutoffs of spectra
c     ==================
c
      call skipdoc(inpunit)
      read(inpunit,*)fgr,ldeggr
      if(fgr.lt.0.d0)fgr=0.d0
      if(ldeggr.lt.0)ldeggr=0
      if(fgr.gt.0.d0.and.ldeggr.le.0.or.
     &   fgr.le.0.d0.and.ldeggr.gt.0)then
        stop 'Bad fgr and ldeggr combination!'
      endif
      nogravity=fgr*dble(ldeggr).le.0.d0
c
      call skipdoc(inpunit)
      read(inpunit,*)i,j
      selpsv=i.eq.1
      selsh=j.eq.1
      if(.not.(selpsv.or.selsh))then
        stop 'Error: none of PSV and SH is selected!'
      endif
c
c     Green's function files
c     ======================
c
      call skipdoc(inpunit)
      read(inpunit,*)spcgrndir
      call skipdoc(inpunit)
      read(inpunit,*)ngrn
      if(ngrn.le.0)then
        stop 'bad number of source depths!'
      endif
c
      ierr=0
      allocate(rr0(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: rr0 not allocated!'
      allocate(lygrn(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: lygrn not allocated!'
      allocate(grnsel(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: grnsel not allocated!'
      allocate(grndep(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: grndep not allocated!'
      allocate(grnfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: grnfile not allocated!'
      allocate(rgrnfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: rgrnfile not allocated!'
      allocate(tgrnfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: tgrnfile not allocated!'
      allocate(pgrnfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: pgrnfile not allocated!'
      allocate(stdgrnfile(ngrn),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: stdgrnfile not allocated!'
c
      do ig=1,ngrn
        call skipdoc(inpunit)
        read(inpunit,*)grndep(ig),rr0(ig),grnfile(ig),grnsel(ig)
        if(grnsel(ig).lt.0.or.grnsel(ig).gt.1)then
          stop 'bad Green function selection!'
        endif
        grndep(ig)=grndep(ig)*KM2M
        rr0(ig)=rr0(ig)*KM2M
      enddo
c
c     sort green function files by source depth
c
      do i=1,ngrn
        do j=i+1,ngrn
          if(grndep(j).lt.grndep(i))then
            swap=grndep(i)
            fswap=grnfile(i)
            iswap=grnsel(i)
c
            grndep(i)=grndep(j)
            grnfile(i)=grnfile(j)
            grnsel(i)=grnsel(j)
c
            grndep(j)=swap
            grnfile(j)=fswap
            grnsel(j)=iswap
          endif
        enddo
      enddo
c
      do flen=80,1,-1
        if(spcgrndir(flen:flen).ne.' ')goto 200
      enddo
200   continue
      do ig=1,ngrn
        rgrnfile(ig)=spcgrndir(1:flen)//'R_'//grnfile(ig)
        tgrnfile(ig)=spcgrndir(1:flen)//'T_'//grnfile(ig)
        pgrnfile(ig)=spcgrndir(1:flen)//'P_'//grnfile(ig)
      enddo
c
c     receiver parameters
c     ===================
c
      call skipdoc(inpunit)
      read(inpunit,*)stdgrndir
c
      do flen=80,1,-1
        if(stdgrndir(flen:flen).ne.' ')goto 300
      enddo
300   continue
      do ig=1,ngrn
        stdgrnfile(ig)=stdgrndir(1:flen)//grnfile(ig)
      enddo
c
      call skipdoc(inpunit)
      read(inpunit,*)infofile,tptable,tstable
      infofile=stdgrndir(1:flen)//infofile
      tptable=stdgrndir(1:flen)//tptable
      tstable=stdgrndir(1:flen)//tstable
c
      call skipdoc(inpunit)
      read(inpunit,*)twinout,dtout
      if(twinout.gt.twindow)then
        stop 'Error: too large time window for space-time domain!'
      endif
      if(dtout.le.0.d0)then
        stop 'Error: wrong time sampling for space-time domain!'
      else if(dtout.lt.dt)then
        stop 'Error: too small time interval for space-time domain!'
      endif
      ntout=1+idnint(twinout/dtout)
c
      call skipdoc(inpunit)
      read(inpunit,*)tstart
c
      call skipdoc(inpunit)
      read(inpunit,*)tau
      call skipdoc(inpunit)
      read(inpunit,*)nbpf,f1corner,f2corner
      call skipdoc(inpunit)
      read(inpunit,*)r1,r2,dr1,dr2
      if(r1.lt.0.d0.or.r1.gt.r2.or.dr1.le.0.d0.or.dr1.gt.dr2)then
        stop 'Error: wrong epidistance sampling for Green functions!'
      endif
      r1=r1*KM2M
      r2=r2*KM2M
      dr1=dr1*KM2M
      dr2=dr2*KM2M
      nr=1+idnint(2.d0*(r2-r1)/(dr1+dr2))
c
      allocate(dism(nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: dism not allocated!'
      allocate(disrad(nr),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: disrad not allocated!'
c
      dism(1)=r1
      dism(nr)=r2
      if(nr.gt.2)then
        dr=(r2-r1)/dble(nr-1)
        dr1=dr1*2.d0*dr/(dr1+dr2)
        dr2=dr2*2.d0*dr/(dr1+dr2)
        do i=2,nr-1
          dr=dr1+(dr2-dr1)*dble(i-2)/dble(nr-2)
          dism(i)=dism(i-1)+dr
        enddo
      endif
      do i=1,nr
c
c       rounded to meter
c
        dism(i)=dble(idnint(dism(i)))
        disrad(i)=dism(i)/REARTH
      enddo
c
c     multilayered model parameters
c     =============================
c
      call skipdoc(inpunit)
      read(inpunit,*)l,i
      if(l.le.0)then
        stop 'Error: bad number of data lines of earth model!'
      endif
      dispersion=i.eq.1
c
      l0=l+1
c
      allocate(dp0(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: dp0 not allocated!'
      allocate(vp0(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: vp0 not allocated!'
      allocate(vs0(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: vs0 not allocated!'
      allocate(ro0(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: ro0 not allocated!'
      allocate(qp0(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: qp0 not allocated!'
      allocate(qs0(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: qs0 not allocated!'
c
      allocate(dp0up(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: dp0up not allocated!'
      allocate(vp0up(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: vp0up not allocated!'
      allocate(vs0up(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: vs0up not allocated!'
      allocate(ro0up(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: ro0up not allocated!'
      allocate(qp0up(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: qp0up not allocated!'
      allocate(qs0up(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: qs0up not allocated!'
c
      allocate(dp0lw(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: dp0lw not allocated!'
      allocate(vp0lw(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: vp0lw not allocated!'
      allocate(vs0lw(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: vs0lw not allocated!'
      allocate(ro0lw(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: ro0lw not allocated!'
      allocate(qp0lw(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: qp0lw not allocated!'
      allocate(qs0lw(l0),stat=ierr)
      if(ierr.ne.0)stop 'Error in qpgetinp: qs0lw not allocated!'
c
      qsmin=10000.d0
      depatmos=0.d0
      rratmos=REARTH
      do i=1,l
        call skipdoc(inpunit)
        read(inpunit,*)j,dp0(i),vp0(i),vs0(i),ro0(i),qp0(i),qs0(i)
c
c       input inpunits:    -,km,  km/s, km/s, g/cm^3,-,-
c
        if(i.eq.1)then
          depatmos=-KM2M*dp0(1)
          rratmos=REARTH+depatmos
        endif
        dp0(i)=KM2M*dp0(i)+depatmos
        vp0(i)=KM2M*vp0(i)
        vs0(i)=KM2M*vs0(i)
        ro0(i)=KM2M*ro0(i)
        if(vs0(i).gt.0.d0)qsmin=dmin1(qsmin,qs0(i))
        if(i.gt.1)then
          if(dp0(i).lt.dp0(i-1))then
            stop 'Error: bad layering of earth model!'
          endif
        endif
      enddo
c
      dpr=dpr+depatmos
      do i=1,ngrn
        grndep(i)=grndep(i)+depatmos
      enddo
c
      if(dp0(1).ne.0.d0)then
        stop 'Error: bad start depth!'
      else if(dp0(l).gt.rratmos)then
        stop 'Error: bad definition of earth radius!'
      else if(dp0(l).lt.rratmos)then
        l=l+1
        dp0(l)=rratmos
        vp0(l)=vp0(l-1)
        vs0(l)=vs0(l-1)
        ro0(l)=ro0(l-1)
        qp0(l)=qp0(l-1)
        qs0(l)=qs0(l-1)
      endif
c
      l0=0
      do i=2,l
        if(dp0(i).gt.dp0(i-1))then
          l0=l0+1
          dp0up(l0)=dp0(i-1)
          vp0up(l0)=vp0(i-1)
          vs0up(l0)=vs0(i-1)
          ro0up(l0)=ro0(i-1)
          qp0up(l0)=qp0(i-1)
          qs0up(l0)=qs0(i-1)
c
          dp0lw(l0)=dp0(i)
          vp0lw(l0)=vp0(i)
          vs0lw(l0)=vs0(i)
          ro0lw(l0)=ro0(i)
          qp0lw(l0)=qp0(i)
          qs0lw(l0)=qs0(i)
        endif
      enddo
c
      deallocate(dp0,vp0,vs0,ro0,qp0,qs0)
c
c     end of inputs
c     =============
c
      return
      end

      subroutine qsfftinv(icmp,istp)
      implicit none
c
      integer*4 icmp,istp
c
      include 'qsglobal.h'
c
      integer*4 nn,nn2,nch,nch2
      parameter (nn=2*nfmax,nn2=nfmax,nch=2*nrmax,nch2=nrmax)
      integer*4 lf,mf,ir,j,it
      real*8 t,pi,pi2,slw0,omi
      real*8 f(nn),y0(nch),y(nch)
      complex*16 s
      complex*16 cy(nn,nch2)
c
      complex*16 wvf(nn2)
      save wvf
c
      pi=4.d0*datan(1.d0)
      pi2=2.d0*pi
c
      if(v0.gt.0.d0)then
        slw0=1.d0/v0
      else
        slw0=0.d0
      endif
c
      print *,' Output: '//outfile(icmp,istp)(1:flen(icmp,istp))
      do lf=1,nf
        f(lf)=dble(lf-1)*df
        do ir=1,nr
          cy(lf,ir)=grns(lf,icmp,ir,istp)
        enddo
      enddo
c
      if(v0.gt.0.d0.or.dabs(tstart).gt.0.d0)then
c
c       for time reduction
c
        do lf=1,nf
          do ir=1,nr
            s=dcmplx(-fi,f(lf))
     &         *dcmplx(2.d0*pi*(tstart+r(ir)*slw0),0.d0)
            cy(lf,ir)=cy(lf,ir)*cdexp(s)
          enddo
        enddo
      endif
c
c     seismometer filtering
c
      if(cdabs(asm).ne.1.d0)then
        do lf=1,nf
          do ir=1,nr
            cy(lf,ir)=asm*cy(lf,ir)
          enddo
        enddo
      endif
c
      if(nroot+npole.gt.0)then
        do lf=1,nf
          s=dcmplx(-2.d0*pi*fi,2.d0*pi*f(lf))
          do ir=1,nr
            do j=1,nroot
              cy(lf,ir)=cy(lf,ir)*(s-root(j))
            enddo
            do j=1,npole
              cy(lf,ir)=cy(lf,ir)/(s-pole(j))
            enddo
          enddo
        enddo
      endif
c
c     muliplication with wavelet spectrum
c
      if(iexist.ne.1)then
        call qswavelet(wvf,nf)
        iexist=1
      endif
      do lf=1,nf
        do ir=1,nr
          cy(lf,ir)=cy(lf,ir)*wvf(lf)
        enddo
      enddo
c
      mf=1
      do lf=2*nf,nf+2,-1
        mf=mf+1
        do ir=1,nr
          cy(lf,ir)=dconjg(cy(mf,ir))
        enddo
      enddo
      do ir=1,nr
        cy(nf+1,ir)=(0.d0,0.d0)
      enddo
c
c     convention for Fourier transform:
c     f(t)=\int F(f) exp(i2\pi f t) df
c
      do ir=1,nr
        call four1(cy(1,ir),2*nf,+1)
      enddo
c
      open(20,file=outfile(icmp,istp),status='unknown')
      write(20,'(a,$)')'   T_sec    '
      do ir=1,nr-1
        write(20,'(a4,a1,a1,2a4,$)')'   ',
     &         varbtxt,comptxt(icmp),rcvtxt(ir),'   '
      enddo
      write(20,'(a4,a1,a1,2a4)')'   ',
     &         varbtxt,comptxt(icmp),rcvtxt(nr),'   '
c
      do ir=1,nr
        y0(ir)=0.d0
      enddo
      omi=2.d0*pi*fi
      do it=1,nt
        t=dble(it-1)*dt
        do ir=1,nr
          y(ir)=df*dreal(cy(it,ir))*dexp(-omi*t)
        enddo
        if(wdeg.eq.2)then
          do ir=1,nr
            y(ir)=y0(ir)+y(ir)*dt
            y0(ir)=y(ir)
          enddo
        endif
        write(20,1003)t+tstart
        do ir=1,nr-1
          write(20,1004)y(ir)
        enddo
        write(20,1005)y(nr)
      enddo
      close(20)
1003  format(f12.5,$)
1004  format(E12.4,$)
1005  format(E12.4)
      return
      end

      subroutine qsmatrix0(a,ck,z,n)
      implicit none
c
      integer*4 n
      real*8 z
      complex*16 ck
      complex*16 a(4,4)
c
      include 'qsglobal.h'
c
      complex*16 c0,c1,c2
      data c0,c1,c2/(0.d0,0.d0),(1.d0,0.d0),(2.d0,0.d0)/
c
      integer*4 i
      complex*16 ck2,cz,cxi,cfac,b(4,4)
      complex*16 cxps,cdkp,cdks,cps,csp,cdeps,cdesp
c
      ck2=ck*ck
c
      a(1,1)=kp(n)
      a(2,1)=c2*cmu(n)*ck2-acc(n)
      a(3,1)=ck
      a(4,1)=c2*ck*cmu(n)*kp(n)
      a(1,2)=-kp(n)
      a(2,2)=a(2,1)
      a(3,2)=ck
      a(4,2)=-a(4,1)
c
      b(1,3)=ck
      b(2,3)=c2*ck*cmu(n)*ks(n)
      b(3,3)=ks(n)
      b(4,3)=c2*cmu(n)*ck2-acc(n)
      b(1,4)=ck
      b(2,4)=-b(2,3)
      b(3,4)=-ks(n)
      b(4,4)=b(4,3)
c
      cz=dcmplx(z,0.d0)
      cxi=cla(n)+c2*cmu(n)
c
c     cxps=(kp-ks)*z
c     cdkp=(k-kp)*k^2*vp^2/omiga^2
c     cdks=(k-ks)*k^2*vp^2/omiga^2
c     cdeps=(1-exp(cxps))*k^2*vp^2/omiga^2
c     cdesp=(1-exp(-cxps))*k^2*vp^2/omiga^2
c
      cxps=acc(n)*(cla(n)+cmu(n))*cz/(cmu(n)*cxi*(kp(n)+ks(n)))
      cdkp=ck2/(ck+kp(n))
      cdks=ck2*cxi/((ck+ks(n))*cmu(n))
      if(dabs(z).gt.0.d0)then
        i=1
        cps=(1.d0,0.d0)
        csp=(1.d0,0.d0)
        cdeps=(1.d0,0.d0)
        cdesp=(1.d0,0.d0)
10      i=i+1
        cfac=cxps/dcmplx(dble(i),0.d0)
        cps=cps*cfac
        csp=-csp*cfac
        cdeps=cdeps+cps
        cdesp=cdesp+csp
        if(cdabs(cps).gt.1.0d-12)goto 10
        cfac=(cla(n)+cmu(n))*ck2*cz/(cmu(n)*(kp(n)+ks(n)))
        cdeps=-cdeps*cfac
        cdesp=cdesp*cfac
      else
        cdeps=0.d0
        cdesp=0.d0
      endif
c
c     define stable propagator for omiga -> 0:
c
c     a(i,3)=[a(i,3)-a(i,1)*exp(cxps)]*k^2*vp^2/omiga^2
c     a(i,4)=[a(i,4)+a(i,2)*exp(-cxps)]*k^2*vp^2/omiga^2
c
      a(1,3)=cdkp+kp(n)*cdeps
      a(2,3)=c2*cmu(n)*ck*(ck*cdeps-cdks)+cxi*ck2*cdexp(cxps)
      a(3,3)=-cdks+ck*cdeps
      a(4,3)=c2*cmu(n)*ck*(cdkp+kp(n)*cdeps)-cxi*ck2
      a(1,4)=cdkp+kp(n)*cdesp
      a(2,4)=c2*cmu(n)*ck*(cdks-ck*cdesp)-cxi*ck2*cdexp(-cxps)
      a(3,4)=cdks-ck*cdesp
      a(4,4)=c2*cmu(n)*ck*(cdkp+kp(n)*cdesp)-cxi*ck2
c
      return
      end

      subroutine qpdifmat0(ly,ldeg,rr,mat)
      use qpalloc
      implicit none
      integer ly,ldeg
      real*8 rr
      complex*16 mat(6,6)
c
c     3x3 coefficient matrix for spheroidal mode l = 0
c
      real*8 mass,rorr,beta,dro,ro1
      complex*16 cup,clw,crr,crorr,cxirr,clarr,cmurr,cgrrr,cvprr
      complex*16 cgarr,gamma
c
      complex*16 c1,c2,c4
      data c1,c2,c4/(1.d0,0.d0),(2.d0,0.d0),(4.d0,0.d0)/
c
      crr=dcmplx(rr,0.d0)
      cup=(crr-crrlw(ly))/(crrup(ly)-crrlw(ly))
      clw=c1-cup
      clarr=cup*claup(ly)+clw*clalw(ly)
      cmurr=cup*cmuup(ly)+clw*cmulw(ly)
      cvprr=cup*cvpup(ly)+clw*cvplw(ly)
      cxirr=clarr+c2*cmurr
      beta=dlog(roup(ly)/rolw(ly))/(rrup(ly)-rrlw(ly))
c
      if(rr.le.rrlw(ly))then
        mass=0.d0
        crorr=crolw(ly)
        rorr=dreal(crorr)
        cgarr=dcmplx(2.d0*PI2*BIGG*rorr,0.d0)
      else if(ly.ge.lyos)then
        crorr=cup*croup(ly)+clw*crolw(ly)
        rorr=dreal(crorr)
        cgarr=dcmplx(2.d0*PI2*BIGG*rorr,0.d0)
c
        dro=(rorr-rolw(ly))/(rr-rrlw(ly))
        ro1=rolw(ly)-dro*rrlw(ly) 
        mass=PI*(rr-rrlw(ly))*((4.d0/3.d0)*ro1
     &        *(rr**2+rr*rrlw(ly)+rrlw(ly)**2)
     &        +dro*(rr**3+rr**2*rrlw(ly)
     &        +rr*rrlw(ly)**2+rrlw(ly)**3))
      else
        rorr=rolw(ly)*dexp(dlog(roup(ly)/rolw(ly))
     &                  *(rr-rrlw(ly))/(rrup(ly)-rrlw(ly)))
        crorr=dcmplx(rorr,0.d0)
        cgarr=dcmplx(2.d0*PI2*BIGG*rorr,0.d0)
c
        mass=2.d0*PI2/beta**3
     &      *(rorr*(beta*rr*(beta*rr-2.d0)+2.d0)
     &       -rolw(ly)*(beta*rrlw(ly)*(beta*rrlw(ly)-2.d0)+2.d0))
      endif
      cgrrr=cgrlw(ly)*(crrlw(ly)/crr)**2
     &     +dcmplx(BIGG*mass/rr**2,0.d0)
c
c     stabilization at the static limit
c
      if(ly.lt.lyos)then
        if(cdabs(comi)/PI2.lt.fbvatm)then
          gamma=dcmplx((dsin(0.25d0*cdabs(comi)/fbvatm))**3,0.d0)
          cvprr=cvprr/cdsqrt(gamma
     &         +(gamma-c1)*dcmplx(beta,0.d0)*cvprr**2/cgrrr)
        endif
      else if(ly.ge.lyos.and.ly.lt.lyob)then
        if(cdabs(comi)/PI2.lt.fbvocean)then
          gamma=dcmplx((dsin(0.25d0*cdabs(comi)/fbvocean))**3,0.d0)
          cvprr=cvprr/cdsqrt(gamma
     &         +(gamma-c1)*dcmplx(beta,0.d0)*cvprr**2/cgrrr)
        endif
      else if(ly.ge.lycm.and.ly.lt.lycc)then
        if(cdabs(comi)/PI2.lt.fbvcore)then
          gamma=dcmplx((dsin(0.25d0*cdabs(comi)/fbvcore))**3,0.d0)
          cvprr=cvprr/cdsqrt(gamma
     &         +(gamma-c1)*dcmplx(beta,0.d0)*cvprr**2/cgrrr)
        endif
      endif 
c
      mat(1,1)=(c1-c2*clarr/cxirr)/crr
      mat(1,2)=c1/(crorr*cvprr**2)/crr
      mat(1,3)=(0.d0,0.d0)
c
      mat(2,1)=c4*(cmurr*(c1+c2*clarr/cxirr)/crr-crorr*cgrrr)
     &        -crorr*comi2*crr
      mat(2,2)=c2*clarr/cxirr/crr
      mat(2,3)=(0.d0,0.d0)
c
      mat(3,1)=cgarr/crr
      mat(3,2)=(0.d0,0.d0)
      mat(3,3)=(0.d0,0.d0)
c
      return
      end

      subroutine butterworth(n,fc,df,nf,lpf)
      implicit none
      integer*4 n,nf
      real*8 fc,df
      complex*16 lpf(nf)
c
      integer*4 l,k
      complex*16 s,cs
c
      real*8 PI
      data PI/3.14159265358979d0/
c
      if(n.le.0.or.fc.le.0.d0)then
        do l=1,nf
          lpf(l)=(1.d0,0.d0)
        enddo
      else if(n.eq.2*(n/2))then
        do l=1,nf
          s=dcmplx(0.d0,df*dble(l-1)/fc)
          lpf(l)=(1.d0,0.d0)
          do k=1,n/2
            cs=dcmplx(2.d0*dcos(PI*dble(2*k+n-1)/dble(2*n)),0.d0)
            lpf(l)=lpf(l)/(s*s-s*cs+(1.d0,0.d0))
          enddo
        enddo
      else
        do l=1,nf
          s=dcmplx(0.d0,df*dble(l-1)/fc)
          lpf(l)=(1.d0,0.d0)/(s+(1.d0,0.d0))
          do k=1,(n-1)/2
            cs=dcmplx(2.d0*dcos(PI*dble(2*k+n-1)/dble(2*n)),0.d0)
            lpf(l)=lpf(l)/(s*s-s*cs+(1.d0,0.d0))
          enddo
        enddo
      endif
      return
      end

c*******************************************************************************
c*******************************************************************************
        subroutine edgkern(y,k,ps,sh,eps)
        implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
c	calculation of response function in frequency-wavelength domain
c       y(6): solution vector
c       k: wave number
c       eps: relative accuracy
c
        double precision k,eps
        double precision y(6)
	logical ps,sh
c
	include 'edgglobal.h'
c       
c       model parameter:
c       n0: number of model layers
c
        integer n0
        double precision h(lmax),ro(lmax),vp(lmax),vs(lmax)
        common /model/ h,ro,vp,vs,n0
c
	integer i
c
	do i=1,6
	  y(i)=0.d0
	enddo
c
	if(ps)call edgpsv(y,k,eps)
	if(sh)call edgsh(y,k,eps)
	return
	end	  

      module qpalloc
c
c     CONSTANTS
c     =========
      real*8 PI,PI2
      parameter(PI=3.14159265358979d0,PI2=6.28318530717959d0)
      real*8 DEG2RAD,KM2M
      parameter(DEG2RAD=1.745329251994328d-02,KM2M=1.0d+03)
      real*8 REARTH,BIGG
      parameter(REARTH=6.371d+06,BIGG=6.6732d-11)
      real*8 RESOLUT
      parameter(RESOLUT=0.01d0)
      real*8 FLTAPER
      parameter(FLTAPER=0.2d0)
      real*8 FSBLW,FSBREF
      parameter(FSBLW=0.25d-03,FSBREF=1.0d+00)
c
      real*8 expol,expos,expoa
      parameter(expol=6.0d+00,expos=16.0d+00,expoa=16.0d+00)
      real*8 slwfac
      parameter(slwfac=1.25d+00)
c
      integer*4 ldeg0,ldeg1,ndmax
      parameter(ldeg0=2500,ldeg1=50,ndmax=4)
c
      logical*2 nogravity,selpsv,selsh,dispersion,fullwave
c
      integer*4 ldegmin,ldegmax,igfirst,iglast
      integer*4 nr,ntout,l0,lys,lyr,lyos,lyob,lycm,lycc,ly0
      integer*4 ngrn,nt,ntcut,ntcutout,nf,nfcut,nbpf,ldeggr
c
      real*8 dt,df,fi,fcut,fgr,rratmos,depatmos
      real*8 slwmax,f1corner,f2corner,qsmin,mmantle
      real*8 dpr,freeairgrd,dtout,tau,tstart,tred,twindow,twinout
c
      complex*16 comi,comi2,cua(8,6)
c
      character*80 spcgrndir,stdgrndir,infofile,tptable,tstable
c
      logical*2, allocatable:: ksmallpsv(:),ksmallsh(:)
c
      integer*4, allocatable:: lygrn(:),grnsel(:),i0sub(:),
     &       ldegpsv(:),ldegsh(:),lylwsh(:),lylwpsv(:),lyupatm(:)
c
      real*4, allocatable:: tgrn(:)
c
      real*8, allocatable:: mshell(:),dswap(:),hpmod(:),
     &            vpmod(:),tp(:,:),tkftp(:,:),slwtp(:,:),
     &            vsmod(:),ts(:,:),tkfts(:,:),slwts(:,:)
      real*8, allocatable:: grndep(:),rr0(:),dism(:),disrad(:),
     &       dp0(:),dp0up(:),dp0lw(:),vp0(:),vp0up(:),vp0lw(:),
     &       vs0(:),vs0up(:),vs0lw(:),ro0(:),ro0up(:),ro0lw(:),
     &       qp0(:),qp0up(:),qp0lw(:),qs0(:),qs0up(:),qs0lw(:),
     &       rrup(:),rrlw(:),vpup(:),vplw(:),vsup(:),vslw(:),
     &       roup(:),rolw(:),qpup(:),qplw(:),qsup(:),qslw(:)
      real*8, allocatable:: disk(:),fdisk(:),dplm1(:),plm(:,:,:)
c
      complex*16, allocatable:: yr(:,:,:),yt(:,:,:),yp(:,:,:),sgrn(:),
     &                          cswap(:)
c
      complex*16, allocatable:: vgrnr(:,:,:),vgrnt(:,:,:),vgrnp(:,:,:)
      complex*16, allocatable:: crrup(:),crrlw(:),
     &       cro(:),croup(:),crolw(:),cla(:),claup(:),clalw(:),
     &       cmu(:),cmuup(:),cmulw(:),cvp(:),cvpup(:),cvplw(:),
     &       cvs(:),cvsup(:),cvslw(:),cgr(:),cgrup(:),cgrlw(:),
     &       cga(:),cgaup(:),cgalw(:)
      complex*16, allocatable:: kp(:),ks(:),kt(:),cps(:,:),cpt(:,:),
     &       mat2x2up(:,:,:),mat2x2lw(:,:,:),mat2x2inv(:,:,:),
     &       mas2x2up(:,:,:),mas2x2lw(:,:,:),mas2x2inv(:,:,:),
     &       mas4x4up(:,:,:),mas4x4lw(:,:,:),mas4x4inv(:,:,:),
     &       mas6x6up(:,:,:),mas6x6lw(:,:,:),mas6x6inv(:,:,:)
      complex*16, allocatable:: cypnorm(:,:)
      complex*16, allocatable:: zjup(:,:,:),zjlw(:,:,:),zhup(:,:,:),
     &       zhlw(:,:,:),wj(:,:,:),wh(:,:,:),zjupg(:),
     &       zjlwg(:),zhupg(:),zhlwg(:),wjg(:),whg(:)
c
      character*80, allocatable:: grnfile(:),rgrnfile(:),
     &             tgrnfile(:),pgrnfile(:),stdgrnfile(:)

c
      end module

	subroutine qpsublayer(ierr)
	implicit none
	integer ierr
c
      include 'qpglobal.h'
c
c	work space
c
	integer i,j,i0,l,ly,ig,di0
      double precision h,dh,z,zz,wvlen,up,lw,uplw4
	double precision rrs,rrr,dvp,dvs,ro1,dro,dqp,dqs,mass
c
	ly0=0
c
      zz=0.d0
	do l=1,l0
        if(vs0up(l).gt.0.d0)then
          wvlen=vs0up(l)/fcut
        else
          wvlen=vp0up(l)/fcut
        endif
	  h=dp0lw(l)-dp0up(l)
	  dvp=2.d0*dabs(vp0lw(l)-vp0up(l))/(vp0lw(l)+vp0up(l))
        if(vs0lw(l)+vs0up(l).gt.0.d0)then
	    dvs=2.d0*dabs(vs0lw(l)-vs0up(l))/(vs0lw(l)+vs0up(l))
        else
          dvs=0.d0
        endif
        dro=2.d0*dabs(dlog(ro0lw(l))-dlog(ro0up(l)))
     &     /(dlog(ro0lw(l))+dlog(ro0up(l)))
	  i0=1+idint(dmax1(dvp/RESOLUT,dvs/RESOLUT,dro/RESOLUT))
        i0=min0(i0,1+idint(4.d0*h/wvlen))
        if(fgr.gt.0.d0)then
          i0=max0(i0,1+idint(4.d0*h/(wvlen*fcut/fgr)))
        endif
        dvp=(vp0lw(l)-vp0up(l))/h
	  dvs=(vs0lw(l)-vs0up(l))/h
	  dro=(dlog(ro0lw(l))-dlog(ro0up(l)))/h
	  dqp=(qp0lw(l)-qp0up(l))/h
	  dqs=(qs0lw(l)-qs0up(l))/h
	  dh=h/dble(i0)
	  do i=1,i0
	    ly0=ly0+1
	    if(ly0.ge.lymax-2-ngrn)then
	      stop ' Error in qpsublayer: lymax too small!'
	    endif
	    z=dble(i-1)*dh
	    rrup(ly0)=rratmos-(zz+z)
	    vpup(ly0)=vp0up(l)+dvp*z
	    vsup(ly0)=vs0up(l)+dvs*z
	    roup(ly0)=ro0up(l)*dexp(dro*z)
	    qpup(ly0)=qp0up(l)+dqp*z
	    qsup(ly0)=qs0up(l)+dqs*z
          z=z+dh
	    rrlw(ly0)=rratmos-(zz+z)
	    vplw(ly0)=vp0up(l)+dvp*z
	    vslw(ly0)=vs0up(l)+dvs*z
	    rolw(ly0)=ro0up(l)*dexp(dro*z)
	    qplw(ly0)=qp0up(l)+dqp*z
	    qslw(ly0)=qs0up(l)+dqs*z
	  enddo
        zz=zz+h
	enddo
c
c     add source layers
c
      do ig=1,ngrn
        rrs=rratmos-grndep(ig)
        if(rrs.lt.0.d0)then
          stop ' Wrong source depth!'
        endif
        do ly=1,ly0
          if(rrs.ge.rrlw(ly))then
            lys=ly
            goto 100
          endif
        enddo
100     continue
        if(rrs.lt.rrup(lys).and.rrs.gt.rrlw(lys))then
          do ly=ly0,lys,-1
            rrup(ly+1)=rrup(ly)
	      vpup(ly+1)=vpup(ly)
	      vsup(ly+1)=vsup(ly)
	      roup(ly+1)=roup(ly)
	      qpup(ly+1)=qpup(ly)
	      qsup(ly+1)=qsup(ly)
            rrlw(ly+1)=rrlw(ly)
	      vplw(ly+1)=vplw(ly)
	      vslw(ly+1)=vslw(ly)
	      rolw(ly+1)=rolw(ly)
	      qplw(ly+1)=qplw(ly)
	      qslw(ly+1)=qslw(ly)
          enddo
          lys=lys+1
          up=(rrs-rrlw(lys))/(rrup(lys-1)-rrlw(lys))
          lw=1.d0-up
          rrlw(lys-1)=rrs
	    vplw(lys-1)=up*vpup(lys-1)+lw*vplw(lys)
	    vslw(lys-1)=up*vsup(lys-1)+lw*vslw(lys)
	    rolw(lys-1)=up*roup(lys-1)+lw*rolw(lys)
	    qplw(lys-1)=up*qpup(lys-1)+lw*qplw(lys)
	    qslw(lys-1)=up*qsup(lys-1)+lw*qslw(lys)
          rrup(lys)=rrs
	    vpup(lys)=vplw(lys-1)
	    vsup(lys)=vslw(lys-1)
	    roup(lys)=rolw(lys-1)
	    qpup(lys)=qplw(lys-1)
	    qsup(lys)=qslw(lys-1)
          ly0=ly0+1       
        endif
      enddo
c
c     add receiver layer
c
      rrr=rratmos-dpr
      if(rrr.lt.0.d0)then
        stop ' Wrong receiver depth!'
      endif
      do ly=1,ly0
        if(rrr.ge.rrlw(ly))then
          lyr=ly
          goto 200
        endif
      enddo
200   continue
      if(rrr.lt.rrup(lyr).and.rrr.gt.rrlw(lyr))then
        do ly=ly0,lyr,-1
          rrup(ly+1)=rrup(ly)
	    vpup(ly+1)=vpup(ly)
	    vsup(ly+1)=vsup(ly)
	    roup(ly+1)=roup(ly)
	    qpup(ly+1)=qpup(ly)
	    qsup(ly+1)=qsup(ly)
          rrlw(ly+1)=rrlw(ly)
	    vplw(ly+1)=vplw(ly)
	    vslw(ly+1)=vslw(ly)
	    rolw(ly+1)=rolw(ly)
	    qplw(ly+1)=qplw(ly)
	    qslw(ly+1)=qslw(ly)
        enddo
        lyr=lyr+1
        up=(rrr-rrlw(lyr))/(rrup(lyr-1)-rrlw(lyr))
        lw=1.d0-up
        rrlw(lyr-1)=rrr
	  vplw(lyr-1)=up*vpup(lyr-1)+lw*vplw(lyr)
	  vslw(lyr-1)=up*vsup(lyr-1)+lw*vslw(lyr)
	  rolw(lyr-1)=up*roup(lyr-1)+lw*rolw(lyr)
	  qplw(lyr-1)=up*qpup(lyr-1)+lw*qplw(lyr)
	  qslw(lyr-1)=up*qsup(lyr-1)+lw*qslw(lyr)
        rrup(lyr)=rrr
	  vpup(lyr)=vplw(lyr-1)
	  vsup(lyr)=vslw(lyr-1)
	  roup(lyr)=rolw(lyr-1)
	  qpup(lyr)=qplw(lyr-1)
	  qsup(lyr)=qslw(lyr-1)
        ly0=ly0+1      
      endif
c
c     determine indices of main interfaces
c
      lyos=1
      lyob=1
      if(vsup(1).le.0.d0)then
        do ly=2,ly0
          if(vsup(ly).gt.0.d0.and.vslw(ly-1).le.0.d0)then
            lyob=ly
            goto 301
          endif
        enddo
301     continue
        do ly=2,lyob-1
          if(roup(ly)-rolw(ly-1).gt.rolw(ly-1))then
            lyos=ly
            goto 302
          endif
        enddo
302     continue
      endif
      lycm=ly0+1
      do ly=max0(2,lyob+1),ly0
        if(vsup(ly).le.0.d0.and.vslw(ly-1).gt.0.d0)then
          lycm=ly
          goto 400
        endif
      enddo
400   lycc=ly0+1
      do ly=max0(2,lycm+1),ly0
        if(vsup(ly).gt.0.d0.and.vslw(ly-1).le.0.d0)then
          lycc=ly
          goto 500
        endif
      enddo
500   continue
c
c     determine indices of receiver layer
c
      rrr=rratmos-dpr
      do ly=1,ly0
        if(rrr.ge.rrup(ly))then
          lyr=ly
          goto 600
        endif
      enddo
600   continue
c
c     determine indices of source layers
c
      do ig=1,ngrn
        rrs=rratmos-grndep(ig)
        do ly=1,ly0
          if(rrs.ge.rrup(ly))then
            lygrn(ig)=ly
            goto 700
          endif
        enddo
700     continue
c        if(lygrn(ig).le.lyob.or.lygrn(ig).ge.lycm)then
c          stop ' Source in a liquid layer!'
c        endif
      enddo
c
      mass=0.d0
      do ly=ly0,1,-1
        dro=(roup(ly)-rolw(ly))/(rrup(ly)-rrlw(ly))
        ro1=rolw(ly)-dro*rrlw(ly) 
        mass=mass+PI*(rrup(ly)-rrlw(ly))*((4.d0/3.d0)*ro1
     &      *(rrup(ly)**2+rrup(ly)*rrlw(ly)+rrlw(ly)**2)
     &      +dro*(rrup(ly)**3+rrup(ly)**2*rrlw(ly)
     &      +rrup(ly)*rrlw(ly)**2+rrlw(ly)**3))
        cgrup(ly)=dcmplx(BIGG*mass/rrup(ly)**2,0.d0)
      enddo
      freeairgrd=-dreal(cgrup(lyr))*2.d0/rrup(lyr)
      if(lyr.gt.1)then
        freeairgrd=freeairgrd+4.d0*PI*BIGG*rolw(lyr-1)
      endif
c
      do ly=1,ly0-1
        cgrlw(ly)=cgrup(ly+1)
      enddo
      cgrlw(ly0)=(0.d0,0.d0)
c
	write(*,'(9a)')'  No','      R(km)','   Vp(km/s)',
     &    '   Vs(km/s)',' Ro(g/cm^3)','      Qp',
     &    '      Qs',' g(m/s^2)'
	do ly=1,ly0
	  write(*,1001)ly,rrup(ly)/1.d3,vpup(ly)/1.d3,vsup(ly)/1.d3,
     &               roup(ly)/1.d3,qpup(ly),qsup(ly),dreal(cgrup(ly))
        j=0
        do ig=1,ngrn
          if(lygrn(ig).eq.ly)then
            j=j+1
            write(*,'(a3,$)')' S '
          endif
        enddo
        if(j.eq.0)write(*,'(a3,$)')'   '
        if(lyr.eq.ly)then
          write(*,'(a3)')' R '
        else
          write(*,'(a3)')'   '
        endif
	  write(*,1002)rrlw(ly)/1.d3,vplw(ly)/1.d3,vslw(ly)/1.d3,
     &             rolw(ly)/1.d3,qplw(ly),qslw(ly),dreal(cgrlw(ly))
	enddo
c
      do ly=1,ly0
        crrup(ly)=dcmplx(rrup(ly),0.d0)
        croup(ly)=dcmplx(roup(ly),0.d0)
        claup(ly)=dcmplx(roup(ly)*(vpup(ly)**2-2.d0*vsup(ly)**2),0.d0)
        cmuup(ly)=dcmplx(roup(ly)*vsup(ly)**2,0.d0)
        cvpup(ly)=dcmplx(vpup(ly),0.d0)
        cvsup(ly)=dcmplx(vsup(ly),0.d0)
        cgaup(ly)=dcmplx(2.d0*PI2*BIGG*roup(ly),0.d0)
c
        crrlw(ly)=dcmplx(rrlw(ly),0.d0)
        crolw(ly)=dcmplx(rolw(ly),0.d0)
        clalw(ly)=dcmplx(rolw(ly)*(vplw(ly)**2-2.d0*vslw(ly)**2),0.d0)
        cvplw(ly)=dcmplx(vplw(ly),0.d0)
        cvslw(ly)=dcmplx(vslw(ly),0.d0)
        cmulw(ly)=dcmplx(rolw(ly)*vslw(ly)**2,0.d0)
        cgalw(ly)=dcmplx(2.d0*PI2*BIGG*rolw(ly),0.d0)
c
        cro(ly)=dcmplx(dsqrt(roup(ly)*rolw(ly)),0.d0)
        cla(ly)=(0.5d0,0.d0)*(claup(ly)+clalw(ly))
        cmu(ly)=(0.5d0,0.d0)*(cmuup(ly)+cmulw(ly))
        cvp(ly)=(0.5d0,0.d0)*(cvpup(ly)+cvplw(ly))
        cvs(ly)=(0.5d0,0.d0)*(cvsup(ly)+cvslw(ly))
        cgr(ly)=(0.5d0,0.d0)*(cgrup(ly)+cgrlw(ly))
        cga(ly)=(0.5d0,0.d0)*(cgaup(ly)+cgalw(ly))
      enddo
c
      mmantle=0.d0
      do ly=lyob,lycm-1
        ro1=0.5d0*(roup(ly)+rolw(ly))
        uplw4=rrup(ly)**4+rrup(ly)**3*rrlw(ly)
     &       +rrup(ly)**2*rrlw(ly)**2+rrup(ly)*rrlw(ly)**3
     &       +rrlw(ly)**4
        mshell(ly)=ro1*(rrup(ly)-rrlw(ly))*uplw4*8.d0*PI/15.d0
        mmantle=mmantle+mshell(ly)
      enddo
c
      do ly=1,lyob-1
        cypnorm(1,ly)=(1.d0,0.d0)
        cypnorm(2,ly)=cla(ly)
        cypnorm(3,ly)=cga(ly)
        cypnorm(4,ly)=cga(ly)
      enddo
      do ly=lyob,lycm-1
        cypnorm(1,ly)=(1.d0,0.d0)
        cypnorm(2,ly)=cla(ly)+(2.d0,0.d0)*cmu(ly)
        cypnorm(3,ly)=(1.d0,0.d0)
        cypnorm(4,ly)=cla(ly)+(2.d0,0.d0)*cmu(ly)
        cypnorm(5,ly)=cga(ly)
        cypnorm(6,ly)=cga(ly)
      enddo
      do ly=lycm,lycc-1
        cypnorm(1,ly)=(1.d0,0.d0)
        cypnorm(2,ly)=cla(ly)
        cypnorm(3,ly)=cga(ly)
        cypnorm(4,ly)=cga(ly)
      enddo
      do ly=lycc,ly0
        cypnorm(1,ly)=(1.d0,0.d0)
        cypnorm(2,ly)=cla(ly)+(2.d0,0.d0)*cmu(ly)
        cypnorm(3,ly)=(1.d0,0.d0)
        cypnorm(4,ly)=cla(ly)+(2.d0,0.d0)*cmu(ly)
        cypnorm(5,ly)=cga(ly)
        cypnorm(6,ly)=cga(ly)
      enddo
c
1001	format(i4,f11.4,3f11.4,2f8.1,f9.4,$)
1002	format(f15.4,3f11.4,2f8.1,f9.4)
      return
	end

      subroutine qsbsj(dk,nk)
      implicit none
      integer*4 nk
      real*8 dk
c
      include 'qsglobal.h'
c
      integer*4 i,ir,ik
      real*8 k,x
      real*8 bessj0,bessj1,bessj
c
      do ik=1,nk
        k=dble(ik)*dk
        do ir=1,nr
          x=k*r(ir)
          bsj(ik,0,ir)=bessj0(x)
          bsj(ik,1,ir)=bessj1(x)
          if(x.gt.2.d0)then
            bsj(ik,2,ir)=bsj(ik,1,ir)*2.d0/x-bsj(ik,0,ir)
          else
            bsj(ik,2,ir)=bessj(2,x)
          endif
          if(x.gt.3.d0)then
            bsj(ik,3,ir)=bsj(ik,2,ir)*4.d0/x-bsj(ik,1,ir)
          else
            bsj(ik,3,ir)=bessj(3,x)
          endif
          bsj(ik,-1,ir)=-bsj(ik,1,ir)
          do i=-1,3
            bsj(ik,i,ir)=bsj(ik,i,ir)*geospr(ir)
          enddo
        enddo
      enddo
c
      return
      end

c*******************************************************************************
c*******************************************************************************
	double precision function bessj(m,x)
	implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	integer m
	double precision x
c
c	J_n(x), n <= 3
c
	double precision eps
	data eps/1.0d-10/
	integer i,m0
	double precision ax,bx,y0,y1,y,sum
c
	double precision bessj0,bessj1
c
	m0=iabs(m)
	ax=dabs(x)
	if(m0.eq.0)then
	  bessj=bessj0(ax)
	else if(m0.eq.1)then
	  bessj=bessj1(ax)
	else
	  if(ax.gt.dble(m0))then
	    bx=2.d0/ax
	    y0=bessj0(ax)
	    y1=bessj1(ax)
	    do i=1,m0-1
	      y=dble(i)*bx*y1-y0
	      y0=y1
	      y1=y
	    enddo
	    bessj=y
	  else if(ax.eq.0.d0)then
	    bessj=0.d0
	  else
	    y=1.d0
	    bx=0.5d0*ax
	    do i=1,m0
	      y=y*bx/dble(i)
	    enddo
	    sum=y
	    bx=bx*bx
	    i=0
100	    i=i+1
	    y=-y*bx/dble(i)/dble(m0+i)
	    sum=sum+y
	    if(dabs(y).gt.eps*dabs(sum).or.i.lt.10)goto 100
	    bessj=sum
	  endif
	endif
	if(dble(m)*x.lt.0.d0.and.mod(m0,2).eq.1)bessj=-bessj
	return
	end

      subroutine qpspropg(ypsv,ldeg,lyup,lylw)
      use qpalloc
      implicit none
c
c     calculation of response (with gravity) to psv source (l>1)
c     ypsv(6,4): solution vector (complex)
c
      integer*4 ldeg,lyup,lylw
      complex*16 ypsv(6,4)
c
c     work space
c
      integer*4 i,j,i0,j0,istp,ly,key
      real*8 y4max
      complex*16 cdet,alf,bet,cyabs,cyswap,ca,cb
      complex*16 y0(6,3),c(2)
      complex*16 yup(6,3),ylw(6,3),yupc(4,2),ylwc(4,2)
      complex*16 coef6(6,6),b6(6,4),coef4(4,4),b4(4,2)
      external qpdifmat4,qpdifmat6
c
      complex*16 c3
      data c3/(3.d0,0.d0)/
c
c===============================================================================
c
c     propagation from surface to atmosphere/ocean bottom
c
      if(lyob.gt.lyup)then
        do j=1,2
          do i=1,4
            yupc(i,j)=(0.d0,0.d0)
          enddo
        enddo
c
        yupc(1,1)=comi2*crrup(lyup)
        yupc(2,1)=cgrup(lyup)
c
        yupc(2,2)=(1.d0,0.d0)
        yupc(3,2)=-comi2
c
        if(lyr.eq.lyup)then
          do j=1,3
            do i=1,6
              y0(i,j)=(0.d0,0.d0)
            enddo
          enddo
c
          y0(1,1)=yupc(1,1)
          y0(3,1)=yupc(2,1)
c
          y0(3,2)=yupc(2,2)
          y0(5,2)=yupc(3,2)
c
        endif
c
        do ly=lyup,min0(lys-1,lyob-1)
          if(ly.gt.lyup.and.ly.eq.lyos)then
c
c           interface ocean-atmosphere
c
            ca=yupc(1,1)*cgrup(ly)/crrup(ly)-yupc(3,1)
            cb=yupc(1,2)*cgrup(ly)/crrup(ly)-yupc(3,2)
c
            if(cdabs(ca).gt.cdabs(cb))then
              do i=1,4
                yupc(i,2)=yupc(i,1)*cb-yupc(i,2)*ca
              enddo
              yupc(2,2)=yupc(2,2)*crolw(ly-1)/croup(ly)
c
              yupc(1,1)=yupc(1,1)*comi2
              yupc(2,1)=(yupc(2,1)*crolw(ly-1)*comi2
     &                 +ca*(croup(ly)-crolw(ly-1)))/croup(ly)
              yupc(3,1)=yupc(3,1)*comi2
              yupc(4,1)=yupc(4,1)*comi2
              if(ly.ge.lyr)then
                do i=1,6
                  y0(i,2)=y0(i,1)*cb-y0(i,2)*ca
                  y0(i,1)=y0(i,1)*comi2
                enddo
              endif
            else
              do i=1,4
                yupc(i,1)=yupc(i,1)*cb-yupc(i,2)*ca
              enddo
              yupc(2,1)=yupc(2,1)*crolw(ly-1)/croup(ly)
c
              yupc(1,2)=yupc(1,2)*comi2
              yupc(2,2)=(yupc(2,2)*crolw(ly-1)*comi2
     &                 +cb*(croup(ly)-crolw(ly-1)))/croup(ly)
              yupc(3,2)=yupc(3,2)*comi2
              yupc(4,2)=yupc(4,2)*comi2
              if(ly.ge.lyr)then
                do i=1,6
                  y0(i,1)=y0(i,1)*cb-y0(i,2)*ca
                  y0(i,2)=y0(i,2)*comi2
                enddo
              endif
            endif
          endif
c
          cyabs=(0.d0,0.d0)
          do i=1,4
            cyabs=cyabs+yupc(i,1)*dconjg(yupc(i,1))/cypnorm(i,ly)**2
          enddo
          cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
          do i=1,4
            yupc(i,1)=yupc(i,1)*cyabs
          enddo
          if(ly.ge.lyr)then
            do i=1,6
              y0(i,1)=y0(i,1)*cyabs
            enddo
          endif
c
          alf=(0.d0,0.d0)
          do i=1,4
            alf=alf+yupc(i,2)*dconjg(yupc(i,1))/cypnorm(i,ly)**2
          enddo
          do i=1,4
            yupc(i,2)=yupc(i,2)-alf*yupc(i,1)
          enddo
          if(ly.ge.lyr)then
            do i=1,6
              y0(i,2)=y0(i,2)-alf*y0(i,1)
            enddo
          endif
c
          cyabs=(0.d0,0.d0)
          do i=1,4
            cyabs=cyabs+yupc(i,2)*dconjg(yupc(i,2))/cypnorm(i,ly)**2
          enddo
          cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
          do i=1,4
            yupc(i,2)=yupc(i,2)*cyabs
          enddo
          if(ly.ge.lyr)then
            do i=1,6
              y0(i,2)=y0(i,2)*cyabs
            enddo
          endif
c
          call ruku(yupc,4,2,ly,ldeg,qpdifmat4,rrup(ly),rrlw(ly))
          if(ly.eq.lyr-1)then
            do j=1,3
              do i=1,6
                y0(i,j)=(0.d0,0.d0)
              enddo
            enddo
            do j=1,2
              y0(1,j)=yupc(1,j)
              y0(2,j)=crolw(ly)*crrlw(ly)**2
     &                *(yupc(1,j)*cgrlw(ly)/crrlw(ly)
     &                -comi2*yupc(2,j)-yupc(3,j))
              y0(3,j)=yupc(2,j)
              y0(5,j)=yupc(3,j)
              y0(6,j)=yupc(4,j)
            enddo
          endif
        enddo
c
        ly=min0(lyob-1,lys-1)
        do j=1,2
          yup(1,j)=yupc(1,j)
          yup(2,j)=crolw(ly)*crrlw(ly)**2
     &            *(yupc(1,j)*cgrlw(ly)/crrlw(ly)
     &            -comi2*yupc(2,j)-yupc(3,j))
          yup(3,j)=(0.d0,0.d0)
          yup(4,j)=(0.d0,0.d0)
          yup(5,j)=yupc(3,j)
          yup(6,j)=yupc(4,j)
        enddo
        if(lys.ge.lyob)then
          yup(1,3)=(0.d0,0.d0)
          yup(2,3)=(0.d0,0.d0)
          yup(3,3)=(1.d0,0.d0)
          yup(4,3)=(0.d0,0.d0)
          yup(5,3)=(0.d0,0.d0)
          yup(6,3)=(0.d0,0.d0)
        endif
        if(lyr.eq.lyob.and.ly.eq.lyob-1)call cmemcpy(yup,y0,18)
      else
        do j=1,3
          do i=1,6
            yup(i,j)=(0.d0,0.d0)
          enddo
        enddo
        yup(1,1)=(1.d0,0.d0)
        yup(3,2)=(1.d0,0.d0)
        yup(5,3)=(1.d0,0.d0)
        if(lyr.eq.lyup)call cmemcpy(yup,y0,18)
      endif
c
c===============================================================================
c
c     propagation from atmosphere/ocean bottom to source
c
      do ly=lyob,lys-1
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+yup(i,1)*dconjg(yup(i,1))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          yup(i,1)=yup(i,1)*cyabs
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,1)=y0(i,1)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        do i=1,6
          alf=alf+yup(i,2)*dconjg(yup(i,1))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          yup(i,2)=yup(i,2)-alf*yup(i,1)
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)-alf*y0(i,1)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+yup(i,2)*dconjg(yup(i,2))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          yup(i,2)=yup(i,2)*cyabs
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        bet=(0.d0,0.d0)
        do i=1,6
          alf=alf+yup(i,3)*dconjg(yup(i,1))/cypnorm(i,ly)**2
          bet=bet+yup(i,3)*dconjg(yup(i,2))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          yup(i,3)=yup(i,3)-alf*yup(i,1)-bet*yup(i,2)
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,3)=y0(i,3)-alf*y0(i,1)-bet*y0(i,2)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+yup(i,3)*dconjg(yup(i,3))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          yup(i,3)=yup(i,3)*cyabs
        enddo
        if(ly.ge.lyr)then
          do i=1,6
            y0(i,3)=y0(i,3)*cyabs
          enddo
        endif
c
        call ruku(yup,6,3,ly,ldeg,qpdifmat6,rrup(ly),rrlw(ly))
        if(ly.eq.lyr-1)call cmemcpy(yup,y0,18)
      enddo
c
      do j=1,3
        yup(1,j)=yup(1,j)/crrup(lys)
        yup(2,j)=yup(2,j)/crrup(lys)**2
        yup(3,j)=yup(3,j)/crrup(lys)
        yup(4,j)=yup(4,j)/crrup(lys)**2
c        yup(5,j)=yup(5,j)
        yup(6,j)=yup(6,j)/crrup(lys)
      enddo
c
c===============================================================================
c
c     propagation within inner core
c
      if(lylw.ge.lycc)then
c
c       lowest layer is within inner core
c
        call qpstart6(ldeg,lylw,ylw)
        if(lylw.eq.lyr.and.lylw.gt.lys)then
          call cmemcpy(ylw,y0,18)
        endif
      endif
c
      do ly=lylw-1,lycc,-1
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,1)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,1)=ylw(i,1)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,1)=y0(i,1)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        do i=1,6
          alf=alf+ylw(i,2)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          ylw(i,2)=ylw(i,2)-alf*ylw(i,1)
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)-alf*y0(i,1)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,2)*dconjg(ylw(i,2))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,2)=ylw(i,2)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        bet=(0.d0,0.d0)
        do i=1,6
          alf=alf+ylw(i,3)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
          bet=bet+ylw(i,3)*dconjg(ylw(i,2))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          ylw(i,3)=ylw(i,3)-alf*ylw(i,1)-bet*ylw(i,2)
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,3)=y0(i,3)-alf*y0(i,1)-bet*y0(i,2)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,3)*dconjg(ylw(i,3))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,3)=ylw(i,3)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,3)=y0(i,3)*cyabs
          enddo
        endif
c
        call ruku(ylw,6,3,ly,ldeg,qpdifmat6,rrlw(ly),rrup(ly))
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,18)
      enddo
c
c===============================================================================
c
c     propagation within outer core
c
      if(lylw.ge.lycc)then
c
c       interface conditions: solid to liquid
c
        y4max=0.d0
        do j=1,3
          if(y4max.lt.cdabs(ylw(4,j)))then
            y4max=cdabs(ylw(4,j))
            j0=j
          endif
        enddo
        do i=1,6
          cyswap=ylw(i,j0)
          ylw(i,j0)=ylw(i,3)
          ylw(i,3)=cyswap
        enddo
        do j=1,2
          ylwc(1,j)=ylw(4,3)*ylw(1,j)-ylw(4,j)*ylw(1,3)
          ylwc(2,j)=ylw(4,3)*ylw(2,j)-ylw(4,j)*ylw(2,3)
          ylwc(3,j)=ylw(4,3)*ylw(5,j)-ylw(4,j)*ylw(5,3)
          ylwc(4,j)=ylw(4,3)*ylw(6,j)-ylw(4,j)*ylw(6,3)
        enddo
        if(lycc.le.lyr.and.lycc.gt.lys)then
          do i=1,6
            cyswap=y0(i,j0)
            y0(i,j0)=y0(i,3)
            y0(i,3)=cyswap
          enddo
          do j=1,2
            do i=1,6
              y0(i,j)=ylw(4,3)*y0(i,j)-ylw(4,j)*y0(i,3)
            enddo
          enddo
          do i=1,6
            y0(i,3)=(0.d0,0.d0)
          enddo
        endif
c
c       y2 = Ur
c
        do j=1,2
          c(j)=-ylwc(2,j)/crolw(lycc-1)/crrlw(lycc-1)**2
     &        +ylwc(1,j)*cgrlw(lycc-1)/crrlw(lycc-1)-ylwc(3,j)
        enddo
        do i=1,4
          ylwc(i,1)=c(2)*ylwc(i,1)-c(1)*ylwc(i,2)
        enddo
        ylwc(2,1)=(0.d0,0.d0)
        do i=1,4
          ylwc(i,2)=comi2*ylwc(i,2)
        enddo
        ylwc(2,2)=c(2)
        if(lycc.le.lyr.and.lycc.gt.lys)then
          do i=1,6
            y0(i,1)=c(2)*y0(i,1)-c(1)*y0(i,2)
            y0(i,2)=comi2*y0(i,2)
          enddo
        endif
      else if(lylw.ge.lycm)then
c
c       lowest layer is within the liquid core
c
        if(cdabs(comi).gt.0.d0)then
c
c         compressible liquid for dynamic response
c
          call qpstart4(ldeg,lylw,ylwc)
        else
c
c         incompressible liquid used for static response
c
          do j=1,2
            do i=1,4
              ylwc(i,j)=(0.d0,0.d0)
            enddo
          enddo
c
          ylwc(3,1)=(1.d0,0.d0)
          ylwc(4,1)=dcmplx(dble(2*ldeg+1),0.d0)
c
          ylwc(1,2)=dcmplx(dble(ldeg),0.d0)
          ylwc(2,2)=(1.d0,0.d0)
          ylwc(4,2)=-dcmplx(dble(ldeg),0.d0)*cgaup(lylw)
        endif
c
        if(lylw.eq.lyr.and.lylw.gt.lys)then
          do j=1,3
            do i=1,6
              y0(i,j)=(0.d0,0.d0)
            enddo
          enddo
          do j=1,2
            y0(1,j)=ylwc(1,j)
            y0(2,j)=croup(lylw)*crrup(lylw)**2
     &              *(ylwc(1,j)*cgrup(lylw)/crrup(lylw)
     &              -comi2*ylwc(2,j)-ylwc(3,j))
            y0(3,j)=ylwc(2,j)
            y0(5,j)=ylwc(3,j)
            y0(6,j)=ylwc(4,j)
          enddo
        endif
      endif
c
      do ly=min0(lylw-1,lycc-1),lycm,-1
        cyabs=(0.d0,0.d0)
        do i=1,4
          cyabs=cyabs+ylwc(i,1)*dconjg(ylwc(i,1))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,4
          ylwc(i,1)=ylwc(i,1)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,1)=y0(i,1)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        do i=1,4
          alf=alf+ylwc(i,2)*dconjg(ylwc(i,1))/cypnorm(i,ly)**2
        enddo
        do i=1,4
          ylwc(i,2)=ylwc(i,2)-alf*ylwc(i,1)
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)-alf*y0(i,1)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,4
          cyabs=cyabs+ylwc(i,2)*dconjg(ylwc(i,2))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,4
          ylwc(i,2)=ylwc(i,2)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)*cyabs
          enddo
        endif
c
        call ruku(ylwc,4,2,ly,ldeg,qpdifmat4,rrlw(ly),rrup(ly))
        if(ly.eq.lyr.and.ly.gt.lys)then
          do j=1,3
            do i=1,6
              y0(i,j)=(0.d0,0.d0)
            enddo
          enddo
          do j=1,2
            y0(1,j)=ylwc(1,j)
            y0(2,j)=croup(ly)*crrup(ly)**2
     &              *(ylwc(1,j)*cgrup(ly)/crrup(ly)
     &              -comi2*ylwc(2,j)-ylwc(3,j))
            y0(3,j)=ylwc(2,j)
            y0(5,j)=ylwc(3,j)
            y0(6,j)=ylwc(4,j)
          enddo
        endif
      enddo
c
c===============================================================================
c
c     propagation from core-mantle boundary to source or ocean bottom
c
      if(lylw.ge.lycm)then
c
c       interface conditions: liquid to solid
c
        do j=1,2
          ylw(1,j)=ylwc(1,j)
          ylw(2,j)=croup(lycm)*crrup(lycm)**2
     &            *(ylwc(1,j)*cgrup(lycm)/crrup(lycm)
     &            -comi2*ylwc(2,j)-ylwc(3,j))
          ylw(3,j)=(0.d0,0.d0)
          ylw(4,j)=(0.d0,0.d0)
          ylw(5,j)=ylwc(3,j)
          ylw(6,j)=ylwc(4,j)
        enddo
        ylw(1,3)=(0.d0,0.d0)
        ylw(2,3)=(0.d0,0.d0)
        ylw(3,3)=(1.d0,0.d0)
        ylw(4,3)=(0.d0,0.d0)
        ylw(5,3)=(0.d0,0.d0)
        ylw(6,3)=(0.d0,0.d0)
c
        if(lycm.eq.lyr.and.lycm.gt.lys)then
          call cmemcpy(ylw,y0,18)
        endif
      else if(lylw.ge.lyob)then
c
c       lowest layer is within the mantle
c
        call qpstart6(ldeg,lylw,ylw)
        if(lylw.eq.lyr.and.lylw.gt.lys)then
          call cmemcpy(ylw,y0,18)
        endif
      endif
c
      do ly=min0(lylw-1,lycm-1),max0(lys,lyob),-1
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,1)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,1)=ylw(i,1)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,1)=y0(i,1)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        do i=1,6
          alf=alf+ylw(i,2)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          ylw(i,2)=ylw(i,2)-alf*ylw(i,1)
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)-alf*y0(i,1)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,2)*dconjg(ylw(i,2))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,2)=ylw(i,2)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        bet=(0.d0,0.d0)
        do i=1,6
          alf=alf+ylw(i,3)*dconjg(ylw(i,1))/cypnorm(i,ly)**2
          bet=bet+ylw(i,3)*dconjg(ylw(i,2))/cypnorm(i,ly)**2
        enddo
        do i=1,6
          ylw(i,3)=ylw(i,3)-alf*ylw(i,1)-bet*ylw(i,2)
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,3)=y0(i,3)-alf*y0(i,1)-bet*y0(i,2)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,6
          cyabs=cyabs+ylw(i,3)*dconjg(ylw(i,3))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,6
          ylw(i,3)=ylw(i,3)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,3)=y0(i,3)*cyabs
          enddo
        endif
c
        call ruku(ylw,6,3,ly,ldeg,qpdifmat6,rrlw(ly),rrup(ly))
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,18)
      enddo
c
c===============================================================================
c
c     propagation from ocean bottom to source in atmosphere
c
      if(lylw.ge.lyob.and.lys.lt.lyob)then
c
c       interface conditions: solid to liquid
c
        y4max=0.d0
        do j=1,3
          if(y4max.lt.cdabs(ylw(4,j)))then
            y4max=cdabs(ylw(4,j))
            j0=j
          endif
        enddo
        do i=1,6
          cyswap=ylw(i,j0)
          ylw(i,j0)=ylw(i,3)
          ylw(i,3)=cyswap
        enddo
        do j=1,2
          ylwc(1,j)=ylw(4,3)*ylw(1,j)-ylw(4,j)*ylw(1,3)
          ylwc(2,j)=ylw(4,3)*ylw(2,j)-ylw(4,j)*ylw(2,3)
          ylwc(3,j)=ylw(4,3)*ylw(5,j)-ylw(4,j)*ylw(5,3)
          ylwc(4,j)=ylw(4,3)*ylw(6,j)-ylw(4,j)*ylw(6,3)
        enddo
        if(lyob.le.lyr.and.lyob.gt.lys)then
          do i=1,6
            cyswap=y0(i,j0)
            y0(i,j0)=y0(i,3)
            y0(i,3)=cyswap
          enddo
          do j=1,2
            do i=1,6
              y0(i,j)=ylw(4,3)*y0(i,j)-ylw(4,j)*y0(i,3)
            enddo
          enddo
          do i=1,6
            y0(i,3)=(0.d0,0.d0)
          enddo
        endif
c
c       y2 = Ur
c
        do j=1,2
          c(j)=-ylwc(2,j)/crolw(lycc-1)/crrlw(lycc-1)**2
     &        +ylwc(1,j)*cgrlw(lycc-1)/crrlw(lycc-1)-ylwc(3,j)
        enddo
        do i=1,4
          ylwc(i,1)=c(2)*ylwc(i,1)-c(1)*ylwc(i,2)
        enddo
        ylwc(2,1)=(0.d0,0.d0)
        do i=1,4
          ylwc(i,2)=comi2*ylwc(i,2)
        enddo
        ylwc(2,2)=c(2)
        if(lyob.le.lyr.and.lyob.gt.lys)then
          do i=1,6
            y0(i,1)=c(2)*y0(i,1)-c(1)*y0(i,2)
            y0(i,2)=comi2*y0(i,2)
          enddo
        endif
      else if(lys.lt.lyob)then
c
c       lowest layer is within the atmosphere
c
        if(cdabs(comi).gt.0.d0)then
c
c         compressible liquid for dynamic response
c
          call qpstart4(ldeg,lylw,ylwc)
        else
c
c         incompressible liquid used for static response
c
          do j=1,2
            do i=1,4
              ylwc(i,j)=(0.d0,0.d0)
            enddo
          enddo
c
          ylwc(3,1)=(1.d0,0.d0)
          ylwc(4,1)=dcmplx(dble(2*ldeg+1),0.d0)
c
          ylwc(1,2)=dcmplx(dble(ldeg),0.d0)
          ylwc(2,2)=(1.d0,0.d0)
          ylwc(4,2)=-dcmplx(dble(ldeg),0.d0)*cgaup(lylw)
        endif
c
        if(lylw.eq.lyr.and.lylw.gt.lys)then
          do j=1,3
            do i=1,6
              y0(i,j)=(0.d0,0.d0)
            enddo
          enddo
          do j=1,2
            y0(1,j)=ylwc(1,j)
            y0(2,j)=croup(lylw)*crrup(lylw)**2
     &              *(ylwc(1,j)*cgrup(lylw)/crrup(lylw)
     &              -comi2*ylwc(2,j)-ylwc(3,j))
            y0(3,j)=ylwc(2,j)
            y0(5,j)=ylwc(3,j)
            y0(6,j)=ylwc(4,j)
          enddo
        endif
      endif
c
      do ly=min0(lylw-1,lyob-1),lys,-1
        if(ly.eq.lyos-1)then
c
c         interface ocean-atmosphere
c
          ca=ylwc(1,1)*cgrlw(ly)/crrlw(ly)-ylwc(3,1)
          cb=ylwc(1,2)*cgrlw(ly)/crrlw(ly)-ylwc(3,2)
c
          if(cdabs(ca).gt.cdabs(cb))then
            do i=1,4
              ylwc(i,2)=ylwc(i,1)*cb-ylwc(i,2)*ca
            enddo
            ylwc(2,2)=ylwc(2,2)*croup(ly+1)/crolw(ly)
c
            ylwc(1,1)=ylwc(1,1)*comi2
            ylwc(2,1)=(ylwc(2,1)*croup(ly+1)*comi2
     &               +ca*(crolw(ly)-croup(ly+1)))/crolw(ly)
            ylwc(3,1)=ylwc(3,1)*comi2
            ylwc(4,1)=ylwc(4,1)*comi2
            if(ly.lt.lyr)then
              do i=1,6
                y0(i,2)=y0(i,1)*cb-y0(i,2)*ca
                y0(i,1)=y0(i,1)*comi2
              enddo
            endif
          else
            do i=1,4
              ylwc(i,1)=ylwc(i,1)*cb-ylwc(i,2)*ca
            enddo
            ylwc(2,1)=ylwc(2,1)*croup(ly+1)/crolw(ly)
c
            ylwc(1,2)=ylwc(1,2)*comi2
            ylwc(2,2)=(ylwc(2,2)*croup(ly+1)*comi2
     &               +cb*(crolw(ly)-croup(ly+1)))/crolw(ly)
            ylwc(3,2)=ylwc(3,2)*comi2
            ylwc(4,2)=ylwc(4,2)*comi2
            if(ly.lt.lyr)then
              do i=1,6
                y0(i,1)=y0(i,1)*cb-y0(i,2)*ca
                y0(i,2)=y0(i,2)*comi2
              enddo
            endif
          endif
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,4
          cyabs=cyabs+ylwc(i,1)*dconjg(ylwc(i,1))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,4
          ylwc(i,1)=ylwc(i,1)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,1)=y0(i,1)*cyabs
          enddo
        endif
c
        alf=(0.d0,0.d0)
        do i=1,4
          alf=alf+ylwc(i,2)*dconjg(ylwc(i,1))/cypnorm(i,ly)**2
        enddo
        do i=1,4
          ylwc(i,2)=ylwc(i,2)-alf*ylwc(i,1)
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)-alf*y0(i,1)
          enddo
        endif
c
        cyabs=(0.d0,0.d0)
        do i=1,4
          cyabs=cyabs+ylwc(i,2)*dconjg(ylwc(i,2))/cypnorm(i,ly)**2
        enddo
        cyabs=(1.d0,0.d0)/cdsqrt(cyabs)
        do i=1,4
          ylwc(i,2)=ylwc(i,2)*cyabs
        enddo
        if(ly.lt.lyr)then
          do i=1,6
            y0(i,2)=y0(i,2)*cyabs
          enddo
        endif
c
        call ruku(ylwc,4,2,ly,ldeg,qpdifmat4,rrlw(ly),rrup(ly))
        if(ly.eq.lyr.and.ly.gt.lys)then
          do j=1,3
            do i=1,6
              y0(i,j)=(0.d0,0.d0)
            enddo
          enddo
          do j=1,2
            y0(1,j)=ylwc(1,j)
            y0(2,j)=croup(ly)*crrup(ly)**2
     &              *(ylwc(1,j)*cgrup(ly)/crrup(ly)
     &              -comi2*ylwc(2,j)-ylwc(3,j))
            y0(3,j)=ylwc(2,j)
            y0(5,j)=ylwc(3,j)
            y0(6,j)=ylwc(4,j)
          enddo
        endif
      enddo
      if(lys.lt.lyob)then
        do j=1,2
          ylw(1,j)=ylwc(1,j)
          ylw(2,j)=croup(lys)*crrup(lys)**2
     &            *(ylwc(1,j)*cgrup(lys)/crrup(lys)
     &            -comi2*ylwc(2,j)-ylwc(3,j))
          ylw(3,j)=(0.d0,0.d0)
          ylw(4,j)=(0.d0,0.d0)
          ylw(5,j)=ylwc(3,j)
          ylw(6,j)=ylwc(4,j)
        enddo
        do i=1,6
          ylw(i,3)=(0.d0,0.d0)
        enddo
      endif
c
      do j=1,3
        ylw(1,j)=ylw(1,j)/crrup(lys)
        ylw(2,j)=ylw(2,j)/crrup(lys)**2
        ylw(3,j)=ylw(3,j)/crrup(lys)
        ylw(4,j)=ylw(4,j)/crrup(lys)**2
c        ylw(5,j)=ylw(5,j)
        ylw(6,j)=ylw(6,j)/crrup(lys)
      enddo
c
      do j=1,3
        y0(1,j)=y0(1,j)/crrup(lyr)
        y0(2,j)=y0(2,j)/crrup(lyr)**2
        y0(3,j)=y0(3,j)/crrup(lyr)
        y0(4,j)=y0(4,j)/crrup(lyr)**2
c        y0(5,j)=y0(5,j)
        y0(6,j)=y0(6,j)/crrup(lyr)
      enddo
c
c===============================================================================
c     source function
c===============================================================================
c
      if(lys.lt.lyob)then
        do istp=1,2
          do i=1,4
            b4(i,istp)=(0.d0,0.d0)
          enddo
          b4(istp,istp)=(1.d0,0.d0)
        enddo
        do j=1,2
          do i=1,2
            coef4(i,j)=yup(i,j)
            coef4(i,j+2)=-ylw(i,j)
          enddo
          do i=3,4
            coef4(i,j)=yup(i+2,j)
            coef4(i,j+2)=-ylw(i+2,j)
          enddo
        enddo
        key=0
        call cdsvd(coef4,b4,4,2,0.d0,key)
        if(key.eq.0)then
          print *,' Warning in qpspropg: anormal exit from cdgemp!'
          return
        endif
        if(lyr.le.lys)then
          do istp=1,2
            do i=1,6
              ypsv(i,istp)=(0.d0,0.d0)
              do j=1,2
                ypsv(i,istp)=ypsv(i,istp)+b4(j,istp)*y0(i,j)
              enddo
            enddo
          enddo
        else
          do istp=1,2
            do i=1,6
              ypsv(i,istp)=(0.d0,0.d0)
              do j=1,2
                ypsv(i,istp)=ypsv(i,istp)+b4(j+2,istp)*y0(i,j)
              enddo
            enddo
          enddo
        endif
        do istp=3,4
          do i=1,6
            ypsv(i,istp)=(0.d0,0.d0)
          enddo
        enddo
      else
        do istp=1,4
          do i=1,6
            b6(i,istp)=(0.d0,0.d0)
          enddo
          b6(istp,istp)=(1.d0,0.d0)
        enddo
        do j=1,3
          do i=1,6
            coef6(i,j)=yup(i,j)
            coef6(i,j+3)=-ylw(i,j)
          enddo
        enddo
        key=0
        call cdsvd(coef6,b6,6,4,0.d0,key)
        if(key.eq.0)then
          print *,' Warning in qpspropg: anormal exit from cdgemp!'
          return
        endif
        if(lyr.le.lys)then
          do istp=1,4
            do i=1,6
              ypsv(i,istp)=(0.d0,0.d0)
              do j=1,3
                ypsv(i,istp)=ypsv(i,istp)+b6(j,istp)*y0(i,j)
              enddo
            enddo
          enddo
        else
          do istp=1,4
            do i=1,6
              ypsv(i,istp)=(0.d0,0.d0)
              do j=1,3
                ypsv(i,istp)=ypsv(i,istp)+b6(j+3,istp)*y0(i,j)
              enddo
            enddo
          enddo
        endif
      endif
      return
      end

	subroutine edgmoment(istype,strength,ro,vp,vs)
	implicit none
c
c	First implemented in Potsdam, Feb, 1999
c	Last modified: Potsdam, Nov, 2001, by R. Wang
c
	double precision pi,pi2
	data pi,pi2/3.14159265358979d0,6.28318530717959d0/
c
	integer istype
	double precision ro,vp,vs
	double precision strength
c
c       source parameters
c
        integer ls,ms,ics
        integer kpower(6)
        double precision zs,r0
        double precision sfct(6)
        common /source/ zs,r0,sfct,ls,ms,ics,kpower
c
	integer i
c
	do i=1,6
	  sfct(i)=0.d0
	  kpower(i)=0
	enddo
c
	if(istype.eq.0)then
c
c	  explosion source (m11=m22=m33=M0)
c
	  ms=0
	  ics=1
	  sfct(1)=-strength/(2.d0*pi*ro*vp*vp)
	  sfct(4)=-strength*(vs/vp)**2/pi
	  kpower(4)=1
	else if(istype.eq.1)then
c
c	  strike-slip (m12=m21=M0)
c
	  ms=2
	  ics=-1
	  sfct(4)=strength/(2.d0*pi)
	  sfct(6)=-sfct(4)
	  kpower(4)=1
	  kpower(6)=1
	else if(istype.eq.2)then
c
c	  dip-slip (m13=m31=M0)
c
	  ms=1
	  ics=1
	  sfct(3)=-strength/(2.d0*pi*ro*vs*vs)
	  sfct(5)=sfct(3)
	else if(istype.eq.3)then
c
c	  compensated linear vector dipole (CLVD) (m11=m22=-M0/2, M33=M0)
c
	  ms=0
	  ics=1
	  sfct(1)=-strength/(2.d0*pi*ro*vp*vp)
	  sfct(4)=strength*(3.d0-4.d0*(vs/vp)**2)/(4.d0*pi)
	  kpower(4)=1
	else if(istype.eq.4)then
c
c	  vertical-single-force (fz=F0)
c
	  ms=0
	  ics=1
	  sfct(2)=strength/(2.d0*pi)
	else if(istype.eq.5)then
c
c	  horizontal-single-force (fx=F0)
c
	  ms=1
	  ics=1
	  sfct(4)=strength/(2.d0*pi)
	  sfct(6)=sfct(4)
	else if(istype.eq.6)then
c
c	  airgun in small pool (m11=m22=M0, fz=M0/r_source)
c
	  ms=0
	  ics=1
	  sfct(2)=-strength/(2.d0*pi*r0)
	  sfct(4)=-strength/(2.d0*pi)
	  kpower(4)=1
	else
	  stop ' Error in edgmoment: wrong source type switch no!'
	endif
c
	return
	end


	  

      subroutine wavelet(tau,df,mm2,wvf)
      implicit none
      integer mm2
      double precision tau,df
      double complex wvf(mm2)
c
      integer l
      double precision f,x
c
      double precision pi2,eps
      data pi2,eps/6.28318530717959d0,1.0d-04/
c
      do l=1,mm2
        f=df*dble(l-1)
        x=f*tau
        if(x.eq.0.d0)then
          wvf(l)=(1.d0,0.d0)
        else if(x.ge.1.d0-eps.and.x.le.1.d0+eps)then
          wvf(l)=dcmplx(-1.d0/x/(1+x),0.d0)
        else
          wvf(l)=dcmplx(0.d0,1.d0/(pi2*x*(1.d0+x)*(1.d0-x)))
     &             *(cdexp(dcmplx(0.d0,-pi2*x))-(1.d0,0.d0))
        endif
      enddo
      return
      end

      subroutine qpdifmat2(ly,ldeg,rr,mat)
      use qpalloc
      implicit none
      integer*4 ly,ldeg
      real*8 rr
      complex*16 mat(6,6)
c
      real*8 mass,ro1,dro
      complex*16 cup,clw,crr,drr,crorr,cxirr,clarr,cmurr,cgrrr
c
      complex*16 c1,c2,c4
      data c1,c2,c4/(1.d0,0.d0),(2.d0,0.d0),(4.d0,0.d0)/
c
      crr=dcmplx(rr,0.d0)
      cup=(crr-rrlw(ly))/(crrup(ly)-crrlw(ly))
      clw=c1-cup
      crorr=cup*croup(ly)+clw*crolw(ly)
      clarr=cup*claup(ly)+clw*clalw(ly)
      cmurr=cup*cmuup(ly)+clw*cmulw(ly)
      cxirr=clarr+c2*cmurr
c
      dro=(roup(ly)-rolw(ly))/(rrup(ly)-rrlw(ly))
      ro1=rolw(ly)-dro*rrlw(ly) 
      mass=PI*(rr-rrlw(ly))
     &    *((4.d0/3.d0)*ro1*(rr**2+rr*rrlw(ly)+rrlw(ly)**2)
     &    +dro*(rr**3+rr**2*rrlw(ly)+rr*rrlw(ly)**2+rrlw(ly)**3))
      cgrrr=cgrlw(ly)*(crrlw(ly)/crr)**2
     &     +dcmplx(BIGG*mass/rr**2,0.d0)
c
      mat(1,1)=(c1-c2*clarr/cxirr)/crr
      mat(1,2)=c1/cxirr/crr
c
      mat(2,1)=c4*(cmurr*(c1+c2*clarr/cxirr)/crr-crorr*cgrrr)
     &        -crorr*comi2*crr
      mat(2,2)=c2*clarr/cxirr/crr
c
      return
      end

      subroutine four1(data,nn,isign)
      implicit none
      integer*4 nn,isign
      real*8 data(2*nn)
c
c     fast fourier transform (fft)
c     convention: f(t)=\int F(f)e^{-i2\pi ft} df 
c     replace data by its discrete fourier transform, if isign is input
c     as 1; or replace data by nn times its inverse discrete fourier
c     transform, if isign is input as -1. data is a complex*16 array of
c     length nn or, equivalently, a real*8 array of length 2*nn.
c     nn must be an integer*4 power of 2 (this is not checked!)
c
c     note for convention: f(t)=\int F(f)e^{i2\pi f t} df, t-domain ==>
c     f-domain, if isign=-1, and f-domain ==> t-domain, if isign=1.
c
      integer*4 i,j,n,m,mmax,istep
      real*8 tempr,tempi
      real*8 wr,wi,wpr,wpi,wtemp,theta
      n=2*nn
      j=1
      do i=1,n,2
        if(j.gt.i)then
          tempr=data(j)
          tempi=data(j+1)
          data(j)=data(i)
          data(j+1)=data(i+1)
          data(i)=tempr
          data(i+1)=tempi
        endif
        m=n/2
1       if((m.ge.2).and.(j.gt.m))then
          j=j-m
          m=m/2
        goto 1
        endif
        j=j+m
      enddo
      mmax=2
2     if(n.gt.mmax)then
        istep=2*mmax
        theta=6.28318530717959d0/dble(isign*mmax)
        wpr=-2.d0*dsin(0.5d0*theta)**2
        wpi=dsin(theta)
        wr=1.d0
        wi=0.d0
        do m=1,mmax,2
          do i=m,n,istep
              j=i+mmax
              tempr=wr*data(j)-wi*data(j+1)
              tempi=wr*data(j+1)+wi*data(j)
              data(j)=data(i)-tempr
              data(j+1)=data(i+1)-tempi
              data(i)=data(i)+tempr
              data(i+1)=data(i+1)+tempi
          enddo
          wtemp=wr
          wr=wr*wpr-wi*wpi+wr
          wi=wi*wpr+wtemp*wpi+wi
        enddo
        mmax=istep
      goto 2
      endif
      return
      end

      subroutine moments(munit,strike,dip,rake,
     &                   mtt,mpp,mrr,mtp,mpr,mrt)
      implicit none
      real*8 munit,strike,dip,rake,
     &       mtt,mpp,mrr,mtp,mpr,mrt
c
      real*8 DEG2RAD
      parameter(DEG2RAD=1.745329251994328d-02)
c
      real*8 st,di,ra
      real*8 sss,sss2,ss2s,css,css2,cs2s
      real*8 ssd,ss2d,csd,cs2d,ssr,csr
c
      st=strike*DEG2RAD
      di=dip*DEG2RAD
      ra=rake*DEG2RAD
c
      sss=dsin(st)
      sss2=sss*sss
      ss2s=dsin(2.d0*st)
      css=dcos(st)
      css2=css*css
      cs2s=dcos(2.d0*st)
c
      ssd=dsin(di)
      ss2d=dsin(2.d0*di)
      csd=dcos(di)
      cs2d=dcos(2.d0*di)
c
      ssr=dsin(ra)
      csr=dcos(ra)
c
      mtt=munit*(-ssd*csr*ss2s-ss2d*ssr*sss2)
      mpp=munit*(ssd*csr*ss2s-ss2d*ssr*css2)
      mrr=-(mtt+mpp)
      mtp=munit*(-ssd*csr*cs2s-0.5d0*ss2d*ssr*ss2s)
      mpr=munit*(csd*csr*sss-cs2d*ssr*css)
      mrt=munit*(-csd*csr*css-cs2d*ssr*sss)
c
      return
      end

      subroutine qptprop(ldeg,ysh,lyup,lylw)
      use qpalloc
      implicit none
c
c     calculation of toroidal response
c     ysh(2,2): solution vector (complex)
c
      integer*4 ldeg,lyup,lylw
      complex*16 ysh(2,2)
c
c     work space
c
      integer*4 i,istp,ly,lyswap,key
      complex*16 cldeg
      complex*16 y0(2),yup(2),ylw(2),wave(2),c(2)
      complex*16 coef(2,2),b(2,2)
c
      if(lylwa.gt.lylw)return
c
      cldeg=dcmplx(dble(ldeg),0.d0)
c
c===============================================================================
c
c     propagation from surface to source
c
      if(freesurf.and.lyup.eq.1.or.
     &   lyup.eq.lyob.and.lyob.gt.1.or.lyup.eq.lycc)then
        yup(1)=(1.d0,0.d0)
        yup(2)=(0.d0,0.d0)
      else
        call qpstart2t(ldeg,lyup,2,yup)
      endif
c
      if(lyr.eq.lyup)call cmemcpy(yup,y0,2)
c
      do ly=lyup,lys-1
        call caxcb(mat2x2inv(1,1,ly),yup,2,2,1,c)
        wave(1)=cdexp( cpt(1,ly))
        wave(2)=cdexp(-cpt(2,ly))
        if(ly.ge.lyr)then
          do i=1,2
            y0(i)=y0(i)*wave(2)
          enddo
        endif
c
	  c(1)=c(1)*wave(1)*wave(2)
c       c(2)=c(2)
c
        call caxcb(mat2x2lw(1,1,ly),c,2,2,1,yup)
        if(ly.eq.lyr-1)call cmemcpy(yup,y0,2)
      enddo
c     yup(1)=yup(1)
      yup(2)=yup(2)/crrup(lys)
c
c===============================================================================
c
c     propagation from bottom to source
c
      if(lylw.eq.lycm)then
        ylw(1)=(1.d0,0.d0)
        ylw(2)=(0.d0,0.d0)
      else if(lylw.eq.lylwb)then
        call qpstart2t(ldeg,lylw,1,ylw)
      else
        ylw(1)=mat2x2up(1,1,lylw)
        ylw(2)=mat2x2up(2,1,lylw)
      endif
      if(lylw.eq.lyr.and.lylw.gt.lys)then
        call cmemcpy(ylw,y0,2)
      endif
c
      do ly=lylw-1,lys,-1
        call caxcb(mat2x2inv(1,1,ly),ylw,2,2,1,c)
        wave(1)=cdexp(-cpt(1,ly))
        wave(2)=cdexp( cpt(2,ly))
c
        if(ly.lt.lyr)then
          do i=1,2
            y0(i)=y0(i)*wave(1)
          enddo
        endif
c
c       c(1)=c(1)
        c(2)=c(2)*wave(1)*wave(2)
c
        call caxcb(mat2x2up(1,1,ly),c,2,2,1,ylw)
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,2)
      enddo
c     ylw(1)=ylw(1)
      ylw(2)=ylw(2)/crrup(lys)
c
c     y0(1)=y0(1)
      y0(2)=y0(2)/crrup(lyr)
c
c===============================================================================
c     source function
c===============================================================================
c
      b(1,1)=(1.d0,0.d0)
      b(2,1)=(0.d0,0.d0)
      b(1,2)=(0.d0,0.d0)
      b(2,2)=(1.d0,0.d0)
      do i=1,2
        coef(i,1)=yup(i)
        coef(i,2)=-ylw(i)
      enddo
      key=0
      call cdsvd500(coef,b,2,2,0.d0,key)
      if(key.eq.0)then
        print *,' Warning in qptprop: anormal exit from cdsvd500!'
        return
      endif
      if(lyr.le.lys)then
        do istp=1,2
          do i=1,2
            ysh(i,istp)=b(1,istp)*y0(i)
          enddo
        enddo
      else
        do istp=1,2
          do i=1,2
            ysh(i,istp)=b(2,istp)*y0(i)
          enddo
        enddo
      endif
c
      if(lylwa.le.0)return
c
c===============================================================================
c
c     propagation from bottom to source
c
      lyswap=lylwa
      call qpstart2t(ldeg,lyswap,1,ylw)
      if(lylwa.eq.lyr.and.lylwa.gt.lys)then
        call cmemcpy(ylw,y0,2)
      endif
c
      do ly=lylwa-1,lys,-1
        call caxcb(mat2x2inv(1,1,ly),ylw,2,2,1,c)
        wave(1)=cdexp(-cpt(1,ly))
        wave(2)=cdexp( cpt(2,ly))
c
        if(ly.lt.lyr)then
          do i=1,2
            y0(i)=y0(i)*wave(1)
          enddo
        endif
c
c       c(1)=c(1)
        c(2)=c(2)*wave(1)*wave(2)
c
        call caxcb(mat2x2up(1,1,ly),c,2,2,1,ylw)
        if(ly.eq.lyr.and.ly.gt.lys)call cmemcpy(ylw,y0,2)
      enddo
c     ylw(1)=ylw(1)
      ylw(2)=ylw(2)/crrup(lys)
c
      if(lyr.gt.lys)then
c       y0(1)=y0(1)
        y0(2)=y0(2)/crrup(lyr)
      endif
c
c===============================================================================
c     source function
c===============================================================================
c
      b(1,1)=(1.d0,0.d0)
      b(2,1)=(0.d0,0.d0)
      b(1,2)=(0.d0,0.d0)
      b(2,2)=(1.d0,0.d0)
      do i=1,2
        coef(i,1)=yup(i)
        coef(i,2)=-ylw(i)
      enddo
      key=0
      call cdsvd500(coef,b,2,2,0.d0,key)
      if(key.eq.0)then
        print *,' Warning in qptprop: anormal exit from cdsvd500!'
        return
      endif
      if(lyr.le.lys)then
        do istp=1,2
          do i=1,2
            ysh(i,istp)=ysh(i,istp)-b(1,istp)*y0(i)
          enddo
        enddo
      else
        do istp=1,2
          do i=1,2
            ysh(i,istp)=ysh(i,istp)-b(2,istp)*y0(i)
          enddo
        enddo
      endif
      return
      end

      subroutine cmemcpy(a,b,n)
      implicit none
c
c     copy complex array a to b
c
      integer*4 n
      complex*16 a(n),b(n)
c
      integer*4 i
c
      do i=1,n
        b(i)=a(i)
      enddo
      return
      end

      subroutine qpdifmat6(ly,ldeg,rr,mat)
      use qpalloc
      implicit none
      integer*4 ly,ldeg
      real*8 rr
      complex*16 mat(6,6)
c
      complex*16 cldeg,clp1,cll1,cup,clw
      complex*16 crr,drr,crorr,clarr,cmurr,cxirr,cgarr,cgrrr
c
      complex*16 c1,c2,c4
      data c1,c2,c4/(1.d0,0.d0),(2.d0,0.d0),(4.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      clp1=cldeg+c1
      cll1=cldeg*clp1
      crr=dcmplx(rr,0.d0)
      cup=(crr-rrlw(ly))/(crrup(ly)-crrlw(ly))
      clw=c1-cup
      crorr=cup*croup(ly)+clw*crolw(ly)
      clarr=cup*claup(ly)+clw*clalw(ly)
      cmurr=cup*cmuup(ly)+clw*cmulw(ly)
      cgarr=cup*cgaup(ly)+clw*cgalw(ly)
      cgrrr=cup*cgrup(ly)+clw*cgrlw(ly)
      cxirr=clarr+c2*cmurr
c
      mat(1,1)=(c1-c2*clarr/cxirr)/crr
      mat(1,2)=c1/cxirr/crr
      mat(1,3)=cll1*clarr/cxirr/crr
      mat(1,4)=(0.d0,0.d0)
      mat(1,5)=(0.d0,0.d0)
      mat(1,6)=(0.d0,0.d0)
c
      mat(2,1)=c4*(cmurr*(c1+c2*clarr/cxirr)/crr-crorr*cgrrr)
     &        -crorr*comi2*crr
      mat(2,2)=c2*clarr/cxirr/crr
      mat(2,3)=cll1*(crorr*cgrrr
     &        -c2*cmurr*(c1+c2*clarr/cxirr)/crr)
      mat(2,4)=cll1/crr
      mat(2,5)=crorr*clp1*crr
      mat(2,6)=-crorr*crr
c
      mat(3,1)=-c1/crr
      mat(3,2)=(0.d0,0.d0)
      mat(3,3)=c2/crr
      mat(3,4)=c1/cmurr/crr
      mat(3,5)=(0.d0,0.d0)
      mat(3,6)=(0.d0,0.d0)
c
      mat(4,1)=crorr*cgrrr-c2*cmurr*(c1+c2*clarr/cxirr)/crr
      mat(4,2)=-clarr/cxirr/crr
      mat(4,3)=c2*cmurr*(c2*cll1*(c1-cmurr/cxirr)-c1)/crr
     &        -crorr*comi2*crr
      mat(4,4)=-c1/crr
      mat(4,5)=-crorr*crr
      mat(4,6)=(0.d0,0.d0)
c
      mat(5,1)=cgarr/crr
      mat(5,2)=(0.d0,0.d0)
      mat(5,3)=(0.d0,0.d0)
      mat(5,4)=(0.d0,0.d0)
      mat(5,5)=-clp1/crr
      mat(5,6)=c1/crr
c
      mat(6,1)=cgarr*clp1/crr
      mat(6,2)=(0.d0,0.d0)
      mat(6,3)=-cgarr*cll1/crr
      mat(6,4)=(0.d0,0.d0)
      mat(6,5)=(0.d0,0.d0)
      mat(6,6)=cldeg/crr
      return
      end

	subroutine qpsublayer(ierr)
      use qpalloc
	implicit none
      integer*4 ierr
c
c	work space
c
	integer*4 i,j,i0,l,ly,lya,lyb,lyp,ig,di0
      real*8 f,h,dh,z,zz,slw,wvlcut,up,lw,uplw4,alfa,beta
	real*8 rrs,rrr,dvp,dvs,ro1,dro,dqp,dqs,mass,gr0
      real*8 bvn2
      logical*2 atmo,action
c
      lymax=0
      do l=1,l0
        if(vs0up(l).gt.0.d0)then
          wvlcut=vs0up(l)/fcut
        else
          wvlcut=vp0up(l)/fcut
        endif
	  h=dp0lw(l)-dp0up(l)
	  dvp=2.d0*dabs(vp0lw(l)-vp0up(l))/(vp0lw(l)+vp0up(l))
        if(vs0lw(l)+vs0up(l).gt.0.d0)then
	    dvs=2.d0*dabs(vs0lw(l)-vs0up(l))/(vs0lw(l)+vs0up(l))
        else
          dvs=0.d0
        endif
        if(dp0lw(l).le.depatmos)then
          atmo=.true.
          dro=2.d0*dabs(dlog(ro0lw(l))-dlog(ro0up(l)))
     &       /(dlog(ro0lw(l))+dlog(ro0up(l)))
        else
          atmo=.false.
          dro=2.d0*dabs(ro0lw(l)-ro0up(l))/(ro0lw(l)+ro0up(l))
        endif
        i0=1+idint(dmax1(dvp/RESOLUT,dvs/RESOLUT,dro/RESOLUT))
        i0=min0(i0,1+idint(5.d0*h/wvlcut))
        lymax=lymax+i0
      enddo
      lymax=lymax+lyadd+1
c
      allocate(ldegpsv(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: ldegpsv not allocated!'
      allocate(ldegsh(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: ldegsh not allocated!'
      allocate(nruku(0:ldegmax,lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: ldegsh not allocated!'
c
      allocate(rrup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: rrup not allocated!'
      allocate(rrlw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: rrlw not allocated!'
      allocate(vpup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: vpup not allocated!'
      allocate(vplw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: vplw not allocated!'
      allocate(vsup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: vsup not allocated!'
      allocate(vslw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: vslw not allocated!'
      allocate(roup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: roup not allocated!'
      allocate(rolw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: rolw not allocated!'
      allocate(qpup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: qpup not allocated!'
      allocate(qplw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: qplw not allocated!'
      allocate(qsup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: qsup not allocated!'
      allocate(qslw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: qslw not allocated!'
c
      allocate(crrup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: crrup not allocated!'
      allocate(crrlw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: crrlw not allocated!'
c
      allocate(cvp(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cvp not allocated!'
      allocate(cvpup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cvpup not allocated!'
      allocate(cvplw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cvplw not allocated!'
c
      allocate(cvs(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cvs not allocated!'
      allocate(cvsup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cvsup not allocated!'
      allocate(cvslw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cvslw not allocated!'
c
      allocate(cro(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cro not allocated!'
      allocate(croup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: croup not allocated!'
      allocate(crolw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: crolw not allocated!'
c
      allocate(cla(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cla not allocated!'
      allocate(claup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: claup not allocated!'
      allocate(clalw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: clalw not allocated!'
c
      allocate(cmu(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cmu not allocated!'
      allocate(cmuup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cmuup not allocated!'
      allocate(cmulw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cmulw not allocated!'
c
      allocate(cgr(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cgr not allocated!'
      allocate(cgrup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cgrup not allocated!'
      allocate(cgrlw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cgrlw not allocated!'
c
      allocate(cga(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cga not allocated!'
      allocate(cgaup(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cgaup not allocated!'
      allocate(cgalw(lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cgalw not allocated!'
c
      allocate(cua(8,6),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cua not allocated!'
      allocate(cypnorm(6,lymax),stat=ierr)
      if(ierr.ne.0)stop ' Error in qpsublayer: cypnorm not allocated!'
c
	ly0=0
c
      zz=0.d0
	do l=1,l0
        if(vs0up(l).gt.0.d0)then
          wvlcut=vs0up(l)/fcut
        else
          wvlcut=vp0up(l)/fcut
        endif
	  h=dp0lw(l)-dp0up(l)
	  dvp=2.d0*dabs(vp0lw(l)-vp0up(l))/(vp0lw(l)+vp0up(l))
        if(vs0lw(l)+vs0up(l).gt.0.d0)then
	    dvs=2.d0*dabs(vs0lw(l)-vs0up(l))/(vs0lw(l)+vs0up(l))
        else
          dvs=0.d0
        endif
        if(dp0lw(l).le.depatmos)then
          atmo=.true.
          dro=2.d0*dabs(dlog(ro0lw(l))-dlog(ro0up(l)))
     &       /(dlog(ro0lw(l))+dlog(ro0up(l)))
        else
          atmo=.false.
          dro=2.d0*dabs(ro0lw(l)-ro0up(l))/(ro0lw(l)+ro0up(l))
        endif
        i0=1+idint(dmax1(dvp/RESOLUT,dvs/RESOLUT,dro/RESOLUT))
        i0=min0(i0,1+idint(5.d0*h/wvlcut))
        dvp=(vp0lw(l)-vp0up(l))/h
	  dvs=(vs0lw(l)-vs0up(l))/h
        if(atmo)then
	    dro=(dlog(ro0lw(l))-dlog(ro0up(l)))/h
        else
          dro=(ro0lw(l)-ro0up(l))/h
        endif
	  dqp=(qp0lw(l)-qp0up(l))/h
	  dqs=(qs0lw(l)-qs0up(l))/h
	  dh=h/dble(i0)
	  do i=1,i0
	    ly0=ly0+1
	    if(ly0.gt.lymax-lyadd)then
	      stop ' Error in qpsublayer: lymax too small!'
	    endif
	    z=dble(i-1)*dh
	    rrup(ly0)=rratmos-(zz+z)
	    vpup(ly0)=vp0up(l)+dvp*z
	    vsup(ly0)=vs0up(l)+dvs*z
          if(atmo)then
	      roup(ly0)=ro0up(l)*dexp(dro*z)
          else
            roup(ly0)=ro0up(l)+dro*z
          endif
	    qpup(ly0)=qp0up(l)+dqp*z
	    qsup(ly0)=qs0up(l)+dqs*z
          z=z+dh
	    rrlw(ly0)=rratmos-(zz+z)
	    vplw(ly0)=vp0up(l)+dvp*z
	    vslw(ly0)=vs0up(l)+dvs*z
          if(atmo)then
	      rolw(ly0)=ro0up(l)*dexp(dro*z)
          else
            rolw(ly0)=ro0up(l)+dro*z
          endif
	    qplw(ly0)=qp0up(l)+dqp*z
	    qslw(ly0)=qs0up(l)+dqs*z
	  enddo
        zz=zz+h
      enddo
c
      deallocate(dp0,dp0up,dp0lw,vp0,vp0up,vp0lw,vs0,vs0up,vs0lw,
     &           ro0,ro0up,ro0lw,qp0,qp0up,qp0lw,qs0,qs0up,qs0lw)
c
c     add source layers
c
      do ig=1,ngrn
        rrs=rratmos-grndep(ig)
        if(rrs.lt.0.d0)then
          stop ' Wrong source depth!'
        endif
        do ly=1,ly0
          if(rrs.ge.rrlw(ly))then
            lys=ly
            goto 100
          endif
        enddo
100     continue
        if(rrs.lt.rrup(lys).and.rrs.gt.rrlw(lys))then
          do ly=ly0,lys,-1
            rrup(ly+1)=rrup(ly)
	      vpup(ly+1)=vpup(ly)
	      vsup(ly+1)=vsup(ly)
	      roup(ly+1)=roup(ly)
	      qpup(ly+1)=qpup(ly)
	      qsup(ly+1)=qsup(ly)
            rrlw(ly+1)=rrlw(ly)
	      vplw(ly+1)=vplw(ly)
	      vslw(ly+1)=vslw(ly)
	      rolw(ly+1)=rolw(ly)
	      qplw(ly+1)=qplw(ly)
	      qslw(ly+1)=qslw(ly)
          enddo
          lys=lys+1
          up=(rrs-rrlw(lys))/(rrup(lys-1)-rrlw(lys))
          lw=1.d0-up
          rrlw(lys-1)=rrs
	    vplw(lys-1)=up*vpup(lys-1)+lw*vplw(lys)
	    vslw(lys-1)=up*vsup(lys-1)+lw*vslw(lys)
          if(rrs.gt.REARTH)then
            rolw(lys-1)=rolw(lys-1)
     &                 *dexp(dlog(roup(lys-1)/rolw(lys-1))*up)
          else
	      rolw(lys-1)=up*roup(lys-1)+lw*rolw(lys)
          endif
	    qplw(lys-1)=up*qpup(lys-1)+lw*qplw(lys)
	    qslw(lys-1)=up*qsup(lys-1)+lw*qslw(lys)
          rrup(lys)=rrs
	    vpup(lys)=vplw(lys-1)
	    vsup(lys)=vslw(lys-1)
	    roup(lys)=rolw(lys-1)
	    qpup(lys)=qplw(lys-1)
	    qsup(lys)=qslw(lys-1)
          ly0=ly0+1       
        endif
      enddo
c
c     add receiver layer
c
      rrr=rratmos-dpr
      if(rrr.lt.0.d0)then
        stop ' Wrong receiver depth!'
      endif
      do ly=1,ly0
        if(rrr.ge.rrlw(ly))then
          lyr=ly
          goto 200
        endif
      enddo
200   continue
      if(rrr.lt.rrup(lyr).and.rrr.gt.rrlw(lyr))then
        do ly=ly0,lyr,-1
          rrup(ly+1)=rrup(ly)
	    vpup(ly+1)=vpup(ly)
	    vsup(ly+1)=vsup(ly)
	    roup(ly+1)=roup(ly)
	    qpup(ly+1)=qpup(ly)
	    qsup(ly+1)=qsup(ly)
          rrlw(ly+1)=rrlw(ly)
	    vplw(ly+1)=vplw(ly)
	    vslw(ly+1)=vslw(ly)
	    rolw(ly+1)=rolw(ly)
	    qplw(ly+1)=qplw(ly)
	    qslw(ly+1)=qslw(ly)
        enddo
        lyr=lyr+1
        up=(rrr-rrlw(lyr))/(rrup(lyr-1)-rrlw(lyr))
        lw=1.d0-up
        rrlw(lyr-1)=rrr
	  vplw(lyr-1)=up*vpup(lyr-1)+lw*vplw(lyr)
	  vslw(lyr-1)=up*vsup(lyr-1)+lw*vslw(lyr)
        if(rrr.gt.REARTH)then
          rolw(lyr-1)=rolw(lyr-1)*dexp(dlog(roup(lyr-1)/rolw(lyr-1))*up)
        else
	    rolw(lyr-1)=up*roup(lyr-1)+lw*rolw(lyr)
        endif
	  qplw(lyr-1)=up*qpup(lyr-1)+lw*qplw(lyr)
	  qslw(lyr-1)=up*qsup(lyr-1)+lw*qslw(lyr)
        rrup(lyr)=rrr
	  vpup(lyr)=vplw(lyr-1)
	  vsup(lyr)=vslw(lyr-1)
	  roup(lyr)=rolw(lyr-1)
	  qpup(lyr)=qplw(lyr-1)
	  qsup(lyr)=qslw(lyr-1)
        ly0=ly0+1      
      endif
c
c     add min. path layer
c
      if(ipatha.eq.1)then
        rrr=rratmos-minpath
        if(rrr.lt.0.d0)then
          stop ' Wrong receiver depth!'
        endif
        do ly=1,ly0
          if(rrr.ge.rrlw(ly))then
            lya=ly
           goto 201
          endif
        enddo
201     continue
        if(rrr.lt.rrup(lya).and.rrr.gt.rrlw(lya))then
          do ly=ly0,lya,-1
            rrup(ly+1)=rrup(ly)
	      vpup(ly+1)=vpup(ly)
	      vsup(ly+1)=vsup(ly)
	      roup(ly+1)=roup(ly)
	      qpup(ly+1)=qpup(ly)
	      qsup(ly+1)=qsup(ly)
            rrlw(ly+1)=rrlw(ly)
	      vplw(ly+1)=vplw(ly)
	      vslw(ly+1)=vslw(ly)
	      rolw(ly+1)=rolw(ly)
	      qplw(ly+1)=qplw(ly)
	      qslw(ly+1)=qslw(ly)
          enddo
          lya=lya+1
          up=(rrr-rrlw(lya))/(rrup(lya-1)-rrlw(lya))
          lw=1.d0-up
          rrlw(lya-1)=rrr
	    vplw(lya-1)=up*vpup(lya-1)+lw*vplw(lya)
	    vslw(lya-1)=up*vsup(lya-1)+lw*vslw(lya)
          if(rrr.gt.REARTH)then
            rolw(lya-1)=rolw(lya-1)
     &                 *dexp(dlog(roup(lya-1)/rolw(lya-1))*up)
          else
	      rolw(lya-1)=up*roup(lya-1)+lw*rolw(lya)
          endif
	    qplw(lya-1)=up*qpup(lya-1)+lw*qplw(lya)
	    qslw(lya-1)=up*qsup(lya-1)+lw*qslw(lya)
          rrup(lya)=rrr
	    vpup(lya)=vplw(lya-1)
	    vsup(lya)=vslw(lya-1)
	    roup(lya)=rolw(lya-1)
	    qpup(lya)=qplw(lya-1)
	    qsup(lya)=qslw(lya-1)
          ly0=ly0+1
        endif
      endif
c
c     add max. path layer
c
      if(ipathb.eq.1)then
        rrr=rratmos-maxpath
        if(rrr.lt.0.d0)then
          stop ' Wrong receiver depth!'
        endif
        do ly=1,ly0
          if(rrr.ge.rrlw(ly))then
            lyb=ly
            goto 202
          endif
        enddo
202     continue
        if(rrr.lt.rrup(lyb).and.rrr.gt.rrlw(lyb))then
          do ly=ly0,lyb,-1
            rrup(ly+1)=rrup(ly)
	      vpup(ly+1)=vpup(ly)
	      vsup(ly+1)=vsup(ly)
	      roup(ly+1)=roup(ly)
	      qpup(ly+1)=qpup(ly)
	      qsup(ly+1)=qsup(ly)
            rrlw(ly+1)=rrlw(ly)
  	      vplw(ly+1)=vplw(ly)
	      vslw(ly+1)=vslw(ly)
	      rolw(ly+1)=rolw(ly)
	      qplw(ly+1)=qplw(ly)
	      qslw(ly+1)=qslw(ly)
          enddo
          lyb=lyb+1
          up=(rrr-rrlw(lyb))/(rrup(lyb-1)-rrlw(lyb))
          lw=1.d0-up
          rrlw(lyb-1)=rrr
	    vplw(lyb-1)=up*vpup(lyb-1)+lw*vplw(lyb)
	    vslw(lyb-1)=up*vsup(lyb-1)+lw*vslw(lyb)
          if(rrr.gt.REARTH)then
            rolw(lyb-1)=rolw(lyb-1)
     &                 *dexp(dlog(roup(lyb-1)/rolw(lyb-1))*up)
          else
	      rolw(lyb-1)=up*roup(lyb-1)+lw*rolw(lyb)
          endif
	    qplw(lyb-1)=up*qpup(lyb-1)+lw*qplw(lyb)
	    qslw(lyb-1)=up*qsup(lyb-1)+lw*qslw(lyb)
          rrup(lyb)=rrr
	    vpup(lyb)=vplw(lyb-1)
	    vsup(lyb)=vslw(lyb-1)
	    roup(lyb)=rolw(lyb-1)
	    qpup(lyb)=qplw(lyb-1)
	    qsup(lyb)=qslw(lyb-1)
          ly0=ly0+1      
        endif
      endif
c
c     divide thick layers
c
300   action=.false.
      do ly=1,ly0-1
        if(rrup(ly).gt.2.0d0*rrlw(ly))then
          if(ly0+1.gt.lymax)then
	      stop ' Error in qpsublayer: lymax too small!'
	    endif
          rrr=0.5d0*(rrup(ly)+rrlw(ly))
          lyp=ly
          action=.true.
          goto 301
        endif
      enddo
301   continue
      if(action)then
        do ly=ly0,lyp,-1
          rrup(ly+1)=rrup(ly)
	    vpup(ly+1)=vpup(ly)
	    vsup(ly+1)=vsup(ly)
	    roup(ly+1)=roup(ly)
	    qpup(ly+1)=qpup(ly)
	    qsup(ly+1)=qsup(ly)
          rrlw(ly+1)=rrlw(ly)
  	    vplw(ly+1)=vplw(ly)
	    vslw(ly+1)=vslw(ly)
	    rolw(ly+1)=rolw(ly)
	    qplw(ly+1)=qplw(ly)
	    qslw(ly+1)=qslw(ly)
        enddo
        lyp=lyp+1
        up=(rrr-rrlw(lyp))/(rrup(lyp-1)-rrlw(lyp))
        lw=1.d0-up
        rrlw(lyp-1)=rrr
	  vplw(lyp-1)=up*vpup(lyp-1)+lw*vplw(lyp)
	  vslw(lyp-1)=up*vsup(lyp-1)+lw*vslw(lyp)
        if(rrr.gt.REARTH)then
          rolw(lyp-1)=rolw(lyp-1)
     &               *dexp(dlog(roup(lyp-1)/rolw(lyp-1))*up)
        else
	    rolw(lyp-1)=up*roup(lyp-1)+lw*rolw(lyp)
        endif
	  qplw(lyp-1)=up*qpup(lyp-1)+lw*qplw(lyp)
	  qslw(lyp-1)=up*qsup(lyp-1)+lw*qslw(lyp)
        rrup(lyp)=rrr
	  vpup(lyp)=vplw(lyp-1)
	  vsup(lyp)=vslw(lyp-1)
	  roup(lyp)=rolw(lyp-1)
	  qpup(lyp)=qplw(lyp-1)
	  qsup(lyp)=qslw(lyp-1)
        ly0=ly0+1
        goto 300
      endif
310   continue
c
c     determine indices of main interfaces
c
      lyos=1
      lyob=1
      if(vsup(1).le.0.d0)then
        do ly=2,ly0
          if(vsup(ly).gt.0.d0.and.vslw(ly-1).le.0.d0)then
            lyob=ly
            goto 401
          endif
        enddo
401     continue
        do ly=lyob,2,-1
          if(roup(ly)-rolw(ly-1).gt.10.d0*rolw(ly-1))then
            lyos=ly
            goto 402
          endif
        enddo
402     continue
      endif
      lycm=ly0+1
      do ly=max0(2,lyob+1),ly0
        if(vsup(ly).le.0.d0.and.vslw(ly-1).gt.0.d0)then
          lycm=ly
          goto 403
        endif
      enddo
403   lycc=ly0+1
      do ly=max0(2,lycm+1),ly0
        if(vsup(ly).gt.0.d0.and.vslw(ly-1).le.0.d0)then
          lycc=ly
          goto 404
        endif
      enddo
404   continue
c
c     determine indices of receiver layer
c
      rrr=rratmos-dpr
      do ly=1,ly0
        if(rrr.ge.rrup(ly))then
          lyr=ly
          goto 500
        endif
      enddo
500   continue
c
c     determine indices of source layers
c
      do ig=1,ngrn
        rrs=rratmos-grndep(ig)
        lygrn(ig)=ly0+1
        do ly=1,ly0
          if(rrs.ge.rrup(ly))then
            lygrn(ig)=ly
            goto 600
          endif
        enddo
600     continue
      enddo
c
      mass=0.d0
      do ly=ly0,1,-1
        if(ly.ge.lyos)then
          dro=(roup(ly)-rolw(ly))/(rrup(ly)-rrlw(ly))
          ro1=rolw(ly)-dro*rrlw(ly) 
          mass=mass+PI*(rrup(ly)-rrlw(ly))*((4.d0/3.d0)*ro1
     &        *(rrup(ly)**2+rrup(ly)*rrlw(ly)+rrlw(ly)**2)
     &        +dro*(rrup(ly)**3+rrup(ly)**2*rrlw(ly)
     &        +rrup(ly)*rrlw(ly)**2+rrlw(ly)**3))
        else
          alfa=dlog(roup(ly)/rolw(ly))/(rrup(ly)-rrlw(ly))
          mass=mass+2.d0*PI2/alfa**3
     &        *(roup(ly)*(alfa*rrup(ly)*(alfa*rrup(ly)-2.d0)+2.d0)
     &         -rolw(ly)*(alfa*rrlw(ly)*(alfa*rrlw(ly)-2.d0)+2.d0))
        endif
        cgrup(ly)=dcmplx(BIGG*mass/rrup(ly)**2,0.d0)
      enddo
c
      do ly=1,ly0-1
        cgrlw(ly)=cgrup(ly+1)
      enddo
      cgrlw(ly0)=(0.d0,0.d0)
c
c     make Adam-Williamson condition satisfied in ocean
c
      i=0
      gr0=dreal(cgrup(1))
700   i=i+1
      do ly=lyos,lyob-1
        h=rrup(ly)-rrlw(ly)
        alfa=dreal(cgrup(ly))/vpup(ly)**2
        beta=(dreal(cgrlw(ly))/vplw(ly)**2
     &       -dreal(cgrup(ly))/vpup(ly)**2)/h
        rolw(ly)=roup(ly)*dexp(alfa*h+beta*h**2)
        if(ly.lt.lyob-1)roup(ly+1)=rolw(ly)
      enddo
      mass=0.d0
      do ly=ly0,1,-1
        if(ly.ge.lyos)then
          dro=(roup(ly)-rolw(ly))/(rrup(ly)-rrlw(ly))
          ro1=rolw(ly)-dro*rrlw(ly) 
          mass=mass+PI*(rrup(ly)-rrlw(ly))*((4.d0/3.d0)*ro1
     &        *(rrup(ly)**2+rrup(ly)*rrlw(ly)+rrlw(ly)**2)
     &        +dro*(rrup(ly)**3+rrup(ly)**2*rrlw(ly)
     &        +rrup(ly)*rrlw(ly)**2+rrlw(ly)**3))
        else
          alfa=dlog(roup(ly)/rolw(ly))/(rrup(ly)-rrlw(ly))
          mass=mass+2.d0*PI2/alfa**3
     &        *(roup(ly)*(alfa*rrup(ly)*(alfa*rrup(ly)-2.d0)+2.d0)
     &         -rolw(ly)*(alfa*rrlw(ly)*(alfa*rrlw(ly)-2.d0)+2.d0))
        endif
        cgrup(ly)=dcmplx(BIGG*mass/rrup(ly)**2,0.d0)
      enddo
      do ly=1,ly0-1
        cgrlw(ly)=cgrup(ly+1)
      enddo
      cgrlw(ly0)=(0.d0,0.d0)
      if(dabs(dreal(cgrup(1))-gr0).gt.1.0d-08*dreal(cgrup(1))
     &  .and.i.le.10)then
        gr0=dreal(cgrup(1))
        goto 700
      endif
c
      freeairgrd=-dreal(cgrup(lyr))*2.d0/rrup(lyr)
      if(lyr.gt.1)then
        freeairgrd=freeairgrd+4.d0*PI*BIGG*rolw(lyr-1)
      endif
c
c     for a stable atmposheric density grandient
c
      do ly=1,lyos-1
        beta=dlog(roup(ly)/rolw(ly))/(rrup(ly)-rrlw(ly))
        gr0=dreal(cgrup(ly))
        bvn2=-gr0*(beta+gr0/vpup(ly)**2)
        if(bvn2.lt.0.d0)vpup(ly)=dsqrt(-gr0/beta)
        gr0=dreal(cgrlw(ly))
        bvn2=-gr0*(beta+gr0/vplw(ly)**2)
        if(bvn2.lt.0.d0)vplw(ly)=dsqrt(-gr0/beta)
      enddo
      do ly=2,lyos-1
        vpup(ly)=dmax1(vpup(ly),vplw(ly-1))
        vplw(ly-1)=vpup(ly)
      enddo
c
      do ly=1,ly0
        crrup(ly)=dcmplx(rrup(ly),0.d0)
        croup(ly)=dcmplx(roup(ly),0.d0)
        claup(ly)=dcmplx(roup(ly)*(vpup(ly)**2-2.d0*vsup(ly)**2),0.d0)
        cmuup(ly)=dcmplx(roup(ly)*vsup(ly)**2,0.d0)
        cvpup(ly)=dcmplx(vpup(ly),0.d0)
        cvsup(ly)=dcmplx(vsup(ly),0.d0)
        cgaup(ly)=dcmplx(2.d0*PI2*BIGG*roup(ly),0.d0)
c
        crrlw(ly)=dcmplx(rrlw(ly),0.d0)
        crolw(ly)=dcmplx(rolw(ly),0.d0)
        clalw(ly)=dcmplx(rolw(ly)*(vplw(ly)**2-2.d0*vslw(ly)**2),0.d0)
        cvplw(ly)=dcmplx(vplw(ly),0.d0)
        cvslw(ly)=dcmplx(vslw(ly),0.d0)
        cmulw(ly)=dcmplx(rolw(ly)*vslw(ly)**2,0.d0)
        cgalw(ly)=dcmplx(2.d0*PI2*BIGG*rolw(ly),0.d0)
c
        if(rrup(ly).le.rrlw(ly))then
          cro(ly)=(0.5d0,0.d0)*(croup(ly)+crolw(ly))
        else
          if(ly.ge.lyos)then
            dro=(roup(ly)-rolw(ly))/(rrup(ly)-rrlw(ly))
            ro1=rolw(ly)-dro*rrlw(ly) 
            mass=PI*(rrup(ly)-rrlw(ly))*((4.d0/3.d0)*ro1
     &          *(rrup(ly)**2+rrup(ly)*rrlw(ly)+rrlw(ly)**2)
     &          +dro*(rrup(ly)**3+rrup(ly)**2*rrlw(ly)
     &          +rrup(ly)*rrlw(ly)**2+rrlw(ly)**3))
          else
            alfa=dlog(roup(ly)/rolw(ly))/(rrup(ly)-rrlw(ly))
            mass=2.d0*PI2/alfa**3
     &          *(roup(ly)*(alfa*rrup(ly)*(alfa*rrup(ly)-2.d0)+2.d0)
     &           -rolw(ly)*(alfa*rrlw(ly)*(alfa*rrlw(ly)-2.d0)+2.d0))
          endif
          cro(ly)=dcmplx(mass/((rrup(ly)**3-rrlw(ly)**3)
     &                        *2.d0*PI2/3.d0),0.d0)
        endif
        cla(ly)=(0.5d0,0.d0)*(claup(ly)+clalw(ly))
        cmu(ly)=(0.5d0,0.d0)*(cmuup(ly)+cmulw(ly))
        cvp(ly)=(0.5d0,0.d0)*(cvpup(ly)+cvplw(ly))
        cvs(ly)=(0.5d0,0.d0)*(cvsup(ly)+cvslw(ly))
        cgr(ly)=(0.5d0,0.d0)*(cgrup(ly)+cgrlw(ly))
        cga(ly)=(0.5d0,0.d0)*(cgaup(ly)+cgalw(ly))
      enddo
c
      do ly=1,lyob-1
        cypnorm(1,ly)=(1.d0,0.d0)
        cypnorm(2,ly)=(1.d0,0.d0)
        cypnorm(3,ly)=cga(ly)
        cypnorm(4,ly)=cga(ly)
      enddo
      do ly=lyob,lycm-1
        cypnorm(1,ly)=(1.d0,0.d0)
        cypnorm(2,ly)=cla(ly)+(2.d0,0.d0)*cmu(ly)
        cypnorm(3,ly)=(1.d0,0.d0)
        cypnorm(4,ly)=cla(ly)+(2.d0,0.d0)*cmu(ly)
        cypnorm(5,ly)=cga(ly)
        cypnorm(6,ly)=cga(ly)
      enddo
      do ly=lycm,lycc-1
        cypnorm(1,ly)=(1.d0,0.d0)
        cypnorm(2,ly)=(1.d0,0.d0)
        cypnorm(3,ly)=cga(ly)
        cypnorm(4,ly)=cga(ly)
      enddo
      do ly=lycc,ly0
        cypnorm(1,ly)=(1.d0,0.d0)
        cypnorm(2,ly)=cla(ly)+(2.d0,0.d0)*cmu(ly)
        cypnorm(3,ly)=(1.d0,0.d0)
        cypnorm(4,ly)=cla(ly)+(2.d0,0.d0)*cmu(ly)
        cypnorm(5,ly)=cga(ly)
        cypnorm(6,ly)=cga(ly)
      enddo
c
	write(*,'(9a)')'  No','      R(km)','   Vp(km/s)',
     &    '   Vs(km/s)',' Ro(g/cm^3)','      Qp',
     &    '      Qs',' g(m/s^2)'
c
      rrlw(ly0)=0.d0
c
	do ly=1,ly0
	  write(*,1001)ly,rrup(ly)/1.d3,vpup(ly)/1.d3,vsup(ly)/1.d3,
     &               roup(ly)/1.d3,qpup(ly),qsup(ly),dreal(cgrup(ly))
        j=0
        do ig=1,ngrn
          if(lygrn(ig).eq.ly)then
            j=j+1
            write(*,'(a3,$)')' S '
          endif
        enddo
        if(j.eq.0)write(*,'(a3,$)')'   '
        if(lyr.eq.ly)then
          write(*,'(a3)')' R '
        else
          write(*,'(a3)')'   '
        endif
	  write(*,1002)rrlw(ly)/1.d3,vplw(ly)/1.d3,vslw(ly)/1.d3,
     &             rolw(ly)/1.d3,qplw(ly),qslw(ly),dreal(cgrlw(ly))
      enddo
c
1001	format(i4,f11.4,3f11.4,2f8.1,f9.4,$)
1002  format(f15.4,3f11.4,2f8.1,f9.4)
      return
	end

      subroutine skipdoc(unit)
      implicit none
      integer*4 unit,iostat
      character line*(1)
c
10    continue
      read(unit,'(a)',iostat=iostat)line
      if(iostat.ne.0) then
        stop 'Error occured during read'
      endif
c
      if(line(1:1).ne.'#')then
        backspace (unit)
        return
      else
        goto 10
      endif
c
      return
      end

      subroutine qpstart4(ldeg,ly,cy)
      use qpalloc
      implicit none
c
c     calculate fundamental solution vectors for homogeneous sphere
c
      integer*4 ldeg,ly
      complex*16 cy(4,2)
c
      integer*4 j
      complex*16 cldeg,cgl,ca2,cb2,cgrdr
      complex*16 kpg,ksg,cfp,cfs,chp,chs,spa,spb,cxup,cx2
      complex*16 cllm1,cllp1,c2lp1,c2lp3,c22lp3
      complex*16 ph0,ph1,ps0,ps1
      complex*16 spbphj,spbpsj
c
      complex*16 ci,c1,c2,c3,c4
      data ci,c1,c2,c3,c4/(0.d0,1.d0),
     &     (1.d0,0.d0),(2.d0,0.d0),(3.d0,0.d0),(4.d0,0.d0)/
c
      cldeg=dcmplx(dble(ldeg),0.d0)
      if(dreal(comi).le.0.d0)then
c
c       imcompressible fluid in the quasi-static case
c
        cy(1,1)=cldeg
        cy(2,1)=c1
        cy(3,1)=(0.d0,0.d0)
        cy(4,1)=(0.d0,0.d0)
      else
        cllm1=cldeg*(cldeg-c1)
        cllp1=cldeg*(cldeg+c1)
        c2lp1=c2*cldeg+c1
        c2lp3=c2*cldeg+c3
        c22lp3=c2*(c2*cldeg+c3)
        cgrdr=cgrup(ly)/crrup(ly)
c
        ca2=(comi2+cga(ly)+cgrdr)/cvp(ly)**2
        cb2=comi2/cvs(ly)**2
        cgl=c4*cllp1*(cgrdr/(cvp(ly)*cvs(ly)))**2
c
        kpg=cdsqrt(comi2+cga(ly)+cgrdr-cllp1*cgrdr**2/comi2)/cvp(ly)
        cfp=-comi2/cgrdr
        chp=cfp-cldeg-c1
c
        if(cdabs(kpg*crrup(ly))**2.lt.0.5d0*dble(ldeg))then
c
          cxup=kpg*crrup(ly)
          ph0=spbphj(ldeg,cxup)
          ph1=spbphj(ldeg+1,cxup)
          ps0=spbpsj(ldeg,cxup)
          ps1=spbpsj(ldeg+1,cxup)
c
          cy(1,1)=-(cldeg*chp*ps0/c2+cfp*ph1)/c2lp3
          cy(2,1)=-(chp*ps0/c2-ph1)/c2lp3
          cy(3,1)=(cfp*cvp(ly)**2-(cldeg+c1)*cvs(ly)**2)/crrup(ly)**2
     &             -cga(ly)*cfp*ps0/c22lp3
          cy(4,1)=c2lp1*cy(3,1)+cga(ly)*cldeg*chp*ps0/c22lp3
        else
          call spbjh(ldeg,kpg,rrup(ly),rrlw(ly),
     &               zjupg(0),zjlwg(0),wjg(0),
     &               zhupg(0),zhlwg(0),whg(0))
c
          spa=c1-zjupg(ldeg)
          spb=-ci*zjupg(ldeg)
          cx2=(kpg*crrup(ly))**2
c
          cy(1,1)=cldeg*chp*spa-cfp*spb
          cy(2,1)=chp*spa+spb
          cy(3,1)=cga(ly)*cfp*spa
          cy(4,1)=cga(ly)*(c2lp1*cfp-cldeg*chp)*spa
        endif
      endif
c
      cy(1,2)=cldeg
      cy(2,2)=c1
      cy(3,2)=cldeg*cgrdr-comi2
      cy(4,2)=c2lp1*(cldeg*cgrdr-comi2)-cga(ly)*cldeg
c
c     Note:
c       y1 <- y1 (normal displacement)
c       y2 <- y3 (horizontal displacement)
c       y3 <- y5 (potential)
c       y4 <- y6 (gravity)
c
      return
      end

      subroutine qswaveno(f,k)
      implicit none
c
      real*8 f,k
c
      include 'qsglobal.h'
c
      integer*4 n
      complex*16 ck,ck2
c
      ck=dcmplx(k,0.d0)
      ck2=dcmplx(k*k,0.d0)
c
      if(roair.gt.0.d0)then
        kpair=cdsqrt((ck+comega/cvpair)*(ck-comega/cvpair))
      else
        kpair=(0.d0,0.d0)
      endif
c
      do n=1,n0
        kp(n)=cdsqrt((ck+comega/cvp(n))*(ck-comega/cvp(n)))
        ks(n)=cdsqrt((ck+comega/cvs(n))*(ck-comega/cvs(n)))
        wb(n)=(2.d0,0.d0)*cmu(n)*ck
        wa(n)=cmu(n)*(ck2+ks(n)*ks(n))
      enddo
c
c     for receiver site
c
      do n=1,n0rs
        kprs(n)=cdsqrt((ck+comega/cvprs(n))*(ck-comega/cvprs(n)))
        ksrs(n)=cdsqrt((ck+comega/cvsrs(n))*(ck-comega/cvsrs(n)))
        wbrs(n)=(2.d0,0.d0)*cmurs(n)*ck
        wars(n)=cmurs(n)*(ck2+ksrs(n)*ksrs(n))
      enddo
c
      return
      end

      subroutine qpqmodel(f)
      use qpalloc
      implicit none
c
c     calculate q based on the constant q model
c
c     f = frequency
c
      real*8 f
c
      integer*4 ly
      real*8 fac,pup,plw,sup,slw
      complex*16 cqpup,cqsup,cqplw,cqslw
c
      if(.not.dispersion.or.f.ge.FSBREF)then
        fac=0.d0
      else if(f.le.FSBLW)then
        fac=dlog(FSBLW/FSBREF)/PI
      else
        fac=dlog(f/FSBREF)/PI
      endif
c
      if(1.d0+fac/qsmin.le.0.d0)then
        stop 'Error in qpqmodel: too small Qs value!'
      endif
      do ly=1,ly0
        if(f.gt.0.d0)then
          cqpup=dcmplx(1.d0,0.5d0/qpup(ly))
          cqplw=dcmplx(1.d0,0.5d0/qplw(ly))
        else
          cqpup=(1.d0,0.d0)
          cqplw=(1.d0,0.d0)
        endif
        pup=1.d0+fac/qpup(ly)
        plw=1.d0+fac/qplw(ly)
c
        cvpup(ly)=dcmplx(vpup(ly)*pup/cdabs(cqpup),0.d0)*cqpup
        cvplw(ly)=dcmplx(vplw(ly)*plw/cdabs(cqplw),0.d0)*cqplw
        cvp(ly)=(0.5d0,0.d0)*(cvpup(ly)+cvplw(ly))
c
        if(ly.ge.lyob.and.ly.lt.lycm.or.ly.ge.lycc)then
          sup=1.d0+fac/qsup(ly)
          slw=1.d0+fac/qslw(ly)
          if(f.gt.0.d0)then
            cqsup=dcmplx(1.d0,0.5d0/qsup(ly))
            cqslw=dcmplx(1.d0,0.5d0/qslw(ly))
          else
            cqsup=(1.d0,0.d0)
            cqslw=(1.d0,0.d0)
          endif
          cvsup(ly)=dcmplx(vsup(ly)*sup/cdabs(cqsup),0.d0)*cqsup
          cvslw(ly)=dcmplx(vslw(ly)*slw/cdabs(cqslw),0.d0)*cqslw
          cvs(ly)=(0.5d0,0.d0)*(cvsup(ly)+cvslw(ly))
        else
          cvsup(ly)=(0.d0,0.d0)
          cvslw(ly)=(0.d0,0.d0)
          cvs(ly)=(0.d0,0.d0)
        endif
c
        cmuup(ly)=croup(ly)*cvsup(ly)**2
        claup(ly)=croup(ly)*cvpup(ly)**2-(2.d0,0.d0)*cmuup(ly)
        cmulw(ly)=crolw(ly)*cvslw(ly)**2
        clalw(ly)=crolw(ly)*cvplw(ly)**2-(2.d0,0.d0)*cmulw(ly)
        cmu(ly)=(0.5d0,0.d0)*(cmuup(ly)+cmulw(ly))
        cla(ly)=(0.5d0,0.d0)*(claup(ly)+clalw(ly))
      enddo
      return
      end

      subroutine qpdocu(ierr)
      implicit none
      integer ierr
c
      include 'qpglobal.h'
c
      integer i,j,k,ig,flen
      character*24 fdate
c
      open(20,file=infofile,status='unknown')
      write(20,'(a)')'#   Space-time domain Green function database'
      write(20,'(a)')'#   calculated on '//fdate()
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#   data_type size: REAL*4'
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#   time_window[s] sampling[s] number_of_samples'
      write(20,'(2f10.2,i6)')dble(ntout-1)*dtout,dtout,ntout
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#   number of distances, list of distances'
      write(20,'(i8)')nr
      j=0
      do i=1,nr/5
        write(20,'(5f10.3)')(dism(k)/KM2M,k=j+1,j+5)
        j=j+5
      enddo
      if(j.lt.nr)then
        write(20,'(5f10.3)')(dism(k)/KM2M,k=j+1,nr)
      endif
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#   each file includes all fundamental velocity'
      write(20,'(a)')'#   Green functions for a given source depth'
      write(20,'(a)')'#   data are stored in the following order:'
      write(20,'(a)')'#   distance'
      write(20,'(a)')'#    {time_reduction,'
      write(20,'(a)')'#     mechanism(expl.,strike-slip,dip-slip,clvd)'
      write(20,'(a)')'#      {component(vertical,radial,tangential)'
      write(20,'(a)')'#       {time_series}}}'
      write(20,'(a)')'#   note: time reduction [s] needs (4)+4+(4)'
      write(20,'(a)')'#         bytes, each time series (seimogram)'
      write(20,'(a)')'#         needs (4)+number_of_samples*4+(4)'
      write(20,'(a)')'#         bytes, where (4) bytes are for the'
      write(20,'(a)')'#         reserved places before and after each'
      write(20,'(a)')'#         record'
      write(20,'(a)')'#================================================'
      write(20,'(a)')'#   number of source_depths / files,'
      write(20,'(a)')'#   list of source_depths / filenames'
      write(20,'(i10)')ngrn
      do ig=1,ngrn
        do flen=128,1,-1
          if(stdgrnfile(ig)(flen:flen).ne.' ')goto 100
        enddo
100     continue
        write(20,'(f10.1,a)')grndep(ig)/KM2M,
     &                     '  '//''''//stdgrnfile(ig)(1:flen)//''''
      enddo
      close(20)
      return
      end
